package framework.utils
{
	import Assetlink.Solutions.Formatting.DateTimeFormatting;
	
	import com.hurlant.crypto.Crypto;
	import com.hurlant.crypto.hash.IHash;
	import com.hurlant.crypto.symmetric.ICipher;
	import com.hurlant.crypto.symmetric.IPad;
	import com.hurlant.crypto.symmetric.NullPad;
	import com.hurlant.util.Base64;
	import com.hurlant.util.Hex;
	
	import flash.desktop.NativeApplication;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.system.Capabilities;
	import flash.utils.ByteArray;
	
	import framework.constants.Security;
	import framework.constants.tables.PREFERENCE;
	
	import infrastructure.database.DataAccess;
	import infrastructure.statemanagement.StateMgr;
	
	import mx.controls.Alert;
	import mx.effects.easing.Exponential;	
	
	public class Helper
	{
		
		public static function CreateCacheDirectory(path:String):File
		{
			var folder:File;
			try
			{
				var hotFolderPath:String =	StateMgr.GetInstance().MainDatabase.ResultSet[6][PREFERENCE.VALUE];
				if(hotFolderPath == null || hotFolderPath == "")
			   		folder = new File(File.userDirectory.resolvePath( path).nativePath);
				else
					folder = new File(new File( Decode(hotFolderPath)).resolvePath(path).nativePath);
			   
			   if(!folder.exists)
	           {
	          	 folder.createDirectory();	          	 
	           }
			   return folder;
			}
			catch(ex:Error)
			{
				//WriteLog("Exception while CreateCacheDirectory :" + path + " Exception: " + ex.toString());				
			}
	       return null;
		}
		
		public static function CreateHotDirectory(path:String):File
		{
			var folder:File;
			try
			{
			   var hotFolderPath:String =	StateMgr.GetInstance().MainDatabase.ResultSet[6][PREFERENCE.VALUE];
			   if(hotFolderPath == null || hotFolderPath == "")
			   {
			   	   folder = new File(File.userDirectory.resolvePath( path).nativePath);
			   }
			   else
			   {
			   	  folder = new File(new File( Decode(hotFolderPath)).resolvePath(path).nativePath);
			   }
			   
			   if(!folder.exists)
	           {
	          	 folder.createDirectory();	          	 
	           }
			   return folder;
			}
			catch(ex:Error)
			{
				//WriteLog("Exception while CreateHotDirectory :" + path + " Exception: " + ex.toString());				
			}
	       return null;
		}
		
		public static function GetRootDirectory():String
		{
			if(Capabilities.os.indexOf("Win") == 0)
			{
				
			}
			return "";
		}
		
		public static function GetCurrentDateTimeStamp(dateStyle:Boolean = false):String
		{
			var dt:Date = new Date();
			var timestamp:String = "";
			
			if(dateStyle)
			{
				timestamp = dt.getDate().toString() + "-" + dt.getMonth().toString() + "-" + dt.getFullYear().toString() + "-" + dt.getHours().toString() + "-" + dt.getMinutes().toString() + "-" + dt.getSeconds().toString() ;
			}
			else
			{
				timestamp = dt.getDate().toString() + dt.getMonth().toString() + dt.getFullYear().toString() + dt.getHours().toString() + dt.getMinutes().toString() + dt.getSeconds().toString() ;
			}
			
			return timestamp;
		}
		
		public static function CalculateHours( start:Date, end:Date ) :int
		{
		      var daysInMilliseconds:int = 1000*60*60;//*24
		      return (  (end.time - start.time)  / daysInMilliseconds );
		
		} 
		
		public static function Encode(data:String):String
		{	
			return escape(data);
		}
		
		public static function Decode(data:String):String
		{			
			return unescape(data);
		}
		
		public static function EncodeSpecialChars(text:String):String
		{	
			while (text.indexOf('&') >= 0)
				text = text.replace('&','$ALAND$');
			while (text.indexOf('$ALAND$') >= 0)
				text = text.replace('$ALAND$','&amp;');
			while (text.indexOf('<') >= 0)
				text = text.replace('<','&lt;');
			while (text.indexOf('>') >= 0)
				text = text.replace('>','&gt;');
        	while (text.indexOf('"') >= 0)
            	text = text.replace('"','&quot;');
			while (text.indexOf("'") >= 0)
            	text = text.replace("'",'&#39;');
			return text;
		}
		
		public static function DecodeSpecialChars(text:String):String
		{
			while (text.indexOf('&lt;') >= 0)
				text = text.replace('&lt;','<');
			while (text.indexOf('&gt;') >= 0)
				text = text.replace('&gt;','>');
			while (text.indexOf('&amp;') >= 0)
				text = text.replace('&amp;','&');
        	while (text.indexOf('&quot;')>=0)
            	text = text.replace('&quot;','"');
			while (text.indexOf("&#39;")>=0)
            	text = text.replace("&#39;","'");      
			return text;
		}
		
		public static function GetLoggerInstance(da:DataAccess = null):Logger
		{
		   if(StateMgr.GetInstance().logger == null)
		   {
		   	 	StateMgr.GetInstance().logger = new Logger(da);
		   }
		   return StateMgr.GetInstance().logger;
		}
		
		private static function computeHash(key:String):ByteArray 
		{
            // 1: get a IHash.
            var hash:IHash = Crypto.getHash(Security.AL_HASH_ALGORITHM);
            // 2: get an input               
           	//key is in hex format
           	 var data:ByteArray = Hex.toArray(key); 
            var currentResult:ByteArray = hash.hash(data);
            
            return currentResult;
           // displayOutput();
        }
        
	    public static function encrypt(key:String,inputText:String):String
	     {
	        // 2: get a key
	         var hashKey:ByteArray = computeHash(key);
	        // 3: get an input
	        var txt:String = inputText;
	        var data:ByteArray = Hex.toArray(Hex.fromString(txt));
	        // 1: get an algorithm..
	        var name:String = Security.AL_ALGORITHM;
	       
	        
	        var pad:IPad = new NullPad;
	        var mode:ICipher = Crypto.getCipher(Security.AL_ALGORITHM, hashKey, pad);
	        pad.setBlockSize(mode.getBlockSize());
	        mode.encrypt(data);
	        var currentResult:ByteArray = data;
	        var encrytpedData:String = Base64.encodeByteArray(currentResult);
	       
	       return encrytpedData;
        }
        
        public static function  decrypt(key:String,inputText:String):String
        {
            // 2: get a key
             var hashKey:ByteArray = computeHash(key);           
            // 3: get an output
            var txt:String = inputText;
            
            var data:ByteArray = Base64.decodeToByteArray(txt); 
            
            // 1: get an algorithm..
            
            var name:String = Security.AL_ALGORITHM;
           
            
            var pad:IPad = new NullPad;
            var mode:ICipher = Crypto.getCipher(Security.AL_ALGORITHM, hashKey, pad);
            pad.setBlockSize(mode.getBlockSize());
           
            mode.decrypt(data);
            var currentInput:ByteArray = data;
            var decryptedData:String = Hex.toString(Hex.fromArray(currentInput));
            return decryptedData;
        }
        
        public static function GetAssetlinkDesktopVersion():String
        {
        	 // ADF
	        var adfXml:XML = NativeApplication.nativeApplication.applicationDescriptor;
	        var adfXmlNs:Namespace = adfXml.namespace();
	        return adfXml.adfXmlNs::version;		
        }
        
        public static function GetSchemaVersion():Number
        {
        	var appVersion:String = GetAssetlinkDesktopVersion();
        	var versionArr:Array = appVersion.split(".");
        	return Number(versionArr[2] + "." + versionArr[3]);
        }
        
        public static function GetAppVersion():Number
        {
        	var appVersion:String = GetAssetlinkDesktopVersion();        	
        	var versionArr:Array = appVersion.split(".");
        	return Number(versionArr[0] + "." + versionArr[1]);
        }

		public static function WriteLog(Content:String):void
		{
			try
			{				 
				var localFile:File = File.applicationStorageDirectory.resolvePath("AssetlinkDesktop_Log.txt");				
				//var localFile:File = new File("c:\\AssetlinkDesktop_Log.txt");
				var localFileStream:FileStream = new FileStream();         
				/* Now ask the FileStream to open a File object. The FileMode.APPEND will open the file for writing and append new content to the end of the file. If the file does not yet exist it will be created.  */       
				localFileStream.open(localFile, FileMode.APPEND);         
				/* Write content to the File using the FileStream object. We use the writeMultiByte function on the FileStream object which accepts a String and the character encoding we wich to use (I'm using utf-8)  */				
				localFileStream.writeMultiByte(Content, "utf-8");
				localFileStream.writeMultiByte(File.lineEnding, "utf-8"); 
				/* All done, close the FileStream object.  */        
				localFileStream.close();
			}
			catch(ex:Error)
			{
				Alert.show("Exception in WriteLog :" + Content + " Exception: " + ex.toString());
			}
		}
		
		private static var LocalizedStrings:XMLList = null;
		public static function initializeLocalizedStrings(localStrings:XMLList):void
		{	
			LocalizedStrings = localStrings;				
		}
		
		public static function getLocalizedString(key:String):String
		{			
			var returnVal:String = key;			
			if (LocalizedStrings != null && LocalizedStrings.length() > 0)
			{
				var reqdNode:XMLList = LocalizedStrings.(@id == key);
				if (reqdNode != null && reqdNode.length() > 0)
					returnVal = reqdNode[0].@value;
			}
			return returnVal;
		}
		
		public static function getLocalizedStringEx(key:String, PlaceHolders:Array):String
		{			
			var KeyObj:Object;
			var Key:String = null;
			var Value:String = null;
			
			var returnVal:String = key;			
			if (LocalizedStrings != null && LocalizedStrings.length() > 0)
			{
				var reqdNode:XMLList = LocalizedStrings.(@id == key);
				if (reqdNode != null && reqdNode.length() > 0)
				{
					returnVal = reqdNode[0].@value;
					for(var cnt:int =0; cnt < PlaceHolders.length; cnt++)
					{
						KeyObj = PlaceHolders[cnt];
						if(KeyObj != null)
						{
							Key = KeyObj.Key;
							Key = "$AL$" + Key + "$AL$";
							Value = KeyObj.Value;
							returnVal = returnVal.replace(Key, Value);
						}
					}
				}	
			}
			return returnVal;
		}

	}
}