package framework.utils
{
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	
	import mx.core.Application;
	import mx.core.UIComponent;
	
	public class WorkInProgress extends UIComponent	
	{
		private static var internalObject:WorkInProgress;
		private var spinner:Spinner;
		private var label:TextField
		
		public function WorkInProgress() 	
		{
			super();
			this.percentWidth = 100;
			this.percentHeight = 100;
		}
		
		protected override function createChildren():void
		{
			spinner = new Spinner();
			spinner.size = 100;
			spinner.numTicks = 11;
			spinner.tickWidth = 11;
			spinner.speed =1800;
			spinner.fadeSpeed =1800;
			spinner.setStyle('tickColor', 0xffcc00);
			this.addChild(spinner);   
			
			var labelformat:TextFormat = new TextFormat();
			labelformat.font = getStyle("fontFamily");
			labelformat.color = getStyle("fontColor");
			labelformat.size = getStyle("fontSize");
			labelformat.bold = false;
			
			label = new TextField();
			label.defaultTextFormat = labelformat;
			label.autoSize = TextFieldAutoSize.LEFT;
			label.border=false;
			label.type= TextFieldType.DYNAMIC;
			label.selectable=false;
			label.mouseEnabled=false;
			this.addChild(label);	            
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			this.graphics.clear();
			this.graphics.beginFill(0x313131,0.5);
			this.graphics.drawRect(0, 0, unscaledWidth, unscaledHeight);
			
			spinner.x = (unscaledWidth-(spinner.width+label.width+2))/2;
			spinner.y = (unscaledHeight-spinner.height)/2;
			label.x = spinner.x + spinner.width + 2;
			label.y = spinner.y+spinner.height - label.height; 
			
		}
		
		public static function Show(status:String):void
		{
			if(internalObject == null)
			{
				internalObject = new WorkInProgress();	
				Application.application.addChild(internalObject);			
			}
			else
			{
				Application.application.removeChild(internalObject);	
				Application.application.addChild(internalObject);	
			}
			
			internalObject.label.text = status;
			internalObject.visible = true;
			internalObject.spinner.play();
		}
		
		public static function Hide(status:String):void
		{
			if(internalObject != null)
			{				
				if(internalObject.label.text == status)
				{
					internalObject.visible = false;
					internalObject.spinner.stop();
				}
			}
		}
		
		public static function HideAll():void
		{
			if(internalObject != null)
			{				
				internalObject.visible = false;
				internalObject.spinner.stop();
			}
		}


	}
}