package	infrastructure.statemanagement
{
	import flash.events.Event;
	
	import framework.constants.EVENTS;
	import framework.events.ApplicationErrorEvent;
	import framework.remoteobjects.Session;
	import framework.utils.Helper;
	import framework.utils.Logger;
	
	import infrastructure.database.DataAccess;
	
	import mx.collections.ArrayCollection;
	import mx.collections.XMLListCollection;
	import mx.core.Application;
	import mx.rpc.remoting.mxml.RemoteObject;
	
	
	public class StateMgr
	{
		private static var stateMgr:StateMgr = null;
		
		public  var UserId:String = "";	
		
		public  var Language:String = "";	
		
		public  var HashedSectionHierarchy:Array = new Array();
		[Bindable]  
		public  var SectionHierarchy:XMLListCollection = new XMLListCollection;
		
		//can be used to state of each module
		//handling and storage varies from module to module and
		//each module is responsible for it handling
		public var Modules:Array = new Array(); 	
		
		public var IsConnectedToServer:Boolean =false;
		
		private var fascade:RemoteObject = null;
		
		public var logger:Logger = null;		
		
		public var FormatXml:XML = null;
		public var CurrentCulture:String = null;
		
		public function set Fascade(value:RemoteObject):void 
		{
		  fascade = value
		}
		public function get Fascade():RemoteObject
		{
			return fascade;
		}
		
		private var _hasErrorOccured:Boolean =false;
		public function set hasErrorOccured(value:Boolean):void 
		{
		  _hasErrorOccured = value;
		  Application.application.dispatchEvent(new ApplicationErrorEvent(ApplicationErrorEvent.CONNECTION_ERROR,value));
		}
		public function get hasErrorOccured():Boolean
		{
			return _hasErrorOccured;
		}
		
		
		private var session:Session = null;
		public function set SessionObject(value:Session):void 
		{
		  session = value;
		  Application.application.dispatchEvent(new Event(EVENTS.SESSION_POPULATED));
		}
		public function get SessionObject():Session
		{
			return session;
		}
		
		private var syncdatalist:ArrayCollection = new ArrayCollection();
		public function SyncingData(value:String):void
		{
			syncdatalist.addItem(value);
		} 
		
		
		public function DataSynced(value:String):void
		{
			if(syncdatalist.contains(value))
			{
				syncdatalist.removeItemAt(syncdatalist.getItemIndex(value));
				if(syncdatalist.length == 0)
				{
					Application.application.dispatchEvent(new Event(EVENTS.DATA_SYNCED));
				}
			}
		}
		
		public function ALEncode(url:String):String
		{
			if(session != null)
			{
				return Helper.encrypt(session.Key,url);
			}
			else
			  return url;
		}
		
		public function ALDecode(url:String):String
		{
			if(session != null)
			{
				return Helper.decrypt(session.Key,url);
			}
			else
			  return url;
		}
		
		[Bindable]
		public var MainDatabase:DataAccess = null;		
		
		public function StateMgr()
		{
		}
		
		public static function GetInstance():StateMgr
		{
			if(stateMgr == null)
			{
				stateMgr = new StateMgr();
			}
			
			return stateMgr;
		}

	}
}