package modules.batchcataloger.UI
{
	import flash.desktop.ClipboardFormats;
	import flash.desktop.NativeDragManager;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.events.NativeDragEvent;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.system.Capabilities;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	import flash.utils.Timer;
	
	import framework.constants.EVENTS;
	import framework.constants.MODULES;
	import framework.dialogs.MessageBox;
	import framework.templates.ADComponent;
	import framework.utils.Helper;
	import framework.utils.ProgressBarEx;
	import framework.utils.WorkInProgress;
	
	import infrastructure.statemanagement.StateMgr;
	
	import modules.batchcataloger.UI.component.TargetLocation;
	import modules.batchcataloger.assets.ActionBar;
	import modules.batchcataloger.assets.MenuButton;
	import modules.batchcataloger.assets.checkbox.CheckBoxHeaderColumn;
	import modules.batchcataloger.assets.checkbox.CheckBoxHeaderRenderer;
	import modules.batchcataloger.assets.checkbox.CheckBoxItemRenderer;
	import modules.batchcataloger.events.CatalogJobDetailEvent;
	import modules.batchcataloger.events.TargetLocationEvent;
	import modules.batchcataloger.framework.constants.ADMODULE;
	import modules.batchcataloger.framework.constants.COMMON;
	import modules.batchcataloger.framework.constants.FILE_TYPE;
	import modules.batchcataloger.framework.constants.QUERY;
	import modules.batchcataloger.framework.constants.STRINGS;
	import modules.batchcataloger.framework.constants.remotemethods.CATALOGERSERVICE;
	import modules.batchcataloger.framework.constants.tables.CATALOGJOBDETAILS;
	import modules.batchcataloger.framework.constants.tables.UPLOADJOB;
	import modules.batchcataloger.framework.upload.UploadManager;
	import modules.cataloger;
	
	import mx.collections.ArrayCollection;
	import mx.collections.Sort;
	import mx.collections.SortField;
	import mx.containers.HDividedBox;
	import mx.controls.Alert;
	import mx.controls.DataGrid;
	import mx.controls.Image;
	import mx.controls.TextInput;
	import mx.controls.dataGridClasses.DataGridColumn;
	import mx.core.ClassFactory;
	import mx.effects.Move;
	import mx.events.CloseEvent;
	import mx.events.FlexEvent;
	import mx.events.ListEvent;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;
	import mx.rpc.remoting.mxml.RemoteObject;
	import mx.utils.StringUtil;

	public class CatalogJob extends ADComponent
	{
		private var JobId:String ="";		
		private var JobName:String ="";
		private var IsJobNew:Boolean = true;
		
		private var jobFolder:File = null;
		private var originalFilesFolder:File = null;
		private var previewFilesFolder:File = null;
		private var thumbnailFilesFolder:File = null;
		
		//action bar
		private var actionBar:ActionBar;
		private var ticker:Timer;
		private var SaveBtn:MenuButton;
		private var SubmitBtn:MenuButton;
		private var CancelBtn:MenuButton;
		private var DropPreviewBtn:MenuButton;
		private var DropThumbnailBtn:MenuButton;
		
		
		private var assetData:DataGrid;	
		private var labelJobName:TextField;
		private var textJobName:TextInput;
		private var targetSelector:TargetSelector;
		private var isSectionCreated:Boolean;
		private var facetInfo:FacetInfo;
		private var thumbnailDropArea:FileDropArea;
		private var previewDropArea:FileDropArea;
		private var addPreviewsArea:MultiFilesDropArea;
		private var addThumbnailsArea:MultiFilesDropArea;
		private var divider:HDividedBox;
		private var unMatchedFiles:Array;
		
		private var thumbTween:Move;
		private var prevTween:Move;
		private var currentCatalogJob:Object;
		
		//state
		private var importing:Boolean = false;
		private var isPrevThumbExpected:Boolean = false;
		
		private var isDropPreview:Boolean = false;
		private var isDropThumbnail:Boolean = false;
		
		[Bindable]
		private var recordset:ArrayCollection;
	//	private var assetlist:ArrayCollection = new ArrayCollection();
		private var ro:RemoteObject;
		
		public function CatalogJob(job:Object)
		{
			
			super();
			this.styleName = "catalogjobscreen";
			
			if(job == null)
			{
				IsJobNew = true;
				
				JobId = Helper.GetCurrentDateTimeStamp();
				JobName = "";
				//JobName = ""+"_"+Helper.GetCurrentDateTimeStamp(false);
				job = new Object();
				job.JOBID = JobId;
				job.JOBNAME = JobName;				
			}
			else
			{
				IsJobNew = false;
				JobId = job.JOBID;
				JobName = Helper.Decode(job.JOBNAME);
			}
			currentCatalogJob = job;
			this.percentWidth =100;
			this.percentHeight =100;
			
		//	throw new Error("");
			this.addEventListener(NativeDragEvent.NATIVE_DRAG_ENTER,onDragIn);
		//	this.addEventListener(NativeDragEvent.NATIVE_DRAG_OVER,onDragOver);
          	this.addEventListener(NativeDragEvent.NATIVE_DRAG_DROP,onDrop);
         	this.addEventListener(NativeDragEvent.NATIVE_DRAG_EXIT,onDragExit);
			ro = StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].Fascade;
          	actionBar = new ActionBar();
			actionBar.percentWidth = 100;
			
			
			this.addEventListener(FlexEvent.CREATION_COMPLETE,onCreationComplete);

			jobFolder = Helper.CreateHotDirectory(COMMON.HOT_FOLDERNAME +"/" +StateMgr.GetInstance().UserId + "/" + JobId);
         	
         	originalFilesFolder = Helper.CreateHotDirectory( COMMON.HOT_FOLDERNAME +"/" +StateMgr.GetInstance().UserId + "/" + JobId + "/" + COMMON.ORIGINAL_FOLDERNAME);
         	
         	previewFilesFolder = Helper.CreateHotDirectory(COMMON.HOT_FOLDERNAME +"/" +StateMgr.GetInstance().UserId + "/" + JobId+ "/" + COMMON.PREVIEW_FOLDERNAME);
         	
         	thumbnailFilesFolder = Helper.CreateHotDirectory(COMMON.HOT_FOLDERNAME +"/" +StateMgr.GetInstance().UserId + "/" + JobId+ "/" + COMMON.THUMBNAIL_FOLDERNAME);
	       
          	//this.addEventListener( MouseEvent.MOUSE_DOWN, mouseDrag );
          	
		}		
		
		protected override function createChildren():void
		{
		//	ticker = new Timer(100); 
           // ticker.addEventListener(TimerEvent.TIMER, Timer_Tick);
          
          
			actionBar.x = 0;
			actionBar.y = 0;
			actionBar.height = 40;
			this.addChild(actionBar);	
			
			//this.addChild(actionBarButtons);	
			SaveBtn = new MenuButton(STRINGS.BUTTON_SAVE_AS_DRAFT);
			SaveBtn.setActualSize(110,30);			
			this.addChild(SaveBtn);
			
			SubmitBtn = new MenuButton(STRINGS.BUTTON_SUBMIT);
			SubmitBtn.setActualSize(115,30);			
			this.addChild(SubmitBtn);
			
			CancelBtn = new MenuButton(STRINGS.BUTTON_CANCEL_JOB);
			CancelBtn.setActualSize(110,30);			
			this.addChild(CancelBtn);
			
			DropPreviewBtn = new MenuButton(STRINGS.BUTTON_ADD_PREVIEWS);
			DropPreviewBtn.setActualSize(195,30);			
			this.addChild(DropPreviewBtn);
			
			DropThumbnailBtn = new MenuButton(STRINGS.BUTTON_ADD_THUMBNAILS);
			DropThumbnailBtn.setActualSize(190,30);			
			this.addChild(DropThumbnailBtn);
			
				
			SaveBtn.addEventListener(MouseEvent.CLICK,saveHandler);
			SubmitBtn.addEventListener(MouseEvent.CLICK,submitHandler);
			CancelBtn.addEventListener(MouseEvent.CLICK,closeHandler);
			DropPreviewBtn.addEventListener(MouseEvent.CLICK, dropPreviewHandler);
			DropThumbnailBtn.addEventListener(MouseEvent.CLICK, dropThumbnailHandler);
						
			var labelformat:TextFormat = new TextFormat();
			labelformat.font = getStyle("labelFontFamily");
			labelformat.color = getStyle("labelFontColor");
			labelformat.size = getStyle("labelFontSize");
			labelformat.bold = true;	
			
			labelJobName = new TextField();
			labelJobName.defaultTextFormat = labelformat;
			labelJobName.autoSize = TextFieldAutoSize.LEFT;
			labelJobName.border=false;
			labelJobName.type= TextFieldType.DYNAMIC;
			labelJobName.selectable=false;
			labelJobName.mouseEnabled=false;
			labelJobName.text = STRINGS.LABEL_JOB_NAME;
			this.addChild(labelJobName);
			
			textJobName = new TextInput();
			textJobName.width = 280;			
			textJobName.height = 22;
			textJobName.styleName = "catalogjob";
			this.addChild(textJobName);
			
			/*datetimeStampLabel = new TextField();
			datetimeStampLabel.defaultTextFormat = labelformat;
			datetimeStampLabel.autoSize = TextFieldAutoSize.LEFT;
			datetimeStampLabel.border=false;
			datetimeStampLabel.type= TextFieldType.DYNAMIC;
			datetimeStampLabel.selectable=false;
			datetimeStampLabel.mouseEnabled=false;
			//datetimeStamp.text = STRINGS.LABEL_JOB_NAME;
			this.addChild(datetimeStampLabel);*/
			
			divider = new HDividedBox();
			divider.setStyle("horizontalGap",2); 
			this.addChild(divider);
         	
			assetData = new DataGrid();
			assetData.percentWidth = 60;
			assetData.percentHeight = 100;
			divider.addChild(assetData);
			assetData.styleName = "assetliststyle";
			assetData.headerHeight = 30;
			assetData.rowHeight = 25;
			assetData.allowMultipleSelection = true;
			assetData.selectable = false;
			assetData.allowDragSelection = false;
			assetData.addEventListener(ListEvent.ITEM_CLICK,singleClickHandler);
			assetData.addEventListener(MouseEvent.CLICK,gridClickHandler);
			
			var gridColumns:Array = new Array(5);
			
			var checkBoxColumn:CheckBoxHeaderColumn = new CheckBoxHeaderColumn();
			checkBoxColumn.headerText = "";
			checkBoxColumn.dataField = "SELECTED";
			checkBoxColumn.resizable = false;
			checkBoxColumn.sortable = false;
			checkBoxColumn.headerRenderer = new ClassFactory(CheckBoxHeaderRenderer);
			checkBoxColumn.itemRenderer = new ClassFactory(CheckBoxItemRenderer);
			checkBoxColumn.width = 5;
			checkBoxColumn.addEventListener(MouseEvent.CLICK,headerClickHandler);
			gridColumns[0] = checkBoxColumn;
			
			var originalGridColumn:DataGridColumn = new DataGridColumn();
			originalGridColumn.headerText = STRINGS.JOBDETAILS_ORIGINAL;
			originalGridColumn.labelFunction = assetData_LabelFunc;
			originalGridColumn.dataField = CATALOGJOBDETAILS.ORIGINAL;
			originalGridColumn.width = 30;
			gridColumns[1] = originalGridColumn;
			
			var previewGridColumn:DataGridColumn = new DataGridColumn();
			previewGridColumn.headerText = STRINGS.JOBDETAILS_PREVIEW;
			previewGridColumn.dataField = CATALOGJOBDETAILS.PREVIEW;
			previewGridColumn.labelFunction = assetData_LabelFunc;
			previewGridColumn.width = 10;
			gridColumns[2] = previewGridColumn;
			
			var thumbnailGridColumn:DataGridColumn = new DataGridColumn();
			thumbnailGridColumn.headerText = STRINGS.JOBDETAILS_THUMBNAIL;
			thumbnailGridColumn.labelFunction = assetData_LabelFunc;
			thumbnailGridColumn.dataField = CATALOGJOBDETAILS.THUMBNAIL;
			thumbnailGridColumn.width = 10;
			gridColumns[3] = thumbnailGridColumn;	
			
			
		/*	var descriptionGridColumn:DataGridColumn = new DataGridColumn();
			descriptionGridColumn.headerText = STRINGS.JOBDETAILS_DESCRIPTION;
			descriptionGridColumn.labelFunction = assetData_LabelFunc;
			descriptionGridColumn.dataField = CATALOGJOBDETAILS.DESCRIPTION;
			descriptionGridColumn.width = 10;
			gridColumns[4] = descriptionGridColumn;
			
			var expiryGridColumn:DataGridColumn = new DataGridColumn();
			expiryGridColumn.headerText = STRINGS.JOBDETAILS_EXPIRYDATE;
			expiryGridColumn.labelFunction = assetData_LabelFunc;
			expiryGridColumn.dataField = CATALOGJOBDETAILS.EXPIRYDATE;
			expiryGridColumn.width = 20;
			gridColumns[5] = expiryGridColumn;
		*/	
			var targetGridColumn:DataGridColumn = new DataGridColumn();
			targetGridColumn.headerText = STRINGS.JOBDETAILS_TARGETLOCATION;
			targetGridColumn.dataField = CATALOGJOBDETAILS.TARGETLOCATION;
			targetGridColumn.width = 30;
			targetGridColumn.itemRenderer = new ClassFactory(TargetLocation);
			gridColumns[4] = targetGridColumn;
			
			assetData.columns = gridColumns;
			
			assetData.addEventListener(TargetLocationEvent.SELECT,targetLocationSelectHandler);
			
			facetInfo = new FacetInfo(currentCatalogJob);
			facetInfo.percentWidth = 40;
			facetInfo.percentHeight = 100;				
			facetInfo.styleName = "facetInfoStyle";
			
			addPreviewsArea = new MultiFilesDropArea(true);
			addPreviewsArea.percentWidth = 65;
			addPreviewsArea.percentHeight = 100;
			addPreviewsArea.styleName = "addPreviewsStyle";
			
			addPreviewsArea.addEventListener(CatalogJobDetailEvent.PREVIEWS_THUMBNAILS_DROPPED, previewsThumbnailsDroppedHandler)
			addPreviewsArea.addEventListener(CatalogJobDetailEvent.UNMATCHED_FILES_ERROR_CANCEL, unmatchedFilesErrorCancelHandler)
			addPreviewsArea.addEventListener(CatalogJobDetailEvent.PREVIEWS_THUMBNAILS_DROP_CANCEL, previewsThumbnailsDropCancelHandler)
			
			addThumbnailsArea = new MultiFilesDropArea();
			addThumbnailsArea.percentWidth = 65;
			addThumbnailsArea.percentHeight = 100;
			addThumbnailsArea.styleName = "addThumbnailsStyle";
			
			addThumbnailsArea.addEventListener(CatalogJobDetailEvent.PREVIEWS_THUMBNAILS_DROPPED, previewsThumbnailsDroppedHandler)
			addThumbnailsArea.addEventListener(CatalogJobDetailEvent.UNMATCHED_FILES_ERROR_CANCEL, unmatchedFilesErrorCancelHandler)
			addThumbnailsArea.addEventListener(CatalogJobDetailEvent.PREVIEWS_THUMBNAILS_DROP_CANCEL, previewsThumbnailsDropCancelHandler)
			
			divider.addChild(facetInfo);
			
			targetSelector = new TargetSelector();			
			targetSelector.visible = false;
			this.addChild(targetSelector);
			
			targetSelector.addEventListener(TargetLocationEvent.TARGET_CHANGE,targetLocationChangeHandler);
			targetSelector.addEventListener(TargetLocationEvent.SECTION_CREATED,sectionCreatedHandler);		
			
			thumbnailDropArea = new FileDropArea(STRINGS.LABEL_DROP_THUMBNAIL_HERE);
			thumbnailDropArea.visible = false;
			this.addChild(thumbnailDropArea);
			
			previewDropArea = new FileDropArea(STRINGS.LABEL_DROP_PREVIEW_HERE);
			previewDropArea.visible = false;
			this.addChild(previewDropArea);
			
			textJobName.text = JobName;
			//textJobName.text = JobName.split('_')[0];
			//datetimeStampLabel.text = "_"+JobName.split('_')[1];
			this.systemManager.stage.focus = textJobName;
			this.addEventListener(KeyboardEvent.KEY_UP,keyboardHandler);
			
			if(JobId != "")
			{
				cataloger.da.DataAccessSelect("select 'false' as SELECTED,* from CATALOGJOBDETAILS where JOBID =" + JobId,resultHandler)
			} 
			facetInfo.Init();
		}
		public function setText():void
		{
			SaveBtn.label = STRINGS.BUTTON_SAVE_AS_DRAFT;
			SubmitBtn.label = STRINGS.BUTTON_SUBMIT;
			CancelBtn.label = STRINGS.BUTTON_CANCEL_JOB;
			DropPreviewBtn.label = STRINGS.BUTTON_ADD_PREVIEWS;
			DropThumbnailBtn.label = STRINGS.BUTTON_ADD_THUMBNAILS;
			labelJobName.text = STRINGS.LABEL_JOB_NAME;
			
			assetData.columns[1].headerText = STRINGS.JOBDETAILS_ORIGINAL;
			assetData.columns[2].headerText = STRINGS.JOBDETAILS_PREVIEW;
			assetData.columns[3].headerText = STRINGS.JOBDETAILS_THUMBNAIL;
			assetData.columns[4].headerText = STRINGS.JOBDETAILS_TARGETLOCATION;
			
			thumbnailDropArea.setText(STRINGS.LABEL_DROP_THUMBNAIL_HERE);
			previewDropArea.setText(STRINGS.LABEL_DROP_PREVIEW_HERE);
			
			addThumbnailsArea.setText();
			addPreviewsArea.setText();
			targetSelector.setText();
			facetInfo.setText();
		}
		
		private function assetData_LabelFunc(item:Object, dgCol:DataGridColumn):String
		{
			return Helper.Decode(item[dgCol.dataField].toString());
		}
		
		private var currentRecord:Object;
		private function targetLocationSelectHandler(evt:TargetLocationEvent):void
		{
			currentRecord = evt.Data;
			if(assetData.selectedIndices != null && assetData.selectedIndices.length>1)
			{
				targetSelector.Show("");
			}
			else
			{
				targetSelector.Show(currentRecord.TARGETLOCATIONID);
			}
		}
		
		private function targetLocationChangeHandler(evt:TargetLocationEvent):void
		{
			try
			{
				if(assetData.selectedIndices != null && assetData.selectedIndices.length>1)
				{
					if(assetData.selectedItems.indexOf(currentRecord) > -1)
					{
						for(var i:int=0;i<assetData.selectedIndices.length; i++)
						{
							
							recordset[assetData.selectedIndices[i]].TARGETLOCATIONID = evt.Data.@NodeData;
							recordset[assetData.selectedIndices[i]].TARGETLOCATION = evt.Data.@Path;
							recordset.itemUpdated(recordset[assetData.selectedIndices[i]]);
						}
					}
					else
					{
						currentRecord.TARGETLOCATIONID = evt.Data.@NodeData;
						currentRecord.TARGETLOCATION = evt.Data.@Path;
						recordset.itemUpdated(currentRecord);
					}
				}
				else
				{
					//Alert.show(evt.Data.@NodeData + "-" + evt.Data.@Text);
					currentRecord.TARGETLOCATIONID = evt.Data.@NodeData;
					currentRecord.TARGETLOCATION = evt.Data.@Path;
					recordset.itemUpdated(currentRecord);
				}
			}
			catch(ex:Error)
			{
				MessageBox.Show(ex.toString(),"Target Location");
			}		
		}
		
		protected override function childrenCreated():void
		{
			WorkInProgress.Hide(STRINGS.WIP_LOADING);
		}
		
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			this.graphics.clear();
			this.graphics.beginFill(getStyle("backgroundColor"),1);
			this.graphics.drawRect(0, 0, unscaledWidth, unscaledHeight);
			
			actionBar.x = 0;
			actionBar.y = 0;
			actionBar.width = unscaledWidth;
			
			SaveBtn.x= 10;
			SaveBtn.y =(actionBar.height-SaveBtn.height)/2;
			
			SubmitBtn.x= SaveBtn.x+SaveBtn.width + 10;
			SubmitBtn.y = SaveBtn.y;
			
			CancelBtn.x= SubmitBtn.x+SubmitBtn.width + 10;
			CancelBtn.y = SaveBtn.y;
			
			DropPreviewBtn.x= CancelBtn.x+CancelBtn.width + 10;
			DropPreviewBtn.y = SaveBtn.y;
			
			DropThumbnailBtn.x= DropPreviewBtn.x+DropPreviewBtn.width + 10;
			DropThumbnailBtn.y = SaveBtn.y;
			
			divider.x =0;
			divider.y = textJobName.y	+ textJobName.height +20;
			divider.width = unscaledWidth;
			divider.height = unscaledHeight - divider.y;
			
			labelJobName.x =3;
			labelJobName.y =actionBar.height + 10;
			
			textJobName.x =labelJobName.x +labelJobName.width + 10; 
			textJobName.y = labelJobName.y;
			
			/*datetimeStampLabel.x = textJobName.x + textJobName.width + 10;
			datetimeStampLabel.y = labelJobName.y;*/
			
			/*assetData.x=0;
			assetData.y= 0;
			assetData.width = unscaledWidth *50/100;			
			assetData.height = unscaledHeight - assetData.y -5;
			
			facetInfo.x = assetData.x + assetData.width+1;
			facetInfo.y = assetData.y;
			facetInfo.width = unscaledWidth - assetData.width;
			facetInfo.height = assetData.height;
			*/
			
			targetSelector.width = unscaledWidth;
			targetSelector.height= unscaledHeight;
		}
		
		private function onCreationComplete(event:FlexEvent):void
		{
			if(JobId != "")
			{
			 
			}
		}	
		
		
		
		public function mouseDrag(event:MouseEvent):void
		{	
			stage.nativeWindow.startMove();
		}
		
		private var thumbTweening:Boolean = false;
		private var prevTweening:Boolean = false;
		
		private function onDragExit(event:NativeDragEvent):void
		{
			thumbnailDropArea.visible = false;
			previewDropArea.visible = false;
			
		}
		
		private function onDragOver(event:NativeDragEvent):void
		{
			//Alert.show("sdasa");
		}
		  
		private function onDragIn(event:NativeDragEvent):void
		{	
			if (!isDropPreview && !isDropThumbnail)
			{
				unMatchedFiles = new Array();
				
				var files:Array = event.clipboard.getData(ClipboardFormats.FILE_LIST_FORMAT) as Array;
				
				//Alert.show(files.length.toString());    
				if(files != null && files.length > 0)
				{
					if(isPrevThumbExpected && files.length ==1)
					{
						if(!thumbnailDropArea.visible)
						{
							//callLater(ShowThumbnailHandlers);
						
						}			    
			 		}
			      	NativeDragManager.acceptDragDrop(this);
			    }
		 	}
        }
        
        private function ShowThumbnailHandlers():void
        {
        	previewDropArea.width = this.width/2;
			previewDropArea.height = this.height;
			previewDropArea.x = 0;
			previewDropArea.y = 0;
			previewDropArea.visible = true;
							
			thumbnailDropArea.width = this.width - previewDropArea.width;
			thumbnailDropArea.height = this.height;
			thumbnailDropArea.x = this.width/2;
			thumbnailDropArea.y = 0;
			thumbnailDropArea.visible = true;
			this.invalidateDisplayList();
        }
        
        private function resultHandler(result:ArrayCollection):void
		{
		  	recordset = result;
		  	
			assetData.dataProvider = recordset;		  	
		}
		
		private function fileCopyHandler(evt:Event):void
		{
			ProgressBarEx.SetProgress(copied,totalfiles);
			
            if((copied +1) >= totalfiles)
	         {
	         	ProgressBarEx.Hide();
				if (unMatchedFiles.length > 0)
				{	
	   				if (isDropPreview)
	   					addPreviewsArea.dispatchEvent(new CatalogJobDetailEvent(CatalogJobDetailEvent.UNMATCHED_FILES_ERROR, unMatchedFiles));
	   				else
	   					addThumbnailsArea.dispatchEvent(new CatalogJobDetailEvent(CatalogJobDetailEvent.UNMATCHED_FILES_ERROR, unMatchedFiles));
	   			}
	   			else
	   			{
	   				if (isDropPreview)
	   				{
	   					divider.removeChild(addPreviewsArea);
   						DropPreviewBtn.enabled = true;
	   					divider.addChild(facetInfo);
	         			isDropPreview = false;
   					}
   					else if (isDropThumbnail)
   					{
   						divider.removeChild(addThumbnailsArea);
	   					DropThumbnailBtn.enabled = true;
	   					divider.addChild(facetInfo);
	   					isDropThumbnail = false;
	   				}
	   			}
	         	//IsPreview = false;
	         	//IsThumbnail = false;
	         }
			copied++; 	          
	        CopyFile();	 
		}
		
		private function fileCopyIOErrorEventHandler(evet:IOErrorEvent):void
		{
		  	ProgressBarEx.Hide();
		  	MessageBox.Show("An error occured while copying the files.");
			StateMgr.GetInstance().logger.Write(ADMODULE.JOBDETAILS,"fileCopyIOErrorEventHandler()",evet.toString());
		}
		
		private var current_dropped_filename:File = null;
		private function CopyFile():void
		{
			try
			{
				
				var orgName:String = "";
				var file:File = dropfiles[copied];
	          	if(file != null)
	          	{	
					file.addEventListener(Event.COMPLETE,fileCopyHandler);
					file.addEventListener(IOErrorEvent.IO_ERROR, fileCopyIOErrorEventHandler);
	          		
	          		var checkFileExist:File = null;
	          		var fileExists:Boolean = false;
					current_dropped_filename = file;
					
	          		if(!isDropPreview && !isDropThumbnail)
	          		{   
			            checkFileExist = new File(originalFilesFolder.nativePath + "/" + file.name);
						if (checkFileExist.exists)
						{
							MessageBox.Show(STRINGS.ORIGINAL_FILE_ALREADY_PRESENT);
							fileExists = true;
						}
						else if (!checkFileExist.exists)
			            {
				            var record:Array = new Array();
				            record[CATALOGJOBDETAILS.JOBDETAILSID]= Helper.GetCurrentDateTimeStamp() + copied.toString();
							record[CATALOGJOBDETAILS.ORIGINAL] = Helper.Encode(file.name);
							record[CATALOGJOBDETAILS.PREVIEW] = "";
							record[CATALOGJOBDETAILS.THUMBNAIL] = "";
							record[CATALOGJOBDETAILS.DESCRIPTION] = "";
							record[CATALOGJOBDETAILS.EXPIRYDATE] = "";
							record[CATALOGJOBDETAILS.TARGETLOCATION] ="";
							record[CATALOGJOBDETAILS.TARGETLOCATIONID] ="";
							record[CATALOGJOBDETAILS.METADATA] ="";
							record["SELECTED"] ="false";
							recordset.addItem(record);
							
							file.copyToAsync(originalFilesFolder.resolvePath(file.name),true);
			            }
			            else
			            	fileExists = true;
	          		}
	          		else if (isDropPreview)
	          		{	
	          			checkFileExist = new File(previewFilesFolder.nativePath + "/" + file.name);
						
						if (checkFileExist.exists)
						{
							MessageBox.Show(STRINGS.REPLACE_PREVIEW_FILES_CONFIRMATION,STRINGS.MESSAGE_HEADER_CONFIRM,prvfilereplaceHandler,
								MessageBox.YES|MessageBox.NO);
						}
						else if (!checkFileExist.exists)
			            {
		          			var isPreviewMatched:Boolean = false;
		          			for (var i:int = 0; i < recordset.length; i++)
		          			{	
		          				orgName = Helper.Decode(recordset[i][CATALOGJOBDETAILS.ORIGINAL]);
	          					//orgName = Helper.Decode(orgName.substring(0,orgName.lastIndexOf(".")));
		          				if (orgName.toUpperCase() == file.name.substring(0,file.name.lastIndexOf(".")).toUpperCase())
		          				{
		          					isPreviewMatched = true;
		          					recordset[i][CATALOGJOBDETAILS.PREVIEW] = Helper.Encode(file.name);
		          					recordset.itemUpdated(recordset[i][CATALOGJOBDETAILS.PREVIEW]);
		          					break;
		          				}
		          			}
		          			if (!isPreviewMatched)
		          			{ 
		          				unMatchedFiles.push(file.name);
		          				file.dispatchEvent(new Event(Event.COMPLETE));
		          			}
		          			else
		          				file.copyToAsync(previewFilesFolder.resolvePath(file.name),true);
			            }
			            else
			            	fileExists = true;
	          		}
	          		else if (isDropThumbnail)
	          		{
	          			checkFileExist = new File(thumbnailFilesFolder.nativePath + "/" + file.name);
						if (checkFileExist.exists)
						{
							MessageBox.Show(STRINGS.REPLACE_THUMBNAIL_FILES_CONFIRMATION,STRINGS.MESSAGE_HEADER_CONFIRM,thbfilereplaceHandler,
								MessageBox.YES|MessageBox.NO);
						}
						else if (!checkFileExist.exists)
			            {
		          			var isThumbnailMatched:Boolean = false;
		          			for (var j:int = 0; j < recordset.length; j++)
		          			{	
		          				orgName = Helper.Decode(recordset[j][CATALOGJOBDETAILS.ORIGINAL]);
		          				//orgName = Helper.Decode(orgName.substring(0,orgName.lastIndexOf(".")));
		          				if (orgName.toUpperCase() == file.name.substring(0,file.name.lastIndexOf(".")).toUpperCase())
		          				{
		          					isThumbnailMatched = true;
		          					recordset[j][CATALOGJOBDETAILS.THUMBNAIL] = Helper.Encode(file.name);
		          					recordset.itemUpdated(recordset[j][CATALOGJOBDETAILS.THUMBNAIL]);
		          					break;
		          				}
		          			}
		          			if (!isThumbnailMatched)
		          			{ 
		          				unMatchedFiles.push(file.name);
		          				file.dispatchEvent(new Event(Event.COMPLETE));
		          			}
		          			else
	          				file.copyToAsync(thumbnailFilesFolder.resolvePath(file.name),true);
			            }
			            else
			            	fileExists = true;
	          		}
	          		/*else if(IsPreview)
	          		{
	          			recordset[assetData.selectedIndices[0]][CATALOGJOBDETAILS.PREVIEW] = file.name;
	          			file.copyToAsync(previewFilesFolder.resolvePath(Helper.Decode(recordset[assetData.selectedIndices[0]][CATALOGJOBDETAILS.ORIGINAL].toString()) + "." + file.extension),true);
	          			recordset.itemUpdated(recordset[assetData.selectedIndices[0]][CATALOGJOBDETAILS.PREVIEW]);
	          		}
	          		else if (IsThumbnail)
	          		{
	          			recordset[assetData.selectedIndices[0]][CATALOGJOBDETAILS.THUMBNAIL] = file.name;
	          			file.copyToAsync(thumbnailFilesFolder.resolvePath(Helper.Decode(recordset[assetData.selectedIndices[0]][CATALOGJOBDETAILS.ORIGINAL].toString()) + "." + file.extension),true);
	          			recordset.itemUpdated(recordset[assetData.selectedIndices[0]][CATALOGJOBDETAILS.THUMBNAIL]);
	          		}*/
	          		else
	          		{
	          			//file.dispatchEvent(new Event(Event.COMPLETE));
	          		}
	          		
	          		if (fileExists)
	          			file.dispatchEvent(new Event(Event.COMPLETE));
	          	}
		  }
		  catch(ex:Error)
		  {
		  	StateMgr.GetInstance().logger.Write(ADMODULE.JOBDETAILS,"CopyFile()",ex.toString());
		  }
		}
		
		private function thbfilereplaceHandler(evt:CloseEvent):void
		{
			var isPreviewMatched:Boolean = false;
			
			if(evt.detail == MessageBox.YES && current_dropped_filename != null)
			{
				var isThumbnailMatched:Boolean = false;
				for (var j:int = 0; j < recordset.length; j++)
				{	
					var orgName:String = Helper.Decode(recordset[j][CATALOGJOBDETAILS.ORIGINAL]);
					
					if (orgName.toUpperCase() == current_dropped_filename.name.substring(0,current_dropped_filename.name.lastIndexOf(".")).toUpperCase())
					{
						isThumbnailMatched = true;
						recordset[j][CATALOGJOBDETAILS.THUMBNAIL] = Helper.Encode(current_dropped_filename.name);
						recordset.itemUpdated(recordset[j][CATALOGJOBDETAILS.THUMBNAIL]);
						break;
					}
				}
				if (!isThumbnailMatched)
				{ 
					unMatchedFiles.push(current_dropped_filename.name);
					current_dropped_filename.dispatchEvent(new Event(Event.COMPLETE));
				}
				else
					current_dropped_filename.copyToAsync(thumbnailFilesFolder.resolvePath(current_dropped_filename.name),true);
			}//if(evt.detail == MessageBox.OK && current_dropped_filename != null)
			else
			{
				//If File exists and if User Do not want to replace the file then nothing will happen and the Complete Event should be thrown
				//to hide the import bar
				current_dropped_filename.dispatchEvent(new Event(Event.COMPLETE));
			}
		}
		
		private function prvfilereplaceHandler(evt:CloseEvent):void
		{
			var isPreviewMatched:Boolean = false;
			
			if(evt.detail == MessageBox.YES && current_dropped_filename != null)
			{
				for (var i:int = 0; i < recordset.length; i++)
				{	
					var orgName:String = Helper.Decode(recordset[i][CATALOGJOBDETAILS.ORIGINAL]);
					
					if (orgName.toUpperCase() == current_dropped_filename.name.substring(0,current_dropped_filename.name.lastIndexOf(".")).toUpperCase())
					{
						isPreviewMatched = true;
						recordset[i][CATALOGJOBDETAILS.PREVIEW] = Helper.Encode(current_dropped_filename.name);
						recordset.itemUpdated(recordset[i][CATALOGJOBDETAILS.PREVIEW]);
						break;
					}
				}
				if (!isPreviewMatched)
				{ 
					unMatchedFiles.push(current_dropped_filename);
					current_dropped_filename.dispatchEvent(new Event(Event.COMPLETE));
				}
				else
					current_dropped_filename.copyToAsync(previewFilesFolder.resolvePath(current_dropped_filename.name),true);
			}//if(evt.detail == MessageBox.OK && current_dropped_filename != null)
			else
			{
				//If File exists and if User Do not want to replace the file then nothing will happen and the Complete Event should be thrown
				//to hide the import bar
				current_dropped_filename.dispatchEvent(new Event(Event.COMPLETE));
			}
		}
		
		private static var copied:int = -1;
		private var totalfiles:int = -1;
		private var dropfiles:Array = null;
		/*private var IsThumbnail:Boolean = false;
		private var IsPreview:Boolean = false;*/		
		
		private function onDrop(event:NativeDragEvent):void
        { 
			  if (!isDropPreview && !isDropThumbnail)
			  {
				  thumbnailDropArea.visible = false;		  
				  previewDropArea.visible = false;
				  					 
				  /*IsThumbnail =  false;
				  IsPreview = false;*/
				  
			  	  dropfiles = event.clipboard.getData(ClipboardFormats.FILE_LIST_FORMAT) as Array; 
			  	  
			      if(dropfiles != null && dropfiles.length > 0)
			      {
			  	     if(isPrevThumbExpected && dropfiles.length ==1)
					  {
						//isDropPreview = false;
						//isDropThumbnail = false;
						/*if(thumbnailDropArea.hitTestPoint(event.localX,event.localY))
						{
							IsThumbnail = true;
						}
						else if(previewDropArea.hitTestPoint(event.localX,event.localY))
						{
							IsPreview = true;
						}*/
					  }			      
			       	 totalfiles = dropfiles.length;
					 copied = 0;		
					      	          
			      	 ProgressBarEx.Show(copied,totalfiles);
					 callLater(CopyFile);
			  	  }
		  	  }     
        }
        
        
        private function previewsThumbnailsDroppedHandler(evt:CatalogJobDetailEvent):void
        {
        	unMatchedFiles = new Array();
        	
        	dropfiles = evt.Data as Array;
        	totalfiles = dropfiles.length;
        	copied = 0;
        	
        	ProgressBarEx.Show(copied,totalfiles);
			callLater(CopyFile); 
        }
          
        private function addImage(nativePath:String):void
          {
            var i:Image = new Image();
            i.width = 100;
            i.height = 80;
            if(Capabilities.os.search("Mac") >= 0){
              i.source = "file://" + nativePath;
            } else {
              i.source = nativePath;
            }
            this.addChild(i);
          }
          
        private function saveHandler(evt:MouseEvent):void
		{
			WorkInProgress.Show(STRINGS.WIP_SAVING);
			
			if(facetInfo.saveBtn != null && facetInfo.saveBtn.enabled && facetInfo.selectedFacets.length > 0)
			{
				MessageBox.Show(STRINGS.CONFIRM_SAVE_BUSINESSINFO,STRINGS.MESSAGE_HEADER_CONFIRM,SaveJob,MessageBox.OK|MessageBox.CANCEL);
			}
			else
			{
				this.callLater(SaveJob);					
			}	
		}
		
		private function SaveJob(evt:CloseEvent=null):void
		{
			try
			{		
				if (String(currentCatalogJob.STATUS).split("_")[0] == COMMON.JOB_STATUS_ERROR)
				{	
					if (currentCatalogJob.NEWJOBNAME == null || currentCatalogJob.NEWJOBNAME == "")
					{	
						if (textJobName.text != Helper.Decode(currentCatalogJob.JOBNAME)) 
							cataloger.da.DataAccessUpdate("UPDATE CATALOGJOB SET NEWJOBNAME = '"+Helper.Encode(textJobName.text)+"' WHERE JOBID="+JobId,QUERY.SELECT_CATALOGJOB);
						else
						{
							MessageBox.Show(STRINGS.MESSAGE_CHANGE_JOBNAME);
							WorkInProgress.Hide(STRINGS.WIP_SAVING);
							return;
						}
					}
				}
				
				var isBusinessInfoValid:Boolean = true;
				if(evt != null && evt.detail == MessageBox.OK)
		        {
		        	isBusinessInfoValid = facetInfo.GetBusinessInfo();
		        }
				
				if (isSectionCreated)
					SaveNewSectionHeirarchy();
				
				if(ValidateData(COMMON.JOB_STATUS_DRAFT) && isBusinessInfoValid)
				{	
					if(IsJobNew)
					{
						UpdateRecord(COMMON.JOB_STATUS_DRAFT,true, "MD_CATALOGER_JOBSTATUS_DRAFT");
					}
					else
					{	
						UpdateRecord(COMMON.JOB_STATUS_DRAFT, false, "MD_CATALOGER_JOBSTATUS_DRAFT");
					}
					UpdateCatalogJobDetailsTable(0,recordset.length);
					close();
				}
				else
				{					
					WorkInProgress.Hide(STRINGS.WIP_SAVING);
				}
				
			}
			catch(ex:Error)
			{	
				MessageBox.Show(ex.toString());
			}
		}
		
		private function submitHandler(evt:MouseEvent):void
		{
			WorkInProgress.Show(STRINGS.WIP_SUBMITTING);
			
			if(facetInfo.saveBtn != null && facetInfo.saveBtn.enabled && facetInfo.selectedFacets.length > 0)
			{
				MessageBox.Show(STRINGS.CONFIRM_SAVE_BUSINESSINFO,STRINGS.MESSAGE_HEADER_CONFIRM,SubmitJob,MessageBox.OK|MessageBox.CANCEL);
			}
			else
			{
				this.callLater(SubmitJob);				
			}
		}
		
		private var MsgBxSelectedBtn:String = "";		
		private function SubmitJob(evt:CloseEvent=null):void
		{
			try
			{	
				if(evt != null && evt.detail == MessageBox.OK)
					MsgBxSelectedBtn = "MessageBox_OK";
				
				if(StringUtil.trim(textJobName.text) == "")
				{
					MessageBox.Show(STRINGS.ERROR_JOB_NAME_IS_MANDATORY,STRINGS.MESSAGE_HEADER_ERROR,jobNameErrorHandler);
					WorkInProgress.Hide(STRINGS.WIP_SUBMITTING);
					return;
				}
				
				//check If Job with the same name already exists or not on Cataloger mount point							
				ro.getOperation(CATALOGERSERVICE.ISJOBWITHSAMENAMEEXISTSONMOUNTPOINT).removeEventListener(ResultEvent.RESULT,ValidateJobHandler);
				ro.getOperation(CATALOGERSERVICE.ISJOBWITHSAMENAMEEXISTSONMOUNTPOINT).addEventListener(ResultEvent.RESULT,ValidateJobHandler);				
				ro.isJobWithSameNameExistsOnMountPoint(StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerMoutPoint,StateMgr.GetInstance().UserId, StringUtil.trim(textJobName.text));			
			}	
			catch(ex:Error)
			{
				MessageBox.Show(ex.toString());
			}
		}
		
		private function ValidateJobHandler(evt:ResultEvent):void
		{
			try
			{		
				//Remove Event Listener, so that it will not be called more than once.
				ro.getOperation(CATALOGERSERVICE.ISJOBWITHSAMENAMEEXISTSONMOUNTPOINT).removeEventListener(ResultEvent.RESULT,ValidateJobHandler);
				
				var isJobWithSameNameExists:String 	= evt.result as String;
				if(isJobWithSameNameExists.toUpperCase() == "TRUE")
				{					
					MessageBox.Show(STRINGS.MESSAGE_JOBNAME_ALREADY_EXISTS);
					WorkInProgress.Hide(STRINGS.WIP_SUBMITTING);
					this.systemManager.stage.focus = textJobName;						
				}
				else
				{
					if (String(currentCatalogJob.STATUS).split("_")[0] == COMMON.JOB_STATUS_ERROR)
					{
						if (currentCatalogJob.NEWJOBNAME == null || currentCatalogJob.NEWJOBNAME == "")
						{	
							if (textJobName.text != Helper.Decode(currentCatalogJob.JOBNAME)) 
								cataloger.da.DataAccessUpdate("UPDATE CATALOGJOB SET NEWJOBNAME = '"+Helper.Encode(textJobName.text)+"' WHERE JOBID="+JobId,QUERY.SELECT_CATALOGJOB);
							else
							{
								MessageBox.Show(STRINGS.MESSAGE_CHANGE_JOBNAME);
								WorkInProgress.Hide(STRINGS.WIP_SUBMITTING);
								return;
							}
						}
					}
									
					var isBusinessInfoValid:Boolean = true;
					if(MsgBxSelectedBtn == "MessageBox_OK")
					{
						isBusinessInfoValid = facetInfo.GetBusinessInfo();
					}
					
					if (isSectionCreated)
						SaveNewSectionHeirarchy();
					
					if(ValidateData(COMMON.JOB_DROP_INPROGRESS) && isBusinessInfoValid)
					{	
						if(IsJobNew)
						{	
							UpdateRecord(COMMON.JOB_DROP_INPROGRESS,true, "MD_CATALOGER_JOBSTATUS_DROP_INPROGRESS");
						}
						else
						{
							UpdateRecord(COMMON.JOB_DROP_INPROGRESS, false, "MD_CATALOGER_JOBSTATUS_DROP_INPROGRESS");
						}
						UpdateCatalogJobDetailsTable(0,recordset.length);
						UpdateUploadJobTable(0,recordset.length);
						
						cataloger.da.DataAccessUpdate("UPDATE CATALOGJOB SET NEWJOBNAME = '' WHERE JOBID="+JobId,QUERY.SELECT_CATALOGJOB);
					}
					else
					{					
						WorkInProgress.Hide(STRINGS.WIP_SUBMITTING);
					}
				}					
				
			}	
			catch(ex:Error)
			{
				MessageBox.Show(ex.toString());
			}
		}
		
		private function ValidateData(status:String):Boolean
		{
			//if(StringUtil.trim(textJobName.text.split('_')[0]) == "")
			if(StringUtil.trim(textJobName.text) == "")
			{
				MessageBox.Show(STRINGS.ERROR_JOB_NAME_IS_MANDATORY,STRINGS.MESSAGE_HEADER_ERROR,jobNameErrorHandler);
				return false;
			}
			else if (textJobName.text.indexOf("\\") >= 0 || textJobName.text.indexOf("/") >= 0 || textJobName.text.indexOf(":") >= 0 || textJobName.text.indexOf("*") >= 0 || textJobName.text.indexOf("?") >= 0 || textJobName.text.indexOf('"') >= 0 || textJobName.text.indexOf("<") >= 0 || textJobName.text.indexOf(">") >= 0 || textJobName.text.indexOf("|") >= 0)
			{
				MessageBox.Show(STRINGS.ERROR_JOB_NAME_SPECIALCHARS + ' \\ / : * ? " < > |', STRINGS.MESSAGE_HEADER_ERROR, jobNameErrorHandler);
				return false;
			}  
			if(status == COMMON.JOB_DROP_INPROGRESS)
			{
				for(var j:int=0;j<recordset.length; j++)
				{	
					if(recordset[j].TARGETLOCATION == "")
					{
						MessageBox.Show(STRINGS.ERROR_TARGET_LOCATION_NOT_SET_FOR_ALL_ASSETS,STRINGS.MESSAGE_HEADER_ERROR,targetLocationErrorHandler);
						return false;
					}
				}
			}
			
			return true;
		}
		
		private function jobNameErrorHandler(evt:Event):void
		{
			this.systemManager.stage.focus = textJobName;
		}
		
		private function targetLocationErrorHandler(evt:Event):void
		{
			this.systemManager.stage.focus = assetData;
		}
		
		private function UpdateUploadJobTable(i:int,total:int):void
		{
			if(i < total)
			{
			  		var sql:String = "";
			  		var extension:String = "";
			  		var filename:String = "";
			  		var filenameArray:Array;
			  		 
			  		filename = Helper.Decode(recordset[i][CATALOGJOBDETAILS.ORIGINAL].toString());
			  		var file:File = originalFilesFolder.resolvePath(filename);
			  		sql = "INSERT INTO UPLOADJOB (" + 
								UPLOADJOB.JOBID+","+UPLOADJOB.FILE+","+UPLOADJOB.FILEPATH+","+UPLOADJOB.TYPE+","+UPLOADJOB.UPLOADEDBYTES+","+UPLOADJOB.TOTALBYTES+","+UPLOADJOB.UPLOADED+") " + 
								"VALUES ("+ JobId+",'"+Helper.Encode(filename)+"','"+Helper.Encode(file.nativePath)+"','"+FILE_TYPE.ORIGINAL+"',0,"+file.size.toString()+",0)";
						cataloger.da.DataAccessInsert(sql);
						
						if(recordset[i][CATALOGJOBDETAILS.THUMBNAIL].toString() != "")
						{
							filename = Helper.Decode(recordset[i][CATALOGJOBDETAILS.THUMBNAIL].toString()); 
							filenameArray = filename.split(".");
							extension = filenameArray[filenameArray.length-1];
							
							file = thumbnailFilesFolder.resolvePath(Helper.Decode(recordset[i][CATALOGJOBDETAILS.ORIGINAL].toString()) + "." + extension);
							sql = "INSERT INTO UPLOADJOB (" + 
								UPLOADJOB.JOBID+","+UPLOADJOB.FILE+","+UPLOADJOB.FILEPATH+","+UPLOADJOB.TYPE+","+UPLOADJOB.UPLOADEDBYTES+","+UPLOADJOB.TOTALBYTES+","+UPLOADJOB.UPLOADED+") " + 
								"VALUES ("+ JobId+",'"+Helper.Encode(file.name)+"','"+Helper.Encode(file.nativePath)+"','"+FILE_TYPE.THUMBNAIL+"',0,"+file.size.toString()+",0)";
							cataloger.da.DataAccessInsert(sql);
						}
						
						if(recordset[i][CATALOGJOBDETAILS.PREVIEW].toString() != "")
						{
							filename = Helper.Decode(recordset[i][CATALOGJOBDETAILS.PREVIEW].toString()); 
							filenameArray = filename.split(".");
							extension = filenameArray[filenameArray.length-1];
							
							file = previewFilesFolder.resolvePath(Helper.Decode(recordset[i][CATALOGJOBDETAILS.ORIGINAL].toString()) + "." + extension);
							sql = "INSERT INTO UPLOADJOB (" + 
								UPLOADJOB.JOBID+","+UPLOADJOB.FILE+","+UPLOADJOB.FILEPATH+","+UPLOADJOB.TYPE+","+UPLOADJOB.UPLOADEDBYTES+","+UPLOADJOB.TOTALBYTES+","+UPLOADJOB.UPLOADED+") " + 
								"VALUES ("+ JobId+",'"+Helper.Encode(file.name)+"','"+Helper.Encode(file.nativePath)+"','"+FILE_TYPE.PREVIEW+"',0,"+file.size.toString()+",0)";
							cataloger.da.DataAccessInsert(sql);							
						}
						
						i++;
						callLater(UpdateUploadJobTable,[i,total]);
			}			
			else
			{
				callLater(CreateAssetInfo);
			}
		}
		
		private function CreateAssetInfo():void
		{
			var dataSortField:SortField = new SortField();
                dataSortField.name = CATALOGJOBDETAILS.TARGETLOCATION;
                
			var targetLocationSort:Sort = new Sort();
                targetLocationSort.fields = [dataSortField];
				recordset.sort = targetLocationSort;
				recordset.refresh();
				
			var writer:String = "<ASSETINFO>";
			callLater(AddAssetToAssetInfo,[0,recordset.length,writer]);
		}
		
		private function AddAssetToAssetInfo(i:int,total:int,writer:String,section:String=""):void
		{
			if(i<total)
			{
				var currentSection:String = Helper.Decode(recordset[i][CATALOGJOBDETAILS.TARGETLOCATION]);
				if(section != currentSection)
				{
					if(section!="")
					{
						writer += "</SECTION>";
					}
					section = currentSection;			
					writer += "<SECTION Path=\""+Helper.EncodeSpecialChars(section) + "\">"; 
				}
				
				writer += "<DIGITALASSET>";
				writer += "<NAME>"+ Helper.EncodeSpecialChars(Helper.Decode(recordset[i][CATALOGJOBDETAILS.ORIGINAL].toString())) +"</NAME>";
				if(recordset[i][CATALOGJOBDETAILS.DESCRIPTION].toString() != "")
				{
					writer += "<DESCRIPTION>"+ Helper.EncodeSpecialChars(Helper.Decode(recordset[i][CATALOGJOBDETAILS.DESCRIPTION].toString())) +"</DESCRIPTION>";						
				}
				
				if(recordset[i][CATALOGJOBDETAILS.EXPIRYDATE].toString() != "")
				{
					var dateStr:String = recordset[i][CATALOGJOBDETAILS.EXPIRYDATE].toString();					
					var dateArr:Array = dateStr.split("/");
					writer += "<EXPIRYDATE>";
					writer += "<DAY>"+dateArr[1]+"</DAY>";
					//Code Changes done as Month value returned by dateArr[0] is correct according to Month Selected, hence no need to
					//Add "1" to the month value hence Commented.
					//writer += "<MONTH>"+(Number(dateArr[0])+1)+"</MONTH>";
					writer += "<MONTH>"+(Number(dateArr[0]))+"</MONTH>";
					writer += "<YEAR>"+dateArr[2]+"</YEAR>";
					writer += "</EXPIRYDATE>";
				}
				
				writer += recordset[i][CATALOGJOBDETAILS.METADATA]; //digital asset information
				writer += "</DIGITALASSET>";
				i++;
				callLater(AddAssetToAssetInfo,[i,total,writer,section]);
			}
			else
			{	
				writer += "</SECTION>";
				writer +="<DIGITALASSETCOUNT>"+recordset.length.toString()+"</DIGITALASSETCOUNT>";
				writer += "</ASSETINFO>";
						
				writer = Helper.Encode(writer);
				cataloger.da.DataAccessUpdate("UPDATE CATALOGJOB SET ASSETINFO='"+writer+"' WHERE JOBID="+JobId);
				
				UploadManager.AddJobToQueue(JobId,textJobName.text,writer);
				//UploadManager.AddJobToQueue(JobId,textJobName.text+datetimeStampLabel.text,writer);
				close();
			}
			
		}
		
		private function DeleteJobDetailsRecord():void	
		{
			cataloger.da.DataAccessDelete("DELETE FROM CATALOGJOBDETAILS WHERE JOBID=" +JobId);					
		}
		
		private function closeHandler(evt:MouseEvent):void
		{
			
			if (isSectionCreated)
				SaveNewSectionHeirarchy();
			close();
			
		}
		
		private function close():void
		{
			this.visible = false;
			this.dispatchEvent(new CatalogJobDetailEvent(CatalogJobDetailEvent.CLOSE));
			if(this.parent != null)
			{
				this.parent.dispatchEvent(new Event(EVENTS.ENAABLE_LANGUAGE_MENU));
				this.parent.removeChild(this);
			}			
			WorkInProgress.HideAll();
		}
		
		private function UpdateRecord(status:String,insert:Boolean = false, jobstausDisplayTextID:String=null):void
		{
			try
			{
				if(!insert)
				{	
					cataloger.da.DataAccessUpdate("UPDATE CATALOGJOB SET BUSINESSINFO = '"+facetInfo.facetTemplate.toString()+"',JOBNAME='"+Helper.Encode(textJobName.text)+"', STATUS='"+status+"', JOBSTATUSDISPLAYTEXTID='"+jobstausDisplayTextID +"' WHERE JOBID="+JobId,QUERY.SELECT_CATALOGJOB);
					//cataloger.da.DataAccessUpdate("UPDATE CATALOGJOB SET BUSINESSINFO = '"+facetInfo.facetTemplate.toString()+"',JOBNAME='"+textJobName.text+datetimeStampLabel.text+"', STATUS='"+status+"' WHERE JOBID="+JobId,QUERY.SELECT_CATALOGJOB);
					
					DeleteJobDetailsRecord();	
					
				}
				else
				{	
					cataloger.da.DataAccessInsert("INSERT INTO CATALOGJOB (JOBSTATUSDISPLAYTEXTID,JOBID,JOBNAME,STATUS,BUSINESSINFO,USERID) VALUES ('" + jobstausDisplayTextID+"', "+JobId+",'"+Helper.Encode(textJobName.text)+"','"+status+"','"+facetInfo.facetTemplate.toString()+"','"+StateMgr.GetInstance().UserId+"')",QUERY.SELECT_CATALOGJOB);
					//cataloger.da.DataAccessInsert("INSERT INTO CATALOGJOB (JOBID,JOBNAME,STATUS,BUSINESSINFO,USERID) VALUES ("+JobId+",'"+textJobName.text+datetimeStampLabel.text+"','"+status+"','"+facetInfo.facetTemplate.toString()+"','"+StateMgr.GetInstance().UserId+"')",QUERY.SELECT_CATALOGJOB);
										
				}
						
			}
			catch(ex:Error)
			{
				MessageBox.Show(ex.toString());
			}
		}
		
		private function UpdateCatalogJobDetailsTable(i:int,total:int):void
		{
			if(i < total)
			{
				try
				{	
			  var sql:String = "INSERT INTO CATALOGJOBDETAILS (" + 
								CATALOGJOBDETAILS.JOBDETAILSID+","+ CATALOGJOBDETAILS.JOBID+","+CATALOGJOBDETAILS.METADATA+","+CATALOGJOBDETAILS.ORIGINAL+","+CATALOGJOBDETAILS.PREVIEW+","+CATALOGJOBDETAILS.THUMBNAIL+","+CATALOGJOBDETAILS.DESCRIPTION+","+CATALOGJOBDETAILS.EXPIRYDATE+","+CATALOGJOBDETAILS.TARGETLOCATION+","+CATALOGJOBDETAILS.TARGETLOCATIONID+") " + 
								"VALUES ("+recordset[i][CATALOGJOBDETAILS.JOBDETAILSID].toString()+","+ JobId+",'"+recordset[i][CATALOGJOBDETAILS.METADATA].toString()+"','"+Helper.Encode(Helper.Decode(recordset[i][CATALOGJOBDETAILS.ORIGINAL].toString()))+"','"+Helper.Encode(Helper.Decode(recordset[i][CATALOGJOBDETAILS.PREVIEW].toString()))+"','"+Helper.Encode(Helper.Decode(recordset[i][CATALOGJOBDETAILS.THUMBNAIL].toString()))+"','"+Helper.Encode(Helper.Decode(recordset[i][CATALOGJOBDETAILS.DESCRIPTION].toString()))+"','"+Helper.Encode(Helper.Decode(recordset[i][CATALOGJOBDETAILS.EXPIRYDATE].toString()))+"','"+Helper.Encode(Helper.Decode(recordset[i][CATALOGJOBDETAILS.TARGETLOCATION].toString()))+"','"+recordset[i][CATALOGJOBDETAILS.TARGETLOCATIONID].toString()+"')";
						cataloger.da.DataAccessInsert(sql);
						i++;
						UpdateCatalogJobDetailsTable(i,total);
				}
				catch(ex:Error)
				{
					MessageBox.Show(ex.toString());
				}
			}
			/*else
			{
				close();
			}*/
		}
		
		private function singleClickHandler(evt:ListEvent):void
		{
			if(evt.columnIndex > 0 && evt.columnIndex < 4)
			{
				var column:CheckBoxHeaderColumn =	assetData.columns[0];
			
				column.selected = false;
				
				for(var j:int=0;j<recordset.length; j++)
				{	
					recordset[j].SELECTED = false;
				}	
				
				var list:Array = new Array();
				list.push(evt.rowIndex);
				recordset[evt.rowIndex].SELECTED = true;
				assetData.selectedIndices =list;
				
				
				callLater(dispatchEvent,[new CatalogJobDetailEvent(CatalogJobDetailEvent.GRID_SELECTION,assetData.selectedIndices,recordset)]);
			}
		}
		
		private function gridClickHandler(evt:MouseEvent):void
		{
			isPrevThumbExpected = false;
			
			if(evt.target.toString().indexOf("CheckBox")>0)
			{
				var list:Array;
				var column:CheckBoxHeaderColumn =	assetData.columns[0];
			
				column.selected = false;
				list = new Array();
				
				for(var j:int=0;j<recordset.length; j++)
				{	
					if(recordset[j].SELECTED.toString() == 'true')
					{
						list.push(j);
					}
					
				}		
				assetData.selectedIndices = list;
				this.systemManager.stage.focus = assetData;
				
				callLater(dispatchEvent,[new CatalogJobDetailEvent(CatalogJobDetailEvent.GRID_SELECTION,assetData.selectedIndices,recordset)]);
			
			}
			
			if(assetData.selectedIndices.length == 1)
			{
				isPrevThumbExpected = true;
			}
		}
		
		private function headerClickHandler(evt:MouseEvent):void
		{	
			var list:Array;
			var column:CheckBoxHeaderColumn =	assetData.columns[0];
			if(column.selected)
			{			
				list = new Array();
				for(var i:int=0;i<recordset.length; i++)
				{
					list.push(i);
				}
				
				assetData.selectedIndices = list;
				this.systemManager.stage.focus = assetData;
			}
			else
			{
				assetData.selectedIndices = new Array();
			}
			for(var j:int=0;j<recordset.length; j++)
			{	
				recordset[j].SELECTED = column.selected;
				recordset.itemUpdated(recordset[j]);					
			}	
				//recordset.refresh();
				callLater(dispatchEvent,[new CatalogJobDetailEvent(CatalogJobDetailEvent.GRID_SELECTION,assetData.selectedIndices,recordset)]);
			
		}
		
		private function keyboardHandler(evt:KeyboardEvent):void
		{
			//46 is delete key on windows and 8 is on macintosh
			//8 is backspace in windows
			if((Capabilities.os.indexOf("Win") == 0 && evt.keyCode == 46) || (Capabilities.os.indexOf("Mac") == 0 && evt.keyCode == 8))
			//if(evt.keyCode == Keyboard.DELETE)
			{
				//check if focus is on datagrid
				if(this.systemManager.stage.focus == assetData)
				{
					if(assetData.selectedIndices != null && assetData.selectedIndices.length>0)
					{
						MessageBox.Show(STRINGS.DELETE_FILES_CONFIRMATION,STRINGS.MESSAGE_HEADER_CONFIRM,clickHandler,MessageBox.OK|MessageBox.CANCEL);	
					}
				}
			}
		}
		
		private function clickHandler(evt:CloseEvent):void
		{
			var checkFileExist:File = null;
			if(evt.detail == MessageBox.OK)
	        {
	        	for(var j:int=0;j<recordset.length; j++)
				{	
					if(recordset[j].SELECTED.toString() == 'true')
					{						
						checkFileExist = new File(originalFilesFolder.nativePath + "/" + Helper.Decode(recordset[j][CATALOGJOBDETAILS.ORIGINAL]));
						if(checkFileExist.exists)
							checkFileExist.deleteFileAsync();
						
						recordset.removeItemAt(j);
						j--;
					}	
				}
				recordset.refresh();
				var column:CheckBoxHeaderColumn =	assetData.columns[0];			
				column.selected = false;
				callLater(dispatchEvent,[new CatalogJobDetailEvent(CatalogJobDetailEvent.GRID_SELECTION,new Array(),recordset)]);
				thumbnailDropArea.visible = false;
				previewDropArea.visible = false;
	        }
	        else
	        {		
				this.systemManager.stage.focus = assetData;	
	        }
			
		}
		
		private function dropPreviewHandler(evt:MouseEvent):void
		{
			//if (!IsPreview && !IsThumbnail)
			{	
				var oldAssetDataWidth:int  = assetData.width;
				
				if (divider.contains(facetInfo))
					divider.removeChild(facetInfo);
				else
					divider.removeChild(addThumbnailsArea);
					
				isDropPreview = true;
				isDropThumbnail = false;
				
				addPreviewsArea.Init();
				divider.addChild(addPreviewsArea);
				
				assetData.width = oldAssetDataWidth;
				
				DropPreviewBtn.enabled = false;
				DropThumbnailBtn.enabled = true;
			}
		}
		
		private function dropThumbnailHandler(evt:MouseEvent):void
		{
			//if (!IsPreview && !IsThumbnail)
			{	
				var oldAssetDataWidth:int  = assetData.width;
				
				if (divider.contains(facetInfo))
					divider.removeChild(facetInfo);
				else
					divider.removeChild(addPreviewsArea);
				
				isDropThumbnail = true;	
				isDropPreview = false;
				
				addThumbnailsArea.Init();
				divider.addChild(addThumbnailsArea);
				
				assetData.width = oldAssetDataWidth;
				
				DropThumbnailBtn.enabled = false;
				DropPreviewBtn.enabled = true;
			}
		}
		
		private function unmatchedFilesErrorCancelHandler(evt:CatalogJobDetailEvent=null):void
		{	
			if (isDropPreview)
			{
				divider.removeChild(addPreviewsArea);
				DropPreviewBtn.enabled = true;
				isDropPreview = false;
			}
			else
			{
				divider.removeChild(addThumbnailsArea);
				DropThumbnailBtn.enabled = true;
				isDropThumbnail = false;
			}
			divider.addChild(facetInfo);
				
		}
		
		private function previewsThumbnailsDropCancelHandler(evt:CatalogJobDetailEvent):void
		{
			unmatchedFilesErrorCancelHandler();
		}
		
		private function SaveNewSectionHeirarchy():void
		{
			if (targetSelector.sections != null && targetSelector.sections.toString() != "")
			{
				var cachefolder:File = Helper.CreateCacheDirectory(COMMON.CACHE_FOLDERNAME+"/"+StateMgr.GetInstance().UserId);
				var file:File = cachefolder.resolvePath(COMMON.FILE_SECTION_HIERARCHY);
				var stream:FileStream = new FileStream();
				stream.open(file, FileMode.WRITE);				
				stream.writeMultiByte(targetSelector.sections.toString(), 'UTF-8');
				stream.close();
				isSectionCreated = false;
			}
		}
		
		private function sectionCreatedHandler(evt:TargetLocationEvent):void
		{
			isSectionCreated = true;	
		}
	}
}