package modules.batchcataloger.UI
{
	import assets.ButtonEx;
	
	import flash.display.CapsStyle;
	import flash.display.JointStyle;
	import flash.display.LineScaleMode;
	import flash.display.Sprite;
	import flash.events.FocusEvent;
	import flash.events.MouseEvent;
	import flash.filters.DropShadowFilter;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	
	import modules.batchcataloger.events.TargetLocationEvent;
	import modules.batchcataloger.framework.constants.STRINGS;
	
	import mx.controls.TextInput;
	import mx.core.UIComponent;
	import mx.validators.StringValidator;
	
	public class CreateSection extends UIComponent
	{
		private var dialogBoxWidth:int = 350;
		private var dialogBoxHeight:int = 150;
		private var dialogBox:Sprite;
		
		private var header:TextField;
		private var labelName:TextField;
		private var txtName:TextInput;
		private var doneBtn:ButtonEx;
		private var cancelBtn:ButtonEx;
		
		private var strValidator:StringValidator;
		
		public function CreateSection()
		{
			super();
			this.percentHeight = 100;
			this.percentWidth = 100;	
			this.styleName = "createSectionStyle";
		}
		
		protected override function createChildren():void
		{
			super.createChildren();
			
			dialogBox = new Sprite();
			var borderSize:int = getStyle("borderThickness");
			dialogBox.graphics.lineStyle(borderSize,getStyle("borderColor"),1,true, LineScaleMode.NORMAL,
                               CapsStyle.ROUND, JointStyle.ROUND, 3);			
			
			dialogBox.graphics.beginFill(getStyle("dialogColor"),1);
			dialogBox.graphics.drawRoundRect(0 ,0 , dialogBoxWidth, dialogBoxHeight,25,25);					
			
			var shadow:DropShadowFilter = new DropShadowFilter();
			shadow.color = getStyle("shadowColor");
			shadow.distance = 7;
			shadow.angle = 54;
			shadow.blurX = 11;
			shadow.blurY = 12;
			dialogBox.filters = [shadow];
			
			this.addChild(dialogBox);
			
			var headerformat:TextFormat = new TextFormat();
			headerformat.font = getStyle("titleFontFamily");
			headerformat.color = getStyle("titleFontColor");
			headerformat.size = getStyle("titleFontSize");			
			headerformat.bold = true;			
			
			header = new TextField();
			header.defaultTextFormat = headerformat;
			//header.width = 150;
			header.autoSize = TextFieldAutoSize.LEFT;
			header.border=false;
			header.type= TextFieldType.DYNAMIC;
			header.selectable=false;
			header.mouseEnabled=false;
			header.text = STRINGS.LABEL_CREATESECTION_FORM;
			
			this.addChild(header);
			
			var labelformat:TextFormat = new TextFormat();
			labelformat.font = getStyle("labelFontFamily");
			labelformat.color = getStyle("labelFontColor");
			labelformat.size = getStyle("labelFontSize");
			labelformat.bold = false;	
			
			labelName = new TextField();
			labelName.defaultTextFormat = labelformat;
			//labelName.autoSize = TextFieldAutoSize.LEFT;
			labelName.width = 70;
			labelName.height = 22;
			labelName.border=false;
			labelName.type= TextFieldType.DYNAMIC;
			labelName.selectable=false;
			labelName.mouseEnabled=false;
			labelName.text = STRINGS.LABEL_CREATESECTION_NAME; 
			
			this.addChild(labelName);
			
			txtName = new TextInput();
			txtName.width = 220;			
			txtName.height = 22;
			txtName.styleName = "createSection";
			this.addChild(txtName);
			
			txtName.addEventListener(FocusEvent.FOCUS_OUT, txtNameFocusOutHandler);
			
			doneBtn = new ButtonEx();
			doneBtn.setActualSize(80, 20);
			doneBtn.label = STRINGS.BUTTON_CREATESECTION_DONE;
			
			this.addChild(doneBtn);
			
			cancelBtn = new ButtonEx();
			cancelBtn.setActualSize(80, 20);
			cancelBtn.label = STRINGS.BUTTON_CREATESECTION_CANCEL;
			
			this.addChild(cancelBtn);
			
			doneBtn.addEventListener(MouseEvent.CLICK, doneClickHandler);
			cancelBtn.addEventListener(MouseEvent.CLICK, cancelClickHandler);
			
			dialogBox.graphics.lineStyle(1,getStyle("strokeColor"),1,true);
			dialogBox.graphics.moveTo(5, 5 + header.height + 5);
			dialogBox.graphics.lineTo(dialogBoxWidth-5,5 + header.height + 5);
			
			this.addEventListener(TargetLocationEvent.CREATE_SECTION_OPEN, createSectionOpenHandler);
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{	
			dialogBox.x = (unscaledWidth-dialogBox.width)/2;
			dialogBox.y = (unscaledHeight-dialogBox.height)/2;
			
			this.graphics.clear();
			this.graphics.beginFill(getStyle("backgroundColor"),getStyle("backgroundAlpha"));
			this.graphics.drawRect(0, 0, unscaledWidth, unscaledHeight);
			
			header.x = dialogBox.x + 5;
	    	header.y = dialogBox.y + 5;
	    	
	    	labelName.x = dialogBox.x + 20;
			labelName.y = dialogBox.y + 60;
			
			txtName.x = dialogBox.x + 100;
			txtName.y = dialogBox.y + 60;
			
			doneBtn.x = dialogBox.x +(dialogBoxWidth-doneBtn.width-cancelBtn.width -20)/2;
	    	cancelBtn.x = doneBtn.x +doneBtn.width+20;
		    
	    	doneBtn.y = dialogBox.y + dialogBoxHeight - doneBtn.height -10;
	    	cancelBtn.y = doneBtn.y;
		}
		
		private function doneClickHandler(evt:MouseEvent):void
		{
			txtName.dispatchEvent(new FocusEvent(FocusEvent.FOCUS_OUT)); 
			if (txtName.text != "")
			{ 
				this.dispatchEvent(new TargetLocationEvent(TargetLocationEvent.CREATE_SECTION_DONE, txtName.text));
				Hide();
			}
		}
		
		private function cancelClickHandler(evt:MouseEvent):void
		{
			Hide();
		}
		
		private function createSectionOpenHandler(evt:TargetLocationEvent):void
		{
			 
		}
		
		private function txtNameFocusOutHandler(evt:FocusEvent):void
		{
			strValidator = new StringValidator();
			strValidator.property = "text";
			strValidator.source = txtName;
			strValidator.required = true;
			strValidator.validate();			
		}
		
		public function Init():void
		{
			txtName.text = "";
			txtName.errorString = "";
		}
		
		public function Show():void
		{	
			this.visible = true;
		}
		
		public function Hide():void
		{	
			this.visible = false;
		}
		
		public function setText():void
		{
			header.text 	= STRINGS.LABEL_CREATESECTION_FORM;
			labelName.text 	= STRINGS.LABEL_CREATESECTION_NAME; 			
			doneBtn.label 	= STRINGS.BUTTON_CREATESECTION_DONE;		
			cancelBtn.label = STRINGS.BUTTON_CREATESECTION_CANCEL;		
		}
	}
}