package modules.batchcataloger.UI
{
	import Assetlink.Solutions.Formatting.DateTimeFormatting;
	
	import UI.FormRendition;
	
	import assets.ButtonEx;
	import assets.SquareButton;
	
	import events.FormEvents;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	
	import framework.constants.EVENTS;
	import framework.dialogs.MessageBox;
	import framework.remoteobjects.Session;
	import framework.utils.Helper;
	import framework.utils.WorkInProgress;
	
	import infrastructure.statemanagement.StateMgr;
	
	import modules.batchcataloger.events.CatalogJobDetailEvent;
	import modules.batchcataloger.framework.constants.COMMON;
	import modules.batchcataloger.framework.constants.STRINGS;
	import modules.batchcataloger.framework.constants.tables.CATALOGJOBDETAILS;
	import modules.batchcataloger.remoteobjects.FacetForm;
	
	import mx.collections.ArrayCollection;
	import mx.containers.Box;
	import mx.containers.Form;
	import mx.containers.FormItem;
	import mx.containers.HBox;
	import mx.containers.Panel;
	import mx.containers.VBox;
	import mx.controls.Alert;
	import mx.controls.Button;
	import mx.controls.ComboBox;
	import mx.controls.DateField;
	import mx.controls.Text;
	import mx.controls.TextArea;
	import mx.core.UIComponent;
	import mx.formatters.DateFormatter;
	
	
	public class FacetInfo extends UIComponent
	{
		private var businessInfoHolder:VBox;
		private var assetInfoHolder:VBox;		
		private var session:Session;
		private var assetForm:Form;
		private var businessForm:VBox;
		private var base:VBox;
		
		private var FacetListBox:VBox;		
   		private var facetSelectionArea:HBox;
   		
   		private var addedFacets:ArrayCollection;
   		public var selectedFacets:ArrayCollection;
		private var dissociatedFacets:ArrayCollection;
				
		private var selectedFileIDs:String = "";
		private var selectedFileIDArr:Array = new Array();
		
		private var recordset:ArrayCollection;
		
		private var facetNameListXML:File;
		private var cachefolder:File;		
		private var nhCollectionXML:File;		
		private var formLocalizationXML:File;
		private var localizationXML:File;
		private var descriptionData:TextArea;
		private var expiryDateData:DateField;
		private var btnMininmizeAI:SquareButton;
		private var btnMininmizeBI:SquareButton
		public var nhCollection:XML;
		private var formLocalization:XML;
		private var localizedStrings:XML;
		
		public var saveBtn:ButtonEx;
		private var selectLabel:Text;
		private var sectionLabelAI:Text;
		private var sectionLabelBI:Text;
		private var descriptionAI:FormItem;
		private var expiryDateAI:FormItem;
		
		private var ddFacetList:ComboBox;
		private var addBtn:ButtonEx;
		
		private var facetTemplateXML:File;
		public var facetTemplate:XML;
		private var stream:FileStream = new FileStream();
        private var facetNameList:XML;
        
        private var JobId:String ="0";
		private var isDataValid:Boolean = true;
		
		private var formRendition:FormRendition;
		
		public function FacetInfo(job:Object)
		{
			super();			
			JobId = job.JOBID;
			
			cachefolder = Helper.CreateCacheDirectory(COMMON.CACHE_FOLDERNAME);
			localizationXML = cachefolder.resolvePath(COMMON.FILE_LOCALIZATION);
			stream.open(localizationXML, FileMode.READ);			
			localizedStrings = XML(stream.readMultiByte(stream.bytesAvailable, 'UTF-8'));
			stream.close();
			
			cachefolder = Helper.CreateCacheDirectory(COMMON.CACHE_FOLDERNAME+"/"+StateMgr.GetInstance().UserId);
        	
        	facetNameListXML = cachefolder.resolvePath(COMMON.FILE_FACETNAMELIST);
        	stream.open(facetNameListXML, FileMode.READ); 			
			facetNameList = XML(stream.readMultiByte(stream.bytesAvailable, 'UTF-8'));
 			stream.close();
 			
 			nhCollectionXML = cachefolder.resolvePath(COMMON.FILE_NHCOLLECTION);
        	stream.open(nhCollectionXML,FileMode.READ);        	
			nhCollection = XML(stream.readMultiByte(stream.bytesAvailable,'UTF-8'));
        	stream.close();			
			
			formLocalizationXML = cachefolder.resolvePath(COMMON.FILE_FACETLOCALIZATION);
			stream.open(formLocalizationXML,FileMode.READ);			
			formLocalization = XML(stream.readMultiByte(stream.bytesAvailable,'UTF-8'));
			stream.close();
			
			StateMgr.GetInstance().FormatXml = XML(XML(localizedStrings).Formats);
 			formRendition = new FormRendition();
 			
 			//mulSelSep = nhCollection.MultiSelectSeperator;
 			
 			if(job.JOBNAME == "")
 			{
	 			facetTemplateXML = cachefolder.resolvePath("facettemplate.xml");
	 			stream.open(facetTemplateXML, FileMode.READ);
				facetTemplate = XML(stream.readMultiByte(stream.bytesAvailable, 'UTF-8'));
	 			stream.close();
 			}
 			else
 			{
 			  facetTemplate = XML(job.BUSINESSINFO) ;
 			}
		}
		
		protected override function createChildren():void
		{
			base = new VBox();
			base.setStyle("verticalGap","3");
			base.setStyle("verticalScrollPolicy","off");
			base.setStyle("horizontalScrollPolicy","off");
			base.percentHeight = 100;
			base.percentWidth = 100;			
			this.addChild(base);
			
			
			assetInfoHolder = new VBox();
			assetInfoHolder.percentWidth = 100;
		//	assetInfoHolder.height = 150
			
			var assetInfoHeader:HBox = new HBox();
						
			assetInfoHeader.styleName = "holderBackgoundStyle";					
			assetInfoHeader.percentWidth = 100;
			assetInfoHeader.height = 30;
			
			
			btnMininmizeAI = new SquareButton();
			btnMininmizeAI.label = "-";
			btnMininmizeAI.addEventListener(MouseEvent.CLICK, MinimizeAssetInfoSection,false,0,false);
			btnMininmizeAI.useHandCursor = true;
			btnMininmizeAI.enabled= false;
			assetInfoHeader.addChild(btnMininmizeAI);
		
			
			sectionLabelAI = new Text();
			sectionLabelAI.styleName = "mypanelTitle";
			sectionLabelAI.text =  STRINGS.JOBDETAILS_ASSETINFORMATION;
			assetInfoHeader.addChild(sectionLabelAI);
				
			base.addChild(assetInfoHeader);
			
			
			assetInfoHolder.styleName = "holderStyle";
		//	assetInfoHolder.title = STRINGS.JOBDETAILS_ASSETINFORMATION;
		//	assetInfoHolder.layout = "vertical";
			
			
			assetForm =  new Form();
			
			descriptionAI = new FormItem();
			descriptionAI.label = STRINGS.JOBDETAILS_DESCRIPTION;
			descriptionData = new TextArea();
			descriptionData.addEventListener(Event.CHANGE,assetInfoChanged);
			descriptionAI.addChild(descriptionData);			
			assetForm.addChild(descriptionAI);
			
			expiryDateAI = new FormItem();
			expiryDateAI.label = STRINGS.JOBDETAILS_EXPIRYDATE;
			expiryDateData = new DateField();
			expiryDateData.addEventListener(Event.CHANGE,assetInfoChanged);			
			expiryDateData.labelFunction = dateLabelFunction;
			expiryDateData.parseFunction = null;			
			expiryDateAI.addChild(expiryDateData);		
			assetForm.addChild(expiryDateAI);
			
			//assetInfoHolder.addChild(assetForm);
				
			base.addChild(assetInfoHolder);
			
			
			var businessInfoHeader:HBox = new HBox();
			
			businessInfoHeader.styleName = "holderBackgoundStyle";					
			businessInfoHeader.percentWidth = 100;
			businessInfoHeader.height = 30;
			
			
			btnMininmizeBI = new SquareButton();
			btnMininmizeBI.label = "-";
			btnMininmizeBI.addEventListener(MouseEvent.CLICK, MinimizeBusinessInfoSection,false,0,false);
			btnMininmizeBI.useHandCursor = true;
			btnMininmizeBI.enabled= false;
			businessInfoHeader.addChild(btnMininmizeBI);
			
			
			
			sectionLabelBI = new Text();
			sectionLabelBI.styleName = "mypanelTitle";
			sectionLabelBI.text =  STRINGS.JOBDETAILS_BUSINESSINFORMATION;
			businessInfoHeader.addChild(sectionLabelBI);
			
			base.addChild(businessInfoHeader);
			
			businessInfoHolder = new VBox();
			businessInfoHolder.setStyle("verticalScrollPolicy","off");
			businessInfoHolder.setStyle("horizontalScrollPolicy","off");
			businessInfoHolder.styleName = "holderStyle";
			//businessInfoHolder.title = STRINGS.JOBDETAILS_BUSINESSINFORMATION;
			//businessInfoHolder.layout = "vertical";
			
			//businessInfoHolder.setStyle("paddingTop","5");
			
			businessForm = new VBox();
			businessForm.percentHeight = 100;
			businessForm.percentWidth = 100;
			businessForm.setStyle("verticalScrollPolicy","off");
			businessForm.setStyle("horizontalScrollPolicy","off");
			
			businessInfoHolder.addChild(businessForm);
			base.addChild(businessInfoHolder);
			
			FacetListBox = new VBox();
		//	FacetListBox.percentWidth = 100;
			 
			FacetListBox.setStyle("paddingLeft","10"); 
			//FacetListBox.setStyle("paddingBottom","10"); 
			
			facetSelectionArea = new HBox();
			facetSelectionArea.y = 10;
			facetSelectionArea.percentWidth = 100;        	
			facetSelectionArea.setStyle("paddingLeft","10");
			
			selectLabel = new Text();
			selectLabel.text = STRINGS.LABEL_SELECT +":";
			selectLabel.setStyle("fontSize","12");
			
			ddFacetList = new ComboBox();
			ddFacetList.styleName = "biComboBox";
			ddFacetList.labelField = "@displayname";
			ddFacetList.height = 22;
			
			addBtn = new ButtonEx();
			addBtn.label = STRINGS.BUTTON_ADD;
			addBtn.height = 16;
			addBtn.addEventListener(MouseEvent.CLICK, AddFacet, false, 0, false);      
			
			saveBtn = new ButtonEx();
			saveBtn.label = STRINGS.BUTTON_SAVE_DATA;
			saveBtn.height = 25;
			saveBtn.enabled = false;
			saveBtn.addEventListener(MouseEvent.CLICK,savedataHandler,false,0,false);
			
			var currLanguage:String = StateMgr.GetInstance().Language;
			var formLocalizationNode:XML = formLocalization.language.(@name==currLanguage)[0];
			var localizedCommonStrings:XML = (localizedStrings.language.(@name == currLanguage)[0]).module.(@name == "batchcataloger")[0];
			
			expiryDateData.monthNames = STRINGS.MonthLabels;
			expiryDateData.dayNames = STRINGS.WeekDayshortLabels;
			formRendition.init(nhCollection, formLocalizationNode, localizedCommonStrings, this);
			
			addEventListener(FormEvents.DELETE_FORM, DeleteFacet);
			addEventListener(FormEvents.FORM_CHANGE, formChangeHandler);
			addEventListener(FormEvents.CONDITIONAL_DATA_CHANGED, ConditionalDataChangeHandler);
			
			this.owner.parent.addEventListener(CatalogJobDetailEvent.GRID_SELECTION,fileSelectionChangeHandler);
			this.owner.parent.addEventListener(CatalogJobDetailEvent.CLOSE,closeHandler);	
		}
		
		public function setText():void
		{
			if(sectionLabelAI == null) return;
			
			sectionLabelAI.text =  STRINGS.JOBDETAILS_ASSETINFORMATION;
			descriptionAI.label = STRINGS.JOBDETAILS_DESCRIPTION;
			expiryDateAI.label = STRINGS.JOBDETAILS_EXPIRYDATE;
			sectionLabelBI.text =  STRINGS.JOBDETAILS_BUSINESSINFORMATION;
			selectLabel.text = STRINGS.LABEL_SELECT +":";
			addBtn.label = STRINGS.BUTTON_ADD;
			saveBtn.label = STRINGS.BUTTON_SAVE_DATA;
			
			expiryDateData.monthNames = STRINGS.MonthLabels;
			expiryDateData.dayNames = STRINGS.WeekDayshortLabels;
			
			//Form Rendition Localization Handling
			var currLanguage:String = StateMgr.GetInstance().Language;
			var formLocalizationNode:XML = formLocalization.language.(@name==currLanguage)[0];
			var localizedCommonStrings:XML = (localizedStrings.language.(@name == currLanguage)[0]).module.(@name == "batchcataloger")[0];
			formRendition.SetLocalizationStrings(formLocalizationNode, localizedCommonStrings);
			
			if(selectedFacets != null && selectedFacets.length > 0 )
			{
				for (var i:int=0; i<selectedFacets.length; i++)
				{
					var selFacet:FacetForm = selectedFacets[i];
					formRendition.LocalizeForm(selFacet.FacetBox, selFacet.FormConfigXML, selFacet.ArrConditionalSectionInfo);
				}
			}
		}
		
		private function dateLabelFunction(date:Date):String
		{
			/*if(date == null)
				return "";
			
			return date.date + " " + STRINGS.MonthLabels[date.month] + " " + date.fullYear;*/
			
			if(date == null)
				return "";
			var currentLanguage:String = StateMgr.GetInstance().Language;
			var currentCulture:String = StateMgr.GetInstance().CurrentCulture;
			var FormatXml:XML = XML(StateMgr.GetInstance().FormatXml);
			var CurrentDateFormatting:XML = null;
			
			CurrentDateFormatting 				= XML(FormatXml.language.(@name == currentLanguage).FormattingTypes.DateFormatting);
			var ObjDTFormat:DateTimeFormatting  = new DateTimeFormatting(CurrentDateFormatting);
			var formattedDate:String 			= ObjDTFormat.ConvertStdDateToDisplayFormat(date);	
			
			return formattedDate;
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			this.graphics.clear();
			this.graphics.beginFill(assetInfoHolder.getStyle("backgroundColor"),1);
			this.graphics.drawRect(0, 0, unscaledWidth, unscaledHeight);
			
			base.width = unscaledWidth;
			base.height = unscaledHeight;
			businessForm.width = unscaledWidth;
			//businessForm.height = unscaledHeight - assetInfoHolder.height -3*30 -saveBtn.height;
			FacetListBox.maxHeight = unscaledHeight - assetInfoHolder.height -3*30 -saveBtn.height - 35;
			FacetListBox.maxWidth = unscaledWidth - 5;
			FacetListBox.width = unscaledWidth - 5;
		//	assetInfoHolder.width = unscaledWidth;
			
		//	businessInfoHolder.y = assetInfoHolder.height;
		//	businessInfoHolder.width = unscaledWidth;
			//businessInfoHolder.height = unscaledHeight-assetInfoHolder.height;
						
			formRendition.updateParentDisplay();
		}
		
		
		public function Init():void
		{
		}
        
        public function fileSelectionChangeHandler(evt:CatalogJobDetailEvent):void
        {	
 			formRendition.HideFormPopups();
 			
 			var facetNames:XMLList = facetNameList.FACETNAME;
        	        	
        	selectedFacets = new ArrayCollection();
        	dissociatedFacets = new ArrayCollection();
        	addedFacets = new ArrayCollection(); 
        	
        	selectedFileIDArr = evt.Data as Array;
        	recordset =  evt.Target as ArrayCollection;        	
        	
        	selectedFileIDs = evt.Data.toString(); 
        	var currFacetName:XML;
        	for each(currFacetName in facetNames)
        	{	
        		var currFacet:FacetForm = new FacetForm();
        		var currRelationshipName:String = currFacetName.@relationshipname;
        		var currTypeName:String = currFacetName.@typename;
        		currFacet.Name = currTypeName;
        		currFacet.RelationshipName = currRelationshipName;
        		var currFormConfigXML:File = cachefolder.resolvePath(currRelationshipName+"_FormConfiguration.xml");
        		stream.open(currFormConfigXML, FileMode.READ);
        		//currFacet.FormConfigXML = stream.readMultiByte(stream.bytesAvailable, File.systemCharset);
				currFacet.FormConfigXML = stream.readMultiByte(stream.bytesAvailable, 'UTF-8');
				
        		stream.close();
        		var assoAssetIDList:String;
        		  
        		if (facetTemplate != null)
        		{
        			var assoNode:XML = facetTemplate.child(currRelationshipName)[0];
        			// The following has been done to solve the bug when the job is saved therefore facettemplate is cached.
        			//The cached facettemplate does not reflect the new facets added
        			if (assoNode == null)
    				{
    					assoNode = XML("<" + currRelationshipName + "/>");
    					var facetChild:XML = XML("<" + currTypeName + "/>");
    					assoNode.appendChild(facetChild);
     					facetTemplate.appendChild(assoNode);
     					//assoNode = assoChild;
    				}
        			//if (assoNode != null)
        			{ 
		        		var facetNodeXML:XML = assoNode.child(currTypeName)[0];
		        		assoAssetIDList = facetNodeXML;
		        		if (assoAssetIDList.length > 0)
		        		{	        	
		        			for (var q:int = 0; q<selectedFileIDArr.length; q++)
		        			{	
		        				if (assoAssetIDList.indexOf(recordset[selectedFileIDArr[q]][CATALOGJOBDETAILS.JOBDETAILSID])>=0)
		        				{
		        					if (!selectedFacets.contains(currFacet))
		        						selectedFacets.addItem(currFacet);
		        						break;
		        				}
		        			}
		        			if (!selectedFacets.contains(currFacet))
		        				dissociatedFacets.addItem(currFacet);
		        		}
		        		else
		        			dissociatedFacets.addItem(currFacet);
        			}
        		}
        	}
        	
        	if ((facetSelectionArea == null || !businessForm.contains(facetSelectionArea)))
        	{	        
	        	if (selectedFileIDs.length > 0)
	        	{
		          	
					
					ddFacetList.dataProvider = facetNames;
		        	facetSelectionArea.addChild(selectLabel);
		        	facetSelectionArea.addChild(ddFacetList);
		        	facetSelectionArea.addChild(addBtn);
		        	
		        	
					businessForm.addChild(facetSelectionArea);
					businessForm.addChild(FacetListBox); 
		    		
	        	}
        	}
        	else if (businessForm.contains(facetSelectionArea))
        	{
        		if (selectedFileIDs.length == 0)
				{
					businessForm.removeAllChildren();
						
				}
        			
        	}
			
			if (selectedFileIDs.length > 0)
			{				
				base.addChild(saveBtn);				
				assetInfoHolder.addChild(assetForm);
				btnMininmizeAI.enabled = true;
				btnMininmizeBI.enabled = true;
			}
			else
			{
				assetInfoHolder.removeChild(assetForm);
				base.removeChild(saveBtn);
				btnMininmizeAI.enabled = false;
				btnMininmizeBI.enabled = false;
			}
			
			if(selectedFileIDArr != null)
			{
				var tempDescription:String = "";
				var tempExpiryDate:String = "";
				
				for (var assetCnt:int = 0; assetCnt < selectedFileIDArr.length; assetCnt++)
				{
					var description:String = Helper.Decode(recordset[selectedFileIDArr[assetCnt]][CATALOGJOBDETAILS.DESCRIPTION]);
					var expiryDate:String = recordset[selectedFileIDArr[assetCnt]][CATALOGJOBDETAILS.EXPIRYDATE];
					if(assetCnt == 0)
					{
						tempDescription = description;
						tempExpiryDate = expiryDate;
					}
					
					if(description != tempDescription)
					{
						tempDescription = "";
					}
					
					if(expiryDate != tempExpiryDate)
					{
						tempExpiryDate = "";
					}
				}
				
				descriptionData.text = tempDescription;
				
				var df:DateFormatter = new DateFormatter();
				df.formatString = "MM/DD/YYYY";
				if(tempExpiryDate != null && tempExpiryDate != "")
				{
					expiryDateData.data = DateField.stringToDate(tempExpiryDate,"MM/DD/YYYY");
				}
				else
				{
					expiryDateData.data = null;
				}
			}
        	
        	if (FacetListBox.height > 0)
        		FacetListBox.removeAllChildren();
        		
			formRendition.ClearFieldDataViewState();
			
    		for (var i:int=0; i<selectedFacets.length; i++)
        	{
        		var selFacet:FacetForm = selectedFacets[i];
        		var businessInfo:String = GetFormInput(selFacet);
        		
        		var FacetBox:VBox = formRendition.GenerateFacetForm(selFacet.FormConfigXML, businessInfo, false, selFacet.ArrConditionalSectionInfo);
        		
        		//foll line added after restructuring
        		selFacet.FacetBox = FacetBox;
        		selFacet.ArrConditionalSectionInfo = formRendition.getConditionalDisplayInformation();
				selectedFacets[i] = selFacet;
				
        		/*var FacetBox:VBox = GenerateFacetForm(selectedFacets[i]);*/
        		FacetListBox.addChild(FacetBox);
    		}
			
			saveBtn.enabled = false;
			validateNow();
    		invalidateDisplayList();
        }
        
        private function GetFormInput(currFacet:FacetForm):String
        {
        	var assoAssetIDs:String;
			var assoAssetIDArr:Array;
        	var currTypeName:String = currFacet.Name;
    		var currRelationshipName:String = currFacet.RelationshipName;
    		var assoNode:XML = facetTemplate.child(currRelationshipName)[0];
    		var facetNodeXML:XML = assoNode.child(currTypeName)[0];
    		assoAssetIDs = facetNodeXML;
			assoAssetIDArr = assoAssetIDs.split(',');
        	
        	var businessInfoStr:String = "<BUSINESSINFO>";
        	if (assoAssetIDArr != null && assoAssetIDArr.length > 0)
			{	
    			var oldValArr:Array = new Array();
    			for (var p:int = 0; p < selectedFileIDArr.length; p++)
    			{											
					var metaData:String = String(recordset[selectedFileIDArr[p]][CATALOGJOBDETAILS.METADATA]);
					if (metaData != null && metaData.length > 0)
					{	
						businessInfoStr += String(recordset[selectedFileIDArr[p]][CATALOGJOBDETAILS.METADATA]);
						var tempXML:XML = XML("<TEMPROOT>"+String(recordset[selectedFileIDArr[p]][CATALOGJOBDETAILS.METADATA])+"</TEMPROOT>");
						var facetNodeList:XMLList = tempXML.elements(currRelationshipName);
						if (facetNodeList == null || facetNodeList.length() == 0)
							businessInfoStr += "<"+currRelationshipName + ">" + "<"+currTypeName+"/>" + "</" + currRelationshipName + ">";
					}
					else
						businessInfoStr += "<"+currRelationshipName + ">" + "<"+currTypeName+"/>" + "</" + currRelationshipName + ">";
    			}
			}
			businessInfoStr += "</BUSINESSINFO>";
			return businessInfoStr;
        } 
        
        public function AddFacet(event:MouseEvent):void
        {
        	var AddFacetBtn:ButtonEx = event.currentTarget as ButtonEx;
        	var ddFacetList:ComboBox = AddFacetBtn.parent.getChildAt(1) as ComboBox;
        	var SelDDItem:XML = ddFacetList.selectedItem as XML;
        	var FacetToBeAdded:FacetForm = null;
        	for (var i:int=0; i<dissociatedFacets.length; i++)
        	{
        		var currFacet:FacetForm = dissociatedFacets[i];
        		if (currFacet.Name == SelDDItem.@typename && currFacet.FormConfigXML != null && currFacet.FormConfigXML != "")
        		{
        			FacetToBeAdded = currFacet;
        			addedFacets.addItem(currFacet);
        			selectedFacets.addItem(currFacet);
        			dissociatedFacets.removeItemAt(i);		        			
        			break;
        		}        		
        	}
        	if (FacetToBeAdded != null && FacetToBeAdded.FormConfigXML != null && FacetToBeAdded.FormConfigXML != "")
        	{
	        	/*var FacetBox:VBox = GenerateFacetForm(FacetToBeAdded);*/
	        	var FacetBox:VBox = formRendition.GenerateFacetForm(FacetToBeAdded.FormConfigXML);
	        	//FacetListBox.addChildAt(FacetBox, 0);
				FacetListBox.addChildAt(FacetBox, selectedFacets.length - 1);
	        	
	        	//foll Added after restructuring
	        	FacetToBeAdded.FacetBox = FacetBox;
				FacetToBeAdded.ArrConditionalSectionInfo = formRendition.getConditionalDisplayInformation();
        	}
        }
        
        //public function DeleteFacet(event:MouseEvent):void
        public function DeleteFacet(event:FormEvents):void
        {
        	//var DeleteFacetBtn:Button = event.currentTarget as Button;
        	//var FacetBox:VBox = DeleteFacetBtn.parent.parent as VBox;
        	var FacetBox:VBox = event.Target as VBox;
        	for (var i:int=0; i<selectedFacets.length; i++)
        	{
        		var currFacet:FacetForm = selectedFacets[i];
        		var currRelationshipName:String = currFacet.RelationshipName;
        		var currTypeName:String = currFacet.Name;
        		if (FacetBox.name == currFacet.Name)
        		{  
        			//FacetBox.parent.removeChild(FacetBox);
        			dissociatedFacets.addItem(currFacet); 
        			selectedFacets.removeItemAt(i);
        			        			 
        			var assoNode:XML = facetTemplate.child(currRelationshipName)[0];
        			var facetNode:XML = assoNode.child(currTypeName)[0];
        			var assoIDList:String = facetNode;
        			for (var j:int = 0; j < selectedFileIDArr.length; j++)
        			{
        				if (assoIDList.indexOf(recordset[selectedFileIDArr[j]][CATALOGJOBDETAILS.JOBDETAILSID]+',') >=0)
        					assoIDList = assoIDList.replace(recordset[selectedFileIDArr[j]][CATALOGJOBDETAILS.JOBDETAILSID]+',','');
    					facetNode.setChildren(assoIDList);
        				var businessInfo:XML = XML("<BUSINESSINFO>" + String(recordset[selectedFileIDArr[j]][CATALOGJOBDETAILS.METADATA]) + "</BUSINESSINFO>");
        				var requiredAssoNode:XML = businessInfo.child(currRelationshipName)[0];
        				if (requiredAssoNode != null)
        				{	
        					delete businessInfo.children()[requiredAssoNode.childIndex()];
        					var businessInfoStr:String = businessInfo.toXMLString();
        					businessInfoStr = businessInfoStr.replace("<BUSINESSINFO>","");
        					businessInfoStr = businessInfoStr.replace("</BUSINESSINFO>","");
        					businessInfoStr = businessInfoStr.replace("<BUSINESSINFO/>",""); // this check is if there is no data inside the root node
        					recordset[selectedFileIDArr[j]][CATALOGJOBDETAILS.METADATA] = businessInfoStr;  	
        				}
        			}
        		}
        	}
        	
        	for (var p:int=0; p<addedFacets.length; p++)
        	{
        		var currAddedFacet:FacetForm = addedFacets[p];
        		if (FacetBox.name == currAddedFacet.Name)
        		{        	
        			addedFacets.removeItemAt(p);
        		}
        	}
        }
        
        private function formChangeHandler(evt:FormEvents):void
        {				
        	saveBtn.enabled = true;		
        }
		
		private function ConditionalDataChangeHandler(evt: FormEvents):void
		{
			saveBtn.enabled = true;		 
			
			var strCurrBI: String = null;
			var IsConditionSatisfied: String = null;			
			var CurrFacet:String = null;
			var evtObj:Object = null;
			var lst_SecCondOnfo:Array = null;
			
			evtObj = evt.Params as Object;
			if(evtObj != null)			
			{	
				CurrFacet = evtObj.SelectedFacet;
				IsConditionSatisfied = evtObj.IsConditionSatisfied;
				lst_SecCondOnfo = evtObj.SectionConditionalInfo;
				
				if(IsConditionSatisfied == "TRUE")
				{
					//Step 1: Render Form according to the condition.
					//Alert.show("Form Data Changed - Conditional Field changed" + selectedFileIDs);
					var BIdata:String =  GetBusinessInfoForConditionalDisplay(CurrFacet);
					if(BIdata == null || BIdata == "")
						return;
					
					strCurrBI = "<BUSINESSINFO>" + BIdata + "</BUSINESSINFO>";
					
					for (var i:int=0; i<selectedFacets.length; i++)
					{
						var selFacet:FacetForm = selectedFacets[i];
						if(selFacet.Name == CurrFacet)
						{			
							//var businessInfo:String = GetFormInput(selFacet);
							var FacetBox:VBox = formRendition.GenerateFacetForm(selFacet.FormConfigXML, strCurrBI,false,selFacet.ArrConditionalSectionInfo);
							selFacet.FacetBox = FacetBox;						
							selFacet.ArrConditionalSectionInfo = formRendition.getConditionalDisplayInformation();							
							
							//********************************************************************************//
							// SelectedFacets length: 4
							// SelectedFacets index(i)   VBoxindex   Formula[(SelectedFacets length - i) - 1]            
							//     0                     3             (4 - 0) - 1 = 3                     
							//     1                     2             (4 - 1) - 1 = 2 
							//     2                     1             (4 - 2) - 1 = 1
							//     3                     0             (4 - 3) - 1 = 0
							//********************************************************************************//
							
							//foll line added after restructuring							
							/*FacetListBox.removeChildAt((selectedFacets.length - i )- 1);
							FacetListBox.addChildAt(FacetBox, (selectedFacets.length - i) - 1);*/
							
							FacetListBox.removeChildAt(i);
							FacetListBox.addChildAt(FacetBox, i);
						}//If currFacet = Facet beding updated						
					}//For each facet					
				}//if(IsConditionAwareField == "TRUE")
			}//if(params != null)
		}
		
		private function assetInfoChanged(evt:Event):void
		{
			saveBtn.enabled = true;
		}
        
        private function closeHandler(evt:Event):void
        {
        		
        }
        
        private function savedataHandler(event:MouseEvent):void
        {
        	WorkInProgress.Show(STRINGS.WIP_SAVING_BUSINESSINFORMATION);
			GetAssetInfo(event);
        	GetBusinessInfo(event);			
        }
		
		public function GetAssetInfo(evt:MouseEvent=null):Boolean
		{
			for (var assetCnt:int = 0; assetCnt < selectedFileIDArr.length; assetCnt++)
			{
				recordset[selectedFileIDArr[assetCnt]][CATALOGJOBDETAILS.DESCRIPTION] = descriptionData.text;
				
				var df:DateFormatter = new DateFormatter();
				df.formatString = "MM/DD/YYYY";
				
				recordset[selectedFileIDArr[assetCnt]][CATALOGJOBDETAILS.EXPIRYDATE] = df.format(expiryDateData.selectedDate);
			}
			
			return true;
		}
        
        public function GetBusinessInfo(evt:MouseEvent=null):Boolean
        {
			var allBusinessInfoValid:Boolean = true;
			
        	isDataValid = true;			
        	for (var assetCnt:int = 0; assetCnt < selectedFileIDArr.length; assetCnt++)
    		{	
        		var businessInfoStr:String = "";
        		for (var facetCnt:int = 0; facetCnt<selectedFacets.length; facetCnt++)
        		{
	        		var currFacet:FacetForm = selectedFacets[facetCnt];
        			var currRelationshipName:String = currFacet.RelationshipName;        			
        			var currTypeName:String = currFacet.Name;
        			var result:Object = formRendition.SaveFormInputXML(currFacet.FacetBox, XML(currFacet.FormConfigXML),currFacet.ArrConditionalSectionInfo);
        			isDataValid = Boolean(result.isDataValid); 
	        		if (isDataValid == true)
	    			{ 
		    			businessInfoStr += result.inputXML;
		    			var assoNode:XML = facetTemplate.child(currRelationshipName)[0];
	        			var facetNode:XML = assoNode.child(currTypeName)[0];
	    				var assoAssetIDList:String = facetNode;
	    				
	    				if (assoAssetIDList.indexOf(recordset[selectedFileIDArr[assetCnt]][CATALOGJOBDETAILS.JOBDETAILSID]+',') < 0)    				
	    					assoAssetIDList += recordset[selectedFileIDArr[assetCnt]][CATALOGJOBDETAILS.JOBDETAILSID] + ',';  
	        			
	    				facetNode.setChildren(assoAssetIDList);
					} 
					
					if(allBusinessInfoValid)
						allBusinessInfoValid = isDataValid;
        		}
    			if (allBusinessInfoValid == true)
    			{	
    				recordset[selectedFileIDArr[assetCnt]][CATALOGJOBDETAILS.METADATA] = businessInfoStr;
    				saveBtn.enabled = false; 
    			}
				else
				{
					MessageBox.Show(STRINGS.INVALID_BUSINESSINFO_ERRORMESSAGE);
    				break;
    			}
    		}
    		if (evt != null)
    			WorkInProgress.Hide(STRINGS.WIP_SAVING_BUSINESSINFORMATION);
    		if (this.stage != null) 
    			this.stage.focus = null;
			return isDataValid;
        }
		
		
		private function MinimizeBusinessInfoSection(event:MouseEvent):void
		{
			var MinimizeFacetDataBtn:Button = event.currentTarget as Button;        	
			
			if (businessForm.visible == true)
			{
				MinimizeFacetDataBtn.label = "+";
				businessForm.visible = false;
				businessForm.includeInLayout = false;
			}
			else
			{
				MinimizeFacetDataBtn.label = "-";
				businessForm.visible = true;
				businessForm.includeInLayout = true;
			}
		}
		
		private function MinimizeAssetInfoSection(event:MouseEvent):void
		{
			var MinimizeFacetDataBtn:Button = event.currentTarget as Button;        	
			
			if (assetForm.visible == true)
			{
				MinimizeFacetDataBtn.label = "+";
				assetForm.visible = false;
				assetForm.includeInLayout = false;
			//	assetInfoHolder.height = 30;
			}
			else
			{
				MinimizeFacetDataBtn.label = "-";
				assetForm.visible = true;
				assetForm.includeInLayout = true;
				//assetInfoHolder.height = 150; 
			}
		}
		
		//Meenal: Changes done for Conditional Display support
		public function GetBusinessInfoForConditionalDisplay(CurrSelectedFacet:String):String
		{
			var BInfo:String = null;
			isDataValid = true;
			for (var assetCnt:int = 0; assetCnt < selectedFileIDArr.length; assetCnt++)
			{	
				var businessInfoStr:String = "";
				for (var facetCnt:int = 0; facetCnt<selectedFacets.length; facetCnt++)
				{
					currFacet = selectedFacets[facetCnt];
					var currTypeName:String = currFacet.Name;
					if(currTypeName == CurrSelectedFacet)
					{
						var currFacet:FacetForm = selectedFacets[facetCnt];
						var currRelationshipName:String = currFacet.RelationshipName;        			
						
						var result:Object = formRendition.SaveFormInputXML(currFacet.FacetBox, XML(currFacet.FormConfigXML),currFacet.ArrConditionalSectionInfo, false);
						isDataValid = Boolean(result.isDataValid); 
						if (isDataValid == true)
						{ 
							BInfo = result.inputXML;
							var assoNode:XML = facetTemplate.child(currRelationshipName)[0];
							var facetNode:XML = assoNode.child(currTypeName)[0];
							var assoAssetIDList:String = facetNode;
							
							//if (assoAssetIDList.indexOf(recordset[selectedFileIDArr[assetCnt]][CATALOGJOBDETAILS.JOBDETAILSID]+',') < 0)    				
							//	assoAssetIDList += recordset[selectedFileIDArr[assetCnt]][CATALOGJOBDETAILS.JOBDETAILSID] + ',';  
							
							//-facetNode.setChildren(assoAssetIDList);
						} 
					}
				}
				if (isDataValid == true)
				{	
					//recordset[selectedFileIDArr[assetCnt]][CATALOGJOBDETAILS.METADATA] = businessInfoStr;
					//saveBtn.enabled = false;
					return BInfo;
				}
				else
				{
					MessageBox.Show(STRINGS.INVALID_BUSINESSINFO_ERRORMESSAGE);
					break;
				}
			}
			//if (evt != null)
			//	WorkInProgress.Hide(STRINGS.WIP_SAVING_BUSINESSINFORMATION);
			if (this.stage != null) 
				this.stage.focus = null;
			return "";
		}
		
		
	}	
}
			