package modules.batchcataloger.UI
{
	import flash.events.ErrorEvent;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	
	import framework.constants.MODULES;
	import framework.constants.tables.PREFERENCE;
	import framework.dialogs.MessageBox;
	import framework.remoteobjects.Session;
	import framework.utils.Helper;
	import framework.utils.WorkInProgress;
	
	import infrastructure.statemanagement.StateMgr;
	
	import modules.batchcataloger.UI.component.JobNameRenderer;
	import modules.batchcataloger.UI.component.JobStatusRenderer;
	import modules.batchcataloger.assets.ActionBar;
	import modules.batchcataloger.assets.MenuButton;
	import modules.batchcataloger.assets.checkbox.CheckBoxHeaderColumn;
	import modules.batchcataloger.assets.checkbox.CheckBoxHeaderRenderer;
	import modules.batchcataloger.assets.checkbox.CheckBoxItemRenderer;
	import modules.batchcataloger.events.CatalogJobEvent;
	import modules.batchcataloger.framework.constants.ADMODULE;
	import modules.batchcataloger.framework.constants.COMMON;
	import modules.batchcataloger.framework.constants.EVENTS;
	import modules.batchcataloger.framework.constants.QUERY;
	import modules.batchcataloger.framework.constants.STRINGS;
	import modules.batchcataloger.framework.constants.remotemethods.CATALOGERSERVICE;
	import modules.batchcataloger.framework.constants.remotemethods.INFRASTRUCTURE;
	import modules.batchcataloger.framework.constants.tables.CATALOGJOB;
	import modules.batchcataloger.framework.utils.RemoteConnection;
	import modules.cataloger;
	
	import mx.collections.ArrayCollection;
	import mx.controls.DataGrid;
	import mx.controls.dataGridClasses.DataGridColumn;
	import mx.core.Application;
	import mx.core.ClassFactory;
	import mx.core.UIComponent;
	import mx.events.CloseEvent;
	import mx.rpc.events.ResultEvent;
	import mx.rpc.remoting.mxml.RemoteObject;

	public class JobList extends UIComponent
	{
		 private var catalogJobScreen:CatalogJob = null;
    
		//private var toolBarButtons:JobList_buttons;
		
		public var DeleteBtn:MenuButton;
		public var NewjobBtn:MenuButton;
		private var ReSyncBtn:MenuButton;
		private var RefreshJobStatusBtn:MenuButton;
		private var actionBar:ActionBar;
		
		private var rc:RemoteConnection;
		private var ro:RemoteObject;
		
		private var jobListGrid:DataGrid;	
		
		[Bindable]
		private var jobCollection:ArrayCollection = new ArrayCollection();
		
		
		public function JobList()
		{
			rc = new RemoteConnection();
			super();
		}
		
		
		protected override function createChildren():void
		{
			
			actionBar = new ActionBar();
			actionBar.percentWidth = 100;
			actionBar.x = 0;
			actionBar.y = 0;
			actionBar.height = 40;
			this.addChild(actionBar);	
			
					
			DeleteBtn = new MenuButton(STRINGS.BUTTON_DELTE_JOB);
			DeleteBtn.setActualSize(145,30);			
			actionBar.addChild(DeleteBtn);
			
			NewjobBtn = new MenuButton(STRINGS.BUTTON_NEW_JOB);
			NewjobBtn.setActualSize(165,30);			
			actionBar.addChild(NewjobBtn);
			
			ReSyncBtn = new MenuButton(STRINGS.BUTTON_RESYNC_DATA);
			ReSyncBtn.setActualSize(175,30);			
			actionBar.addChild(ReSyncBtn);
			
			RefreshJobStatusBtn = new MenuButton(STRINGS.BUTTON_REFRESH_JOBSTATUS);
			RefreshJobStatusBtn.setActualSize(135,30);			
			actionBar.addChild(RefreshJobStatusBtn);	
			
			DeleteBtn.addEventListener(MouseEvent.CLICK,deleteHandler);	
			NewjobBtn.addEventListener(MouseEvent.CLICK,newJobHandler);
			ReSyncBtn.addEventListener(MouseEvent.CLICK, resyncDataHandler);
			RefreshJobStatusBtn.addEventListener(MouseEvent.CLICK,refreshJobStatusHandler);
			Application.application.addEventListener(EVENTS.REFRESH_JOB_STATUS,RefreshJobStatus);
			this.addEventListener( modules.batchcataloger.framework.constants.EVENTS.ENAABLE_LANGUAGE_MENU, enableLanguagemenuHandler);
			jobListGrid = new DataGrid();
			this.addChild(jobListGrid);
			
			jobListGrid.styleName = "jobliststyle";
			jobListGrid.headerHeight = 30;
			jobListGrid.rowHeight = 25;
			jobListGrid.allowDragSelection = false;
			jobListGrid.allowMultipleSelection = true;
			jobListGrid.selectable = false;
			jobListGrid.doubleClickEnabled = true;
			jobListGrid.addEventListener(CatalogJobEvent.SELECT,gridListClickHandler);
			jobListGrid.addEventListener(CatalogJobEvent.ERROR_CLICK,ErrorStatusClickHandler);
			jobListGrid.addEventListener(CatalogJobEvent.INPROGRESS_CLICK,InProgressStatusClickHandler);			
			jobListGrid.addEventListener(MouseEvent.CLICK,gridClickHandler);
			//jobListGrid.dataProvider = cataloger.da.dbResult;//jobCollection;
			
			var gridColumns:Array = new Array(3);
			
			var cbColumn:CheckBoxHeaderColumn = new CheckBoxHeaderColumn();
			cbColumn.headerText = "";
			cbColumn.dataField = "SELECTED";
			cbColumn.resizable = false;
			cbColumn.sortable = false;
			cbColumn.headerRenderer = new ClassFactory(CheckBoxHeaderRenderer);
			cbColumn.itemRenderer = new ClassFactory(CheckBoxItemRenderer);
			cbColumn.width = 5;
			cbColumn.addEventListener(MouseEvent.CLICK,headerClickHandler);
			gridColumns[0] = cbColumn;
			
			var jobNameColumn:DataGridColumn = new DataGridColumn();
			jobNameColumn.dataField = CATALOGJOB.JOBNAME;
			jobNameColumn.itemRenderer = new ClassFactory(JobNameRenderer);
			jobNameColumn.width = 80;
			gridColumns[1] = jobNameColumn;
			
			var statusColumn:DataGridColumn = new DataGridColumn();
			statusColumn.dataField = CATALOGJOB.STATUS;
			statusColumn.itemRenderer = new ClassFactory(JobStatusRenderer);
			statusColumn.width = 20;
			gridColumns[2] = statusColumn;
			
			jobListGrid.columns = gridColumns;
		}
		
		public function setText():void
		{
			
			DeleteBtn.label = STRINGS.BUTTON_DELTE_JOB;
			NewjobBtn.label = STRINGS.BUTTON_NEW_JOB;
			ReSyncBtn.label = STRINGS.BUTTON_RESYNC_DATA;
			RefreshJobStatusBtn.label = STRINGS.BUTTON_REFRESH_JOBSTATUS;
			
			
			jobListGrid.columns[1].headerText = STRINGS.JOBLIST_JOBNAME;
			jobListGrid.columns[2].headerText = STRINGS.JOBLIST_STATUS;
			
			if(catalogJobScreen != null)
			{
				catalogJobScreen.setText();
			}
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			//super.updateDisplayList(unscaledWidth,unscaledHeight);
			actionBar.width = unscaledWidth;
		
			DeleteBtn.x= 10;
			DeleteBtn.y = (actionBar.height-DeleteBtn.height)/2;
	
			NewjobBtn.x= DeleteBtn.x + DeleteBtn.width + 10;
			NewjobBtn.y = DeleteBtn.y;
			
			ReSyncBtn.x = RefreshJobStatusBtn.x - ReSyncBtn.width - 10;
			ReSyncBtn.y = DeleteBtn.y;
			
			RefreshJobStatusBtn.x= actionBar.width - RefreshJobStatusBtn.width - 10;
			RefreshJobStatusBtn.y = DeleteBtn.y;
			
			jobListGrid.x=0;
			jobListGrid.y= actionBar.height;
			jobListGrid.width = unscaledWidth ;
			
			jobListGrid.height = unscaledHeight - jobListGrid.y;
			
			if(catalogJobScreen != null)
			{
				catalogJobScreen.width = unscaledWidth;
				catalogJobScreen.height = unscaledHeight;
			}
		}
		
		private function newJobHandler(evt:MouseEvent):void
		{
			WorkInProgress.Show(STRINGS.WIP_LOADING);
			callLater(ShowCatalogJob,[null]);				
		}
	
		private function deleteHandler(evt:MouseEvent):void
		{		 	
			var bJobSelected:Boolean = false;
		 	for(var j:int=0;j<cataloger.da.ResultSet.length; j++)
				{	
					if(cataloger.da.ResultSet[j].SELECTED.toString() == 'true')
					{
						bJobSelected = true;
						break;		
					}
				}
			if(bJobSelected)
			{
			  MessageBox.Show(STRINGS.DELETE_JOB_CONFIRMATION,STRINGS.MESSAGE_HEADER_CONFIRM,clickHandler,MessageBox.OK|MessageBox.CANCEL);
			}			
			else
			{
				 MessageBox.Show(STRINGS.PLEASE_SELECT_JOBS_TO_DELETE,STRINGS.MESSAGE_HEADER_ERROR);
			}
		}
		
		private function resyncDataHandler(evt:MouseEvent):void
		{	
			MessageBox.Show(STRINGS.MESSAGE_RESYNC_ALERT, STRINGS.MESSAGE_HEADER_RESYNC_CONFIRM, confirmResyncHandler,MessageBox.YES|MessageBox.NO);
		}
		
		private function confirmResyncHandler(evt:CloseEvent):void
		{
			if (evt.detail == MessageBox.YES)
			{
				WorkInProgress.Show(STRINGS.WIP_RESYNCING_WITH_SERVER);
				Application.application.dispatchEvent(new Event(EVENTS.RESYNC_DATA));	
			}
		}
		
		private function refreshJobStatusHandler(evt:MouseEvent):void
		{	
			WorkInProgress.Show(STRINGS.WIP_REFRESHING_STATUS);
							
			if (StateMgr.GetInstance().IsConnectedToServer)
				Application.application.dispatchEvent(new Event(EVENTS.REFRESH_JOB_STATUS));
			else
			{
				WorkInProgress.Hide(STRINGS.WIP_REFRESHING_STATUS);
				MessageBox.Show(STRINGS.ERROR_CONNECTION_FAILURE);
			}	
		}
		
		private function RefreshJobStatus(evt:Event):void
		{
			var submittedJobNames:Array = new Array();
			var currJobName:String = "";
			var JobID:String = "";
			for(var j:int=0;j<cataloger.da.ResultSet.length; j++)
			{
				if(cataloger.da.ResultSet[j].STATUS.toString() == COMMON.JOB_STATUS_SUBMITTED || cataloger.da.ResultSet[j].STATUS.toString() == COMMON.JOB_STATUS_RELEASED || String(cataloger.da.ResultSet[j].STATUS).split(' (')[0] == COMMON.JOB_STATUS_INPROGRESS)
				{	
					currJobName = Helper.Decode(cataloger.da.ResultSet[j].JOBNAME.toString());
					JobID 		= cataloger.da.ResultSet[j].JOBID.toString();
					while (currJobName.indexOf(",") >= 0)
						currJobName = currJobName.replace(",","$ALCOMMA$");
					
					currJobName = currJobName + "$JBID$" + JobID;
					submittedJobNames.push(currJobName);
				}
			}
			var jobNames:String = submittedJobNames.toString();
			if (submittedJobNames.length > 0)
			{
				StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.GET_CATALOGER_JOBSTATUS).removeEventListener(ResultEvent.RESULT,jobStatusHandler);
				StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.GET_CATALOGER_JOBSTATUS).addEventListener(ResultEvent.RESULT,jobStatusHandler);
				StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.GET_CATALOGER_JOBSTATUS).removeEventListener(ErrorEvent.ERROR,jobStatusHandlerError);
				StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.GET_CATALOGER_JOBSTATUS).addEventListener(ErrorEvent.ERROR,jobStatusHandlerError);			
				StateMgr.GetInstance().Fascade.GetJobStatus(StateMgr.GetInstance().SessionObject, jobNames);
			}
			else
				WorkInProgress.Hide(STRINGS.WIP_REFRESHING_STATUS);
		}
		
		private function jobStatusHandler(evt:ResultEvent):void
		{
			var statusList:XML = XML(evt.result as String);
			UpdateFileWatcherJobStatus(statusList);
			UpdateCatalogerJobStatus(statusList);  	
			WorkInProgress.Hide(STRINGS.WIP_REFRESHING_STATUS);
			StateMgr.GetInstance().logger.Write(ADMODULE.JOBLIST,"jobStatusHandler()",evt.toString());
		}
		
		private function jobStatusHandlerError(evt:ErrorEvent):void
		{
			StateMgr.GetInstance().logger.Write(ADMODULE.JOBLIST,"jobStatusHandlerError()",evt.toString());
		}
		
		private function UpdateFileWatcherJobStatus(statusList:XML):void
		{
			if (Number(statusList.FILENOTIFICATIONCOLLECTION.@TotalRecordCount)>0)
			{
				var fileNotificationList:XMLList = 	statusList.FILENOTIFICATIONCOLLECTION.FILENOTIFICATION.(STATUS == COMMON.JOB_STATUS_ERROR);
				var fileNotication:XML;
				for each (fileNotication in fileNotificationList)
				{	
					var status:String = fileNotication.STATUS.toString()+"_"+COMMON.JOB_STATUS_SENDER_FILEWATCHER;
					//var submittedJobId:String = fileNotication.NOTIFICATIONID.toString() + "$ALSEP$" + fileNotication.LINK.toString();
					//cataloger.da.DataAccessUpdate("UPDATE CATALOGJOB SET SUBMITTEDJOBID = "+fileNotication.NOTIFICATIONID.toString()+", STATUS='"+status+"' WHERE JOBNAME='"+Helper.Encode(fileNotication.JOBNAME.toString())+"'",QUERY.SELECT_CATALOGJOB);
					cataloger.da.DataAccessUpdate("UPDATE CATALOGJOB SET LINK = '"+fileNotication.LINK.toString()+"', SUBMITTEDJOBID = "+fileNotication.NOTIFICATIONID.toString()+", STATUS='"+status+"' WHERE JOBNAME='"+Helper.Encode(fileNotication.JOBNAME.toString())+"'",QUERY.SELECT_CATALOGJOB);
				}
				cataloger.da.ResultSet.refresh();
			}
		}
		
		private function UpdateCatalogerJobStatus(statusList:XML):void
		{	
			
			if (Number(statusList.CATALOGJOBCOLLECTION.@TotalRecordCount)>0)
			{
				var catalogJobList:XMLList = statusList.CATALOGJOBCOLLECTION.CATALOGJOB;
				var catalogJob:XML;
				var inProgressJobs:String = "";
				for each (catalogJob in catalogJobList)
				{	
					var status:String = catalogJob.STATUS.toString();
					var link:String = "";
					var jobid:String = catalogJob.@JOBID;
					
					var jobstatusDisplayTextID: String = catalogJob.JOBSTATUSDISPLAYTEXTID.toString();
					if (status == COMMON.JOB_STATUS_ERROR)
					{
						status += "_"+COMMON.JOB_STATUS_SENDER_CATALOGER; 
						link = catalogJob.LINK.toString();
					}
					else if (status.split(' (')[0] == COMMON.JOB_STATUS_INPROGRESS)
					{
						inProgressJobs += catalogJob.JOBNAME.toString()+ "$JBID$" + jobid + "$ALSEP$";
						//status += "_"+COMMON.JOB_STATUS_SENDER_CATALOGER; 
						link = catalogJob.LINK.toString();
					}	
					
					if (status.split(' (')[0] != COMMON.JOB_STATUS_CANCELLED || status.split(' (')[0] != COMMON.JOB_STATUS_DONE)
						cataloger.da.DataAccessUpdate("UPDATE CATALOGJOB SET LINK = '"+link+"',SUBMITTEDJOBID = "+catalogJob.CATALOGJOBID.toString()+", STATUS='"+status+"', JOBSTATUSDISPLAYTEXTID='"+ jobstatusDisplayTextID+"' WHERE JOBNAME='"+Helper.Encode(catalogJob.JOBNAME.toString())+"' AND JOBID='" + jobid + "'",QUERY.SELECT_CATALOGJOB);
					else
						cataloger.da.DataAccessUpdate("UPDATE CATALOGJOB SET JOBSTATUSDISPLAYTEXTID='" + jobstatusDisplayTextID + "', STATUS='"+status+"' WHERE JOBNAME='"+Helper.Encode(catalogJob.JOBNAME.toString())+"' AND JOBID='" + jobid +"'",QUERY.SELECT_CATALOGJOB);
					
					cataloger.da.DataAccessUpdate("UPDATE CATALOGJOB SET FILECATALOGCOUNT="+ int(catalogJob.@FILECATALOGCOUNT) +",TOTALDIGITALASSETCOUNT="+ int(catalogJob.@DIGITALASSETCOUNT)+ " WHERE JOBNAME='"+Helper.Encode(catalogJob.JOBNAME.toString())+"' AND JOBID='" + jobid + "'",QUERY.SELECT_CATALOGJOB);
				}
				
				if (inProgressJobs != null && inProgressJobs != "")
					GetInProgressJobDetails(inProgressJobs);
				
				cataloger.da.ResultSet.refresh();
			}
		} 
		
		private function GetInProgressJobDetails(jobNames:String):void
		{
			ro = StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].Fascade;
			ro.getOperation(CATALOGERSERVICE.GETCATALOGEDFILESCOUNT).removeEventListener(ResultEvent.RESULT,InProgressJobDetailsHandler);
			ro.getOperation(CATALOGERSERVICE.GETCATALOGEDFILESCOUNT).addEventListener(ResultEvent.RESULT,InProgressJobDetailsHandler);
			ro.GetCatalogedFilesCount(StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerMoutPoint,StateMgr.GetInstance().UserId, jobNames);
		}
		
		private function InProgressJobDetailsHandler(evt:ResultEvent):void
		{
			var jobs:XML = XML(evt.result as String);
			var jobList:XMLList = jobs.JOB;
			var job:XML;
			var jobstatus:String = "";
			var jobid:String = "";
			
			for each (job in jobList)
			{
				if (job.@FILECATALOGCOUNT != null && String(job.@FILECATALOGCOUNT) != "" && job.@DIGITALASSETCOUNT != null && String(job.@DIGITALASSETCOUNT) != "")
				{
					jobid = job.@JOBID;
					jobstatus = COMMON.JOB_STATUS_INPROGRESS + " (" + job.@FILECATALOGCOUNT.toString() + "/" + job.@DIGITALASSETCOUNT + " "+ COMMON.FILES_CATALOGED + ")";
					cataloger.da.DataAccessUpdate("UPDATE CATALOGJOB SET STATUS='" + jobstatus +"', FILECATALOGCOUNT="+ int(job.@FILECATALOGCOUNT) +",TOTALDIGITALASSETCOUNT="+ int(job.@DIGITALASSETCOUNT)+" WHERE JOBNAME='"+Helper.Encode(job.@JOBNAME.toString())+"' AND JOBID='" + jobid + "'",QUERY.SELECT_CATALOGJOB);
				}
			}
		}
		
		private function ErrorStatusClickHandler(evt:CatalogJobEvent):void
		{
			var errorJob:Object 	= evt.Data as Object;
			var errorSender:String 	= String(errorJob.STATUS).split('_')[1];
			var server:String 		= StateMgr.GetInstance().MainDatabase.ResultSet[2][PREFERENCE.VALUE];
			var session:Session 	= StateMgr.GetInstance().SessionObject;			
			var Url:String 			= server + errorJob.LINK;
				
			StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.DECODE_URL_FOR_RESPONSE_REDIRECTS).removeEventListener(ResultEvent.RESULT, DecodeUrlHandler);
			StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.DECODE_URL_FOR_RESPONSE_REDIRECTS).addEventListener(ResultEvent.RESULT, DecodeUrlHandler);
			StateMgr.GetInstance().Fascade.DecodeURLForResponseRedirects(Url);
		}
		
		private function InProgressStatusClickHandler(evt:CatalogJobEvent):void
		{
			var errorJob:Object 	= evt.Data as Object;
			var errorSender:String 	= String(errorJob.STATUS).split(' (')[1];
			var server:String 		= StateMgr.GetInstance().MainDatabase.ResultSet[2][PREFERENCE.VALUE];
			var session:Session 	= StateMgr.GetInstance().SessionObject;
			var Url:String 			= server + errorJob.LINK;
			
			StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.DECODE_URL_FOR_RESPONSE_REDIRECTS).removeEventListener(ResultEvent.RESULT, DecodeUrlHandler);
			StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.DECODE_URL_FOR_RESPONSE_REDIRECTS).addEventListener(ResultEvent.RESULT, DecodeUrlHandler);
			StateMgr.GetInstance().Fascade.DecodeURLForResponseRedirects(Url);
		}
		
		private function DecodeUrlHandler(evt:ResultEvent):void	 
		{
			var pageurl:String 	= evt.result as String;
			var session:Session 	= StateMgr.GetInstance().SessionObject;
			pageurl = pageurl  + "&SessionID=" + session.SessionID;
			
			StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.ENCODE_URL_FOR_RESPONSE_REDIRECTS).removeEventListener(ResultEvent.RESULT, EncodeUrlHandler);
			StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.ENCODE_URL_FOR_RESPONSE_REDIRECTS).addEventListener(ResultEvent.RESULT, EncodeUrlHandler);
			StateMgr.GetInstance().Fascade.EncodeURLForResponseRedirects(pageurl);
		}
		
	    private function EncodeUrlHandler(evt:ResultEvent):void	 
		{
			var pageurl:String 	= evt.result as String;
			var PageURL:URLRequest = new URLRequest();
			PageURL.url = pageurl;
			if (StateMgr.GetInstance().IsConnectedToServer)
				navigateToURL(PageURL);    			
			else
				MessageBox.Show(STRINGS.ERROR_CONNECTION_FAILURE);
		}
		
		private function clickHandler(evt:CloseEvent):void
		{
			if(evt.detail == MessageBox.OK)
	        {
	        	for(var j:int=0;j<cataloger.da.ResultSet.length; j++)
				{	
					if(cataloger.da.ResultSet[j].SELECTED.toString() == 'true')
					{
						cataloger.da.DataAccessDelete("DELETE FROM CATALOGJOB WHERE JOBID=" +cataloger.da.ResultSet[j].JOBID);					
						cataloger.da.ResultSet.removeItemAt(j);
						j--;						
					}	
				}
				cataloger.da.ResultSet.refresh();
				var column:CheckBoxHeaderColumn =	jobListGrid.columns[0];
				
				column.selected = false;
	        }
	        else
	        {
	        	this.systemManager.stage.focus = jobListGrid;
	        }
			
		}
		
		public function Init():void
		{	
			//Application.application.dispatchEvent(new Event(EVENTS.REFRESH_JOB_STATUS));			
			jobListGrid.dataProvider = cataloger.da.ResultSet;
		}
		
		private function gridListClickHandler(evt:CatalogJobEvent):void
		{				
			WorkInProgress.Show(STRINGS.WIP_LOADING);			
			callLater(ShowCatalogJob,[evt.Data]);
			
		}
		
		private function ShowCatalogJob(obj:Object):void
		{	
			Application.application.dispatchEvent(new Event(EVENTS.DISABLE_LANGUAGE_MENU));
			catalogJobScreen = new CatalogJob(obj);		 	
		 	this.addChild(catalogJobScreen);
		}
		
		
		
		private function gridClickHandler(evt:MouseEvent):void
		{
			if(evt.target.toString().indexOf("CheckBox")>0)
			{
				var list:Array;
				var column:CheckBoxHeaderColumn =	jobListGrid.columns[0];
			
				column.selected = false;
				list = new Array();
				
				for(var j:int=0;j<cataloger.da.ResultSet.length; j++)
				{	
					if(cataloger.da.ResultSet[j].SELECTED.toString() == 'true')
					{
						list.push(j);
					}
					
				}		
				jobListGrid.selectedIndices = list;
			}
		}
		
		private function headerClickHandler(evt:MouseEvent):void
		{
			var list:Array;
			var column:CheckBoxHeaderColumn =	jobListGrid.columns[0];
			if(column.selected)
				{			
					list = new Array();
					for(var i:int=0;i<jobListGrid.rowCount; i++)
					{
						list.push(i);
					}
					
					jobListGrid.selectedIndices = list;
				}
				else
				{
					jobListGrid.selectedIndices = new Array();
				}
				for(var j:int=0;j<cataloger.da.ResultSet.length; j++)
				{	
					cataloger.da.ResultSet[j].SELECTED = column.selected;
					cataloger.da.ResultSet.itemUpdated(cataloger.da.ResultSet[j]);					
				}	
		}
		
		private function enableLanguagemenuHandler(evt:Event):void
		{
			Application.application.dispatchEvent(new Event(EVENTS.ENAABLE_LANGUAGE_MENU));
		}
	}
}