package modules.batchcataloger.UI.component
{
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	
	import framework.utils.Helper;
	
	import modules.batchcataloger.events.CatalogJobEvent;
	import modules.batchcataloger.framework.constants.COMMON;
	
	import mx.controls.Alert;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.core.IDataRenderer;
	import mx.core.UIComponent;

	public class JobNameRenderer extends UIComponent implements IDataRenderer, IListItemRenderer
	{
		private var dataVal:Object;
		private var label:TextField;
		
		[Bindable]
		private var labelformat:TextFormat=null;
		
		public function JobNameRenderer()
		{
			
		}
		
		public function get data():Object
        {
        	return dataVal;
        }
        
		public function set data(value:Object):void
		{				
			dataVal = value;
			label.text = Helper.Decode(dataVal.JOBNAME.toString()) + " ";
			
				
			var tf:TextFormat = label.defaultTextFormat; 
			if(dataVal.STATUS != COMMON.JOB_STATUS_DRAFT && String(dataVal.STATUS).split('_')[0] != COMMON.JOB_STATUS_ERROR)
			{				
				buttonMode = false;
				useHandCursor = false;
				tf.italic = true;			
				
				//label.text = dataVal.JOBNAME + "_" + dataVal.JOBID;
				//tf.bold = false;
			}
			else
			{
				buttonMode = true;
				useHandCursor = true;
				tf.italic = false;
				
				//label.text = dataVal.JOBNAME;
				//tf.bold = true;
			}
			label.setTextFormat(tf);
		}
		
		protected override function createChildren():void
		{
			
			labelformat = new TextFormat();
			labelformat.font = getStyle("fontFamily");
			labelformat.color = getStyle("fontColor");
			labelformat.size = getStyle("fontSize");
			
			//labelformat.bold = false;
			
			label = new TextField();
			label.defaultTextFormat = labelformat;
			label.autoSize = TextFieldAutoSize.LEFT;
			label.border=false;
			label.type= TextFieldType.DYNAMIC;
			label.selectable=false;
			label.mouseEnabled=false;
			label.text = "";
			
			//label.buttonMode = true;
			//label.useHandCursor = true;
			buttonMode = true;
			useHandCursor = true;
			this.addChild(label);
			this.toolTip = "";
			
			this.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			super.updateDisplayList(unscaledWidth,unscaledHeight);
			label.width = unscaledWidth-3;
			label.x = 3;
		}
		
		private function clickHandler(evt:MouseEvent):void
		{
			if(this.buttonMode)
			{
				this.parent.parent.dispatchEvent(new CatalogJobEvent(CatalogJobEvent.SELECT,dataVal));
			}
			//Alert.show(dataVal.ORIGINAL);
			
		}
		
	}
}