package modules.batchcataloger.UI.component
{
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	
	import framework.events.ApplicationErrorEvent;
	import framework.utils.Helper;
	
	import infrastructure.statemanagement.StateMgr;
	
	import modules.batchcataloger.events.CatalogJobEvent;
	import modules.batchcataloger.framework.constants.COMMON;
	import modules.batchcataloger.framework.constants.STRINGS;
	
	import mx.containers.HBox;
	import mx.controls.Alert;
	import mx.controls.Image;
	import mx.controls.ProgressBar;
	import mx.controls.ProgressBarMode;
	import mx.controls.Text;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.core.Application;
	import mx.core.IDataRenderer;
	import mx.core.ScrollPolicy;
	import mx.core.UIComponent;
	import mx.messaging.AbstractConsumer;

	public class JobStatusRenderer extends UIComponent implements IDataRenderer, IListItemRenderer
	{
		private var dataVal:Object;
		private var bar:ProgressBar;
		private var label:TextField;
		private var showError:HBox;
		[Bindable]
		private var labelformat:TextFormat=null;
		
		
		public function JobStatusRenderer()
		{
			labelformat = new TextFormat();
		}
		
		public function get data():Object
        {
        	return dataVal;
        }
        
		public function set data(value:Object):void
		{
			var statusDisplayValue:String = "";
			
			dataVal = value;
			if (!showError.visible)
			{	
				if(dataVal.JOBSTATUSDISPLAYTEXTID != null)
				{
					statusDisplayValue = Helper.getLocalizedString(dataVal.JOBSTATUSDISPLAYTEXTID);
					if(statusDisplayValue != dataVal.JOBSTATUSDISPLAYTEXTID)
						label.text = statusDisplayValue;
					else
						label.text = dataVal.STATUS;
				}	
				else
					label.text = dataVal.STATUS;
				
				if(dataVal.STATUS == COMMON.JOB_DROP_INPROGRESS)
				{				
					label.visible = false;
					if (StateMgr.GetInstance().hasErrorOccured)
						showError.visible = true;
					else	
						bar.visible = true;			
					
				}
				else
				{
					label.visible = true;
					bar.visible = false;
					if(String(dataVal.STATUS).split('_')[0] == COMMON.JOB_STATUS_ERROR)
					{
						buttonMode = true;
						useHandCursor = true;
						toolTip = STRINGS.TOOLTIP_JOBSTATUS_ERROR;
						var tf:TextFormat = label.defaultTextFormat;
						tf.underline = true;
						
						if(dataVal.JOBSTATUSDISPLAYTEXTID != null)
						{
							statusDisplayValue = Helper.getLocalizedString(dataVal.JOBSTATUSDISPLAYTEXTID);
							if(statusDisplayValue != dataVal.JOBSTATUSDISPLAYTEXTID)
								label.text = statusDisplayValue;
							else
								label.text = String(dataVal.STATUS).split('_')[0];
						}	
						else
							label.text = String(dataVal.STATUS).split('_')[0];
						
						label.setTextFormat(tf);
					}
					else if(String(dataVal.STATUS).split(' (')[0] == COMMON.JOB_STATUS_INPROGRESS)
					{
						buttonMode = true;
						useHandCursor = true;
						toolTip = STRINGS.TOOLTIP_JOBSTATUS_INPROGRESS;
						var tf1:TextFormat = label.defaultTextFormat;
						tf1.underline = true;
						
						if(dataVal.JOBSTATUSDISPLAYTEXTID != null && dataVal.JOBSTATUSDISPLAYTEXTID != "")
						{
							var placeHolders:Array = null;
							var keyvalueObj:Object = null;
							
							placeHolders = new Array();
							keyvalueObj = new Object();
							keyvalueObj.Key = "FILECATALOGCOUNT";
							keyvalueObj.Value = dataVal.FILECATALOGCOUNT;
							placeHolders.push(keyvalueObj);
							
							keyvalueObj = new Object();
							keyvalueObj.Key = "TOTALDIGITALASSETCOUNT";
							keyvalueObj.Value = dataVal.TOTALDIGITALASSETCOUNT;
							placeHolders.push(keyvalueObj);							
							
							statusDisplayValue = Helper.getLocalizedStringEx(dataVal.JOBSTATUSDISPLAYTEXTID,placeHolders);
							if(statusDisplayValue != dataVal.JOBSTATUSDISPLAYTEXTID)
								label.text = statusDisplayValue;
							else
								label.text = dataVal.STATUS;
						}	
						else
							label.text = dataVal.STATUS;
						
						/*if(dataVal.JOBSTATUSDISPLAYTEXTID != null)
						{
							statusDisplayValue = Helper.getLocalizedString(dataVal.JOBSTATUSDISPLAYTEXTID);
							if(statusDisplayValue != dataVal.JOBSTATUSDISPLAYTEXTID)
								label.text = statusDisplayValue + " (" + String(dataVal.STATUS).split(' (')[1];
							else
								label.text = String(dataVal.STATUS).split('_')[0]  + " (" + String(dataVal.STATUS).split(' (')[1];
						}	
						else
							label.text = String(dataVal.STATUS).split('_')[0] + " (" + String(dataVal.STATUS).split(' (')[1];*/
						
						label.setTextFormat(tf1);
					}
					else
					{
						toolTip = "";
						useHandCursor = false;
					}	
				}
			}
			else
			{
				if (dataVal.STATUS != COMMON.JOB_DROP_INPROGRESS)
				{
					showError.visible = false;
					label.visible = true;
				}
			}
		}
		
		protected override function createChildren():void
		{   
			labelformat.font = getStyle("fontFamily");
			labelformat.color = getStyle("fontColor");
			labelformat.size = getStyle("fontSize");
			//labelformat.bold = false;
			
			label = new TextField();
			label.defaultTextFormat = labelformat;
			label.autoSize = TextFieldAutoSize.LEFT;
			label.border=false;
			label.type= TextFieldType.DYNAMIC;
			label.selectable=false;
			label.mouseEnabled=false;
			label.text = "";
			
			bar = new  ProgressBar();
			bar.mode = ProgressBarMode.MANUAL;
			bar.styleName = "uploadstatus";
			bar.label = "";
			bar.visible = false;
			label.visible = false;
			
			showError = new HBox();
			showError.visible = false;
			showError.horizontalScrollPolicy = ScrollPolicy.OFF;
			var errorImg:Image = new Image();
			errorImg.source = "resources/icons/error.png";
			showError.addChild(errorImg);
			
			var errorLbl:Text = new Text();
			errorLbl.setStyle("color","#000000");
			errorLbl.text = STRINGS.ERROR_CATALOGER_CONNECTION_FAILURE;
			showError.addChild(errorLbl);
			
			this.addChild(label);
			this.addChild(bar);
			
			this.addChild(showError);
			
			this.toolTip = "";
			
			this.addEventListener(MouseEvent.CLICK,clickHandler);
			Application.application.addEventListener(ApplicationErrorEvent.CONNECTION_ERROR, connectionErrorHandler);
		}
		
		private function connectionErrorHandler(e:ApplicationErrorEvent):void
		{	
			if (dataVal != null && dataVal.STATUS == COMMON.JOB_DROP_INPROGRESS)
			{
				if (StateMgr.GetInstance().hasErrorOccured && bar.visible)
				{
					showError.visible = true;
					bar.visible = false;
				}
				else if (!StateMgr.GetInstance().hasErrorOccured && showError.visible)
				{
					showError.visible = false;
					bar.visible = true;
				}
			}
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			super.updateDisplayList(unscaledWidth,unscaledHeight);
				
			bar.setActualSize(unscaledWidth-4,unscaledHeight);
			//bar.setStyle("trackHeight",unscaledHeight-4);
			label.width = unscaledWidth-3;
			bar.x = 3;
			bar.y = (unscaledHeight-bar.getStyle("trackHeight"))/2;
			label.x = 3;
			bar.setProgress(dataVal.UPLOADEDBYTES,dataVal.TOTALBYTES);
			
			showError.setActualSize(unscaledWidth-4,unscaledHeight);
			showError.x = 3;
			showError.y = 0;
		}
		
		private function clickHandler(evt:MouseEvent):void
		{
			if(String(dataVal.STATUS).split('_')[0] == COMMON.JOB_STATUS_ERROR)
			{
				this.parent.parent.dispatchEvent(new CatalogJobEvent(CatalogJobEvent.ERROR_CLICK,dataVal));
			}
			if(String(dataVal.STATUS).split(' (')[0] == COMMON.JOB_STATUS_INPROGRESS)
			{
				this.parent.parent.dispatchEvent(new CatalogJobEvent(CatalogJobEvent.INPROGRESS_CLICK,dataVal));
			}
		}
		
	}
}