package modules.batchcataloger.UI.component
{
	import assets.ButtonEx;
	
	import flash.events.MouseEvent;
	
	import modules.batchcataloger.framework.constants.STRINGS;
	
	import modules.batchcataloger.events.FacetSeriesChangeEvent;
	
	import mx.controls.Alert;
	import mx.controls.Label;
	import mx.controls.dataGridClasses.DataGridListData;
	import mx.controls.listClasses.BaseListData;
	import mx.controls.listClasses.IDropInListItemRenderer;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.core.IDataRenderer;
	import mx.core.UIComponent;
	
	public class TreeViewItemRenderer extends UIComponent implements IListItemRenderer, IDataRenderer,IDropInListItemRenderer
	{
		[Bindable]
		private var dataVal:Object;
		
		private var col:DataGridListData;
		private var ownernameArr:Array;
		private var currfield:XML;
		
		private var select:ButtonEx;
		private var labeltxt:Label;
		private var _listData:BaseListData;
		public function TreeViewItemRenderer()
		{
			super();
			select = new ButtonEx();
			labeltxt = new Label();
		}
		
		protected override function createChildren():void
		{
			this.addChild(labeltxt);
			this.addChild(select);
			
			this.addEventListener(FacetSeriesChangeEvent.TREESELECTION_CHANGE, getTreeSelectedValues);
			
			select.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			super.updateDisplayList(unscaledWidth,unscaledHeight);
			
			select.setActualSize(60,20);	
			
			labeltxt.setActualSize(unscaledWidth-60,20);
			labeltxt.x = 0;
			
			select.label = STRINGS.BUTTON_TARGETLOCATION_SELECT;		
			select.x= unscaledWidth - select.width - 5;
			
		}
		
		 public function get listData():BaseListData
        {
            return _listData;
        }

        /**
         * @private
         */
        public function set listData(value:BaseListData):void
        { 
        	_listData = value;
        	
        }
		
		public function get data():Object
        {
    		return dataVal;
        }
        
		public function set data(value:Object):void
		{	
			
			dataVal = value;
			 
			if(_listData)
			{
            	if (currfield == null)
                {
                	col = DataGridListData(_listData);
               		ownernameArr = col.owner.name.split("$ALSEP$");
                
	                var xml:XML = XML(dataVal);
					var currfieldlist:XMLList = xml.child(col.dataField.toString());
					currfield = currfieldlist[0];
					if (String(currfield).length > 0)
					{
						var text:String = String(currfield);
						text = text.substr(4, text.length - 8); 
						while (text.indexOf('$AL$') >= 0)
							text = text.replace('$AL$',',')
						labeltxt.text = text;
					}
                }
			}
		}
		
		public function clickHandler(evt:MouseEvent):void
		{						
			var NHID:String = ownernameArr[col.columnIndex + 2];
			this.owner.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.SHOW_TREEVIEW, this, NHID, currfield.toString()));
		}
		
		private function getTreeSelectedValues(evt:FacetSeriesChangeEvent):void
		{	
			var fieldData:String = evt.Data as String;			
			var text:String = fieldData;
			if (text.length > 0)
			{	
				currfield.setChildren(text);
				text = text.substr(4, text.length - 8); 
				while (text.indexOf('$AL$') >= 0)
					text = text.replace('$AL$',',')
			}
			labeltxt.text = text;
			if (col != null)
			{
				var target1:String = ownernameArr[0] + "$ALSEP$" + ownernameArr[1];			
				var target2:String = col.rowIndex.toString() + "$ALSEP$" + col.dataField.toString();
				col.owner.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.SERIES_CHANGE, fieldData, target1, target2));
			}
		} 
	}
}