package modules.batchcataloger.assets
{
	import flash.events.MouseEvent;
	import flash.filters.GlowFilter;
	
	import modules.batchcataloger.framework.constants.STRINGS;
	
	import mx.controls.Button;

	public class MenuButton extends Button
	{		
		[Embed(source='resources/icons/new.png')]
 		private var iconNew:Class;
 		
		[Embed(source='resources/icons/delete.png')]
 		private var iconDelete:Class;
 		
		[Embed(source='resources/icons/save.png')]
 		private var iconSave:Class;
 		
		[Embed(source='resources/icons/submit.png')]
 		private var iconSubmit:Class;
 		
		[Embed(source='resources/icons/cancel.png')]
 		private var iconCancel:Class;
 		
 		[Embed(source='resources/icons/refresh.png')]
 		private var iconRefresh:Class;
 		
 		[Embed(source='resources/icons/dropfiles.png')]
 		private var iconDrop:Class;
 		
		public function MenuButton(value:String ="")
		{
			super();
			this.label = value;
			switch(value)
			{
				case STRINGS.BUTTON_NEW_JOB:
					this.setStyle("icon",iconNew);
				break;
				case STRINGS.BUTTON_DELTE_JOB:
					this.setStyle("icon",iconDelete);
				break;
				case STRINGS.BUTTON_SAVE_AS_DRAFT:
					this.setStyle("icon",iconSave);
				break;
				case STRINGS.BUTTON_SUBMIT:
					this.setStyle("icon",iconSubmit);
				break;
				case STRINGS.BUTTON_CANCEL_JOB:
					this.setStyle("icon",iconCancel);
				break;
				case STRINGS.BUTTON_REFRESH_JOBSTATUS:	
					this.setStyle("icon",iconRefresh);
				break;
				case STRINGS.BUTTON_RESYNC_DATA:	
					this.setStyle("icon",iconRefresh);
				break;
				case STRINGS.BUTTON_ADD_PREVIEWS:	
					this.setStyle("icon",iconDrop);
				break;
				case STRINGS.BUTTON_ADD_THUMBNAILS:	
					this.setStyle("icon",iconDrop);
				break;
			}
			this.addEventListener(MouseEvent.MOUSE_OVER,mouseOverHandler);
			this.addEventListener(MouseEvent.MOUSE_OUT,mouseOutHandler);
						
			useHandCursor =  true;
			buttonMode = true;
			this.styleName = "menu";			
		}
		
		public override function set enabled(val:Boolean):void
		{
			super.enabled = val;			
			buttonMode = val;
			useHandCursor =  val;
		}
	
		
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			
			super.updateDisplayList(unscaledWidth,unscaledHeight);
				
						
		}
		
		private function mouseOverHandler(evt:MouseEvent):void
		{
			
			if(getStyle("textGlowColor") != null  && getStyle("textGlowColor") != "" && enabled)
			{
				textField.filters = [new GlowFilter(getStyle("themeColor"),0.7,3,3)];
			}
			
		}
		
		private function mouseOutHandler(evt:MouseEvent):void
		{
			textField.filters = null;
			
		}
	}
}