// ActionScript file
import flash.events.Event;
import flash.filesystem.File;
import flash.filesystem.FileMode;
import flash.filesystem.FileStream;
import flash.utils.ByteArray;

import framework.constants.MODULES;
import framework.constants.tables.PREFERENCE;
import framework.dialogs.MessageBox;
import framework.events.MigrationEvent;
import framework.utils.Helper;

import infrastructure.database.DataAccess;
import infrastructure.statemanagement.StateMgr;

import modules.batchcataloger.UI.JobList;
import modules.batchcataloger.framework.constants.ADMODULE;
import modules.batchcataloger.framework.constants.COMMON;
import modules.batchcataloger.framework.constants.DATABASE;
import modules.batchcataloger.framework.constants.EVENTS;
import modules.batchcataloger.framework.constants.QUERY;
import modules.batchcataloger.framework.constants.STRINGS;
import modules.batchcataloger.framework.constants.remotemethods.INFRASTRUCTURE;
import modules.batchcataloger.framework.constants.tables.SETTINGS;
import modules.batchcataloger.framework.upload.UploadManager;
import modules.batchcataloger.framework.utils.RemoteConnection;
import modules.batchcataloger.remoteobjects.FacetAssociationInfo;
import modules.batchcataloger.remoteobjects.FacetForm;

import mx.collections.ArrayCollection;
import mx.collections.XMLListCollection;
import mx.controls.Alert;
import mx.core.Application;
import mx.rpc.events.ResultEvent;
import mx.utils.Base64Encoder;



   private var jobListScreen:JobList = null;
   private var uploadManager:UploadManager;
   private var rc:RemoteConnection = null;
		
  
  	[Bindable]
   private static var _da:DataAccess
   
	public  static function get da():DataAccess
	{
		return _da;
	}
	
	public static function set da(value:DataAccess):void
	{
		_da = value;
	}
		
	public function preinit():void 
	{
		
	}
	
	public function init():void
	{	
	}
	
	public function load():void
	{			
	
	}
	
	public function RegisterEvents():void 
	{
	  	rc = new RemoteConnection();	
	    StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER] = new Object();
		
		CreateDefaultDatabase();
		
	    Application.application.addEventListener(MigrationEvent.MIGRATE+MODULES.BATCH_CATALOGER,schemaMigrationHandler);
	    Application.application.addEventListener(EVENTS.SYNC_DATA,syncDataHandler);
		Application.application.addEventListener(EVENTS.LANGUAGE_CHANGED,languageChangeHandler);
	    Application.application.addEventListener(EVENTS.SESSION_POPULATED,sessionPopulatedHandler);
	    Application.application.addEventListener(EVENTS.PREFERENCE_CHANGED,preferenceChangeHandler);
	    Application.application.addEventListener(EVENTS.RESET_DATA,resetDataHandler);
		
		jobListScreen = new JobList();
		this.addChild(jobListScreen);
		
		
		 if(StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerIPAddress != "")
		 {		 	
		 	UploadManager.Start(da);
		 }
		 
		 jobListScreen.Init();
		
		
		LoadSectionHierarchy();
		
		if(StateMgr.GetInstance().Language != "")
			UpdateLanguage(StateMgr.GetInstance().Language);
	}
	
	private function CreateDefaultDatabase():void
	{         
         var catalogerDB:File = new File(DATABASE.CATALOGER);
          
         if(!catalogerDB.exists)
          {
	          var catalogerDBOrg:File = new File(DATABASE.DEFAULT_CATALOGER);
	          catalogerDBOrg.copyTo(catalogerDB);
          }	          
	        
		da = new DataAccess(DATABASE.CATALOGER);
		
		da.openConnection(QUERY.SELECT_CATALOGJOB);
		
		da.DataAccessSelect(QUERY.SELECT_SETTINGS, settingInfoHandlder);
	 }
	
	 private function resetDataHandler(e:Event):void
	 {
	 	DeleteDataBaseFiles();
	 	CreateDefaultDatabase();
	 	
	 	UploadManager.Stop();
	 	UploadManager.Start(da);
		
		jobListScreen.Init();
	 }
	 
	 private function DeleteDataBaseFiles():void
	 {
	 	if (da != null)
	 		da.closeConnection();
	 		
	 	var catalogerDB:File = new File(DATABASE.CATALOGER);
        if(catalogerDB.exists)
        {
	        catalogerDB.deleteFile();	        
        }
	 }
	 
	 private function settingInfoHandlder(result:ArrayCollection):void
	 {
	 	StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerIPAddress = (result[0][SETTINGS.VALUE] == null?"":result[0][SETTINGS.VALUE]);
		StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerMoutPoint = (result[1][SETTINGS.VALUE] == null?"":result[1][SETTINGS.VALUE]);
		if ( result.length > 2)
			StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerCommunicationProtocol = (((result[2][SETTINGS.VALUE] == null)||(result[2][SETTINGS.VALUE] == ""))?"http://":result[2][SETTINGS.VALUE]);
		else
			StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerCommunicationProtocol = "http://";
		
 		InitializeCatalogerRemoteConnection();
	 }


	private function languageChangeHandler(evt:Event):void
	{
		
		UpdateLanguage(StateMgr.GetInstance().Language);
	}

	private function UpdateLanguage(newlanguage:String):void
	{
		try
		{
			var cacheFolder:File = Helper.CreateCacheDirectory(COMMON.CACHE_FOLDERNAME );
			
			var file:File= new File(cacheFolder.nativePath + "/" + COMMON.FILE_LOCALIZATION);
			
			var fs:FileStream = new FileStream();
			fs.open(file, FileMode.READ);
			var localizedStrings:XML = XML(fs.readUTFBytes(fs.bytesAvailable));
			var stringList:XMLList = (localizedStrings.language.(@name == newlanguage)[0]).module.(@name == "batchcataloger")[0].string;
			for each(var lstring:XML in stringList)
			{					
				switch(String(lstring.@id))
				{
					case "MD_PLEASE_SELECT_JOBS_TO_DELETE": STRINGS.PLEASE_SELECT_JOBS_TO_DELETE = lstring.@value; break;
					case "MD_DELETE_JOB_CONFIRMATION": STRINGS.DELETE_JOB_CONFIRMATION = lstring.@value; break;
					case "MD_DELETE_FILES_CONFIRMATION": STRINGS.DELETE_FILES_CONFIRMATION = lstring.@value; break;
					case "MD_MESSAGE_HEADER_CONFIRM": STRINGS.MESSAGE_HEADER_CONFIRM = lstring.@value; break;
					case "MD_MESSAGE_HEADER_ERROR": STRINGS.MESSAGE_HEADER_ERROR = lstring.@value; break;
					case "MD_JOBLIST_JOBNAME": STRINGS.JOBLIST_JOBNAME = lstring.@value; break;
					case "MD_JOBLIST_STATUS": STRINGS.JOBLIST_STATUS = lstring.@value; break;
					case "MD_JOBDETAILS_ORIGINAL": STRINGS.JOBDETAILS_ORIGINAL = lstring.@value; break;
					case "MD_JOBDETAILS_PREVIEW": STRINGS.JOBDETAILS_PREVIEW = lstring.@value; break;
					case "MD_JOBDETAILS_THUMBNAIL": STRINGS.JOBDETAILS_THUMBNAIL = lstring.@value; break;
					case "MD_JOBDETAILS_DESCRIPTION": STRINGS.JOBDETAILS_DESCRIPTION = lstring.@value; break;
					case "MD_JOBDETAILS_EXPIRYDATE": STRINGS.JOBDETAILS_EXPIRYDATE = lstring.@value; break;
					case "MD_JOBDETAILS_TARGETLOCATION": STRINGS.JOBDETAILS_TARGETLOCATION = lstring.@value; break;
					case "MD_JOBDETAILS_BUSINESSINFORMATION": STRINGS.JOBDETAILS_BUSINESSINFORMATION = lstring.@value; break;
					case "MD_JOBDETAILS_ASSETINFORMATION": STRINGS.JOBDETAILS_ASSETINFORMATION = lstring.@value; break;
					case "MD_BUTTON_DELTE_JOB": STRINGS.BUTTON_DELTE_JOB = lstring.@value; break;
					case "MD_BUTTON_NEW_JOB": STRINGS.BUTTON_NEW_JOB = lstring.@value; break;
					case "MD_BUTTON_REFRESH_JOBSTATUS": STRINGS.BUTTON_REFRESH_JOBSTATUS = lstring.@value; break;
					case "MD_BUTTON_RESYNC_DATA": STRINGS.BUTTON_RESYNC_DATA = lstring.@value; break;
					case "MD_TOOLTIP_JOBSTATUS_ERROR": STRINGS.TOOLTIP_JOBSTATUS_ERROR = lstring.@value; break;
					case "MD_MESSAGE_HEADER_RESYNC_CONFIRM": STRINGS.MESSAGE_HEADER_RESYNC_CONFIRM = lstring.@value; break;
					case "MD_MESSAGE_RESYNC_ALERT": STRINGS.MESSAGE_RESYNC_ALERT = lstring.@value; break;
					case "MD_BUTTON_SAVE_SHARED":  STRINGS.BUTTON_TREEVIEW_SAVE = STRINGS.BUTTON_SAVE_AS_DRAFT = lstring.@value; break;
					case "MD_BUTTON_SUBMIT": STRINGS.BUTTON_SUBMIT = lstring.@value; break;
					case "MD_BUTTON_CANCEL_SHARED": STRINGS.BUTTON_ADD_FILES_ERROR_CANCEL = STRINGS.BUTTON_ADD_FILES_CANCEL = STRINGS.BUTTON_TREEVIEW_CANCEL = STRINGS.BUTTON_CREATESECTION_CANCEL = STRINGS.BUTTON_TARGETLOCATION_CANCEL = STRINGS.BUTTON_CANCEL_JOB = lstring.@value; break;
					case "MD_BUTTON_ADD_PREVIEWS": STRINGS.BUTTON_ADD_PREVIEWS = lstring.@value; break;
					case "MD_BUTTON_ADD_THUMBNAILS": STRINGS.BUTTON_ADD_THUMBNAILS = lstring.@value; break;
					case "MD_LABEL_DROP_THUMBNAIL_HERE": STRINGS.LABEL_DROP_THUMBNAIL_HERE = lstring.@value; break;
					case "MD_LABEL_DROP_PREVIEW_HERE": STRINGS.LABEL_DROP_PREVIEW_HERE = lstring.@value; break;
					case "MD_LABEL_JOB_NAME": STRINGS.LABEL_JOB_NAME = lstring.@value; break;
					case "MD_MESSAGE_CHANGE_JOBNAME": STRINGS.MESSAGE_CHANGE_JOBNAME = lstring.@value; break;
					case "MD_BUTTON_TARGETLOCATION_SELECT": STRINGS.BUTTON_TARGETLOCATION_SELECT = lstring.@value; break;
					case "MD_BUTTON_TARGETLOCATION_CREATESECTION": STRINGS.BUTTON_TARGETLOCATION_CREATESECTION = lstring.@value; break;
					case "MD_ERROR_SELECT_SECTION": STRINGS.ERROR_SELECT_SECTION = lstring.@value; break;
					case "MD_LABEL_CREATESECTION_FORM": STRINGS.LABEL_CREATESECTION_FORM = lstring.@value; break;
					case "MD_LABEL_CREATESECTION_NAME": STRINGS.LABEL_CREATESECTION_NAME = lstring.@value; break;
					case "MD_BUTTON_CREATESECTION_DONE": STRINGS.BUTTON_CREATESECTION_DONE = lstring.@value; break;
					case "MD_ERROR_SECTION_ALREADY_EXIST": STRINGS.ERROR_SECTION_ALREADY_EXIST = lstring.@value; break;
					case "MD_LABEL_SELECT": STRINGS.LABEL_SELECT = lstring.@value; break;
					case "MD_BUTTON_ADD": STRINGS.BUTTON_ADD = lstring.@value; break;
					case "MD_BUTTON_SAVE_DATA": STRINGS.BUTTON_SAVE_DATA = lstring.@value; break;
					case "MD_INVALID_BUSINESSINFO_ERRORMESSAGE": STRINGS.INVALID_BUSINESSINFO_ERRORMESSAGE = lstring.@value; break;
					case "MD_LABEL_ADD_PREVIEWS": STRINGS.LABEL_ADD_PREVIEWS = lstring.@value; break;
					case "MD_LABEL_ADD_THUMBNAILS": STRINGS.LABEL_ADD_THUMBNAILS = lstring.@value; break;
					case "MD_LABEL_ADD_FILES_ERROR": STRINGS.LABEL_ADD_FILES_ERROR = lstring.@value; break;
					case "MD_LABEL_ADD_PREVIEWS_ERROR_DETAIL": STRINGS.LABEL_ADD_PREVIEWS_ERROR_DETAIL = lstring.@value; break;
					case "MD_LABEL_ADD_THUMBNAILS_ERROR_DETAIL": STRINGS.LABEL_ADD_THUMBNAILS_ERROR_DETAIL = lstring.@value; break;
					case "MD_LABEL_UPLOAD_PREVIEWS_INFO": STRINGS.LABEL_UPLOAD_PREVIEWS_INFO = lstring.@value; break;
					case "MD_LABEL_UPLOAD_THUMBNAILS_INFO": STRINGS.LABEL_UPLOAD_THUMBNAILS_INFO = lstring.@value; break;
					case "MD_LABEL_SELECT_PREVIEWS_INFO": STRINGS.LABEL_SELECT_PREVIEWS_INFO = lstring.@value; break;
					case "MD_LABEL_SELECT_THUMBNAILS_INFO": STRINGS.LABEL_SELECT_THUMBNAILS_INFO = lstring.@value; break;
					case "MD_BUTTON_SELECT_PREVIEWS": STRINGS.BUTTON_SELECT_PREVIEWS = lstring.@value; break;
					case "MD_BUTTON_SELECT_THUMBNAILS": STRINGS.BUTTON_SELECT_THUMBNAILS = lstring.@value; break;
					case "MD_ERROR_ALL_FIELDS_ARE_MANDATORY": STRINGS.ERROR_ALL_FIELDS_ARE_MANDATORY = lstring.@value; break;
					case "MD_ERROR_COULD_NOT_CONNECT_TO_SERVER": STRINGS.ERROR_COULD_NOT_CONNECT_TO_SERVER = lstring.@value; break;
					case "MD_ERROR_LOADING_SECTIONS": STRINGS.ERROR_LOADING_SECTIONS = lstring.@value; break;
					case "MD_ERROR_LOADING_LANGUAGES": STRINGS.ERROR_LOADING_LANGUAGES = lstring.@value; break;
					case "MD_ERROR_CONNECTION_FAILURE": STRINGS.ERROR_CONNECTION_FAILURE = lstring.@value; break;
					case "MD_ERROR_CATALOGER_CONNECTION_FAILURE": STRINGS.ERROR_CATALOGER_CONNECTION_FAILURE = lstring.@value; break;
					case "MD_ERROR_JOB_NAME_IS_MANDATORY": STRINGS.ERROR_JOB_NAME_IS_MANDATORY = lstring.@value; break;
					case "MD_ERROR_JOB_NAME_SPECIALCHARS": STRINGS.ERROR_JOB_NAME_SPECIALCHARS = lstring.@value; break;
					case "MD_ERROR_TARGET_LOCATION_NOT_SET_FOR_ALL_ASSETS": STRINGS.ERROR_TARGET_LOCATION_NOT_SET_FOR_ALL_ASSETS = lstring.@value; break;
					case "MD_ERROR_RETRIEVING_SECTION_HIERARCHY": STRINGS.ERROR_RETRIEVING_SECTION_HIERARCHY = lstring.@value; break;
					case "MD_NETWORK_STATUS_CONNECTED": STRINGS.NETWORK_STATUS_CONNECTED = lstring.@value; break;
					case "MD_NETWORK_STATUS_DISCONNECTED": STRINGS.NETWORK_STATUS_DISCONNECTED = lstring.@value; break;
					case "MD_WIP_SAVING": STRINGS.WIP_SAVING = lstring.@value; break;
					case "MD_WIP_SUBMITTING": STRINGS.WIP_SUBMITTING = lstring.@value; break;
					case "MD_WIP_RESYNCING_WITH_SERVER": STRINGS.WIP_RESYNCING_WITH_SERVER = lstring.@value; break;
					case "MD_WIP_LOADING": STRINGS.WIP_LOADING = lstring.@value; break;
					case "MD_WIP_REFRESHING_STATUS": STRINGS.WIP_REFRESHING_STATUS = lstring.@value; break;
					case "MD_WIP_SAVING_BUSINESSINFORMATION": STRINGS.WIP_SAVING_BUSINESSINFORMATION = lstring.@value; break;
					
					case "January_Shared": STRINGS.MonthLabels[0] = lstring.@value; break;
					case "Febuary_Shared": STRINGS.MonthLabels[1] = lstring.@value; break;
					case "March_Shared": STRINGS.MonthLabels[2] = lstring.@value; break;
					case "April_Shared": STRINGS.MonthLabels[3] = lstring.@value; break;
					case "May_Shared": STRINGS.MonthLabels[4] = lstring.@value; break;
					case "June_Shared": STRINGS.MonthLabels[5] = lstring.@value; break;
					case "July_Shared": STRINGS.MonthLabels[6] = lstring.@value; break;
					case "August_Shared": STRINGS.MonthLabels[7] = lstring.@value; break;
					case "September_Shared": STRINGS.MonthLabels[8] = lstring.@value; break;
					case "October_Shared": STRINGS.MonthLabels[9] = lstring.@value; break;
					case "November_Shared": STRINGS.MonthLabels[10] = lstring.@value; break;
					case "December_Shared": STRINGS.MonthLabels[11] = lstring.@value; break;
					
					
					case "S_Shared": STRINGS.WeekDayshortLabels[6] = STRINGS.WeekDayshortLabels[0] = lstring.@value; break;
					case "M_Shared": STRINGS.WeekDayshortLabels[1] = lstring.@value; break;
					case "T_Shared": STRINGS.WeekDayshortLabels[4] = STRINGS.WeekDayshortLabels[2] = lstring.@value; break;
					case "W_Shared": STRINGS.WeekDayshortLabels[3] = lstring.@value; break;
					case "F_Shared": STRINGS.WeekDayshortLabels[5] = lstring.@value; break;
					
					case "MD_CATALOGER_JOBSTATUS_DRAFT": STRINGS.JOB_STATUS_DRAFT_DISPLAYTEXT = lstring.@value; break;
					case "MD_CATALOGER_JOBSTATUS_SUBMITTED": STRINGS.JOB_STATUS_SUBMITTED_DISPLAYTEXT = lstring.@value; break;
					case "MD_CATALOGER_JOBSTATUS_DROP_INPROGRESS": STRINGS.JOB_DROP_INPROGRESS_DISPLAYTEXT = lstring.@value; break;	
					case "MD_CONFIRM_SAVE_BUSINESSINFO": STRINGS.CONFIRM_SAVE_BUSINESSINFO = lstring.@value; break;					
					case "MD_JOB_INPROGRESS_DISPLAYTEXT": STRINGS.JOB_INPROGRESS_DISPLAYTEXT =  lstring.@value; break;
					case "MD_MESSAGE_JOBNAME_ALREADY_EXISTS": STRINGS.MESSAGE_JOBNAME_ALREADY_EXISTS =  lstring.@value; break;	
					case "MD_TOOLTIP_JOBSTATUS_INPROGRESS": STRINGS.TOOLTIP_JOBSTATUS_INPROGRESS = lstring.@value; break;
					
					case "MD_REPLACE_PREVIEW_FILES_CONFIRMATION": STRINGS.REPLACE_PREVIEW_FILES_CONFIRMATION =  lstring.@value; break;	
					case "MD_REPLACE_THUMBNAIL_FILES_CONFIRMATION": STRINGS.REPLACE_THUMBNAIL_FILES_CONFIRMATION = lstring.@value; break;
					case "MD_ORIGINAL_FILE_ALREADY_PRESENT": STRINGS.ORIGINAL_FILE_ALREADY_PRESENT = lstring.@value; break;
				}	
				
			}
			Helper.initializeLocalizedStrings(stringList);
			fs.close();
		}
		catch(ex:Error)
		{
			MessageBox.Show(STRINGS.ERROR_LOADING_LANGUAGES);
			StateMgr.GetInstance().logger.Write("batchcataloger","UpdateLanguage",ex.toString());
			
		}
		jobListScreen.setText();
	}
	
	private  function syncDataHandler(evt:Event):void
	{
		// da = new DataAccess(DATABASE.CATALOGER);
		// open the connection and set the initial data result to view
		
		if(da != null)
			da.openConnection(QUERY.SELECT_CATALOGJOB);
		
		jobListScreen.Init();
		
		RetrieveSectionHierarchy();
		
		RetrieveFacetInformation();
	}
	
	private function RetrieveSectionHierarchy():void
	{
		StateMgr.GetInstance().SyncingData(COMMON.SYNC_DATA_SECTION_HIERARCHY);
		StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.GET_SECTION_HIERARCHY).removeEventListener(ResultEvent.RESULT,sectionHierarchyHandler);
		StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.GET_SECTION_HIERARCHY).addEventListener(ResultEvent.RESULT,sectionHierarchyHandler);
		StateMgr.GetInstance().Fascade.GetSectionHierarchy(StateMgr.GetInstance().SessionObject);
	}
	
	private function preferenceChangeHandler(evt:Event):void
	{		
		//RetrieveCatalogerData();
	}
	
	private function RetrieveCatalogerData():void
	{
		StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.GET_CATALOGER_INFO).removeEventListener(ResultEvent.RESULT, catalogerInfoHandler);
		StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.GET_CATALOGER_INFO).addEventListener(ResultEvent.RESULT, catalogerInfoHandler);
		StateMgr.GetInstance().Fascade.GetCatalogerInformation(StateMgr.GetInstance().SessionObject);
	}
		
	private function catalogerInfoHandler(evt:ResultEvent):void
	{
		if(evt.result is ArrayCollection)
		{				
			var encoder:Base64Encoder = new Base64Encoder();
			encoder.encodeUTFBytes(evt.result[0]);
			var mountpoint:String = encoder.flush();
			
			StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerIPAddress = evt.result[1];
			StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerMoutPoint = mountpoint;
			
			var CatalogerCommunicationProtocol:String = evt.result[2];
			//var CatalogerCommunicationProtocol:String = "http://";
			StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerCommunicationProtocol = CatalogerCommunicationProtocol; //"http://";
			
			da.DataAccessUpdate("UPDATE SETTINGS SET VALUE='"+evt.result[1]+"' where NAME='CatalogerIP'");
			da.DataAccessUpdate("UPDATE SETTINGS SET VALUE='"+mountpoint+"' where NAME='CatalogerMountPoint'");
			da.DataAccessUpdate("UPDATE SETTINGS SET VALUE='"+CatalogerCommunicationProtocol+"' where NAME='CatalogerCommunicationProtocol'");
			
			InitializeCatalogerRemoteConnection();
										
			UploadManager.Start(da);			
		}	
	}
	
	private function InitializeCatalogerRemoteConnection():void
	{
	   if(rc != null && StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].Fascade != null)
	    {
			rc.DisconnectCataloger(StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].Fascade);
	    }
	 	StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].Fascade = rc.GetCatalogerConnection(StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerCommunicationProtocol+StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerIPAddress+"/ADCataloger/Default.aspx");
		//StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].Fascade = rc.GetCatalogerConnection(protocol + "://"+StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerIPAddress+"/ADCataloger/Default.aspx");
	}		
		
	private function sectionHierarchyHandler(evt:ResultEvent):void
	{	
		var xml:String = null;
		
		//check if the data is in format of ByteArray, the new logic to compress the
		//data is returned in ByuteArray
		//old logic (uncompressed) still returns in string format
		if (evt.result is ByteArray)
		{
			var ba:ByteArray = evt.result as ByteArray
			ba.uncompress();			
			ba.position = 0;
		
			xml = ba.readUTFBytes(ba.bytesAvailable);
		}
		else
			xml = evt.result as String;
		
		if(xml.indexOf("<Error>") == 0)
		{	
		     MessageBox.Show(STRINGS.ERROR_RETRIEVING_SECTION_HIERARCHY);
			 StateMgr.GetInstance().logger.Write(ADMODULE.INFRASTRUCTURE,"sectionHierarchyHandler()",xml);			
		}
		
		var cachefolder:File = Helper.CreateCacheDirectory(COMMON.CACHE_FOLDERNAME+"/"+StateMgr.GetInstance().UserId);
          
		var sectionhierarchy:File = cachefolder.resolvePath("sectionhierarchy.xml");
		  
		var stream:FileStream = new FileStream();
		stream.open(sectionhierarchy, FileMode.WRITE);		
		stream.writeMultiByte(xml,'UTF-8');
		stream.close();
		
		this.parentApplication.dispatchEvent(new Event(EVENTS.SECTIONHIERARCHY_REFRESHED));
		StateMgr.GetInstance().DataSynced(COMMON.SYNC_DATA_SECTION_HIERARCHY);
	}
	
	private function sessionPopulatedHandler(evet:Event):void
	{
		//Mudassar: Cataloger mount point path is retriev on session vheck earlier it was o
		//on preference change
			RetrieveCatalogerData();	
	}
	
/*	private function catalogerInfoHandler(evet:Event):void
	{	 
		Application.application.dispatchEvent(new Event(EVENTS.REFRESH_JOB_STATUS));
		UploadManager.Start(da);
	}
*/	
	
	
	private function RetrieveFacetInformation():void
	{ 
		StateMgr.GetInstance().SyncingData(COMMON.SYNC_DATA_FACET_INFO);
		StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.GET_FACET_LIST).removeEventListener(ResultEvent.RESULT, getFacetFormList);
		StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.GET_FACET_LIST).addEventListener(ResultEvent.RESULT, getFacetFormList);
		StateMgr.GetInstance().Fascade.GetFacetList(StateMgr.GetInstance().SessionObject);
	}
	
	
	 public function getFacetFormList(event:ResultEvent):void
        {
        	
   		   var facetInfoObj:FacetAssociationInfo = event.result as FacetAssociationInfo;
        	
        	var cachefolder:File = Helper.CreateCacheDirectory(COMMON.CACHE_FOLDERNAME+"/"+StateMgr.GetInstance().UserId);
        	var facetNameListXML:File = cachefolder.resolvePath(COMMON.FILE_FACETNAMELIST);
        	var nhCollectionXML:File = cachefolder.resolvePath(COMMON.FILE_NHCOLLECTION);
			var facetLocalizationXML:File = cachefolder.resolvePath(COMMON.FILE_FACETLOCALIZATION);
			
			var stream:FileStream = new FileStream();
			stream.open(facetNameListXML, FileMode.WRITE);			
			stream.writeMultiByte(facetInfoObj.FacetNameList,'UTF-8');
			stream.close();
			
			stream.open(nhCollectionXML, FileMode.WRITE);			
			stream.writeMultiByte(facetInfoObj.NamedHeirarchyXML,'UTF-8');
			stream.close();
			
			stream.open(facetLocalizationXML, FileMode.WRITE);			
			stream.writeMultiByte(facetInfoObj.LocalizationXML,'UTF-8');
			stream.close();
        	
        	var facetTemplateStr:String = '<FACETTEMPLATE>';
        	for (var i:int = 0; i < facetInfoObj.FacetFormList.length; i++)
        	{
        		var currFacet:FacetForm = facetInfoObj.FacetFormList[i];
        		facetTemplateStr += '<'+currFacet.RelationshipName+'>';
        		facetTemplateStr += '<'+currFacet.Name+'>';
        		facetTemplateStr += '</'+currFacet.Name+'>';
        		facetTemplateStr += '</'+currFacet.RelationshipName+'>';
        		var currFacetConfig:File = cachefolder.resolvePath(currFacet.RelationshipName + "_FormConfiguration.xml");
        		stream.open(currFacetConfig, FileMode.WRITE);        		
				stream.writeMultiByte(currFacet.FormConfigXML,'UTF-8');
        		stream.close();       		
        		
        	}
        	facetTemplateStr += '</FACETTEMPLATE>';
			var facetTemplateXML:File = cachefolder.resolvePath("facettemplate.xml");
			stream.open(facetTemplateXML, FileMode.WRITE);			
			stream.writeMultiByte(facetTemplateStr,'UTF-8');
			stream.close();
			StateMgr.GetInstance().DataSynced(COMMON.SYNC_DATA_FACET_INFO);
        }
	
	protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
	{
	//	super.updateDisplayList(unscaledWidth, unscaledHeight);
	
		jobListScreen.width = unscaledWidth;
		jobListScreen.height = unscaledHeight;
	}
	
	private function refreshHandler(evt:Event):void
	{
		LoadSectionHierarchy();
	}
	
	private function LoadSectionHierarchy():void
	{
		var cacheFolder:File;
		var file:File;
		
		cacheFolder = Helper.CreateCacheDirectory(COMMON.CACHE_FOLDERNAME +"/" +StateMgr.GetInstance().UserId );
			
		file = new File(cacheFolder.nativePath + "/" + COMMON.FILE_SECTION_HIERARCHY);
			
		if(file.exists)
		{
			try
			{
				var fs:FileStream = new FileStream();
				fs.open(file, FileMode.READ);
				var sections:XML = XML(fs.readUTFBytes(fs.bytesAvailable));
				fs.close();
			}
			catch(ex:Error)
			{
				MessageBox.Show(ex.toString());
			}
			
			StateMgr.GetInstance().SectionHierarchy = new XMLListCollection(sections.TreeNode);
		
		}	
	}
	
	private function gridClickHandler(event:Event):void 
	{
		var thisItem:Object = event.currentTarget.selectedItem;
		//var listingPrice:String = thisItem.listingPrice;
		
		//htmlctrl.htmlLoader.window.calledFromAS(listingPrice);
		
		// Alert.show(thisItem.SELECTED.toString());
	}

	private function migartionRefreshStepsforVersion(version:String):void
	{
		switch(version)
		{
			case "2.0": break;
		}
	}
	
	 private function schemaMigrationHandler(evt:MigrationEvent):void
        {
		  var toVersion:String = evt.Data.toVersion;
		  var module:XML = XML(evt.Data.module);
		  
		   if(module.@refresh != null && module.@refresh.toString() != "")
		   {
			   if(module.@refresh.toString() == "true")
			   {
				   migartionRefreshStepsforVersion(toVersion);
			   }
		   }
           var queries:XMLList = module.children();
           for ( var i:Number = 0 ; i < queries.length() ; i++ )
			  {
			  	var query:XML = queries[i];
			  	da.DataAccessExecute(query.toString());
			  }
		   da.DataAccessSelect(QUERY.SELECT_CATALOGJOB);
        }
	
	