package modules.batchcataloger.framework.upload
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.utils.ByteArray;
	
	import framework.dialogs.MessageBox;
	import framework.utils.Helper;
	
	import infrastructure.database.DataAccess;
	import infrastructure.statemanagement.StateMgr;
	
	import modules.batchcataloger.framework.constants.ADMODULE;
	import modules.batchcataloger.framework.constants.COMMON;
	import modules.batchcataloger.framework.constants.EVENTS;
	import modules.batchcataloger.framework.constants.FILE_TYPE;
	import modules.batchcataloger.framework.constants.QUERY;
	import modules.batchcataloger.framework.constants.remotemethods.CATALOGERSERVICE;
	
	import mx.rpc.events.ResultEvent;
	import mx.rpc.remoting.mxml.RemoteObject;
	
	public class JobFile extends Sprite
	{
		private var jobname:String;
		private var username:String;
		private var dropfolder:String;
		private var remoteObject:RemoteObject
		private var dataAccess:DataAccess;
		
		private var uploadedBytes:Number;
		private var lastToken:Number = 0;
		private var totalBytes:Number;
		private var packetsize:Number;
		private var lastPacketSize:Number;
		
		private var fs:FileStream;
		private var file:Object;
		
		public function JobFile(folder:String,user:String,job:String,ro:RemoteObject,da:DataAccess,packetSize:Number)
		{
			dropfolder= folder;
			username = user;
			jobname = job;
			packetsize = packetSize;
			dataAccess = da;
			remoteObject = ro;
			remoteObject.getOperation(CATALOGERSERVICE.SEND_PACKET).addEventListener(ResultEvent.RESULT, packetSuccessHanlder);
				
		}
		public function Dispose():void
		{
			remoteObject.getOperation(CATALOGERSERVICE.SEND_PACKET).removeEventListener(ResultEvent.RESULT, packetSuccessHanlder);
			
		}
		
		public function Init(obj:Object):void
		{
			try
			{
				file = obj;
				uploadedBytes = file.UPLOADEDBYTES;
				totalBytes = file.TOTALBYTES;
				lastToken = (file.LASTTOKEN == null ||file.LASTTOKEN == ""?0:file.LASTTOKEN);
				
				fs = new FileStream();
				var tFile:File;
				
				tFile= new File( Helper.Decode(file.FILEPATH));
				
				fs.open(tFile, FileMode.READ);
				
				fs.position = uploadedBytes;
				
				SendPacket();
			}
			catch(ex:Error)
			{
				StateMgr.GetInstance().logger.Write(ADMODULE.UPLOADMANAGER,"JobFile.as-Init()",ex.toString());
			}
		}
		
		private function SendPacket():void
		{
			try
			{
				lastToken++;
				var finalPacket:Boolean = false;
				
				var ba:ByteArray = new ByteArray();
				if(fs.bytesAvailable > packetsize)
				{
					fs.readBytes(ba,0,packetsize);
					lastPacketSize = packetsize;
					finalPacket = false;
				}
				else
				{
					fs.readBytes(ba,0,fs.bytesAvailable);
					lastPacketSize = fs.bytesAvailable;
					finalPacket = true;
				}
				uploadedBytes = uploadedBytes + lastPacketSize;
				remoteObject.SendPacket(dropfolder,username,jobname,Helper.Decode(file.FILE),lastToken,ba,file.TYPE,finalPacket,ba.length,uint(totalBytes));
			}	
			catch(ex:Error)
			{
				StateMgr.GetInstance().logger.Write(ADMODULE.UPLOADMANAGER,"JobFile.as-SendPacket()",ex.toString());
			}		
		}
		
		private function packetSuccessHanlder(evt:ResultEvent):void
		{
			if(evt.result.toString() == "PACKETSUCCESS")
			{
				dataAccess.DataAccessUpdate("UPDATE UPLOADJOB SET UPLOADEDBYTES = "+uploadedBytes.toString()+", LASTTOKEN = "+lastToken.toString()+" WHERE UPLOADJOBID = "+file.UPLOADJOBID,QUERY.SELECT_CATALOGJOB);
				SendPacket();
				//Application.application.dispatchEvent(new UploadJobEvent(UploadJobEvent.IN_PROGRESS,file.UPLOADJOBID));
			}
			else if (evt.result.toString() == "FILESUCCESS")
			{
				var q:String = "UPDATE UPLOADJOB SET UPLOADED = 1, UPLOADEDBYTES = "+file.TOTALBYTES+", LASTTOKEN = "+lastToken.toString()+"  WHERE UPLOADJOBID = "+file.UPLOADJOBID;
				dataAccess.DataAccessUpdate(q,QUERY.SELECT_CATALOGJOB);
				fs.close();
				fs = null;
				this.dispatchEvent(new Event(EVENTS.JOBFILE_UPLOADED));
				//Application.application.dispatchEvent(new UploadJobEvent(UploadJobEvent.UPLOAD_COMPLETE,file.UPLOADJOBID));			
			}
			else if(evt.result.toString() == "INVALIDPACKET")
			{
				//resend the packet
				lastToken--;
				uploadedBytes = uploadedBytes - lastPacketSize;
				fs.position = uploadedBytes;
				SendPacket();
			}
			else
			{
				MessageBox.Show(evt.message.toString());
			}
			
			
		}
		

	}
}