package  modules.batchcataloger.framework.upload
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.StatusEvent;
	import flash.filesystem.File;
	import flash.utils.ByteArray;
	
	import framework.constants.MODULES;
	import framework.constants.tables.PREFERENCE;
	import framework.utils.Helper;
	
	import infrastructure.database.DataAccess;
	import infrastructure.statemanagement.StateMgr;
	
	import modules.batchcataloger.framework.constants.ADMODULE;
	import modules.batchcataloger.framework.constants.COMMON;
	import modules.batchcataloger.framework.constants.EVENTS;
	import modules.batchcataloger.framework.constants.QUERY;
	import modules.batchcataloger.framework.constants.remotemethods.CATALOGERSERVICE;
	import modules.batchcataloger.framework.utils.RemoteConnection;
	
	import mx.collections.ArrayCollection;
	import mx.core.Application;
	import mx.rpc.events.ResultEvent;
	import mx.rpc.remoting.mxml.RemoteObject;	
	
	public class UploadManager extends Sprite
	{
		private var UploadQueue:ArrayCollection = new ArrayCollection();
		
		private static var uploadMgr:UploadManager = null;
		
		private var currentJob:ArrayCollection = null;
		private var fileIndex:int =-1;
		private var lastToken:int =-1;
		
		private var jobIndex:int = -1;
		
		private var currentFile:JobFile;
		
		private var da:DataAccess;
		private var ro:RemoteObject;
		private var rc:RemoteConnection;
		
		private var PACKET_SIZE:Number = 1048576;//1 mb = 1024 * 1024
	
		public function UploadManager(dataAccess:DataAccess)
		{
			 da = dataAccess;
			 Application.application.addEventListener(StatusEvent.STATUS,statusHandler);
			 rc = new RemoteConnection();
			 if(StateMgr.GetInstance().IsConnectedToServer)
			 {
			 	Init();
			 }
			
		}
		
		private function statusHandler(event:StatusEvent):void
		{
			if(StateMgr.GetInstance().IsConnectedToServer)
			{
				//StateMgr.GetInstance().hasErrorOccured = false;
				Init();
			}
			else
			{
			  if(ro != null)
			  {
				ro = rc.DisconnectCataloger(ro);
				currentJob = null;
			  }	
			}
		}
		
		private function Init(bForce:Boolean=false):void
		{
			if(bForce)
			{				
			  if(ro != null)
			   {
				ro = rc.DisconnectCataloger(ro);
				StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].Fascade = rc.GetCatalogerConnection(StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerCommunicationProtocol +StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerIPAddress+"/ADCataloger/Default.aspx");
				//StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].Fascade = rc.GetCatalogerConnection(protocol + "://"+StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerIPAddress+"/ADCataloger/Default.aspx");
		 		
				currentJob = null;
			   }	
			}
			
			if(currentJob == null)
			{
		 		ro = StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].Fascade;
	 			da.DataAccessSelect(QUERY.SELECT_CATALOGJOB_INPROGRESS,inprogressjobHandler);
		 	}	
		}
		
		private function  inprogressjobHandler(result:ArrayCollection):void
		{
			for(var i:int=0;i<result.length; i++)
			{
				var obj:Object = new Object();
				obj.JOBID = result[i].JOBID;
				obj.JOBNAME = result[i].JOBNAME;
				obj.ASSETINFO = result[i].ASSETINFO;
				UploadQueue.addItem(obj);
			}
			jobIndex = -1;
			StartNextJob();
		}
		
		private function StartUploadingJob(jobid:Object):void
		{			
			da.DataAccessSelect(QUERY.SELECT_UPLOADJOB.replace("$JOBID$",jobid.toString()),jobDetailsHandler);
		}
		
		private function jobDetailsHandler(result:ArrayCollection):void
		{
			currentJob = result;
			fileIndex = 0;
			if(currentJob.length > 0)
			{
				if(currentFile != null)
				{
					currentFile.Dispose();
					currentFile = null;
				}
				
				//currentFile = new JobFile(StateMgr.GetInstance().CatalogerMoutPoint,StateMgr.GetInstance().UserId,UploadQueue[jobIndex].JOBNAME,ro,da,PACKET_SIZE);
				currentFile = new JobFile(StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerMoutPoint,StateMgr.GetInstance().UserId,Helper.Decode(UploadQueue[jobIndex].JOBNAME),ro,da,PACKET_SIZE);
				currentFile.addEventListener(EVENTS.JOBFILE_UPLOADED,jobFileUploaded);
				currentFile.Init(currentJob[fileIndex])
			}
			else
			{
				UploadAssetInfo();
			}
			
		}
		
		private function jobFileUploaded(evt:Event):void
		{
		
			if(fileIndex+1 < currentJob.length)
			{
				fileIndex++;	
				currentFile.Init(currentJob[fileIndex]);
			}
			else
			{	 
				//delete records from database
				da.DataAccessDelete("DELETE FROM UPLOADJOB WHERE JOBID=" +currentJob[fileIndex].JOBID);
				
				// the following code for DeleteNTFSFiles has been removed to support job editing
				//clean NTFS files
				//DeleteNTFSFiles(currentJob[fileIndex].JOBID);	
				
				currentFile.Dispose();
				currentFile = null;
				UploadAssetInfo();				
			}
		}
		
		private function DeleteNTFSFiles(jobid:String):void
		{
			try
			{
				var jobFolder:File =  Helper.CreateHotDirectory(COMMON.HOT_FOLDERNAME +"/" +StateMgr.GetInstance().UserId + "/" + jobid)
				jobFolder.deleteDirectoryAsync(true);
			}
			catch(ex:Error)
			{
				StateMgr.GetInstance().logger.Write(ADMODULE.UPLOADMANAGER,"DeleteNTFSFiles()",ex.toString());
			}
		}
		
		private function UploadAssetInfo():void
		{
			ro.getOperation(CATALOGERSERVICE.SEND_PACKET).removeEventListener(ResultEvent.RESULT, assetInfoUploadHandlder);
			ro.getOperation(CATALOGERSERVICE.SEND_PACKET).addEventListener(ResultEvent.RESULT, assetInfoUploadHandlder);
			var ba:ByteArray = new ByteArray();
			ba.writeUTFBytes(Helper.Decode(UploadQueue[jobIndex].ASSETINFO));
			ro.SendPacket(StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerMoutPoint,StateMgr.GetInstance().UserId,Helper.Decode(UploadQueue[jobIndex].JOBNAME),"ASSETINFO",1,ba,"",true,ba.length,ba.length);
		}
		
		private function assetInfoUploadHandlder(evt:ResultEvent):void
		{
			ro.getOperation(CATALOGERSERVICE.SEND_PACKET).removeEventListener(ResultEvent.RESULT, assetInfoUploadHandlder);
			
			da.DataAccessUpdate("UPDATE CATALOGJOB SET STATUS='"+COMMON.JOB_STATUS_SUBMITTED+"', JOBSTATUSDISPLAYTEXTID='MD_CATALOGER_JOBSTATUS_SUBMITTED' WHERE JOBID="+UploadQueue[jobIndex].JOBID,QUERY.SELECT_CATALOGJOB);
			currentJob = null;					
			StartNextJob();
		}
		
		private function StartNextJob():void
		{	
			if(jobIndex+1 < UploadQueue.length )
			{
				jobIndex++;
				 StartUploadingJob(UploadQueue[jobIndex].JOBID);
			}	
		}
		
		private function AddJob(jobid:String, jobname:String,assetinfo:String):void
		{
			var obj:Object = new Object();
			obj.JOBID = jobid;
			obj.JOBNAME = jobname;
			obj.ASSETINFO = assetinfo;
			UploadQueue.addItem(obj);
			if(currentJob == null)
			{
				StartNextJob();
			}
		}
	
		/*public function MakeConnectionToServer(url:String):void
		{
			var serverurl:String = url;
			var amfChannel:AMFChannel = new AMFChannel("cataloger", serverurl);
		  	amfChannel.netConnection.objectEncoding = ObjectEncoding.AMF3;
		  	var amfChannelSet:ChannelSet = new ChannelSet();
		  	amfChannelSet.addChannel(amfChannel);	  	
		  
		  	
		  	ro = new RemoteObject(COMMON.REMOTING_DESTINATION);
			ro.channelSet = amfChannelSet;
			ro.source = COMMON.REMOTING_CATALOGER_SERVICE;
			ro.addEventListener(FaultEvent.FAULT,remoteConnectionHandler);
			//	ro.ValidateUser(loginname,password,tenant);
		}*/
		
		/*private function remoteConnectionHandler(evt:FaultEvent):void
		{
			Logger.Write(ADMODULE.UPLOADMANAGER,"UploadManger.as-remoteConnectionHandler()",evt.toString());
			//MessageBox.Show(evt.toString());
		}*/
		
		public static function Start(dataAccess:DataAccess):void
		{
			if(uploadMgr == null)			
			{
				uploadMgr = new UploadManager(dataAccess);
			}
			else
			{
				uploadMgr.da = dataAccess;
				uploadMgr.Init(true);
			}
		}
		private function Dispose():void
		{
			
		    Application.application.removeEventListener(StatusEvent.STATUS,uploadMgr.statusHandler);
		}
		public static function Stop():void
		{
			uploadMgr.Dispose();
			uploadMgr = null;
		}
		
		public static function AddJobToQueue(jobid:String,jobname:String,assetinfo:String):void
		{
			if(uploadMgr != null)
			{
				uploadMgr.AddJob(jobid,jobname,assetinfo);	
			}
		}
		
		
	}
}