package modules.batchcataloger.framework.utils
{
	import flash.net.ObjectEncoding;
	
	import framework.constants.MODULES;
	
	import infrastructure.statemanagement.StateMgr;
	
	import modules.batchcataloger.framework.constants.ADMODULE;
	import modules.batchcataloger.framework.constants.COMMON;
	
	import mx.messaging.ChannelSet;
	import mx.messaging.channels.AMFChannel;
	import mx.messaging.channels.SecureAMFChannel;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;
	import mx.rpc.remoting.mxml.RemoteObject;
	
	
	public class RemoteConnection
	{
		
		
		public function RemoteConnection()
		{
			
		}
		
		public function GetCatalogerConnection(url:String):RemoteObject
		{	
			var serverurl:String = url;
			var protocol:String = serverurl.split(":")[0];
			var amfChannelSet:ChannelSet = new ChannelSet();
			if (protocol.toLocaleLowerCase() == "https")
			{
				var secureAmfChannel:SecureAMFChannel = new SecureAMFChannel("securecataloger", serverurl);
				secureAmfChannel.netConnection.objectEncoding = ObjectEncoding.AMF3;
				amfChannelSet.addChannel(secureAmfChannel);				
		 	}
		 	else
		 	{
				var amfChannel:AMFChannel = new AMFChannel("cataloger", serverurl);
				amfChannel.netConnection.objectEncoding = ObjectEncoding.AMF3;
				amfChannelSet.addChannel(amfChannel);
		  	}
		  	var ro:RemoteObject = new RemoteObject(COMMON.REMOTING_DESTINATION);
			ro.channelSet = amfChannelSet;
			ro.source = COMMON.REMOTING_CATALOGER_SERVICE;
			ro.addEventListener(FaultEvent.FAULT,remoteConnectionHandler);
			ro.addEventListener(ResultEvent.RESULT,resultConnectionHandler);
			ro.GetCatalogedFilesCount(StateMgr.GetInstance().Modules[MODULES.BATCH_CATALOGER].CatalogerMoutPoint,StateMgr.GetInstance().UserId,"mudassar_ankit");
			return ro;
		}
		
		public function DisconnectCataloger(ro:RemoteObject):RemoteObject
		{
			ro.disconnect();
			ro.removeEventListener(FaultEvent.FAULT,remoteConnectionHandler);
			ro = null;
			return ro;
		}
		
		private function resultConnectionHandler(evt:ResultEvent):void
		{
			StateMgr.GetInstance().hasErrorOccured = false;
		}
		
		private function remoteConnectionHandler(evt:FaultEvent):void
		{	
			StateMgr.GetInstance().logger.Write(ADMODULE.UPLOADMANAGER,"UploadManger.as-remoteConnectionHandler()",evt.toString());
			StateMgr.GetInstance().hasErrorOccured = true;
		}
	}
}