package assets
{
	import framework.constants.STRINGS;
	
	import mx.core.UIComponent;

	public class TopBar extends UIComponent
	{
		
		
		public var PreferenceBtn:LinkButton;		
		public var HelpBtn:LinkButton;
		public var AboutBtn:LinkButton;
		public var OptionsBtn:LinkButton;
		
		public function TopBar()
		{
			super();
			PreferenceBtn = new LinkButton(STRINGS.BUTTON_PREFERENCE_LINK);
			HelpBtn = new LinkButton(STRINGS.BUTTON_HELP_LINK);
			AboutBtn = new LinkButton(STRINGS.BUTTON_ABOUT_LINK);
			OptionsBtn = new LinkButton(STRINGS.BUTTON_OPTIONS_LINK);
			this.styleName = "topbarstyle";
		}
		
		public function setText():void
		{
			PreferenceBtn.label = STRINGS.BUTTON_PREFERENCE_LINK;
			HelpBtn.label = STRINGS.BUTTON_HELP_LINK;
			AboutBtn.label = STRINGS.BUTTON_ABOUT_LINK;
			OptionsBtn.label = STRINGS.BUTTON_OPTIONS_LINK;
		}
		
		public function get Height():Number
		{
			return this.height;
		}
		
		protected override function createChildren():void
		{
			PreferenceBtn.height = 25;
			PreferenceBtn.width = 90;
			this.addChild(PreferenceBtn);
			
			OptionsBtn.height = 25;
			OptionsBtn.width = 90;
			this.addChild(OptionsBtn);
			
			HelpBtn.height = 25;
			HelpBtn.width = 90;
			this.addChild(HelpBtn);		
			
			AboutBtn.height = 25;
			AboutBtn.width = 90;
			this.addChild(AboutBtn);
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			//topBarBk.x = 0;
			//topBarBk.y= 0;
			//topBarBk.width = unscaledWidth;
										
			this.graphics.clear();
			this.graphics.beginFill(getStyle("bodyColor"),1);
			this.graphics.drawRect(0, 0, unscaledWidth, unscaledHeight);
			this.graphics.beginFill(getStyle("embossTopColor"),1);
			this.graphics.drawRect(0, 0, unscaledWidth, 1);
			this.graphics.beginFill(getStyle("embossBottomFirstColor"),1);
			this.graphics.drawRect(0, unscaledHeight-2, unscaledWidth, 1);
			this.graphics.beginFill(getStyle("embossBottomLastColor"),1);
			this.graphics.drawRect(0, unscaledHeight-1, unscaledWidth, 1);
			
			
			PreferenceBtn.y = (unscaledHeight - PreferenceBtn.height)/2;
			HelpBtn.y = PreferenceBtn.y;
			AboutBtn.y = PreferenceBtn.y;
			OptionsBtn.y = PreferenceBtn.y;
			
			PreferenceBtn.x = 5;
			OptionsBtn.x = PreferenceBtn.x + PreferenceBtn.width + 5;
			HelpBtn.x = OptionsBtn.x + OptionsBtn.width + 5;
			AboutBtn.x = HelpBtn.x + HelpBtn.width + 5;
		}
		
	}
}