package framework.migration
{
	import flash.events.EventDispatcher;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	
	import framework.constants.STRINGS;
	import framework.events.MigrationEvent;
	import framework.utils.WorkInProgress;
	
	import mx.core.Application;
	import mx.rpc.http.HTTPService;

	public class MigrationManager extends EventDispatcher
	{
		private var versionHttpService:HTTPService = new HTTPService();
	    private var _latestVersionStr:String;
	    
	    private var _previousSchemaVersion:Number;
	    private var _newSchemaVersion:Number;
	    
	    private var _nextControlFlow:Function;


		public function MigrationManager():void
	    { 
	    }
	    
		public function start(previousSchemaVersion:Number,newSchemaVersion:Number,nextControlFlow:Function):void
		{
			_nextControlFlow = nextControlFlow;
	        _previousSchemaVersion = previousSchemaVersion;
	        _newSchemaVersion = newSchemaVersion;
			
			var config:File = new File(File.applicationDirectory.resolvePath("resources/config/migrationconfig.xml").nativePath);
			var fs:FileStream = new FileStream();
			fs.open(config, FileMode.READ);
			var scriptsStr:String = fs.readUTFBytes(fs.bytesAvailable);
			fs.close();
				
			migrate(scriptsStr);
		}
		
	 
	
	  
	    private function migrate(configXML:String):void
	    {
	        var migrationConfig:XML = new XML(configXML);
	        var migrationScripts:XMLList = migrationConfig.children();
	        
	        var lastSchemaVersion:Number = _previousSchemaVersion;
	        var newSchemaVersion:Number = _newSchemaVersion;
	        
	       
	        
	        for ( var i:Number = 0 ; i < migrationScripts.length() ; i++ )
			  {
			  	  var migrationScript:* = migrationScripts[i];			  	  
			  	  
			  	  if(lastSchemaVersion == Number(migrationScript.@fromversion))
			  	  {
			  	  	var modules:XMLList = migrationScript.modules.children();
			  	  	for ( var j:Number = 0 ; j < modules.length() ; j++ )
			 		 {
			 		 	var module:XML = modules[j];
			 		 	var modulename:String =  module.name();
						var data:Object = new Object();
						data.toVersion = migrationScript.@toversion;
						data.module = module;
			 		 	 Application.application.dispatchEvent(new MigrationEvent(MigrationEvent.MIGRATE+modulename,data));
			 		 }
			  	  	
			  	  	        
			  	  	 lastSchemaVersion = Number(migrationScript.@toversion);
			  	  } 
			  	  
			  	  if(lastSchemaVersion == newSchemaVersion)
			  	     break;
			  	  
			  }
	        
	       WorkInProgress.Hide(STRINGS.WIP_MIGRATING_SCHEMA);
	       if(_nextControlFlow != null)
		   {
		     _nextControlFlow();
		   }
	    }    
		
	}
}