package framework.preference
{
	import assets.ButtonEx;
	
	import flash.display.CapsStyle;
	import flash.display.InteractiveObject;
	import flash.display.JointStyle;
	import flash.display.LineScaleMode;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.filesystem.File;
	import flash.filters.DropShadowFilter;
	import flash.net.ObjectEncoding;
	import flash.system.Security;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	import flash.ui.Keyboard;
	
	import framework.constants.ADMODULE;
	import framework.constants.COMMON;
	import framework.constants.EVENTS;
	import framework.constants.STRINGS;
	import framework.constants.remotemethods.INFRASTRUCTURE;
	import framework.constants.tables.PREFERENCE;
	import framework.remoteobjects.Session;
	import framework.utils.Helper;
	import framework.utils.SessionUtil;
	import framework.utils.WorkInProgress;
	
	import infrastructure.statemanagement.StateMgr;
	
	import mx.binding.utils.BindingUtils;
	import mx.controls.CheckBox;
	import mx.controls.ComboBox;
	import mx.controls.TextInput;
	import mx.core.UIComponent;
	import mx.messaging.ChannelSet;
	import mx.messaging.channels.AMFChannel;
	import mx.messaging.channels.SecureAMFChannel;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;
	import mx.rpc.remoting.mxml.RemoteObject;

	public class PreferenceUI extends UIComponent
	{
		private var dialogWidth:int = 430;
		private var dialogHeight:int = 360;
		private var dialogBox:Sprite;
		
		private var rememberMeSelect:CheckBox;
		private var saveBtn:ButtonEx;
		private var cancelBtn:ButtonEx;
		private var browseHotFolderBtn:ButtonEx;
		
		private var header:TextField;
		
		private var labelLogin:TextField;
		private var labelPassword:TextField;
		private var labelServer:TextField;
		private var labelTenant:TextField;
		private var labelProtocol:TextField;
		private var labelRememberMe:TextField;
		private var labelHotFolder:TextField;
		
		private var labelError:TextField;
		
		private var txtLogin:TextInput;
		private var txtPassword:TextInput;
		private var txtServer:TextInput;
		private var txtTenant:TextInput;
		private var txtHotFolder:TextInput;
		private var protocol:ComboBox;
		private var hotFolder:File;

		
		private var orgLogin:String;
		private var orgPassword:String;
		private var orgServer:String;
		private var orgTenant:String;
		private var rememberUser:Boolean = false;
		
		public function PreferenceUI()
		{
			super();	
			this.percentWidth = 100;
			this.percentHeight = 100;
							
		}
		
		protected override function createChildren():void
		{
			dialogBox = new Sprite();			
			this.addChild(dialogBox);
			
			saveBtn = new ButtonEx();
			
			saveBtn.setActualSize(70,25);
			saveBtn.addEventListener(MouseEvent.CLICK,saveHandler);
			this.addChild(saveBtn);
			
			
			cancelBtn = new ButtonEx();
			cancelBtn.setActualSize(80,25);
			cancelBtn.addEventListener(MouseEvent.CLICK,closeHandler);
			this.addChild(cancelBtn);
			
			
			var headerformat:TextFormat = new TextFormat();
			headerformat.font = getStyle("titleFontFamily");
			headerformat.color = getStyle("titleFontColor");
			headerformat.size = getStyle("titleFontSize");			
			headerformat.bold = true;			
			
			header = new TextField();
			header.defaultTextFormat = headerformat;
			//header.width = 150;
			header.autoSize = TextFieldAutoSize.LEFT;
			header.border=false;
			header.type= TextFieldType.DYNAMIC;
			header.selectable=false;
			header.mouseEnabled=false;
			
			this.addChild(header);
			
			var labelformat:TextFormat = new TextFormat();
			labelformat.font = getStyle("labelFontFamily");
			labelformat.color = getStyle("labelFontColor");
			labelformat.size = getStyle("labelFontSize");
			labelformat.bold = false;	
			
			labelLogin = new TextField();
			labelLogin.defaultTextFormat = labelformat;
			labelLogin.autoSize = TextFieldAutoSize.LEFT;
			labelLogin.border=false;
			labelLogin.type= TextFieldType.DYNAMIC;
			labelLogin.selectable=false;
			labelLogin.mouseEnabled=false;			
			this.addChild(labelLogin);
			
			labelPassword = new TextField();
			labelPassword.defaultTextFormat = labelformat;
			labelPassword.autoSize = TextFieldAutoSize.LEFT;
			labelPassword.border=false;
			labelPassword.type= TextFieldType.DYNAMIC;
			labelPassword.selectable=false;
			labelPassword.mouseEnabled=false;			
			this.addChild(labelPassword);
			
			labelServer = new TextField();
			labelServer.defaultTextFormat = labelformat;
			labelServer.autoSize = TextFieldAutoSize.LEFT;
			labelServer.border=false;
			labelServer.type= TextFieldType.DYNAMIC;
			labelServer.selectable=false;
			labelServer.mouseEnabled=false;
			this.addChild(labelServer);
			
			labelProtocol = new TextField();
			labelProtocol.defaultTextFormat = labelformat;
			labelProtocol.autoSize = TextFieldAutoSize.LEFT;
			labelProtocol.border=false;
			labelProtocol.type= TextFieldType.DYNAMIC;
			labelProtocol.selectable=false;
			labelProtocol.mouseEnabled=false;
			labelProtocol.text = "://"
			
			this.addChild(labelProtocol);
			
			labelTenant = new TextField();
			labelTenant.defaultTextFormat = labelformat;
			labelTenant.autoSize = TextFieldAutoSize.LEFT;
			labelTenant.border=false;
			labelTenant.type= TextFieldType.DYNAMIC;
			labelTenant.selectable=false;
			labelTenant.mouseEnabled=false;
			
			this.addChild(labelTenant);
			
			var errorformat:TextFormat = new TextFormat();
			errorformat.font = getStyle("errorFontFamily");
			errorformat.color = getStyle("errorFontColor");
			errorformat.size = getStyle("errorFontSize");
			errorformat.bold = false;	
			
			labelError = new TextField();
			labelError.defaultTextFormat = errorformat;
			labelError.autoSize = TextFieldAutoSize.LEFT;
			labelError.border=false;
			labelError.type= TextFieldType.DYNAMIC;
			labelError.selectable=false;
			labelError.mouseEnabled=false;
			labelError.multiline = true;
			labelError.wordWrap = true;
			labelError.width = dialogWidth-60; 
			labelError.text = ""
			
			this.addChild(labelError);
			
			rememberMeSelect = new CheckBox();
			this.addChild(rememberMeSelect);
						
			labelRememberMe = new TextField();
			labelRememberMe.defaultTextFormat = labelformat;
			labelRememberMe.autoSize = TextFieldAutoSize.LEFT;
			labelRememberMe.border=false;
			labelRememberMe.type= TextFieldType.DYNAMIC;
			labelRememberMe.selectable=false;
			labelRememberMe.mouseEnabled=false;
			
			this.addChild(labelRememberMe);
			
			txtLogin = new TextInput();
			txtLogin.width = 220;			
			txtLogin.height = 22;
			txtLogin.styleName = "preference";
			this.addChild(txtLogin);
			
			txtPassword = new TextInput();
			txtPassword.displayAsPassword = true;
			txtPassword.width = 220;
			txtPassword.height = 22;
			txtPassword.styleName = "preference";
			this.addChild(txtPassword);
			
			protocol = new ComboBox();
			protocol.width = 70;
			protocol.height = 22;
			protocol.setStyle("cornerRadius","0");
			var protocolArray:Array = new Array();
			protocolArray.push({label:"http", data:"http"});
			protocolArray.push({label:"https", data:"https"});
			protocol.dataProvider = protocolArray;
			this.addChild(protocol);
			
			txtServer = new TextInput();
			txtServer.width = 130;
			txtServer.height = 22;
			txtServer.styleName = "preference";
			this.addChild(txtServer);
			
			txtTenant = new TextInput();
			txtTenant.width = 220;
			txtTenant.height = 22;
			txtTenant.styleName = "preference";
			this.addChild(txtTenant);
			
			labelHotFolder = new TextField();
			labelHotFolder.defaultTextFormat = labelformat;
			labelHotFolder.autoSize = TextFieldAutoSize.LEFT;
			labelHotFolder.border=false;
			labelHotFolder.type= TextFieldType.DYNAMIC;
			labelHotFolder.selectable=false;
			labelHotFolder.mouseEnabled=false;
			this.addChild(labelHotFolder);
						
			txtHotFolder = new TextInput();
			txtHotFolder.width = 160;
			txtHotFolder.editable = false
			txtHotFolder.height = 22;
			txtHotFolder.styleName = "preference";
			this.addChild(txtHotFolder);
			
			browseHotFolderBtn= new ButtonEx();
			browseHotFolderBtn.setActualSize(85,22);
			browseHotFolderBtn.addEventListener(MouseEvent.CLICK,browseHandler);
			this.addChild(browseHotFolderBtn);
			
			hotFolder = new File();
			
			
			txtLogin.tabIndex = 1;
			txtPassword.tabIndex = 2;
			protocol.tabIndex = 3;
			txtServer.tabIndex = 4;
			txtTenant.tabIndex = 5;
			txtHotFolder.tabIndex = 6;		
			
			init();
			
			txtLogin.addEventListener(KeyboardEvent.KEY_DOWN,keyboardHandler);
			txtPassword.addEventListener(KeyboardEvent.KEY_DOWN,keyboardHandler);
			txtServer.addEventListener(KeyboardEvent.KEY_DOWN,keyboardHandler);
			txtTenant.addEventListener(KeyboardEvent.KEY_DOWN,keyboardHandler);
			saveBtn.addEventListener(KeyboardEvent.KEY_DOWN,keyboardHandler);
			
			if(txtLogin.text == "" && txtPassword.text=="" && txtServer.text=="" && txtTenant.text=="")
			{
				cancelBtn.enabled = false;
			}
			else
			{
				cancelBtn.enabled = true;
			}
			
			var borderSize:int = getStyle("borderThickness");
			dialogBox.graphics.lineStyle(borderSize,getStyle("borderColor"),1,true, LineScaleMode.NORMAL,
                               CapsStyle.ROUND, JointStyle.ROUND, 3);			
			
			dialogBox.graphics.beginFill(getStyle("dialogColor"),1);
			dialogBox.graphics.drawRoundRect(0 ,0 , dialogWidth, dialogHeight,25);
			dialogBox.graphics.endFill();
			
			dialogBox.graphics.lineStyle(1,getStyle("strokeColor"),1,true);
			dialogBox.graphics.moveTo(5, 5 + 25 + 5);
			dialogBox.graphics.lineTo(dialogWidth-5,5 + 25 + 5);
			var shadow:DropShadowFilter = new DropShadowFilter();
			shadow.color = getStyle("shadowColor");
			shadow.distance = 7;
			shadow.angle = 54;
			shadow.blurX = 11;
			shadow.blurY = 12;
			dialogBox.filters = [shadow];
	
			setText();
			
			//this.systemManager.stage.focus = txtLogin;
		}
		
		public function setText():void
		{
			
			browseHotFolderBtn.label = STRINGS.BUTTON_BROWSE;
			labelHotFolder.text = STRINGS.LABEL_HOT_FOLDER;
			labelRememberMe.text = STRINGS.LABEL_REMEMBER_ME;
			labelTenant.text = STRINGS.LABEL_TENANT;
			labelServer.text = STRINGS.LABEL_SERVER;
			labelPassword.text = STRINGS.LABEL_PASSWORD;
			labelLogin.text = STRINGS.LABEL_LOGIN;
			header.text = STRINGS.SCREEN_TITLE_PREFERENCE;
			saveBtn.label = STRINGS.BUTTON_SAVE;
			cancelBtn.label = STRINGS.BUTTON_CANCEL;
		}
		
		public function init():void
		{
			orgLogin = (AssetlinkDesktop.da.ResultSet[0][PREFERENCE.VALUE] == null?"":AssetlinkDesktop.da.ResultSet[0][PREFERENCE.VALUE]);
			//orgPassword = (AssetlinkDesktop.da.ResultSet[1][PREFERENCE.VALUE] == null?"":AssetlinkDesktop.da.ResultSet[1][PREFERENCE.VALUE]);			
			orgPassword = SessionUtil.GetPassword();
			var server:String = (AssetlinkDesktop.da.ResultSet[2][PREFERENCE.VALUE] == null?"":AssetlinkDesktop.da.ResultSet[2][PREFERENCE.VALUE]);
			orgTenant = (AssetlinkDesktop.da.ResultSet[3][PREFERENCE.VALUE] == null?"":AssetlinkDesktop.da.ResultSet[3][PREFERENCE.VALUE]);
			var serverArray:Array	= server.split("://");
			orgServer = serverArray[1];
			
			if(serverArray[0] == "https")
				protocol.selectedIndex = 1;
			
			txtLogin.text = orgLogin;
			txtPassword.text = orgPassword;
			txtServer.text = orgServer;
			txtTenant.text = orgTenant;
			var hotfolderStr:String = null;
			if(AssetlinkDesktop.da.ResultSet.length >6)
				hotfolderStr = AssetlinkDesktop.da.ResultSet[6][PREFERENCE.VALUE];
			txtHotFolder.text = (hotfolderStr == null || hotfolderStr == ""?File.userDirectory.nativePath:Helper.Decode(hotfolderStr));;
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
				dialogBox.x = (unscaledWidth-dialogBox.width)/2;
				dialogBox.y = (unscaledHeight-dialogBox.height)/2;
				
				this.graphics.clear();
				this.graphics.beginFill(getStyle("backgroundColor"),getStyle("backgroundAlpha"));
				this.graphics.drawRect(0, 0, unscaledWidth, unscaledHeight);
				
				header.x = dialogBox.x + 5;
		    	header.y = dialogBox.y + 5;
		    	
		    	labelLogin.x = dialogBox.x + 30;
		    	labelPassword.x = labelLogin.x;
		    	labelServer.x = labelLogin.x;
		    	labelTenant.x = labelLogin.x;
		    	
		    	labelLogin.y = dialogBox.y + 60;
		    	labelPassword.y = labelLogin.y + 45;
		    	labelServer.y = labelPassword.y + 45;
		    	labelTenant.y = labelServer.y + 45;
		    	
		    	txtLogin.x = dialogBox.x + 157;
		    	txtPassword.x = txtLogin.x;
		    	protocol.x = txtLogin.x;
		    	labelProtocol.x = txtLogin.x + protocol.width+2;
		    	txtServer.x = labelProtocol.x+labelProtocol.width +2 ;
		    	txtTenant.x = txtLogin.x;
		    	
		    	txtLogin.y = dialogBox.y + 60;
		    	txtPassword.y = labelLogin.y + 45;
		    	labelProtocol.y = labelPassword.y + 45;
		    	protocol.y = labelPassword.y + 45;
		    	txtServer.y = labelPassword.y + 45;
		    	txtTenant.y = txtServer.y + 45;
		    	
		    	
		    	
		    	labelHotFolder.x = labelTenant.x;
		    	labelHotFolder.y = labelTenant.y + 40;
		    	
		    	txtHotFolder.x = txtLogin.x;
		    	txtHotFolder.y = labelHotFolder.y;
		    	
		    	browseHotFolderBtn.x = txtHotFolder.x + txtHotFolder.width + 10;
		    	browseHotFolderBtn.y = labelHotFolder.y;
		    	
		    	rememberMeSelect.x = labelHotFolder.x;
		    	rememberMeSelect.y = labelHotFolder.y + 40;
		    	
		    	labelRememberMe.x = rememberMeSelect.x + 20;
		    	labelRememberMe.y = rememberMeSelect.y - 10;
		    	 
		    	labelError.x = labelLogin.x;
		    	labelError.y = labelRememberMe.y + 30;
		    	
		    	
		    	saveBtn.x = dialogBox.x +(dialogWidth-saveBtn.width-cancelBtn.width -20)/2;
		    	cancelBtn.x = saveBtn.x +saveBtn.width+20;
		    
		    	saveBtn.y = dialogBox.y + dialogHeight - saveBtn.height -10;
		    	cancelBtn.y = saveBtn.y;
		    	
		}	
		
		private function browseHandler(event:MouseEvent):void
		{			
			if(hotFolder.hasEventListener(Event.SELECT))
				hotFolder.addEventListener(Event.SELECT, hotFolder_select);
				
            hotFolder.addEventListener(Event.SELECT, hotFolder_select);
            hotFolder.browseForDirectory(STRINGS.LABEL_BROWSE_FOR_DIRECTORY);
		}
		
		private function hotFolder_select(event:Event):void
		{
			txtHotFolder.text = hotFolder.nativePath;
		}
		
		private function closeHandler(event:MouseEvent):void
		{
			close();
			
		}
		
		public function close():void
		{
			labelError.text = "";
			saveBtn.enabled = true;
			cancelBtn.enabled = true;
			this.visible = false;	
		}
		private function showError(error:String):void
		{
			labelError.text = error;
			
			saveBtn.enabled = true;
			//cancelBtn.enabled = true;
		
			this.visible = true;
		}
		
		private function remoteConnectionHandler(event:Event):void
		{
			WorkInProgress.Hide(STRINGS.WIP_VALIDATING_USER_DATA);
			showError(STRINGS.ERROR_COULD_NOT_CONNECT_TO_SERVER);
			StateMgr.GetInstance().logger.Write(ADMODULE.PREFERENCE,"remoteConnectionHandler()",event.toString());
			//Alert.show(event.toString());
		}
		
		private function validateUserHandler(event:ResultEvent):void
		{		
			WorkInProgress.Hide(STRINGS.WIP_VALIDATING_USER_DATA);
			
				
			var session:Session = event.result as Session;
			
			
			
			if(session == null)
			{
				showError(STRINGS.ERROR_INVALID_CREDENTIALS);
			}
			
			else
			{				
				//do the version check for compatability with server			
				if(session.hasOwnProperty("ExpectedADVerion"))
				{
				   if(session.ExpectedADVerion != Helper.GetAssetlinkDesktopVersion())
				   {
				   	if(session.ExpectedADVerion != null && session.ExpectedADVerion != "")
				   	 {
				   	 	showError(STRINGS.ERROR_DESKTOP_NOT_COMPATIBLE_WITH_SERVER + " " + session.ExpectedADVerion);
				   	 }
				   	 else
				   	 {
				   		showError(STRINGS.ERROR_DESKTOP_NOT_COMPATIBLE_WITH_SERVER + " 1.0.1.0"); 	
				   	 }
				   	 return;
				   }
				   
				}
			
				StateMgr.GetInstance().SessionObject = session;
				close();
				StateMgr.GetInstance().UserId = txtLogin.text;
				
				updatePreferenceDetails();
				
				AssetlinkDesktop.da.ResultSet[0][PREFERENCE.VALUE] = txtLogin.text;
				//AssetlinkDesktop.da.ResultSet[1][PREFERENCE.VALUE] = txtPassword.text;
				SessionUtil.SetPassword(txtPassword.text);
				AssetlinkDesktop.da.ResultSet[2][PREFERENCE.VALUE] = protocol.selectedLabel + "://"+txtServer.text;
				AssetlinkDesktop.da.ResultSet[3][PREFERENCE.VALUE] = txtTenant.text;
				//AssetlinkDesktop.da.DataAccessSelect(QUERY.SELECT_PREFERENCE);
				dispatchEvent(new Event(EVENTS.PREFERENCE_CHANGED));
			}
		}
		
		private function saveHandler(event:MouseEvent):void
		{
			saveBtn.enabled = false;
			
			//force use to populate dat on first time use
			if(orgLogin == null || orgLogin == "")
				cancelBtn.enabled = false;
			
			if(txtLogin.text == "" || txtServer.text == "" || txtTenant.text == "")
			{
				showError(STRINGS.ERROR_ALL_FIELDS_ARE_MANDATORY);
			}
			else
			{
				if(orgTenant != txtTenant.text || orgServer != txtServer.text)
				{
					//ValidateServerURL("http://"+txtServer.text+"/"+txtTenant.text+"/Default.aspx",txtLogin.text,txtPassword.text,txtTenant.text);
					ValidateServerURL(protocol.selectedLabel,protocol.selectedLabel+ "://"+txtServer.text+"/"+txtTenant.text+"/Default.aspx",txtLogin.text,txtPassword.text,txtTenant.text);
				}
				else if(orgLogin != txtLogin.text || orgPassword != txtPassword.text)
				{
					//ValidateServerURL("http://"+txtServer.text+"/"+txtTenant.text+"/Default.aspx",txtLogin.text,txtPassword.text,txtTenant.text);
					ValidateServerURL(protocol.selectedLabel,protocol.selectedLabel+ "://"+txtServer.text+"/"+txtTenant.text+"/Default.aspx",txtLogin.text,txtPassword.text,txtTenant.text);
				}
				else
				{
					updatePreferenceDetails();
					close();
				}
			   
			}
		}		
			
		public function show(bforce:Boolean = false):void
		{	
			var remeberme:String = "";
			try
			{
				remeberme = AssetlinkDesktop.da.ResultSet[4][PREFERENCE.VALUE];
			}
			catch(ex:Error)
			{
				
			}
			rememberMeSelect.selected = Boolean(remeberme);
			orgLogin = txtLogin.text;
			orgPassword = txtPassword.text;
			orgServer = txtServer.text;
			orgTenant = txtTenant.text;
			cancelBtn.enabled = !bforce;
			this.visible = true;
		}
		
		private function updatePreferenceDetails():void
		{
			rememberUser = rememberMeSelect.selected;
			if (rememberUser)
			{
				AssetlinkDesktop.da.DataAccessUpdate("UPDATE PREFERENCE SET VALUE='"+txtLogin.text+"' where NAME='"+AssetlinkDesktop.da.ResultSet[0][PREFERENCE.NAME]+"'");
				AssetlinkDesktop.da.DataAccessUpdate("UPDATE PREFERENCE SET VALUE='"+ SessionUtil.EncryptPassword(txtPassword.text) +"' where NAME='"+AssetlinkDesktop.da.ResultSet[1][PREFERENCE.NAME]+"'");
				AssetlinkDesktop.da.DataAccessUpdate("UPDATE PREFERENCE SET VALUE='"+rememberUser.toString()+"' where NAME='"+AssetlinkDesktop.da.ResultSet[4][PREFERENCE.NAME]+"'");
				AssetlinkDesktop.da.ResultSet[4][PREFERENCE.VALUE] = rememberUser.toString();
			}
			else
			{
				AssetlinkDesktop.da.DataAccessUpdate("UPDATE PREFERENCE SET VALUE='' where NAME='"+AssetlinkDesktop.da.ResultSet[0][PREFERENCE.NAME]+"'");
				AssetlinkDesktop.da.DataAccessUpdate("UPDATE PREFERENCE SET VALUE='' where NAME='"+AssetlinkDesktop.da.ResultSet[1][PREFERENCE.NAME]+"'");
				//AssetlinkDesktop.da.DataAccessUpdate("UPDATE PREFERENCE SET VALUE='' where NAME='"+AssetlinkDesktop.da.ResultSet[2][PREFERENCE.NAME]+"'");
				//AssetlinkDesktop.da.DataAccessUpdate("UPDATE PREFERENCE SET VALUE='' where NAME='"+AssetlinkDesktop.da.ResultSet[3][PREFERENCE.NAME]+"'");
				AssetlinkDesktop.da.DataAccessUpdate("UPDATE PREFERENCE SET VALUE='' where NAME='"+AssetlinkDesktop.da.ResultSet[4][PREFERENCE.NAME]+"'");
				AssetlinkDesktop.da.ResultSet[4][PREFERENCE.VALUE] = '';
			}
			AssetlinkDesktop.da.DataAccessUpdate("UPDATE PREFERENCE SET VALUE='"+protocol.selectedLabel + "://"+txtServer.text+"' where NAME='"+AssetlinkDesktop.da.ResultSet[2][PREFERENCE.NAME]+"'");
			AssetlinkDesktop.da.DataAccessUpdate("UPDATE PREFERENCE SET VALUE='"+txtTenant.text+"' where NAME='"+AssetlinkDesktop.da.ResultSet[3][PREFERENCE.NAME]+"'");
			AssetlinkDesktop.da.DataAccessUpdate("UPDATE PREFERENCE SET VALUE='"+Helper.Encode(txtHotFolder.text)+"' where NAME='"+AssetlinkDesktop.da.ResultSet[6][PREFERENCE.NAME]+"'");
			
		    AssetlinkDesktop.da.ResultSet[6][PREFERENCE.VALUE] = Helper.Encode(txtHotFolder.text);
		}
		
		private function ValidateServerURL(protocol:String,url:String,loginname:String,password:String,tenant:String):void
		{
			Security.loadPolicyFile(url.replace("Default.aspx","crossdomain.xml"));
			  	
			WorkInProgress.Show(STRINGS.WIP_VALIDATING_USER_DATA);			
			
			var serverurl:String = url;
			var amfChannelSet:ChannelSet = new ChannelSet();
		
			if (protocol == "http")
			{
				var amfChannel:AMFChannel = new AMFChannel(COMMON.REMOTING_ID, serverurl);
			  	amfChannel.netConnection.objectEncoding = ObjectEncoding.AMF3;
		 		amfChannelSet.addChannel(amfChannel);
		 	}
		 	else
		 	{
		  		var secureAmfChannel:SecureAMFChannel = new SecureAMFChannel(COMMON.SECURE_REMOTING_ID, serverurl);
			  	secureAmfChannel.netConnection.objectEncoding = ObjectEncoding.AMF3;
		 		amfChannelSet.addChannel(secureAmfChannel);
		  	}
		  	
			
		  
		  	
		  	var ro:RemoteObject = new RemoteObject(COMMON.REMOTING_DESTINATION);
			ro.channelSet = amfChannelSet;
			ro.source = COMMON.REMOTING_SERVICE;
			ro.addEventListener(FaultEvent.FAULT,remoteConnectionHandler);
			
			ro.getOperation(INFRASTRUCTURE.VALIDATE_USER).addEventListener(ResultEvent.RESULT, validateUserHandler);
			StateMgr.GetInstance().Fascade = ro;
			ro.ValidateUser(loginname,password,tenant);
		}
		
		private function keyboardHandler(evt:KeyboardEvent):void
		{
			if(txtLogin.text == "" && txtPassword.text=="" && txtTenant.text=="" && txtServer.text=="")
			{
				cancelBtn.enabled = false;
			}
			
			if(evt.keyCode == Keyboard.TAB)
			{
				var obj:Object = null;
				
				if(!evt.shiftKey)
				{
					obj = getNextTabObject(evt.target.tabIndex,true);
					if(obj == null)
					{
						obj = txtLogin;
					}					
				}
				else
				{
					obj = getNextTabObject(evt.target.tabIndex,false);
					
					if(obj == null)
					{
						obj = txtTenant;
					}
				}				
				
				this.systemManager.stage.focus = InteractiveObject(obj);
			}			
		}
		
		private function getNextTabObject(current:int, next:Boolean):Object
		{
			var cnt:int = this.numChildren;
			var i:int = 0;
			var obj:Object = null;
			if(next)
			{
				current =  current + 1;
			}
			else
			{
				current =  current - 1;
			}
					
			for(i=0; i<cnt; i++)
			{
				if(this.getChildAt(i).hasOwnProperty("tabIndex"))
				{
					//Alert.show(Object(layout.getChildAt(i)).tabIndex.toString());
					if(Object(this.getChildAt(i)).tabIndex == current)
					{
						
						obj = Object(this.getChildAt(i));
						break;
					}
				}
			}			
			
			return obj;
		}
		
	}
}