package framework.updater
{
	import air.net.URLMonitor;
	
	import flash.desktop.NativeApplication;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.StatusEvent;
	import flash.net.URLRequest;
	
	import framework.dialogs.MessageBox;
	import framework.utils.Helper;
	
	
	//--------------------------------------------------------------------------
	//
	//  Dispatch Events
	//
	//--------------------------------------------------------------------------
	
	[Event(name="autoupdateevent_update_unnecessary"
	    , type="framework.updater.AutoUpdateEvent")]
	
	
	[Event(name="autoupdateevent_update_cancel"
	    , type="framework.updater.AutoUpdateEvent")]


	public class AutoUpdateManager extends EventDispatcher
	{
		//--------------------------------------------------------------------------
	    //
	    //  Variables
	    //
	    //--------------------------------------------------------------------------
	
	   
	    protected var __autoupdater:AutoUpdater;	   
	    private var _urlMonitor:URLMonitor;	 
	    private var _config:AutoUpdateConfig;	  
	
	    //--------------------------------------------------------------------------
	    //
	    //  Properties(getter/setter)
	    //
	    //--------------------------------------------------------------------------
	
	    private var _applicationVersion:Number = 1.0;
	    /**
	     *
	     * @return　
	     *
	     */
	    public function get applicationVersion():Number
	    {
	        return _applicationVersion;
	    }
	
	
	    //--------------------------------------------------------------------------
	    //
	    //  Methods
	    //
	    //--------------------------------------------------------------------------
	
	    /**
	     * Constructor
	     *
	     * @param config 
	     * @param parent 
	     *
	     */
	    public function AutoUpdateManager(config:AutoUpdateConfig)
	    {
	        _config = config;
	    }
	
	   
	    public function CheckForUpdate():void
	    {
	        // ADF
	       
	        _applicationVersion = Helper.GetAppVersion();
	
	        __autoupdater = new AutoUpdater(_config);
	        __autoupdater.addEventListener(
	            AutoUpdateEvent.GET_VERSION_COMPLETE,_getVersionCompleteHandler);
	        __autoupdater.addEventListener(
	            AutoUpdateEvent.GET_VERSION_FAULT,_getVersionFaultHandler);
	        __autoupdater.addEventListener(
	            AutoUpdateEvent.UPDATE_AIRFILE_FAULT,_updateAirFileFaultHandler);
	
	        _urlMonitor
	            = new URLMonitor(
	                new URLRequest(__autoupdater.getVersionDefineFileUrl())
	            );
	        _urlMonitor.addEventListener(StatusEvent.STATUS,_urlMonitorStatusChangeHandler);
	        _urlMonitor.start();
	
	    }
	
	    //--------------------------------------------------------------------------
	    //
	    //  Event handlers
	    //
	    //--------------------------------------------------------------------------
	
	    private function _urlMonitorStatusChangeHandler(event:StatusEvent):void
	    {
	        if(_urlMonitor.available)
	        {
	            // OFF→ON
	
	            _urlMonitor.stop();
	            __autoupdater.getVersion();
	        }
	        else
	        {
	            // ON→OFF
	        }
	    }
	
	    private function _getVersionCompleteHandler(event:AutoUpdateEvent):void
	    {
	        try
	        {
	            if(__autoupdater.isLatestApp(applicationVersion)){
	               dispatchEvent(new AutoUpdateEvent(AutoUpdateEvent.UPDATE_UNNECESSARY));
	                return;
	            }
	           
	            __autoupdater.loadAirFile();
	        }
	        catch(error:Error){
	            trace(error.getStackTrace());
	            __handleUpdateError(error.toString());
	        }
	    }
	
	   private function _getVersionFaultHandler(event:AutoUpdateEvent):void
	    {
	        __handleUpdateError(event.toString());
	    }
	
	    private function _updateAirFileFaultHandler(event:AutoUpdateEvent):void
	    {
	        __handleUpdateError(event.toString());
	    }
	
	  
	
	    /**
	     * 
	     * 
	     * 
	     *
	     * @param msg 
	     */
	    protected function __handleUpdateError(msg:String):void
	    {
	       MessageBox.Show(msg + "\n","Error");
	    }
	
	    /**
	     * 
	     * 
	     * 
	     *
	     * @param msg 
	     */
	    protected function __handleUpdateWarning(msg:String):void
	    {
	        MessageBox.Show(msg,"Warning");
	    }
	
	    protected function __exitApp(event:Event):void
	    {
	        NativeApplication.nativeApplication.exit(0);
	    }

		
	}
}