package UI
{
	import assets.ButtonEx;
	import assets.DataGridColumnEx;
	import assets.checkbox.CheckBoxHeaderColumn;
	import assets.checkbox.CheckBoxHeaderRenderer;
	import assets.checkbox.CheckBoxItemRenderer;
	import assets.combobox.ComboBoxItemRenderer;
	import assets.datefield.DateFieldItemRenderer;
	import assets.multiselect.TreeViewItemRenderer;
	import assets.text.TextItemRenderer;
	import assets.textarea.TextAreaItemRenderer;
	import assets.textinput.TextInputItemRenderer;
	
	import events.FacetSeriesChangeEvent;
	import events.FormEvents;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import mx.containers.FormItem;
	import mx.containers.HBox;
	import mx.containers.VBox;
	import mx.controls.CheckBox;
	import mx.controls.ComboBox;
	import mx.controls.DataGrid;
	import mx.controls.dataGridClasses.DataGridListData;
	import mx.core.ClassFactory;
	import mx.core.UIComponent;
	import mx.events.DataGridEvent;
	import mx.utils.ObjectUtil;
	
	import utils.Helper;
	import utils.Validators;		
	
	public class FacetSeries
	{	
		private var facetSeriesTemplate:Array;
		public var facetSeriesData:Array;
		public var isDataValid:Boolean = true;
        private	var fsTree:MultiSelectTree;
        private	var fsForm:FacetSeriesForm;
        private var currDataField:String = "";
		private var nhCollection:XML;
		private var selectedIndices:Array;
		private var parentContainer:UIComponent;
		private var validators:Validators = new Validators();
        
		public function FacetSeries()
		{
			fsTree = new MultiSelectTree();
			fsForm = new FacetSeriesForm();
			facetSeriesData = new Array();
			facetSeriesTemplate = new Array();
			selectedIndices = new Array();
		}
		
		public function Init(nhColl:XML, parent:UIComponent):void
		{
			nhCollection = nhColl;
			parentContainer = parent;
			if (parentContainer != null)
			{
				fsForm.Hide();
				fsTree.Hide();
				parentContainer.addChild(fsForm);
				parentContainer.addChild(fsTree);
			}  
		}
		
		public function updateParentDisplay():void
		{
			fsForm.width = parentContainer.width;
			fsForm.height = parentContainer.height;
			
			fsTree.width = parentContainer.width;
			fsTree.height = parentContainer.height; 
		}
		
		private function popupformSaveHandler(evt:FacetSeriesChangeEvent):void
        {
			var dg:DataGrid = evt.Data as DataGrid;
			var dgname:String = dg.name;
			var rowXML:XML = XML(evt.Target1 as String); 
			  
			var seriesXML:XML = XML(facetSeriesData[dgname]);
        	seriesXML.appendChild(rowXML);
        	
        	facetSeriesData[dgname] = seriesXML.toString();
        	dg.dataProvider = XML(facetSeriesData[dgname]).child(dgname.split("$ALSEP$")[1]);
        }
        
		private function facetseriesChangeHandler(evt:FacetSeriesChangeEvent):void
		{	
			
			var dgname:String = evt.Target1 as String;
			var seriesXML:XML = XML(facetSeriesData[dgname]);
			var relFacetName:String = dgname.split("$ALSEP$")[1];
			
			var target2:String = evt.Target2 as String;
			var rowindex:String = target2.split("$ALSEP$")[0];
			var datafieldName:String = target2.split("$ALSEP$")[1];	
			
			var rows:XMLList = seriesXML.child(relFacetName);
			var editedRow:XML = rows[rowindex];
			var currFieldList:XMLList = editedRow.child(datafieldName);			
			var currField:XML = currFieldList[0];
			
			var tempxml:String = "<PARENT>" + evt.Data.toString() + "</PARENT>";
			
			currField.setChildren(XML(tempxml).children());
			
			facetSeriesData[dgname] = seriesXML.toXMLString();
			ControlChangeEventHandler();
		}  
        
        private function TreePopupHandler(evt:FacetSeriesChangeEvent):void
        {
        	var treeviewIR:TreeViewItemRenderer = evt.Data as TreeViewItemRenderer;
        	var currColumn:XML = XML(evt.Target1);
        	var selval:String = evt.Target2 as String;
        	
        	var nhObj:Object = Helper.GetNHDetails(currColumn, nhCollection);
        	var nhTreeNode:XML = XML(nhObj.nhTreeNode);
        	
        	var nhTree:String = nhTreeNode.toXMLString();
			var treeXML:XML = new XML(nhTree);
        	
        	fsTree.initTree(treeXML, treeviewIR, selval,selval);
        	fsTree.Show();
        }
        
        private function FormPopupHandler(evt:MouseEvent):void
        {
        	var addBtn:ButtonEx = evt.currentTarget as ButtonEx;
        	fsForm.initForm(addBtn);
        	fsForm.Show();
        }
        
        private function populateComboboxHandler(evt:FacetSeriesChangeEvent):void
        {
        	var cb:ComboBox = evt.Data as ComboBox;
        	var currColumn:XML = XML(evt.Target1);
        	var selval:String = evt.Target2 as String;
        	
        	var nhObj:Object = Helper.GetNHDetails(currColumn, nhCollection);
        	var nhTreeNode:XML = XML(nhObj.nhTreeNode);
        	
  			var treeNodeList:XMLList = nhTreeNode.TreeNode;
  			cb.dataProvider = treeNodeList;
  			//cb.labelField = "@Text";
			cb.labelFunction = Helper.getNamedHierarchyDisplayValue;
  			if (selval != null && selval.length > 0)
  				cb.selectedItem = treeNodeList.(@Text == selval);
  			else
  				cb.selectedItem = null;
        }
        
        private function chkboxselectionHandler(evt:FacetSeriesChangeEvent):void
        {
        	var cb:CheckBox = evt.Data as CheckBox;
        	var name:String = evt.Target1 as String;
        	var col:DataGridListData = evt.Target2 as DataGridListData;
        	var rowindex:String = col.rowIndex.toString();
        	var fsDG:DataGrid = col.owner as DataGrid;
        	
        	if (!cb.selected)
        	{
        		var chkBoxHeader:CheckBoxHeaderColumn = fsDG.columns[0];
        		chkBoxHeader.selected = false;
        	}
        	
        	//var rowindex:String = evt.Target2 as String;        	
        	
        	UpdateSelectedIndices(cb, name, rowindex);
        }
        
        private function headerClickHandler(evt:FacetSeriesChangeEvent):void
        {
        	var cb:CheckBox = evt.Data as CheckBox;
        	var name:String = evt.Target1 as String;
        	var fsDG:DataGrid = evt.Target2 as DataGrid;
        	
        	var seriesXML:XML = XML(facetSeriesData[name]);
    		var relFacetName:String = name.split("$ALSEP$")[1];
    		var rows:XMLList = seriesXML.child(relFacetName);
    		var row:XML;
    		
    		var rowindex:int = 0;
    		for each (row in rows)
    		{
    			row.SELECTED = cb.selected;
    			UpdateSelectedIndices(cb, name, rowindex.toString());	
    			rowindex++;
    		}
        	fsDG.dataProvider = rows;
        }
        
        private function RenderFormHandler(evt:FacetSeriesChangeEvent):void
        {
        	var facetListBox:VBox = evt.Data as VBox;
        	var formConfig:XML = XML(evt.Target1);
        	var facetBox:VBox = FormRendition.GetInstance().GenerateFacetForm(formConfig.toString(), null, true);
        	if (facetListBox.numChildren == 0)        	
        		facetListBox.addChild(facetBox);
        }
        
        private function UpdateSelectedIndices(cb:CheckBox, name:String,rowindex:String):void
        {
        	if (selectedIndices[name] == null)
        		selectedIndices[name] = "";
        	if (cb.selected)
    		{
    			if (String(selectedIndices[name]).indexOf(rowindex) < 0)
    				selectedIndices[name] += rowindex + ",";
    		}
    		else
    		{
    			if (String(selectedIndices[name]).indexOf(rowindex) >= 0)
    				selectedIndices[name] = String(selectedIndices[name]).replace(rowindex + ",","");
    		}
        }
        
        public function ShowFacetSeries(FieldBox:FormItem, currField:XML, txtOld:XML, isDataCommon:Boolean, formConfigXML:String, ShowReadOnly:Boolean=false/*currFacet:*//*FacetForm*/):void
        {	
        	var facetFormConfig:XML = XML(formConfigXML);
        	
        	//following added after restructuring. It is required as currField.OBJECTTYPENAME does not give typename
        	var currFacet:XML = facetFormConfig.RELATEDFACETS.FACET[0];
			var currFacetObj:Object = new Object();			
			currFacetObj.TypeName = currFacet.@TYPENAME;
			currFacetObj.RelationshipName = currFacet.@RELATIONSHIPNAME;
        	//code added after restructuring ends.
        	
			var facetseriesList:XMLList = facetFormConfig.RELATEDFACETS.FACET.RELATEDFACETS.FACET.((@RELATIONSHIPNAME == currField.@RELATIONSHIPNAME) && (@IsSeries == "YES"));
			//The following condition is to handle when facet itself is facetseries. This case is possible when there are no fields in form.
			if (facetseriesList == null || facetseriesList.length() == 0)
			   	facetseriesList = facetFormConfig.RELATEDFACETS.FACET.((@RELATIONSHIPNAME == currField.@RELATIONSHIPNAME) && (@IsSeries == "YES"));
			
			if (facetseriesList != null && facetseriesList.length() > 0)
			{
	        	var seriesRelatedFacet:XML = facetseriesList[0];	        	
	        	
	        	//the following is required to initialize facetSeriesData and selectedIndices on each render
	        	delete facetSeriesData[currFacetObj.TypeName + "$ALSEP$" + seriesRelatedFacet.@TYPENAME];
	        	delete selectedIndices[currFacetObj.TypeName + "$ALSEP$" + seriesRelatedFacet.@TYPENAME];
	        	
	        	var fstemplate:String = "<"+currField.@RELATIONSHIPNAME+"><"+seriesRelatedFacet.@TYPENAME+">";  	        	
	        	
	        	var fsDG:DataGrid = new DataGrid();
	        	fsDG.name = currFacetObj.TypeName + "$ALSEP$" + seriesRelatedFacet.@TYPENAME;
	        	fsDG.width = Number(currField.@EditableScrollWidth);
	        	fsDG.height = Number(currField.@EditableScrollHeight);
	        	fsDG.headerHeight = 28;
	        	fsDG.rowHeight = 25;	        		        	
	        	fsDG.horizontalScrollPolicy =  "ON";	        		        	
	        	
	        	if (String(currField.@InBuiltActionMode).toUpperCase() == "EDITABLE" || String(currField.@InBuiltActionMode).toUpperCase() == "READONLY")
	        		fsDG.addEventListener(FacetSeriesChangeEvent.SERIES_CHANGE,facetseriesChangeHandler);
	        	else
	        	{
	        		fsDG.addEventListener(FacetSeriesChangeEvent.SERIES_CHANGE,popupformSaveHandler);
	        		fsDG.addEventListener(FacetSeriesChangeEvent.RENDER_FORM, RenderFormHandler);
	        	}
	        	
	        	fsDG.addEventListener(FacetSeriesChangeEvent.POPULATE_COMBOBOX, populateComboboxHandler);
	        	fsDG.addEventListener(FacetSeriesChangeEvent.SHOW_TREEVIEW, TreePopupHandler);
	        	//fsDG.addEventListener(MouseEvent.CLICK, seriesClickHandler);
	        	fsDG.addEventListener(FacetSeriesChangeEvent.CHECKBOX_SELECTION, chkboxselectionHandler);
	        	fsDG.addEventListener(FacetSeriesChangeEvent.HEADERCHECKBOX_SELECTION, headerClickHandler);
	        	fsDG.addEventListener(DataGridEvent.HEADER_RELEASE, GetCurrentDataField);
	        	fsDG.addEventListener(FacetSeriesChangeEvent.ITEM_FOCUSIN, ItemFocusInHandler);
	        	fsDG.addEventListener(Event.CHANGE, ControlChangeEventHandler);
	        	
	        	var fieldColsList:XMLList = currField.Configuration.DisplayLayout.List.DisplayColumns.TargetObject.Column.(@DisplayState == "YES");
	        	var gridCols:Array = new Array(fieldColsList.length());
	        	var fieldCol:XML;
	        	var i:int = 0;
	        	
	        	if (String(currField.@InBuiltActionMode).toUpperCase() == "EDITABLE" || String(currField.@InBuiltActionMode).toUpperCase() == "READONLY")
	        	{
		        	var checkBoxColumn:CheckBoxHeaderColumn = new CheckBoxHeaderColumn();
					checkBoxColumn.headerText = "";
					//checkBoxColumn.dataField = "SELECTED";
					checkBoxColumn.resizable = false;
					checkBoxColumn.sortable = false;
					checkBoxColumn.headerRenderer = new ClassFactory(CheckBoxHeaderRenderer);
					checkBoxColumn.itemRenderer = new ClassFactory(CheckBoxItemRenderer);
					checkBoxColumn.width = 20;
					//checkBoxColumn.addEventListener(MouseEvent.CLICK,headerClickHandler);
					gridCols[0] = checkBoxColumn;
					fsDG.name += "$ALSEP$"+"";		
					i = i + 1;
	        	}
					        	
	        	for each (fieldCol in fieldColsList)
	        	{	
	        		fstemplate += "<" + fieldCol.@FIELDNAME + "/>";
	        		
	        		var dgCol:DataGridColumnEx = new DataGridColumnEx();
	        		dgCol.params = fieldCol.toXMLString();
	        		dgCol.headerText = fieldCol.@DisplayValue;
					if (fieldCol.@DisplayTextID != null && fieldCol.@DisplayTextID.toString() != "")
						dgCol.headerText = Helper.GetLocalizedString(fieldCol.@DisplayTextID);					
					
	        		if (String(fieldCol.@IsMandatory).toUpperCase() == "TRUE")
	        			dgCol.headerText += '*';
					
        			dgCol.dataField = fieldCol.@FIELDNAME;
	        		var colwidth:String = String(fieldCol.@Width).split('px')[0]; 
	        		dgCol.width = Number(colwidth);
	        		dgCol.sortable = Boolean(String(fieldCol.@ApplySort).toLowerCase());	        		
	        		if (String(fieldCol.@SortDataType).toUpperCase() == "ALDATE")
	        			dgCol.sortCompareFunction = date_sortCompareFunc;
	        		
	        		if (String(currField.@InBuiltActionMode).toUpperCase() == "EDITABLE"  || String(currField.@InBuiltActionMode).toUpperCase() == "READONLY")	        		
		        	{
		        		var namedHeirarchyID:String = fieldCol.@NAMEDHIERARCHYID;
		        		
		        		if (namedHeirarchyID == null)
		        			namedHeirarchyID = ""; 
		        		//fsDG.name += "$ALSEP$" + namedHeirarchyID;
		        		
		        		/*var isReadOnly:Boolean = false;
		        		if (fieldCol.attribute("IsReadOnly").length() > 0 && String(fieldCol.@IsReadOnly).toUpperCase() == "TRUE")
		        			isReadOnly = true;*/
		        					        			
		        		//if (!isReadOnly)
						if(!ShowReadOnly)
		        		{
			        		if (String(fieldCol.@UIType).toUpperCase() == "EDITBOX")
		        				dgCol.itemRenderer = new ClassFactory(TextInputItemRenderer);
	        				else if (String(fieldCol.@UIType).toUpperCase() == "TEXTAREA")
	        				{
	        					fsDG.rowHeight = 50;
	        					dgCol.itemRenderer = new ClassFactory(TextAreaItemRenderer);
			    			}
			    			else if (String(fieldCol.@UIType).toUpperCase() == "JCALENDAR")
			       				dgCol.itemRenderer = new ClassFactory(DateFieldItemRenderer);
			       			else if (String(fieldCol.@UIType).toUpperCase() == "DROPDOWNLIST")
			       				dgCol.itemRenderer = new ClassFactory(ComboBoxItemRenderer);
			    			else if (String(fieldCol.@UIType).toUpperCase() == "TREEVIEW")
			    				dgCol.itemRenderer = new ClassFactory(TreeViewItemRenderer);
		        		}
						else
						{
							dgCol.itemRenderer = new ClassFactory(TextItemRenderer);		    
						}
		        	}
		        	else if (String(currField.@InBuiltActionMode).toUpperCase() == "POPUP")
		        		dgCol.itemRenderer = new ClassFactory(TextItemRenderer);		        	
	    			gridCols[i] = dgCol;
	    			i++;     		
	        	}
	        	fsDG.columns = gridCols;
	        	if (txtOld != null && isDataCommon)
        		{
    				fsDG.dataProvider = txtOld.child(seriesRelatedFacet.@TYPENAME);        				
        			facetSeriesData[currFacetObj.TypeName + "$ALSEP$" + seriesRelatedFacet.@TYPENAME] = txtOld;
        		}
	        	
	        	FieldBox.addChild(fsDG); 
	        	fstemplate += "</"+seriesRelatedFacet.@TYPENAME+"></"+currField.@RELATIONSHIPNAME+">";
	        	
	        	if (facetSeriesData[currFacetObj.TypeName + "$ALSEP$" + seriesRelatedFacet.@TYPENAME] == null)
	        		facetSeriesData[currFacetObj.TypeName + "$ALSEP$" + seriesRelatedFacet.@TYPENAME] = '<'+currField.@RELATIONSHIPNAME+ ' TYPE="RELATION" />';
	        	if (facetSeriesTemplate[currFacetObj.TypeName + "$ALSEP$" + seriesRelatedFacet.@TYPENAME] == null)
	        		facetSeriesTemplate[currFacetObj.TypeName + "$ALSEP$" + seriesRelatedFacet.@TYPENAME] = fstemplate;
	        		
				if(!ShowReadOnly)
	        		RenderFacetSeriesActionControls(FieldBox, currField, currFacetObj/*currFacet*/, seriesRelatedFacet.@TYPENAME);	        	
   			} 
        }
        
        public function RenderFacetSeriesActionControls(FieldBox:FormItem, currField:XML, currFacetObj:Object/*currFacet:**//*FacetForm*/, relFacetName:String):void
        {
        	var actionControlArea:HBox = new HBox();
        	var actioncontrolList:XMLList = currField.Configuration.ActionControlList.ActionControl.((String(@Visible).toUpperCase() == "TRUE") && (String(@UIType).toUpperCase() != "SEPARATOR"));
        	var actioncontrol:XML;
        	for each (actioncontrol in actioncontrolList)
        	{
        		if (String(actioncontrol.@UIType).toUpperCase() == "LISTBOX")
        		{
        			var actionCB:ComboBox = new ComboBox();
        			var itemList:XMLList = actioncontrol.Item;
        			actionCB.dataProvider = itemList;
        			actionCB.labelField = "@Text";
        			actionCB.selectedItem = itemList.(String(@Selected).toUpperCase() == "TRUE");;
        			actionControlArea.addChild(actionCB);
        		}
        		else
        		{
	        		if (String(actioncontrol.@Name).toUpperCase() != "EDITSERIESRECORD" && String(actioncontrol.@Name).toUpperCase() != "IMPORTSERIESRECORD" && String(actioncontrol.@Name).toUpperCase() != "EXPORTSERIESRECORD")
	        		{
		        		var actionBtn:ButtonEx = new ButtonEx();
		        		actionBtn.label = actioncontrol.DisplayText;	        		
		        		
						if (actioncontrol.@DisplayTextID != null && actioncontrol.@DisplayTextID.toString() != "")
							actionBtn.label = Helper.GetLocalizedString(actioncontrol.@DisplayTextID);					
						
		        		if (String(currField.@InBuiltActionMode).toUpperCase() == "EDITABLE" || String(currField.@InBuiltActionMode).toUpperCase() == "READONLY")
		        		{	
		        			actionBtn.name = currFacetObj.TypeName + "$ALSEP$" + relFacetName;
		        			if (String(actioncontrol.@Name).toUpperCase() == "ADDSERIESRECORD")
		        				actionBtn.addEventListener(MouseEvent.CLICK, AddSeriesRecord);
		        			else if (String(actioncontrol.@Name).toUpperCase() == "DELETESERIESRECORD")
		        				actionBtn.addEventListener(MouseEvent.CLICK, DeleteSeriesRecord);
			        		else if (String(actioncontrol.@Name).toUpperCase() == "COPYSERIESRECORD")
		        				actionBtn.addEventListener(MouseEvent.CLICK, CopySeriesRecord);
		        		}
	        			else if (String(currField.@InBuiltActionMode).toUpperCase() == "POPUP")
	        			{
	        				if (String(actioncontrol.@Name).toUpperCase() == "ADDSERIESRECORD")
	        				{
		        				var ListElements:XMLList = currField.Configuration.DisplayLayout.List;
		        				var currListElement:XML = ListElements[0];
		        				var formName:String = currListElement.@FormName; 
		        				actionBtn.addEventListener(MouseEvent.CLICK, FormPopupHandler);
		        				actionBtn.name = currFacetObj.TypeName + "$ALSEP$" + relFacetName + "$ALSEP$" + currFacetObj.RelationshipName + "$ALSEP$" + formName + "$ALSEP$" + currField.@AddPopupTitle;
	        				}
	        			}	        		
	        			actionControlArea.addChild(actionBtn);
        			}
        		}
        	}        	       	
        	FieldBox.addChild(actionControlArea);	
        }
        
        public function AddSeriesRecord(evt:MouseEvent):void
        {	
        	var addBtn:ButtonEx = evt.currentTarget as ButtonEx;        	
        	var actionControlArea:HBox = addBtn.parent as HBox;
        	var btnindex:int = actionControlArea.getChildIndex(addBtn);        	
        	var noofRowsDD:ComboBox = actionControlArea.getChildAt(btnindex - 1) as ComboBox;
        	var noofRows:String = noofRowsDD.selectedItem.@Value;        	
        	var fieldBox:FormItem = actionControlArea.parent as FormItem;
        	var fsDG:DataGrid = fieldBox.getChildAt(0) as DataGrid;
        	//var chkBoxHeader:CheckBoxHeaderColumn = fsDG.columns[0];
        	//chkBoxHeader.selected = false;
        	fsDG.errorString = null; //as soon as rows added, the mandatory error is removed in case it exists
        	var relfacetName:String = addBtn.name.split("$ALSEP$")[1];
        	if (facetSeriesTemplate[addBtn.name] != null)
        	{
        		var templateXMLList:XMLList = XML(facetSeriesTemplate[addBtn.name]).child(relfacetName);
        		var templateXML:XML  = templateXMLList[0];
        		for (var i:int = 0; i < Number(noofRows); i++)
        		{
        			facetSeriesData[addBtn.name] = XML(facetSeriesData[addBtn.name]).appendChild(templateXML).toString();
        		}
        		fsDG.dataProvider = XML(facetSeriesData[addBtn.name]).child(relfacetName);
        		ControlChangeEventHandler();        		
//        		fsDG.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.ITEM_VALIDATE));
        	}
        }
        
        public function DeleteSeriesRecord(evt:MouseEvent):void
        {
        	var deleteBtn:ButtonEx = evt.currentTarget as ButtonEx;
        	var actionControlArea:HBox = deleteBtn.parent as HBox;
        	var fieldBox:FormItem = actionControlArea.parent as FormItem;
        	var fsDG:DataGrid = fieldBox.getChildAt(0) as DataGrid;
        	var chkBoxHeader:CheckBoxHeaderColumn = fsDG.columns[0];
        	chkBoxHeader.selected = false;
        	if (selectedIndices[deleteBtn.name] != null)         
        	{
        		var rowindices:Array = String(selectedIndices[deleteBtn.name]).split(',');
        		rowindices.sort(Array.DESCENDING);        		         		
        		
        		var seriesXML:XML = XML(facetSeriesData[deleteBtn.name]);
        		var seriesName:String = seriesXML.name().toString(); 
        		var relFacetName:String = deleteBtn.name.split("$ALSEP$")[1];
        		var rows:XMLList = seriesXML.child(relFacetName);
        		        		
        		for (var i:int = 0; i < rowindices.length - 1; i++)
        		{   
        			delete rows[rowindices[i]];	
        		}
        		selectedIndices[deleteBtn.name] = "";
        		
        		facetSeriesData[deleteBtn.name] = seriesXML.toString();
        		if (facetSeriesData[deleteBtn.name] == null || String(facetSeriesData[deleteBtn.name]).length == 0)
	        		facetSeriesData[deleteBtn.name] = '<'+seriesName+ ' TYPE="RELATION" />';
        		fsDG.dataProvider = XML(facetSeriesData[deleteBtn.name]).child(relFacetName);        		
        		ControlChangeEventHandler();
        	}
    	}
        
        public function CopySeriesRecord(evt:MouseEvent):void
        {
        	
        	var copyBtn:ButtonEx = evt.currentTarget as ButtonEx;
        	var actionControlArea:HBox = copyBtn.parent as HBox;
        	var fieldBox:FormItem = actionControlArea.parent as FormItem;
        	var fsDG:DataGrid = fieldBox.getChildAt(0) as DataGrid;
        	var chkBoxHeader:CheckBoxHeaderColumn = fsDG.columns[0];
        	chkBoxHeader.selected = false;
        	if (selectedIndices[copyBtn.name] != null)         
        	{
        		var rowindices:Array = String(selectedIndices[copyBtn.name]).split(',');        		        		         		
        		rowindices.sort();
        		
        		var seriesXML:XML = XML(facetSeriesData[copyBtn.name]);
        		var relFacetName:String = copyBtn.name.split("$ALSEP$")[1];
        		var rows:XMLList = seriesXML.child(relFacetName);
        		
        		for (var i:int = 1; i < rowindices.length; i++)
        		{   
        			var row:XML = rows[rowindices[i]];	
        			seriesXML = seriesXML.appendChild(row);
        		}
        		
        		selectedIndices[copyBtn.name] = "";
        		facetSeriesData[copyBtn.name] = seriesXML.toString();
        		fsDG.dataProvider = XML(facetSeriesData[copyBtn.name]).child(relFacetName); 
        		ControlChangeEventHandler();       		
        		//fsDG.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.ITEM_VALIDATE));
        	}
        }
        
        private function date_sortCompareFunc(itemA:Object, itemB:Object):int 
		{
                var item:Array = [itemA, itemB]; 
                var dateArr:Array = new Array();
                for (var i:int=0; i < 2; i++)
                {
                	var xml:XML = XML(item[i]);
					var datelist:XMLList = xml.child(currDataField);
					var date:XML = datelist[0];
					if (date.DAY != null && String(date.DAY).length > 0)
					{	
						var currDay:int = Number(date.DAY);
						var currMonth:int = Number(date.MONTH);
						var currYear:int = Number(date.YEAR);
						dateArr[i] = new Date(currYear,currMonth,currDay);					
					}	
                }
                if (dateArr.length == 2)
                	return ObjectUtil.dateCompare(dateArr[0], dateArr[1]);
        		else
        			return 0;
        }
        
        private function GetCurrentDataField(evt:DataGridEvent):void
        {
        	currDataField = evt.dataField.toString(); 	
        }
        
        public function HidePopups():void
        {
        	fsTree.Hide();
        	fsForm.Hide();
        } 
        
        private function ControlChangeEventHandler(evt:Event=null):void
        {
        	//FormRendition.GetInstance().isDataSaved = false;
        	parentContainer.dispatchEvent(new FormEvents(FormEvents.FORM_CHANGE));
        }
        
        private function ItemFocusInHandler(evt:FacetSeriesChangeEvent):void
		{ 
			var dgCol:DataGridColumnEx = evt.Data as DataGridColumnEx;
			var ti:* = evt.Target1;
			var currColumn:XML = XML(dgCol.params);
			
			var tempIsDataValid:Boolean = validators.ValidateField(ti, currColumn);
			if (tempIsDataValid == false)
			{	 
				isDataValid = tempIsDataValid;
			}
			//Alert.show(isDataValid.toString());
		}
		
        private function rowfocusHandler(evt:DataGridEvent):void
        {
        	
        }
	}
}