package UI
{
	import assets.ButtonEx;
	
	import constants.STRINGS;
	
	import events.FacetSeriesChangeEvent;
	
	import flash.events.MouseEvent;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.text.TextField;
	
	import framework.utils.Helper;
	
	import infrastructure.statemanagement.StateMgr;
	
	import mx.containers.Form;
	import mx.containers.FormItem;
	import mx.containers.HBox;
	import mx.containers.VBox;
	import mx.controls.Alert;
	import mx.controls.ComboBox;
	import mx.controls.DataGrid;
	import mx.controls.DateField;
	import mx.controls.Text;
	import mx.controls.TextArea;
	import mx.controls.TextInput;
	import mx.core.UIComponent;
	
	public class FacetSeriesForm extends UIComponent
	{	
		private var cancelBtn:ButtonEx;
		private var saveBtn:ButtonEx;
		private var facetListBox:VBox;
		private var tf:TextField;
		
		private var dialogWidth:int = 350;
		private var dialogHeight:int = 300;
		private var dialogLocX:int = 0;
		private var dialogLocY:int = 0;
				
		private var cacheFolder:File;
		private var facetseriesXML:File;
		private var facetFormConfig:XML;
		private var dg:DataGrid;
		private var relFacetName:String;
		private var Title:String;
		private var mulSelSep:String = STRINGS.MULTISELECT_SEPERATOR;		
		
		public function FacetSeriesForm()
		{
			super();
			facetListBox = new VBox();
		}
		
		public function initForm(addBtn:ButtonEx):void
		{
			var addBtnName:String = addBtn.name;
			var FieldBox:FormItem = addBtn.parent.parent as FormItem;
			dg = FieldBox.getChildAt(0) as DataGrid;
						
			var nameArr:Array = addBtnName.split("$ALSEP$");
			var currFacetName:String = nameArr[0];
			relFacetName = nameArr[1];
			var currfacetRelName:String = nameArr[2];
			var formName:String = nameArr[3];
			Title = nameArr[4];
							
			cacheFolder = Helper.CreateCacheDirectory(STRINGS.CACHE_FOLDERNAME +"/" +StateMgr.GetInstance().UserId);
			facetseriesXML = cacheFolder.resolvePath(currfacetRelName + "_FacetSeries.xml");
								
			try
			{	
				var fs:FileStream = new FileStream();
				fs.open(facetseriesXML, FileMode.READ);				
				var facetseries:XML = XML(fs.readMultiByte(fs.bytesAvailable,'UTF-8'));
				fs.close();
				
				var formList:XMLList = facetseries.Form.(@Name == formName);
				facetFormConfig = formList[0];
											
				if (Title != null)
					tf.text = Title;
				dg.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.RENDER_FORM, facetListBox, facetFormConfig)); 			
			}
			catch(ex:Error)
			{
				Alert.show(ex.toString());
			}
		}
		
		public function Show():void
		{
			this.visible = true;
		}
		
		public function Hide():void
		{
			this.visible = false;
		}
		
		protected override function createChildren():void
		{
			super.createChildren();
			
			tf = new TextField();
			tf.textColor = 255255255;
			this.addChild(tf);			
			
			facetListBox.setStyle("backgroundColor","#FFFFFF");			
			this.addChild(facetListBox);
			
			saveBtn = new ButtonEx();
			saveBtn.label = STRINGS.BUTTON_TREEVIEW_SAVE;
			saveBtn.setActualSize(50,25);
			this.addChild(saveBtn);
			
			saveBtn.addEventListener(MouseEvent.CLICK,saveClickHandler);
			
			cancelBtn = new ButtonEx();
			cancelBtn.label = STRINGS.BUTTON_TREEVIEW_CANCEL;
			cancelBtn.setActualSize(60,25);
			this.addChild(cancelBtn);
			
			cancelBtn.addEventListener(MouseEvent.CLICK,cancelClickHandler);	
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{	
			this.graphics.clear();
			this.graphics.beginFill(0x313131,0.7);
			this.graphics.drawRect(0, 0, unscaledWidth, unscaledHeight);
			
			dialogWidth = unscaledWidth - 20;
			
			facetListBox.height =  dialogHeight - 20 - saveBtn.height - 25;
			facetListBox.width = dialogWidth - 20;
			
			this.graphics.beginFill(0xA0A0A0,1);
			dialogLocX = (unscaledWidth-dialogWidth)/2;
			dialogLocY = (unscaledHeight-dialogHeight)/2;	
			this.graphics.drawRoundRect(dialogLocX -1,dialogLocY -1, dialogWidth+2, dialogHeight+2,25,25);
			
			this.graphics.beginFill(0x313131,1);
			this.graphics.drawRoundRect(dialogLocX ,dialogLocY , dialogWidth, dialogHeight,25,25);
			
			tf.x = dialogLocX + 5;
			tf.y = dialogLocY + 5;
			
			facetListBox.x = 20;
			facetListBox.y = dialogLocY + 25;//(unscaledHeight - tree.height)/2;
			
			saveBtn.x = dialogLocX +(dialogWidth-cancelBtn.width-saveBtn.width) -5 - 5;
			saveBtn.y = dialogLocY + dialogHeight - saveBtn.height -5;
			
			cancelBtn.x = dialogLocX +(dialogWidth-cancelBtn.width) -5;
			cancelBtn.y = dialogLocY + dialogHeight - cancelBtn.height -5;
		}
		
		private function cancelClickHandler(evt:MouseEvent):void
		{
			this.visible = false;			
		}
		
		private function saveClickHandler(evt:MouseEvent):void
		{		
			var rowXML:String = "<"+relFacetName+">";
						    				
			var sections:XMLList = facetFormConfig.Section;
			var currSection:XML;
			var i:int = 0;    				
			for each (currSection in sections)
			{
				var columns:XMLList = currSection.Column; 
				var currColumn:XML;
				var currFacetBox:VBox = facetListBox.getChildAt(0) as VBox; 
				
				var j:int = 0;
				for each(currColumn in columns)
				{							
	  				var fields:XMLList = currColumn.Field;
	  				var currField:XML;
	  				var k:int = 0;
	  				for each(currField in fields)
	  				{ 
	  					if (currField.@RELATIONSHIPTYPE != null && String(currField.@RELATIONSHIPTYPE).length > 0)
	  					{ 
		  					rowXML += '<' + currField.@FIELDNAME + '>';    	  					
				  			var FacetDataBox:VBox = currFacetBox.getChildAt(1) as VBox;			  			
		  					var SectionBox:VBox = FacetDataBox.getChildAt(i) as VBox;
		  					var SectionDataBox:HBox = SectionBox.getChildAt(1) as HBox;
		  					var FacetColumnBox:Form = SectionDataBox.getChildAt(j) as Form;
				  			var FacetFieldBox:FormItem = FacetColumnBox.getChildAt(k) as FormItem;
		  					var FacetFieldTextInput:TextInput;
		  					if (currField.@DataType == "INTEGER" || currField.@DataType == "FLOAT" || currField.@DataType == "STRING" || currField.@DataType == "TEXT" || currField.@DataType == "BOOLEAN")
		  					{
		  						if (String(currField.@UIType).toUpperCase() == "EDITBOX")
		  						{
			  						FacetFieldTextInput = FacetFieldBox.getChildAt(0) as TextInput;
			  						rowXML += FacetFieldTextInput.text;
		  						}
		  						else if (String(currField.@UIType).toUpperCase() == "TEXTAREA")
		  						{
		  							var FacetFieldTxtArea:TextArea = FacetFieldBox.getChildAt(0) as TextArea;
		  							rowXML += FacetFieldTxtArea.text;
		  						}
		  						else if (String(currField.@UIType).toUpperCase() == "DROPDOWNLIST")
		  						{
		  							var FacetFieldComboBox:ComboBox = FacetFieldBox.getChildAt(0) as ComboBox;
		  							rowXML += FacetFieldComboBox.selectedLabel;
		  						}
		  						else if (String(currField.@UIType).toUpperCase() == "MULTISELECT")
		  						{
		  							var selectedVals:String = "";
		  							var FacetFieldTreeArea:VBox = FacetFieldBox.getChildAt(0) as VBox;
		  							var FacetFieldText:Text = FacetFieldTreeArea.getChildAt(0) as Text;
		  							selectedVals = FacetFieldText.text;
		  							while (selectedVals.indexOf(',')>=0)
		  								 selectedVals = selectedVals.replace(',',mulSelSep);
		  							if (selectedVals.length > 0)
		  							{
		  								selectedVals += mulSelSep;
		  								selectedVals = mulSelSep + selectedVals; 
		  							}
		  							rowXML += selectedVals;
		  						}
		  					}
		  					else if (currField.@DataType == "CURRENCY")    	  					
		  					{
		  						var currecyBox:HBox = FacetFieldBox.getChildAt(0) as HBox;
		  						var currencyDD:ComboBox = currecyBox.getChildAt(0) as ComboBox;
		  						rowXML += '<CURRENCY>'+ currencyDD.selectedLabel +'</CURRENCY>';
		  						FacetFieldTextInput = currecyBox.getChildAt(1) as TextInput;
		  						rowXML += '<AMOUNT>' + FacetFieldTextInput.text +'</AMOUNT>';
		  					}
		  					else if (currField.@DataType == "DATETIME")
		  					{
		  						var calendarField:DateField = FacetFieldBox.getChildAt(0) as DateField;
		  						if (calendarField.selectedDate != null)
		  						{	
			  						rowXML += '<DAY>' + calendarField.selectedDate.getDate().toString() + '</DAY>';
			  						rowXML += '<MONTH>' + (calendarField.selectedDate.getMonth()+1).toString() + '</MONTH>';
			  						rowXML += '<YEAR>' + calendarField.selectedDate.getFullYear().toString() + '</YEAR>';			  						
			  						rowXML += '<HOUR>0</HOUR>';
			  						rowXML += '<MINUTE>0</MINUTE>';
			  						rowXML += '<SECOND>0</SECOND>';
		  							
		  						}
		  					}
		  					rowXML += '</' + currField.@FIELDNAME + '>';    	  					
		  					k++;
	  					}
  					}
	  				j++;
	  			}
  				i++;
  			}
  			rowXML += "</"+relFacetName+">";
  			dg.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.SERIES_CHANGE, dg, rowXML));
  			this.visible = false;	
		}		
	}
}