package UI
{
	import assets.ButtonEx;
	import assets.DataGridColumnEx;
	import assets.SquareButton;
	
	import constants.STRINGS;
	
	import events.FacetSeriesChangeEvent;
	import events.FormEvents;
	
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.events.MouseEvent;
	import flash.xml.XMLNode;
	
	import infrastructure.statemanagement.StateMgr;
	
	import mx.charts.chartClasses.NumericAxis;
	import mx.collections.ArrayCollection;
	import mx.containers.Box;
	import mx.containers.Form;
	import mx.containers.FormItem;
	import mx.containers.HBox;
	import mx.containers.VBox;
	import mx.controls.Button;
	import mx.controls.CheckBox;
	import mx.controls.ComboBox;
	import mx.controls.DataGrid;
	import mx.controls.DateField;
	import mx.controls.Label;
	import mx.controls.RadioButton;
	import mx.controls.Text;
	import mx.controls.TextArea;
	import mx.controls.TextInput;
	import mx.core.UIComponent;
	import mx.events.FlexEvent;
	import mx.events.ValidationResultEvent;
	import mx.formatters.DateFormatter;
	import mx.messaging.AbstractConsumer;
	import mx.states.AddChild;
	import mx.states.State;
	import mx.utils.StringUtil;
	import mx.utils.XMLUtil;
	import mx.validators.StringValidator;
	
	import state.ConditionalFieldInfo;
	import state.ConditionalSectionInfo;
	
	import utils.Helper;
	import utils.Validators;
	
	public class FormRendition
	{
		private static var formRendition:FormRendition = null;
		private var mulSelSep:String = STRINGS.MULTISELECT_SEPERATOR;
		private var validators:Validators = new Validators();		
		private var nhCollection:XML;
		private var isDataValid:Boolean = true;		
		//public var isDataSaved:Boolean = false;
		private var parentContainer:UIComponent;
		private var facetSeries:FacetSeries;
		private var msTree:MultiSelectTree;
		
		public var fieldDataList:Array;
		public var currSelectedFacet: String = null;
		
		// Added for Conditional Display in Form
		private var lst_ConditionalSectionInfo: Array;
		private var globalConditionalInfo:ArrayCollection;
		private var FieldDataViewStateDetails:ArrayCollection;
		private var FieldViewStateIndex:Number=0;	
		private var ObjFormatXml:XML = null;
		//var lst_ConditionalFieldInfo: Array;
		
		
		public function FormRendition()
		{
			fieldDataList = new Array();
			facetSeries = new FacetSeries();
			msTree = new MultiSelectTree(); 
			globalConditionalInfo = new ArrayCollection();		
			FieldDataViewStateDetails = new ArrayCollection();
			FieldViewStateIndex = 0;
			ObjFormatXml = XML(StateMgr.GetInstance().FormatXml);
			var language:String = StateMgr.GetInstance().Language;
		}
		
		public function init(nhColl:XML, formLocalization:XML, labelLocalization:XML, parent:UIComponent):void
		{
			nhCollection = nhColl;
			parentContainer = parent;
			var language:String = StateMgr.GetInstance().Language;
			SetLocalizationStrings(formLocalization, labelLocalization);
			
			if (parentContainer != null)
			{
				msTree.Hide();
				parentContainer.addChild(msTree);
			}
			facetSeries.Init(nhColl, parent);
			
		}
		
		public function updateParentDisplay():void
		{	
			msTree.width = parentContainer.width;
			msTree.height = parentContainer.height;
			facetSeries.updateParentDisplay();
		}
        
        public function GenerateFacetForm(formConfigXML:String,formInputXML:String=null, isPopup:Boolean=false,  Arr_ConditionalInfo:Array = null):VBox
        {	
			var facetFormConfig:XML = XML(formConfigXML);
			var relatedFacet:XML = facetFormConfig.RELATEDFACETS.FACET[0];
			var currRelationshipName:String = relatedFacet.@RELATIONSHIPNAME;
			var currTypeName:String = relatedFacet.@TYPENAME;
			
			//Initialization
			lst_ConditionalSectionInfo = new Array();	
			
			if(Arr_ConditionalInfo != null)
				lst_ConditionalSectionInfo = Arr_ConditionalInfo;
			
			currSelectedFacet = currTypeName;
			
			var innerfacetseriesList:XMLList = facetFormConfig.RELATEDFACETS.FACET.((@RELATIONSHIPNAME == currRelationshipName));				
			var isFirstLevelSeries:Boolean = false;
			if (innerfacetseriesList != null && innerfacetseriesList.length() > 0 && innerfacetseriesList.attribute("IsSeries").length() > 0)
			{
				innerfacetseriesList = innerfacetseriesList.(@IsSeries == "YES")
				if (innerfacetseriesList != null && innerfacetseriesList.length() > 0)
					isFirstLevelSeries = true;
			}
			
			var facetNodesList:XMLList;
			if (formInputXML != null)
				facetNodesList = GetFacetNodesList(currRelationshipName, currTypeName, formInputXML, isFirstLevelSeries);
    		
    		var FacetBox:VBox = new VBox();
    		FacetBox.setStyle("borderStyle","1px solid #E0E0E0");
    		FacetBox.percentWidth = 100;
    		FacetBox.name = currTypeName;        		        		
    		
    		RenderFacetLabelArea(FacetBox, currTypeName, isPopup);
    		
    		RenderFacetDataArea(FacetBox, facetFormConfig, facetNodesList, isPopup, isFirstLevelSeries);
    		
			return FacetBox;
        }
        
        private function RenderFacetLabelArea(FacetBox:VBox,typename:String, isPopup:Boolean):void
        {
        	var FacetLabelArea:HBox = new HBox();
    		FacetLabelArea.percentWidth = 100;
    		FacetLabelArea.setStyle("verticalAlign","middle");
    		
    		if (!isPopup)
    		{
	    		var MinimizeFacetData:SquareButton = new SquareButton();
	    		MinimizeFacetData.label = "-";
			 	MinimizeFacetData.addEventListener(MouseEvent.CLICK, MinimizeFacetDataBox,false,0,false);
	       	  	MinimizeFacetData.useHandCursor = true;
	    		FacetLabelArea.addChild(MinimizeFacetData);
    		}    		
    		
    		var FacetLabelText:Text = new Text();
    		FacetLabelText.setStyle("fontFamily","Tahoma");
    		FacetLabelText.setStyle("color","#ffffff");
    		FacetLabelText.setStyle("fontSize","11");
    		//FacetLabelText.setStyle("fontWeight",getStyle("sectionHeaderFontWeight"));
    		//FacetLabelText.setStyle("fontFamily",getStyle("sectionHeaderFontFamily"));
    		//FacetLabelText.setStyle("color",getStyle("sectionHeaderFontColor"));
    		//FacetLabelText.setStyle("fontSize",getStyle("sectionHeaderFontSize"));
    		//FacetLabelText.setStyle("fontWeight",getStyle("sectionHeaderFontWeight"));
    		FacetLabelText.text = typename;
    		FacetLabelArea.addChild(FacetLabelText);
    		FacetLabelArea.setStyle("backgroundColor","#2c5f87");
    		
	    	if (!isPopup)
	    	{
	    		var DeleteFacetBtn:SquareButton = new SquareButton();
	    		DeleteFacetBtn.label = "X";
	    		DeleteFacetBtn.addEventListener(MouseEvent.CLICK,DeleteFacet);    		
	    		FacetLabelArea.addChild(DeleteFacetBtn);
    		}
    		FacetBox.addChild(FacetLabelArea);
        }
        
        private function RenderFacetDataArea(FacetBox:VBox, facetFormConfig:XML, facetNodesList:XMLList,isPopup:Boolean, isFirstLevelSeries:Boolean):void
        {
        	var FacetDataArea:VBox = new VBox();
    		FacetDataArea.percentWidth = 100;
			PouplateSectionInfoClass(facetFormConfig, facetNodesList);
			
			var dataPresent:Boolean = false;			
			for(var cnt:Number=0; cnt < globalConditionalInfo.length; cnt++)
			{
				if(globalConditionalInfo[cnt].facetName == currSelectedFacet)
				{
					dataPresent = true;
					break;
				}	
			}
			
			if(!dataPresent)
			{
				var record:Object = new Object();
				record.facetName = currSelectedFacet;
				record.conditionalInfo = lst_ConditionalSectionInfo;
				globalConditionalInfo.addItem(record);
			}
			
    		RenderSections(FacetDataArea, facetFormConfig, facetNodesList, isPopup, isFirstLevelSeries);  
			FacetBox.addChild(FacetDataArea);
        }
        
        private function RenderSections(FacetDataArea:VBox, facetFormConfig:XML, facetNodesList:XMLList,isPopup:Boolean, isFirstLevelSeries:Boolean):void
        {
			var sectionVisible:Boolean = true;
			var DisplayType:String = null;
			
        	var sections:XMLList = facetFormConfig.Section;    		
    		for (var i:int = 1; i <= sections.length(); i++)
    		{
				var currSection:XML = sections.(@Order == i.toString())[0];
								
				var SectionBox:VBox = new VBox();
				SectionBox.percentWidth = 100;				
    			if (String(currSection.@DisplaySectionBorder).toUpperCase() == "TRUE")
    				SectionBox.setStyle("borderStyle","1px solid #E0E0E0"); 
				
				sectionVisible = true;
				if(lst_ConditionalSectionInfo != null)
				{
					for (var sCntr:Number = 0; sCntr < lst_ConditionalSectionInfo.length; sCntr++)
					{
						var objCondSectionInfo:ConditionalSectionInfo = lst_ConditionalSectionInfo[sCntr];
						if (objCondSectionInfo.m_SectionOrder == currSection.@Order)
						{
							switch (objCondSectionInfo.m_SectionMode.toString().toUpperCase())
							{
								case "HIDDEN":
									sectionVisible = false;
									break;
								
								case "READONLY":								
									DisplayType = "READONLY";
									break;
							}						
							break;
						}
					}
				}
				
				if(sectionVisible)
					RenderSectionLabelArea(SectionBox, currSection);
				
				RenderSectionDataArea(SectionBox, currSection, facetFormConfig, facetNodesList, isPopup, isFirstLevelSeries, lst_ConditionalSectionInfo[i - 1]);
				
				if(sectionVisible)
	    			FacetDataArea.addChild(SectionBox);
				
			}
        }
        
        private function RenderSectionLabelArea(SectionBox:VBox, currSection:XML):void
        {
			var SectionHeadingDisplayTextID: String = null;
        	var SectionLabelBox:HBox = new HBox();
			
			if (String(currSection.@DisplaySectionHeadingOnEditPage).toUpperCase() == "TRUE")
			{				
				SectionLabelBox.setStyle("backgroundColor","#2c5f87");					
				SectionLabelBox.percentWidth = 100;
				
				if (String(currSection.@SectionImageAlignment).toUpperCase() != "DISABLE")
				{
					var MinimizeSectionData:SquareButton = new SquareButton();
		    		MinimizeSectionData.label = "-";
				 	MinimizeSectionData.addEventListener(MouseEvent.CLICK, MinimizeFacetDataBox,false,0,false);
		       	  	MinimizeSectionData.useHandCursor = true;
		    		SectionLabelBox.addChild(MinimizeSectionData);
				}
				
				var SectionLabel:Text = new Text();
				SectionLabel.setStyle("fontFamily","Tahoma");
    			SectionLabel.setStyle("color","#ffffff");
    			SectionLabel.setStyle("fontSize","11");				
				
				SectionHeadingDisplayTextID = currSection.@DisplayTextID;				
				if (SectionHeadingDisplayTextID != null && SectionHeadingDisplayTextID != "")
					SectionLabel.text = Helper.GetLocalizedString(SectionHeadingDisplayTextID);
				else if(currSection.@Heading != null && currSection.@Heading != "")
					SectionLabel.text = currSection.@Heading;				
				
				SectionLabelBox.addChild(SectionLabel);
			}	
			SectionBox.addChild(SectionLabelBox);
        }
        
        private function RenderSectionDataArea(SectionBox:VBox, currSection:XML, facetFormConfig:XML, facetNodesList:XMLList, isPopup:Boolean, isFirstLevelSeries:Boolean, objCondSectionInfo:ConditionalSectionInfo):void
        {
        	var SectionDataBox:HBox = new HBox();
			SectionDataBox.percentWidth = 100;
			RenderColumns(currSection, SectionDataBox, facetFormConfig, facetNodesList, isPopup, isFirstLevelSeries,objCondSectionInfo);
			SectionBox.addChild(SectionDataBox);
        }
        
        private function RenderColumns(currSection:XML, SectionDataBox:HBox, facetFormConfig:XML, facetNodesList:XMLList, isPopup:Boolean, isFirstLevelSeries:Boolean,objCondSectionInfo:ConditionalSectionInfo):void
        {
        	var columns:XMLList = currSection.Column;    				         			
			for (var j:int = 1; j <= columns.length(); j++)
			{	        				
				var currColumn:XML = columns.(@Order == j.toString())[0];
				var ColumnBox:Form = new Form();
				ColumnBox.percentWidth = 100/columns.length();
				RenderFields(currColumn, ColumnBox, facetFormConfig, facetNodesList, isPopup, isFirstLevelSeries,objCondSectionInfo);
				SectionDataBox.addChild(ColumnBox);
			}
        }
        
        private function RenderFields(currColumn:XML, ColumnBox:Form, facetFormConfig:XML, facetNodesList:XMLList, isPopup:Boolean, isFirstLevelSeries:Boolean,objCondSectionInfo:ConditionalSectionInfo):void
        {
        	var fields:XMLList = currColumn.Field;    				
			var FieldVisible:Boolean = true;
			var FieldName:String = null;
			var Disable:String = null;
			var DisplayType:String = null;
			var UpdateViewState:Boolean = false;
			
			for (var k:int = 1; k <= fields.length(); k++)
			{	    					
				var currField:XML = fields.(@Order == k.toString())[0];
				FieldName = currField.@Name;
				UpdateViewState = false;
			
				var FieldBox:FormItem = new FormItem();				
				if (String(currField.@FieldVisible).toLowerCase() != "false")
				{
					// do nothing
					FieldVisible = true;
					DisplayType  = currField.@DisplayType;
					
					for (var fCntr:Number = 0; fCntr < objCondSectionInfo.m_ConditionalFieldInfo.length; fCntr++)
					{
						if (objCondSectionInfo.m_ConditionalFieldInfo[fCntr].FieldName == FieldName)
						{
							switch (objCondSectionInfo.m_ConditionalFieldInfo[fCntr].FieldMode.toString().toUpperCase())
							{
								case "HIDDEN":
									FieldVisible = false;
									UpdateViewState = true;
									break;
								
								case "READONLY":
									Disable = "YES";
									DisplayType = "READONLY";
									break;
							}
							//int_FieldCounter = fCntr;
							break;
						}
					}			
					
				}	
				else
				{	
					FieldBox.height = 1;
					FieldBox.visible = false;
				}				
				
				//Get field Data from FormInput XML, if provided
				var isDataCommon:Boolean = true;
				var txtOld:XML = null;
				if (!isPopup)
				{
					if (facetNodesList != null && facetNodesList.length() > 0)
					{ 
						var fieldInput:Object = GetFieldInput(currField, facetNodesList, facetFormConfig, isFirstLevelSeries);
						isDataCommon = Boolean(fieldInput.isDataCommon);
						txtOld = fieldInput.txtOld;
					}
				}
				
				if(!FieldVisible)
				{
					//This is done to preserve the previous field values for the fields which are made hidden by Condition change events. 
					if(UpdateViewState)	
						UpdateFieldDataViewState(currField,txtOld);
					
					continue;
				}
				
				//the following is required to initialize fieldDataList on each render
				delete fieldDataList[currField.@OBJECTTYPENAME + "$ALSEP$" + currField.@FIELDNAME];
				
				if (String(currField.@LabelAlign).toUpperCase() == "LEFT")
					FieldBox.setStyle("labelStyleName","biFormItemLabelLeftAlign");
				else if (String(currField.@LabelAlign).toUpperCase() == "CENTER")
					FieldBox.setStyle("labelStyleName","biFormItemLabelCenterAlign");				
				
				if (String(currField.@LabelVisible).toLowerCase() != "false" && String(currField.@EditModeLabelVisible).toLowerCase() != "false")
				{	
					FieldBox.label = currField.@Label + ":";
					if (currField.@DisplayTextID != null && currField.@DisplayTextID.toString() != "")
						FieldBox.label = Helper.GetLocalizedString(currField.@DisplayTextID) + ":";
					
					if (String(currField.@IsMandatory).toUpperCase() == "YES")
						 FieldBox.label = '*' + FieldBox.label;
				}
				//var currFieldName:String = currField.@FIELDNAME;
    			
				
				if (DisplayType != "READONLY")				
				{
					if (currField.@DataType == "INTEGER" || currField.@DataType == "FLOAT" || currField.@DataType == "STRING" || currField.@DataType == "TEXT" || currField.@DataType == "BOOLEAN")
						RenderTextControls(FieldBox, currField, txtOld, isDataCommon, facetFormConfig, isPopup);
				    else if (currField.@DataType == "CURRENCY")
			    	   	RenderCurrencyControl(FieldBox, currField, txtOld, isDataCommon);
	    	   	   	else if (currField.@DataType == "DATETIME")
						RenderCalendarControl(FieldBox,currField, txtOld, isDataCommon);
				}
				else
					RenderROField(FieldBox, currField, txtOld, isDataCommon, facetFormConfig, isPopup);
				ColumnBox.addChild(FieldBox);
			}
			
        }
        
        private function GetFacetNodesList(relName:String, typeName:String, formInputXML:String, isFirstLevelSeries:Boolean):XMLList
        {
        	var formInput:XML = XML(formInputXML);
        	//var facetNodes:XMLList = formInput.descendants(typeName);
        	var facetNodes:XMLList = formInput.elements(relName);
        	if (!isFirstLevelSeries)
        		facetNodes = facetNodes.elements(typeName); 
        	return facetNodes;
        }
        
        private function GetFieldInput(currField:XML, facetNodes:XMLList, facetFormConfig:XML, isFirstLevelSeries:Boolean):Object
        {
        	var inputData:Object = new Object();
        	var fieldName:String = currField.@FIELDNAME; 
		    
        	var facetNode:XML;
        	var p:int = 0;
        	var oldValArr:Array = new Array();
        	for each (facetNode in facetNodes)
        	{
        		var fieldNode:XML;
				if (String(currField.@UIType).toUpperCase() == "LISTCONTROL")
				{
					if (!isFirstLevelSeries)
						fieldNode = facetNode.child(currField.@RELATIONSHIPNAME)[0];
					else
						fieldNode = facetNode;
				}
				else
					fieldNode = facetNode.child(fieldName)[0];
				if (p == 0)
				{
					oldValArr[0] = fieldNode; //have used array as it will support all type of data (eg.:date)
					inputData.isDataCommon = true;
					inputData.txtOld = fieldNode;
				}
				else
				{
					if (fieldNode != oldValArr[0])
					{
						inputData.isDataCommon = false;
						inputData.txtOld = null;
						break;
					}	
				}
				p++;
			}
        	return inputData;
        }
        
        public function RenderText(FieldBox:FormItem ,txtOld:String):void
        {
        	var FieldValue:Text = new Text();
			if (txtOld != null)
			{
				FieldValue.text = txtOld;
			}
			FieldBox.addChild(FieldValue);			
        }
        
        private function RenderTextControls(FieldBox:FormItem , currField:XML, txtOld:XML, isDataCommon:Boolean, facetFormConfig:XML, isPopup:Boolean=false):void
        {	
        	var nhObj:Object = Helper.GetNHDetails(currField, nhCollection);
        	var nhTreeNode:XML = XML(nhObj.nhTreeNode);
        	var customTreeNodes:Boolean = Boolean(nhObj.customTreeNodes);
        	
        	if (String(currField.@UIType).toUpperCase() == "EDITBOX")
        	{
        		RenderTextInput(FieldBox, currField, txtOld, isDataCommon);	
			}
			else if (String(currField.@UIType).toUpperCase() == "TEXTAREA")
			{	
				RenderTextArea(FieldBox, currField, txtOld, isDataCommon);
			}
			else if (String(currField.@UIType).toUpperCase() == "DROPDOWNLIST")
			{	
				RenderDropDown(FieldBox, currField, txtOld, isDataCommon, nhTreeNode, customTreeNodes);
			}
			else if (String(currField.@UIType).toUpperCase() == "MULTISELECT")
			{
				RenderTreeview(nhTreeNode, FieldBox, currField, txtOld, isDataCommon, isPopup);
			}
			else if (String(currField.@UIType).toUpperCase() == "RADIOBUTTON")
			{	
				RenderRadioButtonGroup(nhTreeNode, currField, FieldBox, txtOld, isDataCommon, customTreeNodes);
			}
			else if (String(currField.@UIType).toUpperCase() == "CHECKBOX")
			{					
				RenderCheckboxGroup(nhTreeNode, currField, FieldBox, txtOld, isDataCommon, customTreeNodes);
			}
			else if (String(currField.@UIType).toUpperCase() == "LISTCONTROL")
			{	
				facetSeries.ShowFacetSeries(FieldBox, currField, txtOld, isDataCommon, facetFormConfig);
			}			
        }
        
        private function RenderTextInput(FieldBox:FormItem, currField:XML, txtOld:XML, isDataCommon:Boolean):void
        {
        	var FieldValue:TextInput = new TextInput();
    		FieldValue.id = currField.@OBJECTTYPENAME + "$ALSEP$" + currField.@FIELDNAME;
    		FieldValue.addEventListener(FocusEvent.FOCUS_OUT, ControlFocusOutHandler);
    		FieldValue.addEventListener(Event.CHANGE, ControlChangeEventHandler);
			
			FieldValue.name = currField.toXMLString();
			
			if (txtOld == null)
          		FieldValue.text = currField.@DefaultValue;
			
			if (txtOld != null && isDataCommon)
			{	
				FieldValue.text = txtOld;
			}
			
			if (currField.@DataType == "INTEGER" || currField.@DataType == "FLOAT")
				FieldValue.text = Helper.convertStdValueToEditableFormat(FieldValue.text,currField.@DataType);
			
			FieldBox.addChild(FieldValue);
        }
        
        private function RenderTextArea(FieldBox:FormItem, currField:XML, txtOld:XML, isDataCommon:Boolean):void
        {
        	var FieldValueTxtArea:TextArea = new TextArea(); 
			FieldValueTxtArea.name = currField.toXMLString();
			FieldValueTxtArea.addEventListener(FocusEvent.FOCUS_OUT, ControlFocusOutHandler);
    		FieldValueTxtArea.addEventListener(Event.CHANGE, ControlChangeEventHandler);
    		
    		if (txtOld == null)
          		FieldValueTxtArea.text = currField.@DefaultValue;
    		       		
			if (txtOld != null && isDataCommon)
			{
				FieldValueTxtArea.text = txtOld;
			}
			FieldBox.addChild(FieldValueTxtArea);
        }
        
        private function RenderDropDown(FieldBox:FormItem, currField:XML, txtOld:XML, isDataCommon:Boolean, nhTreeNode:XML, customTreeNodes:Boolean):void
        {
        	var FieldValueComboBox:ComboBox = new ComboBox();
			FieldValueComboBox.name = currField.toXMLString();
			FieldValueComboBox.selectedIndex = -1;								 				
			FieldValueComboBox.addEventListener(FocusEvent.FOCUS_OUT, ControlFocusOutHandler);
			
			if(currField.@IsConditionAwareField == "true")
				FieldValueComboBox.addEventListener(Event.CHANGE, function():void { ConditionChangeEventHandler(currField, lst_ConditionalSectionInfo);}, false);
			else
				FieldValueComboBox.addEventListener(Event.CHANGE, ControlChangeEventHandler);
			
			if(nhTreeNode != null)
			{
				var xmlStr:String = nhTreeNode.toXMLString();
				var treeXML:XML = new XML(xmlStr);
				var defaultItem:XML;
				var defaultValue:String;
				if (customTreeNodes == false)
				{ 
					FieldValueComboBox.dataProvider = treeXML.TreeNode;
					//FieldValueComboBox.labelField  = "@Text";					
					FieldValueComboBox.labelFunction = utils.Helper.getNamedHierarchyDisplayValue;
					defaultValue = currField.@DefaultNamedHierarchyValue;
					
					if (defaultValue != null && String(defaultValue).length > 0)
						FieldValueComboBox.selectedItem = treeXML.TreeNode.(@Text == defaultValue);
					if (txtOld != null && isDataCommon)
						FieldValueComboBox.selectedItem = treeXML.TreeNode.(@Text == txtOld);
					
					
				}
				else
				{
					FieldValueComboBox.dataProvider = treeXML.Item;
					//FieldValueComboBox.labelField = "DisplayValue";
					FieldValueComboBox.labelFunction = utils.Helper.getItemListDisplayValue;
					defaultItem = nhTreeNode.ValueList[0];
					if (defaultItem != null)
					{
						defaultValue = defaultItem.Value.toString();
						FieldValueComboBox.selectedItem = treeXML.Item.(Value == defaultValue); 
					}
					if (txtOld != null && isDataCommon)
						FieldValueComboBox.selectedItem = treeXML.Item.(Value == txtOld);
				}
			}
			FieldBox.addChild(FieldValueComboBox);
        }
        
		
		
        private function RenderRadioButton(currField:XML, FieldBox:FormItem):void
        {
        	var fieldValueRadioBtn:RadioButton = new RadioButton();
			fieldValueRadioBtn.name = currField.toXMLString();
			if(currField.@IsConditionAwareField == "true")
				fieldValueRadioBtn.addEventListener(Event.CHANGE, function():void { ConditionChangeEventHandler(currField, lst_ConditionalSectionInfo);}, false);
			else
				fieldValueRadioBtn.addEventListener(Event.CHANGE, ControlChangeEventHandler);
			FieldBox.addChild(fieldValueRadioBtn);
        }
        
        private function RenderCheckBox(currField:XML, FieldBox:FormItem):void
        {
        	var fieldValueChkBox:CheckBox = new CheckBox();
			fieldValueChkBox.name = currField.toXMLString();
			if(currField.@IsConditionAwareField == "true")
				fieldValueChkBox.addEventListener(Event.CHANGE, function():void { ConditionChangeEventHandler(currField, lst_ConditionalSectionInfo);}, false);
			else
				fieldValueChkBox.addEventListener(Event.CHANGE, ControlChangeEventHandler);
			
			FieldBox.addChild(fieldValueChkBox);
        }
        
        private function RenderRadioButtonGroup(nhTreeNode:XML, currField:XML, FieldBox:FormItem, txtOld:XML, isDataCommon:Boolean, customTreeNodes:Boolean):void
        {
        	var fvRadioBtnGrp:HBox = new HBox();
        	fvRadioBtnGrp.name = currField.toXMLString();         	        	
			if (nhTreeNode != null)
			{
				var xmlStr:String = nhTreeNode.toXMLString();
				var treeXML:XML = new XML(xmlStr);
				var defaultItem:XML;
				var defaultValue:String;
				var rb_nameList:XMLList;
				
				if (customTreeNodes == false)
				{ 
					rb_nameList = treeXML.TreeNode;
					defaultValue = currField.@DefaultNamedHierarchyValue;
				}
				else
				{
					rb_nameList = treeXML.Item;
					defaultItem = treeXML.ValueList[0];
					if (defaultItem != null)
						defaultValue = defaultItem.Value.toString();
				}
				var rb_name:XML;
				var displayTextID:String = null;
				for each (rb_name in rb_nameList)
				{	
					displayTextID = "";
					var rb:RadioButton = new RadioButton();
					rb.groupName = currField.@Name;
					rb.id = currField.@OBJECTTYPENAME + "$ALSEP$" + currField.@FIELDNAME;						
					rb.addEventListener(Event.CHANGE, onRadioBtnChange);
					if (customTreeNodes == false)
					{						
						displayTextID = rb_name.@DisplayTextID;
						if(displayTextID != null && displayTextID != "")
						{	
							rb.label = utils.Helper.GetLocalizedString(displayTextID);
							if(rb.label == displayTextID)
								rb.label = rb_name.@Text;
						}
						else
							rb.label = rb_name.@Text;
						
						rb.value = rb_name.@Text;
					}
					else
					{
						var displayValue:String = rb_name.DisplayValue;						
						
						displayTextID = rb_name.@DisplayTextID;
						if(displayTextID != null && displayTextID != "")
						{
							rb.label = utils.Helper.GetLocalizedString(displayTextID);
							if(rb.label == displayTextID)
							{	
								if(displayValue != null && displayValue != "")
									rb.label = displayValue;
								else
									rb.label = rb_name.Value;
							}	
						}
						else
						{
							if(displayValue != null && displayValue != "")
								rb.label = displayValue;
							else
								rb.label = rb_name.Value;
						}
						
						rb.value = rb_name.Value;
					}
					
					
					if (txtOld != null && isDataCommon)
					{
						var rbdata:String = txtOld;
						if (rbdata!=null)
						{
							rbdata += mulSelSep;
							fieldDataList[currField.@OBJECTTYPENAME + "$ALSEP$" + currField.@FIELDNAME] = rbdata;
							if (rbdata.indexOf(rb.value+mulSelSep) >= 0)
							{
								rb.selected = true;
							}
						}
					}
					else
					{
						if (defaultValue != null && defaultValue.length > 0)
						{
							if (rb.value == defaultValue)
							{
								rb.selected = true;
								fieldDataList[currField.@OBJECTTYPENAME + "$ALSEP$" + currField.@FIELDNAME] = defaultValue;
								//rb.dispatchEvent(new Event(Event.CHANGE));
							}
						}
					}	
						
					fvRadioBtnGrp.addChild(rb);
				}
			}
			FieldBox.addChild(fvRadioBtnGrp);
        }
        
        private function RenderCheckboxGroup(nhTreeNode:XML, currField:XML, FieldBox:FormItem, txtOld:XML, isDataCommon:Boolean, customTreeNodes:Boolean):void
        {
        	var fvChkBoxGrp:HBox = new HBox();
			var displayTextID:String = null;
			
        	fvChkBoxGrp.name = currField.toXMLString();
        	if (nhTreeNode != null)
        	{
				var xmlStr:String = nhTreeNode.toXMLString();
				var treeXML:XML = new XML(xmlStr);
				var defaultItem:XML;
				var defaultValue:String;
				var cb_nameList:XMLList;
				if (customTreeNodes == false)
				{ 
					cb_nameList = treeXML.TreeNode;
					defaultValue = currField.@DefaultNamedHierarchyValue;
				}
				else
				{
					cb_nameList  = treeXML.Item;
					defaultItem = treeXML.ValueList[0];
					if (defaultItem != null)
						defaultValue = defaultItem.Value.toString();
				}
				var cb_name:XML;					
				for each (cb_name in cb_nameList)
				{
					var cb:CheckBox = new CheckBox();
					cb.id = currField.@OBJECTTYPENAME + "$ALSEP$" + currField.@FIELDNAME;
					//if(currField.@IsConditionAwareField == "true")
					//	cb.addEventListener(Event.CHANGE, function():void { ConditionChangeEventHandler(currField, lst_ConditionalSectionInfo,cb);}, false);
					//else			
						cb.addEventListener(Event.CHANGE, onChkBoxChange);
					
					displayTextID = "";
					if (customTreeNodes == false)
					{
						displayTextID = cb_name.@DisplayTextID;
						if(displayTextID != null && displayTextID != "")
						{
							cb.label = utils.Helper.GetLocalizedString(displayTextID);
							if(cb.label == displayTextID)
								cb.label = cb_name.@Text;
						}	
						else							
							cb.label = cb_name.@Text;
						
						cb.data = cb_name.@Text;
					}
					else
					{
						displayTextID = cb_name.@DisplayTextID;
						if(displayTextID != null && displayTextID != "")
						{
							cb.label = utils.Helper.GetLocalizedString(displayTextID);
							if(cb.label == displayTextID)
								cb.label = cb_name.Value;
						}	
						else	
							cb.label = cb_name.Value;						
						cb.data = cb_name.Value;
					}
					
					if (txtOld != null && isDataCommon)
					{
						var cbdata:String = txtOld;
						if (cbdata != null)
						{	
							cbdata += mulSelSep;
							fieldDataList[currField.@OBJECTTYPENAME + "$ALSEP$" + currField.@FIELDNAME] = cbdata;
							if (cbdata.indexOf(cb.data+mulSelSep) >= 0)
							{	
								cb.selected = true;
							}
						}
					}
					else
					{
						if (defaultValue != null && defaultValue.length > 0)
						{
							if (cb.data == defaultValue)
							{
								cb.selected = true;
								fieldDataList[currField.@OBJECTTYPENAME + "$ALSEP$" + currField.@FIELDNAME] = mulSelSep + defaultValue + mulSelSep;
								//cb.dispatchEvent(new Event(Event.CHANGE));
							}
						}
					}
						
					fvChkBoxGrp.addChild(cb);
				}
        	}
			FieldBox.addChild(fvChkBoxGrp);
        }
        
        private function RenderTreeview(nhTreeNode:XML, FieldBox:FormItem , currField:XML, txtOld:XML, isDataCommon:Boolean, isPopup:Boolean=false):void
        {
        	var nhValueType:String = "Value"; 
			
			if (currField.@SHOWSELECTEDVALUEPATH != null && String(currField.@SHOWSELECTEDVALUEPATH).toUpperCase() == "TRUE")
				nhValueType = "Path";
        	
        	var fvTreeArea:HBox = new HBox();
        	
        	if (!isPopup)
				fvTreeArea.id = currField.@OBJECTTYPENAME + "$ALSEP$" + currField.@FIELDNAME;				
			else
				fvTreeArea.id = currField.@OBJECTTYPENAME + "$ALSEP$" + currField.@FIELDNAME + "$ALSEP$POPUP";
        	
        	fvTreeArea.name = nhValueType;
    		
    		fvTreeArea.addEventListener(FormEvents.TREESELECTION_CHANGE, treeSelectionChangeHandler);
			
			var fvTreeSelectedVal:TextInput = new TextInput();
			fvTreeSelectedVal.editable = false;
			fvTreeSelectedVal.name = currField.toXMLString();
			fvTreeSelectedVal.addEventListener(FocusEvent.FOCUS_OUT, ControlFocusOutHandler); 
			
			var selectBtn:ButtonEx = new ButtonEx();
			selectBtn.label = STRINGS.BUTTON_TREEVIEW_SELECT;
			selectBtn.setActualSize(60,20);
			
			if (nhTreeNode != null)
			{
				var xmlStr:String = nhTreeNode.toXMLString();
				var treeXML:XML = new XML(xmlStr);
				selectBtn.name = treeXML.toXMLString();
			}
			
			selectBtn.addEventListener(MouseEvent.CLICK,selectClickHandler);
			
			fvTreeArea.addChild(fvTreeSelectedVal);
			fvTreeArea.addChild(selectBtn);
			
			FieldBox.addChild(fvTreeArea);
			
			fieldDataList[currField.@OBJECTTYPENAME + "$ALSEP$" + currField.@FIELDNAME] = mulSelSep;
			if (txtOld!=null && isDataCommon)
			{	
				var treeSelData:String = txtOld;
				fieldDataList[currField.@OBJECTTYPENAME + "$ALSEP$" + currField.@FIELDNAME] = treeSelData;
				
				//var treeDisplayVal:String = treeSelData.substr(mulSelSep.length, treeSelData.length - (2*mulSelSep.length));
				//while (treeDisplayVal.indexOf(mulSelSep) >= 0)
				//	treeDisplayVal = treeDisplayVal.replace(mulSelSep,',');
				
				var treeDisplayVal:String = getSelectedTreeNodeDisplayValue(treeSelData, nhTreeNode, nhValueType);
				fvTreeSelectedVal.text = treeDisplayVal; 
			}
        }
        
        private function selectClickHandler(evt:MouseEvent):void
        {
        	var selBtn:Button = evt.currentTarget as Button;
        	var fvTreeArea:HBox = selBtn.parent as HBox;
        	var treeXML:XML = null;
        	
        	if (selBtn.name != null && selBtn.name != "")
        		treeXML = XML(selBtn.name);
    		
        	var nhValueType:String = fvTreeArea.name;
        	
        	var selVal:String = fieldDataList[fvTreeArea.id];
        	
        	if (nhValueType=="Path")
			{	
				var treeSelDataArr:Array = selVal.split(mulSelSep);						
				selVal = mulSelSep;
				for (var i:int = 1; i < treeSelDataArr.length-1; i++)
				{
					var pathStrArr:Array = String(treeSelDataArr[i]).split("\\");
					selVal += pathStrArr[pathStrArr.length - 1] + mulSelSep;
				}	
			}			
			var treeDisplayVal:String = "";
        	msTree.initTree(treeXML, fvTreeArea, selVal,fieldDataList[fvTreeArea.id], treeDisplayVal);
        	msTree.Show();
        }
        
        private function treeSelectionChangeHandler(evt:FormEvents):void
        {			
        	var fvTreeArea:HBox = evt.currentTarget as HBox;
			
			var eventData:String = evt.Target as String;
			var fieldData:String = eventData.split("$DATA$")[0];
			var fieldDisplayData:String = eventData.split("$DATA$")[1];
			
        	var fvTextInput:TextInput = fvTreeArea.getChildAt(0) as TextInput;
			fieldDataList[fvTreeArea.id] = fieldData;
			
			var displayVal:String;
			if (fieldData == mulSelSep)
				displayVal = "";
			else
				displayVal = fieldDisplayData;
				
			if (displayVal.length > 0)
			{				
				fvTextInput.text = displayVal;
			}
			else
				fvTextInput.text = "";
			ControlChangeEventHandler();
        }
        
		private function getSelectedTreeNodeDisplayValue(treeSelData:String, nhTreeNode:XML, nhValueType:String):String
		{		
			var selectedValues:Array;
			var tempTreeNodeList:XMLList = null;
			var currentValue:String = null;
			var tmpDispValue:String = null;
			var selectedDispValue:String = "";
			var multiselDispSeperator:String = "";
			var tmpDispObject:Object;
			
			if (nhTreeNode != null && (treeSelData != null && treeSelData != ""))
			{
				var treeNodeList:XMLList = nhTreeNode.TreeNode;
				selectedValues = treeSelData.split(mulSelSep);
				if(treeNodeList != null && treeNodeList.length() > 0)
				{
					for(var selValCnt:Number =0 ; selValCnt < selectedValues.length; selValCnt++)
					{						
						tempTreeNodeList = treeNodeList;
						currentValue 	 = selectedValues[selValCnt];
						tmpDispValue 	 = "";
						
						if(currentValue != "")
						{
							//NH by Path
							if (nhValueType =="Path")					
								tmpDispValue = getDisplayValueOfSelectedPathTreeNode(currentValue, tempTreeNodeList);			
							else //NH by Value
							{
								tmpDispObject = getDisplayValueOfSelectedTreeNode(currentValue, tempTreeNodeList);
								if(tmpDispObject.isValueFound)
									tmpDispValue = tmpDispObject.displayValue;
								else
									tmpDispValue = currentValue;								
							}	
						}
						
						if(tmpDispValue != "")
						{
							selectedDispValue = selectedDispValue + multiselDispSeperator + tmpDispValue;	
							multiselDispSeperator = ",";
						}							
					}
				}
				return selectedDispValue;
			}
			else
				return "";
		}
		
        private function RenderCurrencyControl(FieldBox:FormItem, currField:XML, txtOld:XML, isDataCommon:Boolean):void
        {
        	var currencyEditBox:HBox = new HBox();
        	
        	var currencyDD:ComboBox = new ComboBox();
        	var nhObj:Object = Helper.GetNHDetails(currField, nhCollection);
        	var nhTreeNode:XML = XML(nhObj.nhTreeNode); 
        	currencyDD.dataProvider = nhTreeNode.TreeNode;        	
        	//currencyDD.labelField = "@Text";
			currencyDD.labelFunction = utils.Helper.getNamedHierarchyDisplayValue;
        	currencyDD.selectedIndex = -1;
        	currencyDD.addEventListener(Event.CHANGE, ControlChangeEventHandler);
        	
        	var FieldValue:TextInput = new TextInput();
    		FieldValue.id = currField.@OBJECTTYPENAME + "$ALSEP$" + currField.@FIELDNAME;
    		FieldValue.addEventListener(FocusEvent.FOCUS_OUT, ControlFocusOutHandler);
    		FieldValue.name = currField.toXMLString();
    		FieldValue.addEventListener(Event.CHANGE, ControlChangeEventHandler);
			
			if (txtOld != null && String(txtOld.CURRENCY).length > 0 && isDataCommon)
			{	
				currencyDD.selectedItem = nhTreeNode.TreeNode.(@Text == txtOld.CURRENCY); 
				FieldValue.text = Helper.convertStdValueToEditableFormat(txtOld.AMOUNT,currField.@DataType);
				//FieldValue.text = txtOld.AMOUNT;
			}
			currencyEditBox.addChild(currencyDD);
			currencyEditBox.addChild(FieldValue);
			FieldBox.addChild(currencyEditBox);			
        }
        
        private function RenderCalendarControl(FieldBox:FormItem, currField:XML, txtOld:XML, isDataCommon:Boolean):void
        {
        	var calendarField:DateField = new DateField();
			calendarField.labelFunction = Helper.dateLabelFunction;
			calendarField.parseFunction = null;
			calendarField.monthNames = STRINGS.MonthLabels;
			calendarField.dayNames = STRINGS.WeekDayShortLabels;
        	calendarField.name = currField.toXMLString(); 
        	calendarField.addEventListener(FocusEvent.FOCUS_OUT, ControlFocusOutHandler);
        	calendarField.addEventListener(Event.CHANGE, ControlChangeEventHandler);
			if (txtOld != null && String(txtOld.YEAR).length > 0 && isDataCommon)
			{	
				var currDate:Date = new Date(txtOld.YEAR, Number(txtOld.MONTH)-1, Number(txtOld.DAY));
				calendarField.selectedDate = currDate;
			}
			
			FieldBox.addChild(calendarField);			
        }
		
		private function MinimizeFacetDataBox(event:MouseEvent):void
        {
        	var MinimizeFacetDataBtn:Button = event.currentTarget as Button;        	
        	var FacetDataBox:Box = MinimizeFacetDataBtn.parent.parent.getChildAt(1) as Box;
        	
        	if (FacetDataBox.visible == true)
        	{
        		MinimizeFacetDataBtn.label = "+";
        		FacetDataBox.visible = false;
				FacetDataBox.includeInLayout = false;
    	 		//FacetDataBox.height = 0;
    	 	}
    	 	else
    	 	{
    	 		MinimizeFacetDataBtn.label = "-";
    	 		FacetDataBox.visible = true;
				FacetDataBox.includeInLayout = true;
    	 		//FacetDataBox.percentHeight = 100;
    	 	}
        }
        
        private function DeleteFacet(evt:MouseEvent):void
        {
        	var DeleteFacetBtn:Button = evt.currentTarget as Button;
        	var FacetBox:VBox = DeleteFacetBtn.parent.parent as VBox;
        	FacetBox.parent.removeChild(FacetBox);
        	parentContainer.dispatchEvent(new FormEvents(FormEvents.DELETE_FORM, FacetBox));
        }
        
        private function onRadioBtnChange(event:Event):void
        {
			var ControlID:String = null;
			var DBFieldName:String = null;
			var selectedValue:String = null; 
			
        	var rb:RadioButton = event.target as RadioButton;
        	var data:String;
			if (fieldDataList[rb.id] == null)
				fieldDataList[rb.id] = "";
			data = fieldDataList[rb.id];
			
			selectedValue =  rb.value[0];// as String;
			
			if (rb.selected)
			{	
				if (data.indexOf(selectedValue) < 0)	
					fieldDataList[rb.id] = StringUtil.trim(selectedValue) + mulSelSep;
   			}
   			else
   			{
   				if (data.indexOf(selectedValue) >= 0)
					fieldDataList[rb.id] += data.replace(selectedValue+mulSelSep,"");
   			}
   			if (rbGrp != null) //this condition is important when event during initial render with default value
   			{
	   			var rbGrp:HBox = rb.parent as HBox;
	   			var currField:XML = XML(rbGrp.name);
	   			if (String(currField.@IsMandatory).toUpperCase() == "YES")
	   			{	
	   				validators.ValidateHBox(rbGrp, fieldDataList[rb.id]);    			
	      		}
      		}
			ControlID 	= rb.id;
			var FacetName:String =  ControlID.split("$ALSEP$")[0];
			DBFieldName = ControlID.split("$ALSEP$")[1];
			if(IsConditionAwareField(DBFieldName, FacetName))
				Cbx_Rbx_ConditionChangeEventHandler(ControlID, lst_ConditionalSectionInfo);
			else
      			ControlChangeEventHandler();
        }
        
        private function onChkBoxChange(event:Event):void
        {	
			var ControlID:String = null;
			var DBFieldName:String = null;
			var selectedValue:String = null; 
			
			var cb:CheckBox = event.target as CheckBox;
			var data:String;
			
			if (fieldDataList[cb.id] == null)
				fieldDataList[cb.id] = mulSelSep;
			
			data = fieldDataList[cb.id];
			selectedValue = cb.data[0];
			
			if (cb.selected)
			{	
				if (data.indexOf(selectedValue) < 0)
					fieldDataList[cb.id] += StringUtil.trim(selectedValue) + mulSelSep;
			}
			else
			{
				if (data.indexOf(selectedValue) >= 0)
					fieldDataList[cb.id] = data.replace(mulSelSep+ selectedValue + mulSelSep,mulSelSep);
			}
			
			if(fieldDataList[cb.id] == mulSelSep)
				fieldDataList[cb.id] = null;
			
			if (cbGrp  != null) //this condition is important when event during initial render with default value
			{
				var cbGrp:HBox = cb.parent as HBox;
				var currField:XML = XML(cbGrp.name);
				if (String(currField.@IsMandatory).toUpperCase() == "YES")
				{	
					validators.ValidateHBox(cbGrp, fieldDataList[cb.id]);
				}
			}
						
			ControlID 	= cb.id;
			var FacetName:String =  ControlID.split("$ALSEP$")[0];
			DBFieldName = ControlID.split("$ALSEP$")[1];
			if(IsConditionAwareField(DBFieldName, FacetName))
				Cbx_Rbx_ConditionChangeEventHandler(ControlID, lst_ConditionalSectionInfo);
			else
      			ControlChangeEventHandler();
        }       
		
		
        /**
		 * Called on checkbox click
		 */
		/*private function onTreeCheckBoxCheck(event: TreeEvent): void
		{
			var currXML:XML = event.item as XML;
			var tree:TreeCheckBox = event.target as TreeCheckBox;
			var nhValueType:String = tree.name.split("$ALSEP$")[2]; 
							
			if (XML(currXML.parent()).toString() == "")
			{
				currXML.@Checked = "2";
				return;
			}
			
			var dataValue:String;
			if (fieldDataList[tree.id] == null || String(fieldDataList[tree.id]).length == 0)
				fieldDataList[tree.id] = mulSelSep;
			dataValue = fieldDataList[tree.id];
			var currValue:String = currXML.@Text;
			if (nhValueType == "Path")
			{
				var parent:XML = currXML.parent();
				while(parent != null && parent.name().toString() == "TreeNode" && parent.parent() != null && XML(parent.parent()).name().toString() != "TreeNodes")
				{	
					currValue = parent.@Text + "/" + currValue;
					parent = parent.parent();
				}
			}
			
			if (currXML.@Checked == "1")
			{	
				if (dataValue.indexOf(currValue + mulSelSep) < 0)
					fieldDataList[tree.id] += currValue + mulSelSep; 
			}
			else
			{
				if (dataValue.indexOf(currValue+mulSelSep) >= 0)
					fieldDataList[tree.id] = dataValue.replace(currValue + mulSelSep,"");
			}
			
			if (fieldDataList[tree.id] == mulSelSep)
				fieldDataList[tree.id] = "";
			
			fieldDataList[tree.id] = fieldDataList[tree.id];
			
			var displayVal:String = fieldDataList[tree.id];
			var displayText:TextInput = tree.parent.getChildAt(0) as TextInput;
			if (displayVal.length > (2*mulSelSep.length))
			{
				displayVal = displayVal.substr(mulSelSep.length,displayVal.length - (2*mulSelSep.length));
				while (displayVal.indexOf(mulSelSep) >= 0)
					displayVal = displayVal.replace(mulSelSep,',');
				displayText.text = displayVal;
			}
			else
				displayText.text = "";
			ControlChangeEventHandler();
		}*/
		
		
		private function ControlChangeEventHandler(evt:Event=null):void
        {
        	//isDataSaved = false;
        	parentContainer.dispatchEvent(new FormEvents(FormEvents.FORM_CHANGE,null,null, null,false));
			
        }
		
		private function Cbx_Rbx_ConditionChangeEventHandler(ControlID:String, lst_SecCondInfo:Array, ObjControl:Object=null):void
		{
			var ObjEvent:Event = null;
			
			var SelectedFacet:String = ControlID.split("$ALSEP$")[0];			
			var evtObj:Object = new Object();
			evtObj.SelectedFacet = SelectedFacet;
			evtObj.IsConditionSatisfied = "TRUE";
			evtObj.SectionConditionalInfo = lst_SecCondInfo;
			
			parentContainer.dispatchEvent(new FormEvents(FormEvents.CONDITIONAL_DATA_CHANGED,null,null, evtObj,false));
		}
		
		private function ConditionChangeEventHandler(currField:XML, lst_SecCondInfo:Array, ObjControl:Object=null):void
		{
			var ObjEvent:Event = null;		
			
			var evtObj:Object = new Object();
			evtObj.SelectedFacet = currField.@OBJECTTYPENAME;
			evtObj.IsConditionSatisfied = "TRUE";
			evtObj.SectionConditionalInfo = lst_SecCondInfo;
			
			parentContainer.dispatchEvent(new FormEvents(FormEvents.CONDITIONAL_DATA_CHANGED,null,null, evtObj,false));
		}
		
		public function ControlFocusOutHandler(evt:FocusEvent):void
		{	
			var ti:* = evt.currentTarget;
			
			var currField:XML = XML(ti.name);	
			var tempIsDataValid:Boolean = validators.ValidateField(ti, currField);
			if (tempIsDataValid == false)
			{				
				if(isDataValid)
					isDataValid = tempIsDataValid;
			}
			return;
		}
		
		
		
		public function SaveFormInputXML(currFacetBox:VBox, facetFormConfig:XML, arrCondSectionInfo:Array, isSaveClicked:Boolean=true/*, evt:MouseEvent=null*/):Object
        {	
			isDataValid = true;
			facetSeries.isDataValid = true;
    		var businessInfoStr:String = "";
			var relatedFacet:XML = facetFormConfig.RELATEDFACETS.FACET[0];
			var currTypeName:String = relatedFacet.@TYPENAME;
			var currRelationshipName:String = relatedFacet.@RELATIONSHIPNAME;
			var isFirstLevelSeries:Boolean = false;
			var objCondSectionInfo:ConditionalSectionInfo = null;
			var FormFieldName:String = null;
			var FieldVisible:Boolean = true;
			var ChildIndex:Number = 0;
			var Disable:String = null;
			var DisplayType:String = null;
			var result:Object = new Object();
			var FieldLabel:Label = null;
			var HiddenDueTo:String = null; 
			
			var SectionDataBox:HBox = null;
			var FacetColumnBox:Form = null;
			var selectedVal:String = null;
			var treeNode:XML = null;
			
			if(currFacetBox == null)
			{
				result.inputXML = businessInfoStr;
				result.isDataValid = true;
				return result;
			}
				
			businessInfoStr += '<' + currRelationshipName + ' TYPE="RELATION">';
			businessInfoStr += '<' + currTypeName + '>';        			        			
			var sections:XMLList = facetFormConfig.Section;
			var FacetDataBox:VBox = currFacetBox.getChildAt(1) as VBox;
			var currSection:XML;
			var SectionIndex:Number = 0;
			for (var i:int = 0; i < sections.length(); i++)
			{
				currSection = sections.(@Order == (i+1).toString())[0];
				
				var SectionBox:VBox = null;
				//if(i < FacetDataBox.numChildren)
				//	SectionBox = FacetDataBox.getChildAt(i) as VBox;
				
				objCondSectionInfo = arrCondSectionInfo[i];		
				if(SectionIndex < FacetDataBox.numChildren)
					SectionBox = FacetDataBox.getChildAt(SectionIndex) as VBox;
				
				if(objCondSectionInfo.m_SectionMode.toUpperCase() != "HIDDEN")				
					SectionIndex++;
				/*if(SectionBox == null)
					continue;*/
				
				if(SectionBox != null)
  					SectionDataBox = SectionBox.getChildAt(1) as HBox;
				
				var columns:XMLList = currSection.Column; 
				var currColumn:XML;
				for (var j:int = 0; j < columns.length(); j++)
				{				
					if(SectionDataBox != null)
						FacetColumnBox = SectionDataBox.getChildAt(j) as Form;
					
	  				currColumn = columns.(@Order == (j+1).toString())[0];	  				
	  				var fields:XMLList = currColumn.Field;
	  				var currField:XML;	 
					ChildIndex = 0;
					
	  				for (var k:int = 0; k < fields.length(); k++)
	  				{ 	
						HiddenDueTo = "";
						FieldVisible = true;
	  					currField 	 = fields.(@Order == (k+1).toString())[0];
						DisplayType  = currField.@DisplayType;
						
	  					if (currField.@RELATIONSHIPTYPE != null && String(currField.@RELATIONSHIPTYPE).length > 0)
	  					{		
							//Check if field is hidden due to condition
							objCondSectionInfo = arrCondSectionInfo[i];							
							for (var fCntr:Number = 0; fCntr < objCondSectionInfo.m_ConditionalFieldInfo.length; fCntr++)
							{
								if (objCondSectionInfo.m_ConditionalFieldInfo[fCntr].FieldName == currField.@Name)
								{
									switch (objCondSectionInfo.m_ConditionalFieldInfo[fCntr].FieldMode.toString().toUpperCase())
									{
										case "HIDDEN":
											FieldVisible = false;
											HiddenDueTo = ConditionalFieldInfo(objCondSectionInfo.m_ConditionalFieldInfo[fCntr]).HiddenDueTo;
											break;
										
										case "READONLY":
											Disable = "YES";
											DisplayType = "READONLY";
											break;
									}									
									break;
								}
							}			
							
							if(!FieldVisible)
							{
								if(isSaveClicked)
								{									
									if(HiddenDueTo.toUpperCase() == "CONDITION")
									{
										if (String(currField.@UIType).toUpperCase() != "LISTCONTROL")
											businessInfoStr += '<' + currField.@FIELDNAME + '>' + '</' + currField.@FIELDNAME + '>';
									}									
								}
								else
								{
									if(HiddenDueTo.toUpperCase() == "CONDITION" || HiddenDueTo.toUpperCase() == "PARENT")
									{
										var fieldData:String = getFieldDataFromViewState(currTypeName, currField);
										if (String(currField.@UIType).toUpperCase() != "LISTCONTROL" && String(currField.@UIType).toUpperCase() != "CURRENCY" 
											&& String(currField.@UIType).toUpperCase() != "CALENDAR")
											businessInfoStr += '<' + currField.@FIELDNAME + '>' + fieldData +  '</' + currField.@FIELDNAME + '>';
										else if (String(currField.@UIType).toUpperCase() == "LISTCONTROL" || String(currField.@UIType).toUpperCase() == "CURRENCY"
										    || String(currField.@UIType).toUpperCase() == "CALENDAR")
											businessInfoStr +=  fieldData;
									}	
									
								}
								continue;
							}	
							
							
		        			if (String(currField.@UIType).toUpperCase() != "LISTCONTROL")
    	  						businessInfoStr += '<' + currField.@FIELDNAME + '>';
    	  						
							if(FacetColumnBox == null)
								continue;
							
    	  					//var FacetFieldBox:FormItem = FacetColumnBox.getChildAt(k) as FormItem;
							var FacetFieldBox:FormItem = FacetColumnBox.getChildAt(ChildIndex) as FormItem;
							ChildIndex++;
    	  					var FacetFieldTextInput:TextInput = null;
    	  					var strValidator:StringValidator;
    	  					var resultEvent:ValidationResultEvent;
    	  					var tempStr:String = "";
    	  					
							if(DisplayType.toUpperCase() == "READONLY")
							{
								if (String(currField.@UIType).toUpperCase() == "EDITBOX" || String(currField.@UIType).toUpperCase() == "TEXTAREA" 
									|| String(currField.@UIType).toUpperCase() == "DROPDOWNLIST")
								{
									FieldLabel = FacetFieldBox.getChildAt(0) as Label;
									if (currField.@DataType == "INTEGER" || currField.@DataType == "FLOAT")
										businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(Helper.convertDisplayValuetoStdFormat(FieldLabel.text,currField.@DataType)));									
									else
										businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(FieldLabel.text));									
								}			
								else if (String(currField.@UIType).toUpperCase() == "MULTISELECT")
								{
									if ((fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME] != null) && (fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME] != "$AL$"))
										tempStr = fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME];
									businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(tempStr));
									tempStr = "";
								}
								else if (String(currField.@UIType).toUpperCase() == "RADIOBUTTON")
								{	
									if (String(currField.@DataType).toUpperCase() == "BOOLEAN")
									{
										if (fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME] != null)
											tempStr = fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME];
										
										businessInfoStr += StringUtil.trim(tempStr);
										tempStr = "";
									}
									else if (String(currField.@DataType).toUpperCase() == "STRING")
									{
										if (fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME] != null)
											tempStr = fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME];
										if (tempStr.length > 0)
											tempStr = tempStr.substr(0,tempStr.length - mulSelSep.length);		
										businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(tempStr));
										
										/*if (String(currField.@IsMandatory).toUpperCase() == "YES")
										{
											var rbGrp:HBox = FacetFieldBox.getChildAt(0) as HBox;			  									
											var isDataValidtemp:Boolean = validators.ValidateHBox(rbGrp, tempStr);
											if (isDataValidtemp == false)
												isDataValid = isDataValidtemp;
										}*/
										tempStr = "";
									}
									
								}
								else if (String(currField.@UIType).toUpperCase() == "CHECKBOX")
								{					
									if (String(currField.@DataType).toUpperCase() == "BOOLEAN")
									{
										if (fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME] != null)
											tempStr = fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME];
										
										if(tempStr != null || tempStr != "")
											businessInfoStr += StringUtil.trim(tempStr);
										else
											businessInfoStr += "0";
										
										tempStr = "";
									}
									else if (String(currField.@DataType).toUpperCase() == "STRING")
									{
										if (fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME] != null)
											tempStr = fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME];
										if (tempStr.length > 0)
											tempStr = tempStr.substr(0,tempStr.length - mulSelSep.length);		
										businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(tempStr));
										
										/*if (String(currField.@IsMandatory).toUpperCase() == "YES")
										{
										var rbGrp:HBox = FacetFieldBox.getChildAt(0) as HBox;			  									
										var isDataValidtemp:Boolean = validators.ValidateHBox(rbGrp, tempStr);
										if (isDataValidtemp == false)
										isDataValid = isDataValidtemp;
										}*/
										tempStr = "";
									}
								}
								else if (String(currField.@UIType).toUpperCase() == "LISTCONTROL")
								{	
									//TO DO: Need to add support for RO FacetSeries
									var chldfacetseriesList:XMLList = facetFormConfig.RELATEDFACETS.FACET.RELATEDFACETS.FACET.((@RELATIONSHIPNAME == currField.@RELATIONSHIPNAME) && (@IsSeries == "YES"));
									var inrfacetseriesList:XMLList = facetFormConfig.RELATEDFACETS.FACET.((@RELATIONSHIPNAME == currField.@RELATIONSHIPNAME));
									var series_RelatedFacet:XML = null;
									if (chldfacetseriesList != null && chldfacetseriesList.length() > 0)
										series_RelatedFacet = chldfacetseriesList[0];
									else if (inrfacetseriesList != null && inrfacetseriesList.length() > 0)
									{
										inrfacetseriesList = inrfacetseriesList.(@IsSeries == "YES")
										if (inrfacetseriesList != null && inrfacetseriesList.length() > 0)
											series_RelatedFacet = inrfacetseriesList[0];
										isFirstLevelSeries = true;	
									}
									
									var seriesDataXml:XML = XML(facetSeries.facetSeriesData[currTypeName + "$ALSEP$" + series_RelatedFacet.@TYPENAME]);
									//The following is done as when there is no data in facet series, sending empty relationship node is not allowed
									// so when there is no data no node should be made. 
									if (seriesDataXml.children().length() > 0)
										businessInfoStr += facetSeries.facetSeriesData[currTypeName + "$ALSEP$" + series_RelatedFacet.@TYPENAME];
									var FacetFieldDataGrid:DataGrid = FacetFieldBox.getChildAt(0) as DataGrid;
									//FacetFieldDG.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.ITEM_VALIDATE));
									if (String(currField.@IsMandatory).toUpperCase() == "YES")
									{
										if (FacetFieldDataGrid.dataProvider == null || FacetFieldDataGrid.dataProvider == "")
										{	
											FacetFieldDataGrid.errorString = STRINGS.FACETSERIES_DATA_MANDATORY;
											isDataValid = false;
										}
										else
											FacetFieldDataGrid.errorString = null;
									}
								}
								else if (currField.@DataType == "CURRENCY")
								{
									var currencyText:String = null;
									//Date Format: date.date + " " + STRINGS.MonthLabels[date.month] + " " + date.fullYear;
									FieldLabel = FacetFieldBox.getChildAt(0) as Label;
									currencyText = FieldLabel.text;
									var currencyArray:Array = currencyText.split(" ");
									businessInfoStr += '<CURRENCY>'+ currencyArray[0] +'</CURRENCY>';
									if(currencyArray.length == 2)
										businessInfoStr += '<AMOUNT>' + StringUtil.trim(Helper.convertDisplayValuetoStdFormat(currencyArray[1],currField.@DataType)) +'</AMOUNT>';
								}
								else if (currField.@DataType == "DATETIME")
								{
									var dateText:String = null;
									//Date Format: date.date + " " + STRINGS.MonthLabels[date.month] + " " + date.fullYear;
									FieldLabel = FacetFieldBox.getChildAt(0) as Label;
									dateText = FieldLabel.text;
									
									if(dateText != null && dateText != "")
									{
										var dateArray:Array = dateText.split(" ");
										businessInfoStr += '<DAY>' + dateArray[0] + '</DAY>';
										businessInfoStr += '<MONTH>' + Helper.GetMonthNumber(dateArray[1]) + '</MONTH>';
										businessInfoStr += '<YEAR>' + dateArray[2] + '</YEAR>';
										businessInfoStr += '<HOUR>0</HOUR>';
										businessInfoStr += '<MINUTE>0</MINUTE>';
										businessInfoStr += '<SECOND>0</SECOND>';
									}
								}
							}//if(DisplayType.toUpperCase() == "READONLY")
							else if (currField.@DataType == "INTEGER" || currField.@DataType == "FLOAT" || currField.@DataType == "STRING" || currField.@DataType == "TEXT" || currField.@DataType == "BOOLEAN")
    	  					{
    	  						if (String(currField.@UIType).toUpperCase() == "EDITBOX")
    	  						{
	    	  						FacetFieldTextInput = FacetFieldBox.getChildAt(0) as TextInput;	    	  						
									if (currField.@DataType == "INTEGER" || currField.@DataType == "FLOAT")
										businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(Helper.convertDisplayValuetoStdFormat(FacetFieldTextInput.text,currField.@DataType)));
									else
										businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(FacetFieldTextInput.text));
									
									if(isSaveClicked)
	    	  							FacetFieldTextInput.dispatchEvent(new FocusEvent(FocusEvent.FOCUS_OUT));			    	  						
    	  						}
    	  						else if (String(currField.@UIType).toUpperCase() == "TEXTAREA")
    	  						{
    	  							var FacetFieldTxtArea:TextArea = FacetFieldBox.getChildAt(0) as TextArea;
    	  							businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(FacetFieldTxtArea.text));
									if(isSaveClicked)
    	  								FacetFieldTxtArea.dispatchEvent(new FocusEvent(FocusEvent.FOCUS_OUT));
    	  						}
    	  						else if (String(currField.@UIType).toUpperCase() == "DROPDOWNLIST")
    	  						{
									
									
    	  							var FacetFieldComboBox:ComboBox = FacetFieldBox.getChildAt(0) as ComboBox;
    	  							//businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(FacetFieldComboBox.selectedLabel));
									treeNode = FacetFieldComboBox.selectedItem as XML;
									selectedVal = null;
									if(treeNode != null)
									{
										if (XMLList(currField.Item).length() > 0) //If Custom treeNodes = True
											selectedVal = treeNode.Value;
										else
											selectedVal = treeNode.@Text;
									}
									
									businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(selectedVal));
									if(isSaveClicked)
    	  								FacetFieldComboBox.dispatchEvent(new FocusEvent(FocusEvent.FOCUS_OUT));
									
    	  						}
    	  						else if (String(currField.@UIType).toUpperCase() == "MULTISELECT")
    	  						{
    	  							if ((fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME] != null) && (fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME] != "$AL$"))
	  									tempStr = fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME];
  									businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(tempStr));
  									tempStr = "";
  									
  									var fvTreeArea:HBox = FacetFieldBox.getChildAt(0) as HBox;
  									var fvSelVals:TextInput = fvTreeArea.getChildAt(0) as TextInput;
									if(isSaveClicked)
  										fvSelVals.dispatchEvent(new FocusEvent(FocusEvent.FOCUS_OUT));
    	  						}
    	  						else if (String(currField.@UIType).toUpperCase() == "RADIOBUTTON")
    	  						{
    	  							if (String(currField.@DataType).toUpperCase() == "BOOLEAN")
    	  							{
    	  								var FacetFieldRBGrp:HBox = FacetFieldBox.getChildAt(0) as HBox;
    	  								var FacetFieldRBGrpChilds:Array = FacetFieldRBGrp.getChildren();
    	  								if (FacetFieldRBGrpChilds != null && FacetFieldRBGrpChilds.length > 0)
    	  								{
	    	  								var FacetFieldRB1:RadioButton = FacetFieldRBGrp.getChildAt(0) as RadioButton;
	    	  								var FacetFieldRB2:RadioButton = FacetFieldRBGrp.getChildAt(1) as RadioButton;
	    	  								if (FacetFieldRB1.selected)
	    	  									businessInfoStr += StringUtil.trim(FacetFieldRB1.value.toString());
	    	  								else
	    	  									businessInfoStr += StringUtil.trim(FacetFieldRB2.value.toString());	
    	  								}
    	  								//businessInfoStr += FacetFieldRB.selected.toString();
    	  							}
    	  							else if (String(currField.@DataType).toUpperCase() == "STRING")
    	  							{
    	  								if (fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME] != null)
    	  									tempStr = fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME];
	  									if (tempStr.length > 0)
	  										tempStr = tempStr.substr(0,tempStr.length - mulSelSep.length);		
	  									businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(tempStr));
	  									
										if(isSaveClicked)
										{
		  									if (String(currField.@IsMandatory).toUpperCase() == "YES")
		  									{
			  									var rbGrp:HBox = FacetFieldBox.getChildAt(0) as HBox;			  									
	   											var isDataValidtemp:Boolean = validators.ValidateHBox(rbGrp, tempStr);
	   											if (isDataValidtemp == false)
	   												isDataValid = isDataValidtemp;
	    	  								}
										}
    	  								tempStr = "";
    	  							}
    	  						}
    	  						else if (String(currField.@UIType).toUpperCase() == "CHECKBOX")
    	  						{
    	  							
    	  							if (String(currField.@DataType).toUpperCase() == "BOOLEAN")
    	  							{
    	  								var FacetFieldCBGrp:HBox = FacetFieldBox.getChildAt(0) as HBox;
										if(FacetFieldCBGrp != null && FacetFieldCBGrp.numChildren > 0)
										{
											var FacetFieldCB:CheckBox = FacetFieldCBGrp.getChildAt(0) as CheckBox;
											if (FacetFieldCB.selected)
												businessInfoStr += StringUtil.trim(FacetFieldCB.data.toString());
											else
												businessInfoStr += "0";
										}
										//businessInfoStr += FacetFieldCB.selected.toString();
									}
									else if (String(currField.@DataType).toUpperCase() == "STRING")
									{
										if (fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME] != null)
											tempStr = fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME];
										
										if (tempStr.length > 0)
											tempStr = tempStr.substr(0,tempStr.length - mulSelSep.length);
										
										businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(tempStr));
										
										if(isSaveClicked)
										{
		  									if (String(currField.@IsMandatory).toUpperCase() == "YES")
		  									{
			  									var cbGrp:HBox = FacetFieldBox.getChildAt(0) as HBox;
			  									isDataValid = validators.ValidateHBox(cbGrp, tempStr);
			  									if (isDataValidtemp == false)
	   												isDataValid = isDataValidtemp;			  									
		  									}
										}
	  									tempStr = "";
    	  							}
    	  						}
	    	  					else if (String(currField.@UIType).toUpperCase() == "LISTCONTROL")
								{	
									var childfacetseriesList:XMLList = facetFormConfig.RELATEDFACETS.FACET.RELATEDFACETS.FACET.((@RELATIONSHIPNAME == currField.@RELATIONSHIPNAME) && (@IsSeries == "YES"));
									var innerfacetseriesList:XMLList = facetFormConfig.RELATEDFACETS.FACET.((@RELATIONSHIPNAME == currField.@RELATIONSHIPNAME));
									var seriesRelatedFacet:XML = null;
									if (childfacetseriesList != null && childfacetseriesList.length() > 0)
					        			seriesRelatedFacet = childfacetseriesList[0];
				        			else if (innerfacetseriesList != null && innerfacetseriesList.length() > 0)
				        			{
				        				innerfacetseriesList = innerfacetseriesList.(@IsSeries == "YES")
				        				if (innerfacetseriesList != null && innerfacetseriesList.length() > 0)
				        					seriesRelatedFacet = innerfacetseriesList[0];
				        				isFirstLevelSeries = true;	
				        			}
									
									var seriesDataXML:XML = XML(facetSeries.facetSeriesData[currTypeName + "$ALSEP$" + seriesRelatedFacet.@TYPENAME]);
									//The following is done as when there is no data in facet series, sending empty relationship node is not allowed
									// so when there is no data no node should be made. 
									if (seriesDataXML.children().length() > 0)
										businessInfoStr += facetSeries.facetSeriesData[currTypeName + "$ALSEP$" + seriesRelatedFacet.@TYPENAME];
									var FacetFieldDG:DataGrid = FacetFieldBox.getChildAt(0) as DataGrid;
									
									if(isSaveClicked)
									{
										FacetFieldDG.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.ITEM_VALIDATE));
										if (String(currField.@IsMandatory).toUpperCase() == "YES")
	  									{
											if (FacetFieldDG.dataProvider == null || FacetFieldDG.dataProvider == "")
											{	
												FacetFieldDG.errorString = STRINGS.FACETSERIES_DATA_MANDATORY;
												isDataValid = false;
											}
											else
												FacetFieldDG.errorString = null;
	  									}
									}
								}
    	  					}
    	  					else if (String(currField.@DataType).toUpperCase() == "CURRENCY")    	  					
    	  					{
    	  						var currecyBox:HBox = FacetFieldBox.getChildAt(0) as HBox;
    	  						var currencyDD:ComboBox = currecyBox.getChildAt(0) as ComboBox;
								
								treeNode = currencyDD.selectedItem as XML;
								
								if(treeNode != null)
									selectedVal = treeNode.@Text;
								else
									selectedVal = currencyDD.selectedLabel;
								
    	  						businessInfoStr += '<CURRENCY>'+ StringUtil.trim(selectedVal) +'</CURRENCY>';
    	  						FacetFieldTextInput = currecyBox.getChildAt(1) as TextInput;
    	  						businessInfoStr += '<AMOUNT>' + StringUtil.trim(Helper.convertDisplayValuetoStdFormat(FacetFieldTextInput.text, currField.@DataType)) +'</AMOUNT>';
								if(isSaveClicked)
    	  							FacetFieldTextInput.dispatchEvent(new FocusEvent(FocusEvent.FOCUS_OUT));
    	  					}
    	  					else if (String(currField.@DataType).toUpperCase() == "DATETIME")
    	  					{
    	  						var calendarField:DateField = FacetFieldBox.getChildAt(0) as DateField;
								if(isSaveClicked)
    	  							calendarField.dispatchEvent(new FocusEvent(FocusEvent.FOCUS_OUT));
    	  						if (calendarField.selectedDate != null)
    	  						{	
	    	  						businessInfoStr += '<DAY>' + calendarField.selectedDate.getDate().toString() + '</DAY>';
	    	  						businessInfoStr += '<MONTH>' + (calendarField.selectedDate.getMonth()+1).toString() + '</MONTH>';
	    	  						businessInfoStr += '<YEAR>' + calendarField.selectedDate.getFullYear().toString() + '</YEAR>';
    	  							businessInfoStr += '<HOUR>0</HOUR>';
    	  							businessInfoStr += '<MINUTE>0</MINUTE>';
    	  							businessInfoStr += '<SECOND>0</SECOND>';
    	  						}
    	  					}
    	  					
		        			if (String(currField.@UIType).toUpperCase() != "LISTCONTROL")
    	  						businessInfoStr += '</' + currField.@FIELDNAME + '>';
    	  				}
	  				}  	  				    	  				
				} 
    		}       			
			businessInfoStr += '</' + currTypeName + '>';        			
			businessInfoStr += '</' + currRelationshipName + '>';
			
			if (isFirstLevelSeries)
			{
				var tempBusinessInfo:XML = XML(businessInfoStr);
				tempBusinessInfo = tempBusinessInfo.children()[0];
				tempBusinessInfo = tempBusinessInfo.children()[0];
				//if there is no data, the node of the facet series should not be created in AssetInfo else it gives error.
				if (tempBusinessInfo != null)
					businessInfoStr = tempBusinessInfo.toXMLString();
				else
					businessInfoStr = "";	
			}
			
			result = new Object();
			//Alert.show("end:::"+facetSeries.isDataValid);
			if (isDataValid == true && facetSeries.isDataValid == true)
			{	
				result.inputXML = businessInfoStr;
				result.isDataValid = true;
				//isDataSaved = true;  
			}
			else
			{
				result.isDataValid = false;
			}
			if (parentContainer != null)
				parentContainer.stage.focus = null;
        	return result;
        }
		
		public function SetLocalizationStrings(formLocalization:XML, labelLocalization:XML):void
		{
			if (formLocalization != null && formLocalization.toXMLString() != "")
				Helper.InitLocalizedStrings(formLocalization);
			
			if (labelLocalization != null && labelLocalization.toXMLString() != "")
				Helper.LocalizeLabels(labelLocalization);
		}
				
		public function LocalizeForm(facetBox:VBox, formConfigXML:String, arrCondSectionInfo:Array):void
		{		
			var objCondSectionInfo:ConditionalSectionInfo = null;
			var SectionIndex:Number = 0;
			var FieldVisible:Boolean = true;			
			var DisplayType:String = null;			
			var ChildIndex:Number = 0;
			
			msTree.setText();
			
			var facetDataArea:VBox = facetBox.getChildAt(1) as VBox;
			var facetFormConfig:XML = XML(formConfigXML);
			var sections:XMLList = facetFormConfig.Section;
			
			for (var i:int = 0; i < sections.length(); i++)
			{
				var currSection:XML = sections.(@Order == (i+1).toString())[0];
				var sectionBox:VBox = null;
				
				objCondSectionInfo = arrCondSectionInfo[i];		
				if(SectionIndex < facetDataArea.numChildren)
					sectionBox = facetDataArea.getChildAt(SectionIndex) as VBox;
				
				if(objCondSectionInfo.m_SectionMode.toUpperCase() != "HIDDEN")	
					SectionIndex++;
				else if(objCondSectionInfo.m_SectionMode.toUpperCase() == "HIDDEN")
					continue;
				
				var sectionLabelBox:HBox = null;
				var sectionDataBox:HBox = null;
				
				if(sectionBox != null)
				{
					sectionLabelBox = sectionBox.getChildAt(0) as HBox;
					sectionDataBox = sectionBox.getChildAt(1) as HBox;	
					
					for (var j:int = 0; j < sectionLabelBox.numChildren; j++)
					{
						var sectionLabelChild:* = sectionLabelBox.getChildAt(j);					
						if (String(currSection.@DisplaySectionHeadingOnEditPage).toUpperCase() == "TRUE")
						{
							if (sectionLabelChild is Text)
							{						
								if (currSection.@DisplayTextID != null && currSection.@DisplayTextID != "")
									(sectionLabelChild as Text).text = Helper.GetLocalizedString(currSection.@DisplayTextID); 
							}
						}
					}
				}
				
				var columns:XMLList = currSection.Column;
				
				for (var k:int = 0; k < columns.length(); k++)
				{
					
					var columnBox:Form = null;
					if(sectionDataBox != null)
						columnBox = sectionDataBox.getChildAt(k) as Form;
					
					ChildIndex = 0;
					var currColumn:XML = columns.(@Order == (k+1).toString())[0];
					var fields:XMLList = currColumn.Field;    				
					
					if (fields != null && fields.length() > 0)
					{
						for (var l:int =0; l < fields.length(); l++)
						{								
							FieldVisible = true;
							currField 	 = fields.(@Order == (l+1).toString())[0];							
							
							if (currField.@RELATIONSHIPTYPE != null && String(currField.@RELATIONSHIPTYPE).length > 0)
							{		
								//Check if field is hidden due to condition
								objCondSectionInfo = arrCondSectionInfo[i];							
								for (var fCntr:Number = 0; fCntr < objCondSectionInfo.m_ConditionalFieldInfo.length; fCntr++)
								{
									if (objCondSectionInfo.m_ConditionalFieldInfo[fCntr].FieldName == currField.@Name)
									{
										switch (objCondSectionInfo.m_ConditionalFieldInfo[fCntr].FieldMode.toString().toUpperCase())
										{
											case "HIDDEN":
												FieldVisible = false;												
												break;
											
											case "READONLY":												
												DisplayType = "READONLY";
												break;
										}									
										break;
									}
								}			
								
								if(!FieldVisible)
									continue;
							}
							
							if(columnBox == null)
								continue;
							
							var currField:XML = fields.(@Order == (l+1).toString())[0];
							if (String(currField.@LabelVisible).toLowerCase() != "false" && String(currField.@EditModeLabelVisible).toLowerCase() != "false")
							{
								var fieldBox:FormItem = columnBox.getChildAt(ChildIndex) as FormItem;
								ChildIndex++;
								if (currField.@DisplayTextID != null && currField.@DisplayTextID.toString() != "")
								{
									fieldBox.label = Helper.GetLocalizedString(currField.@DisplayTextID) + ":";							
									if (String(currField.@IsMandatory).toUpperCase() == "YES")
										fieldBox.label = '*' + fieldBox.label;
								}
								
								if (currField.@DataType == "DATETIME")
								{
									var calendarField:DateField = fieldBox.getChildAt(0) as DateField;
									calendarField.monthNames = STRINGS.MonthLabels;
									calendarField.dayNames = STRINGS.WeekDayShortLabels;
									var oldDate:Date = calendarField.selectedDate;
									if (oldDate != null)
									{
										calendarField.selectedDate = null;
										calendarField.selectedDate = oldDate;
									}
								}
								else if (currField.@DataType == "INTEGER" || currField.@DataType == "FLOAT" || currField.@DataType == "STRING" || currField.@DataType == "TEXT" || currField.@DataType == "BOOLEAN")
								{
									if (String(currField.@UIType).toUpperCase() == "MULTISELECT")
									{
										var fvTreeArea:HBox = fieldBox.getChildAt(0) as HBox;
										var selectBtn:Button = fvTreeArea.getChildAt(1) as Button;
										selectBtn.label = STRINGS.BUTTON_TREEVIEW_SELECT;
									}								
									else if (String(currField.@UIType).toUpperCase() == "LISTCONTROL")
									{
										if (fieldBox.numChildren > 0)
										{
											var fsDG:DataGrid = fieldBox.getChildAt(0) as DataGrid;											
											var dgCols:Array = fsDG.columns;
											var fieldColsList:XMLList = currField.Configuration.DisplayLayout.List.DisplayColumns.TargetObject.Column.(@DisplayState == "YES");
											for (var m:int = 0; m < dgCols.length-1; m++) //Reduce 1 for check box column
											{
												var fieldCol:XML = fieldColsList[m];
												var dgCol:DataGridColumnEx = dgCols[m+1] as DataGridColumnEx;
												
												if (fieldCol.@DisplayTextID != null && fieldCol.@DisplayTextID.toString() != "")
												{											
													dgCol.headerText = Helper.GetLocalizedString(fieldCol.@DisplayTextID);
													if (String(fieldCol.@IsMandatory).toUpperCase() == "TRUE")
														dgCol.headerText += '*';
												}
											}
											
											var actioncontrolList:XMLList = currField.Configuration.ActionControlList.ActionControl.((String(@Visible).toUpperCase() == "TRUE") && (String(@UIType).toUpperCase() != "SEPARATOR"));
											var actionControlArea:HBox = fieldBox.getChildAt(1) as HBox;
											for (var n:int = 0; n < actionControlArea.numChildren; n++)
											{											
												var actioncontrol:XML = actioncontrolList[n];
												if (String(actioncontrol.@UIType).toUpperCase() != "LISTBOX" && (String(actioncontrol.@Name).toUpperCase() != "EDITSERIESRECORD" && String(actioncontrol.@Name).toUpperCase() != "IMPORTSERIESRECORD" && String(actioncontrol.@Name).toUpperCase() != "EXPORTSERIESRECORD"))
												{
													var actionBtn:* = actionControlArea.getChildAt(n);
													if (actionBtn is Button)
													{
														if (actioncontrol.@DisplayTextID != null && actioncontrol.@DisplayTextID.toString() != "")
															actionBtn.label = Helper.GetLocalizedString(actioncontrol.@DisplayTextID);
													}
												}
											}
											fsDG.dataProvider = fsDG.dataProvider;  
										}
									}
									else if (String(currField.@UIType).toUpperCase() == "CHECKBOX")
									{
									}
									else if (String(currField.@UIType).toUpperCase() == "RADIOBUTTON")
									{
									}
								}
							}
						}
					}
				}
			}
		}
		
		
        public function HideFormPopups():void
        {
        	msTree.Hide();
        	facetSeries.HidePopups();
        }
        
        public static function GetInstance():FormRendition
		{
			if(formRendition == null)
			{
				formRendition = new FormRendition();
			}
			return formRendition;
		}
		
		//Meenal: Added for Conditional Display in MOM Desktop
		//***Rule based Display is not currently handlled in MOM Desktop
		private function PouplateSectionInfoClass(formConfigXML:XML, formInputXML:XMLList=null):Boolean
		{
			//Member Variables
			var IsCondDisplayPresent:Boolean = false;
			var str_SectionMode:String = null;
			var Condition_SectionMode:String = null;
			var SectionHiddenDueTo:String = null;
			var  IsConditionSatisfied:Boolean = false;
			var str_SectionOrder:String = null;
			var SectionNode:XMLNode = null;
			var str_FormMode:String = "EDIT"; //In case of MOM Desktop Form Mode will always be EDIT.
			var obj_ConditionalFInfo:Array = null;
			var IsConditionalDisplay:String = null;
			
			//Initialization
			//lst_ConditionalSectionInfo = new Array();			
			
			var SectionList:XMLList = formConfigXML.Section;			
			var array_SectionList:Array	= Helper.sortXMLList(SectionList, "Order");
			for(var secCnt: Number=0; secCnt < array_SectionList.length; secCnt++)
			{
				IsConditionSatisfied = false;				
				var currSection:XML  = XML(array_SectionList[secCnt]);
				//-var currSection:XML = SectionList.(@Order == secCnt.toString())[0];
				str_SectionOrder     = currSection.@Order;
				IsConditionalDisplay = currSection.@IsConditionalDisplay;
				
				if (IsConditionalDisplay.toUpperCase() == "YES" && currSection.CONDITIONALDISPLAY.CONDITION != null)
				{
					IsCondDisplayPresent = true;
					var  outArray: Array = ValidateCondition(str_FormMode, currSection, formInputXML,null);
					if(outArray != null && outArray.length == 2)
					{
						Condition_SectionMode = outArray[0];
						IsConditionSatisfied = Boolean(outArray[1]);
					}
					if (Condition_SectionMode == "HIDDEN")
						SectionHiddenDueTo = "CONDITION";
				}
				else
				{
					IsConditionSatisfied = true;
					Condition_SectionMode = str_FormMode;
				}
				
				if (Condition_SectionMode.toUpperCase() == "HIDDEN")
					str_SectionMode = "HIDDEN";
				else
					if (Condition_SectionMode.toUpperCase() == "READONLY")
						str_SectionMode = "READONLY";
					else
						if (Condition_SectionMode.toUpperCase() == "EDIT")
							str_SectionMode = "EDIT";
						else
							str_SectionMode = str_FormMode;
				
				
				obj_ConditionalFInfo = PopulateFieldInfoClass(currSection, str_SectionMode, formInputXML, IsCondDisplayPresent, secCnt);
				lst_ConditionalSectionInfo[secCnt] = new ConditionalSectionInfo(str_SectionMode, SectionHiddenDueTo, str_SectionOrder, obj_ConditionalFInfo);
			}
			return IsCondDisplayPresent;
		}
				
		public function PopulateFieldInfoClass(currSection:XML, SectionMode:String, InputFieldXML:XMLList, IsCondDisplayPresent:Boolean, SectionOrder:Number):Array
		{
			var lst_ConditionalFInfo: Array = new Array();
			var IsConditionSatisfied:Boolean = false;
			var IsConditionAwareField: Boolean = false;
			var FieldVisible:Boolean = true;
			var HiddenDueTo:String = null;
			var str_FieldValue:String = null;
			var str_FieldName:String = null;
			var Condition_FieldMode: String = null;
			var str_FieldMode:String = null;
			var fieldIndex:Number = 0;
			var fieldUIType:String = null;
			var fieldDataType:String = null;
			var fieldDefaultValue:String = null;
			var ValueList:XMLList = null;
			var ValueNode:XML = null;
			
			var ColumnList:XMLList = currSection.Column;			
			var array_ColumnList:Array  = Helper.sortXMLList(ColumnList, "Order");
			
			for(var ColumnCnt:Number=0; ColumnCnt < array_ColumnList.length; ColumnCnt++)
			{
				var currColumn:XML = XML(array_ColumnList[ColumnCnt]);
				//var currColumn:XML = ColumnList.(@Order == ColumnCnt.toString())[0];
				
				var FieldList:XMLList = currColumn.Field;
				var array_FieldList:Array = Helper.sortXMLList(FieldList, "Order");
				for(var fieldCnt:Number=0; fieldCnt < array_FieldList.length; fieldCnt++)
				{
					IsConditionSatisfied = false;
					IsConditionAwareField = false;
					FieldVisible = true;
					HiddenDueTo = "";
					str_FieldValue = "";
					fieldDefaultValue = "";
					
					var currField: XML = XML(array_FieldList[fieldCnt]);
					//-var currField:XML = FieldList.(@Order == fieldCnt.toString())[0];
					
					str_FieldName = currField.@Name;
					fieldUIType = currField.@UIType;
					fieldDataType = currField.@DataType;
					
					//Set Default value
					switch(fieldUIType.toUpperCase())
					{
						case "DROPDOWNLIST":
							ValueList = currField.Value;
							if(ValueList != null && ValueList.length() > 0)
							{
								ValueNode = ValueList[0];
								fieldDefaultValue = ValueNode.valueOf().toString();
							}
							break;
						case "CHECKBOX":
						case "RADIOBUTTON":
							ValueList = currField.ValueList.Value;
							if(ValueList != null && ValueList.length() > 0)
							{
								for(var i:Number= 0; i < ValueList.length(); i++)
								{
									ValueNode = ValueList[i];
									fieldDefaultValue = fieldDefaultValue + "$AL$" +  ValueNode.valueOf().toString();
								}
							}
							break;
					}
					
					if (currField.@IsConditionalDisplay.toString().toUpperCase() == "YES" && currField.CONDITIONALDISPLAY.CONDITION != null)
					{
						IsCondDisplayPresent = true;
						if (SectionMode == "HIDDEN")
						{
							Condition_FieldMode = SectionMode;
							HiddenDueTo = "PARENT";
						}
						else
						{
							if(lst_ConditionalSectionInfo != null && lst_ConditionalSectionInfo.length > SectionOrder)
								lst_ConditionalFInfo = ConditionalSectionInfo(lst_ConditionalSectionInfo[SectionOrder]).m_ConditionalFieldInfo;
							
							var outArray:Array = ValidateCondition(SectionMode, currField, InputFieldXML, lst_ConditionalFInfo);
							if(outArray != null && outArray.length == 2)
							{
								Condition_FieldMode = outArray[0];
								IsConditionSatisfied = Boolean(outArray[1]);
							}
							
							if (Condition_FieldMode == "HIDDEN")
								HiddenDueTo = "CONDITION";
						}
					}
					else
					{
						IsConditionSatisfied = true;
						Condition_FieldMode = SectionMode;
						if (SectionMode == "HIDDEN")
							HiddenDueTo = "PARENT";
					}
					
					if (Condition_FieldMode == "HIDDEN")
						str_FieldMode = "HIDDEN";
					else
						if (Condition_FieldMode == "READONLY")
							str_FieldMode = "READONLY";
						else
							if (Condition_FieldMode == "EDIT")
								str_FieldMode = "EDIT";
							else
								str_FieldMode = SectionMode;
					
					if (str_FieldMode == "HIDDEN")
					{
						//xpNav_InputField = xpNav_InputFieldList.SelectSingleNode("Field [@Name='" + str_FieldName + "']");
						
						//if (xpNav_InputField == null && ShowConfiguredFields != true)
						//	FieldVisible = false;
						//else
						//	FieldVisible = true;
						
						//if (xpNav_InputField != null)
						//{
						//	if (xpNav_InputField.GetAttribute("FieldVisible", "").ToUpper() != "FALSE")
						//		FieldVisible = true;
						//	else
						//		FieldVisible = false;
						//} 
						FieldVisible = false;
					}
					
					if (!FieldVisible)
					{
						str_FieldMode = "HIDDEN";
						if (HiddenDueTo == null || HiddenDueTo == "")
							HiddenDueTo = "FIELDVISIBLE";
						/*if (xpNav_InputField != null)
						{
							if (xpNav_InputField.SelectSingleNode("Value") != null)
								str_FieldValue = xpNav_InputField.SelectSingleNode("Value").InnerXml;
							else
								if (xpNav_InputField.SelectSingleNode("ValueList") != null)
								{
									xpInputFieldValueIter = xpNav_InputField.SelectSingleNode("ValueList").Select("Value");
									while (xpInputFieldValueIter.MoveNext())
									{
										if (xpInputFieldValueIter.CurrentPosition == 1)
											str_FieldValue = xpInputFieldValueIter.Current.InnerXml;
										else
											str_FieldValue += "$ALSEP$" + xpInputFieldValueIter.Current.InnerXml;
									}
								}
						}*/
					}//if (!FieldVisible)    
					
					if(currField.@IsConditionAwareField != null && currField.@IsConditionAwareField != "") 
					{
						var strConditionAwareField:String = currField.@IsConditionAwareField;
						if(strConditionAwareField.toUpperCase() == "TRUE")
							IsConditionAwareField = true;
					}	 
					
					lst_ConditionalFInfo[fieldIndex] = new ConditionalFieldInfo(str_FieldName,str_FieldMode, str_FieldValue, IsConditionAwareField, HiddenDueTo, currField.@FIELDNAME,fieldDataType,fieldUIType,fieldDefaultValue);
					fieldIndex++;
				}//For each field in Column				
			}//For each column in section			
			return lst_ConditionalFInfo;
		}
				
		public function getConditionalDisplayInformation():Array
		{
			return lst_ConditionalSectionInfo;
		}
		
		public function ValidateCondition_Org(str_ParentMode:String, CurrNode:XML, InputXMLList:XMLList, lst_ConditionalFieldInfo:Array):Array
		{
			var returnArray:Array = new Array(); //This array will contain following out parameters
												 //  1. Condition_SectionMode 2. IsConditionSatisfied
			var IsConditionSatisfied:Boolean = false;
			var str_Mode:String = null;
			var ConditionalFieldName:String = null;
			var DBFieldName:String = null;
			var ConditionalFieldVisible:Boolean = false;
			var BreakFlag:Boolean = false;
			var ValueFound: Boolean = false;
			var InputXML:XML = null;
			var tmp_ConditionalSecInfo: ConditionalSectionInfo = null;
			var inputFieldValue:String = null;
			var ConditionalFieldUIType:String = null;
			str_Mode = str_ParentMode;
			IsConditionSatisfied = false;
			
			if(InputXMLList != null && InputXMLList.length() > 0)
				InputXML = InputXMLList[0];
			
			var CondDisplayNodeList:XMLList = CurrNode.CONDITIONALDISPLAY;
			if(CondDisplayNodeList != null)
			{
				var CondDisplayNode:XML = XML(CondDisplayNodeList[0]);
				str_Mode = CondDisplayNode.@DEFAULTDISPLAYMODE;
				if (str_Mode == null || str_Mode == "")
					str_Mode = str_ParentMode;
				
				var ConditionList:XMLList = CondDisplayNode.CONDITION;
				var arr_ConditionList:Array = Helper.sortXMLList(ConditionList, "ORDER");
				for(var condCnt:Number=0; condCnt < arr_ConditionList.length; condCnt++)
				{
					var currCondition:XML = XML(arr_ConditionList[condCnt]);
					var FieldListItr:XMLList = currCondition.FIELD;
					
					for(var fieldCnt:Number=0; fieldCnt < FieldListItr.length(); fieldCnt++)
					{
						var currField:XML = XML(FieldListItr[fieldCnt]);
						ConditionalFieldName = currField.@FIELDNAME;			
						inputFieldValue = "";
						ConditionalFieldUIType = GetFieldInfo(lst_ConditionalFieldInfo, ConditionalFieldName, "UIType");
						
						if(ConditionalFieldName != null && ConditionalFieldName != "")
						{
							ConditionalFieldVisible = true;
							if(lst_ConditionalSectionInfo != null)
							{
								for (var SectionIndex:Number = 0; SectionIndex < lst_ConditionalSectionInfo.length; SectionIndex++)
								{
									tmp_ConditionalSecInfo = ConditionalSectionInfo(lst_ConditionalSectionInfo[SectionIndex]);
									for (var FieldIndex:Number = 0; FieldIndex < tmp_ConditionalSecInfo.m_ConditionalFieldInfo.length; FieldIndex++)
									{
										if (tmp_ConditionalSecInfo.m_ConditionalFieldInfo[FieldIndex].FieldName == ConditionalFieldName)
										{
											if (tmp_ConditionalSecInfo.m_ConditionalFieldInfo[FieldIndex].FieldMode == "HIDDEN")
												if (tmp_ConditionalSecInfo.m_ConditionalFieldInfo[FieldIndex].HiddenDueTo == "FIELDVISIBLE")
													ConditionalFieldVisible = true;
												else
													ConditionalFieldVisible = false;
											else
												ConditionalFieldVisible = true;
											break;
										}
									}//for all fields							
								}//For all sections
								
								if (ConditionalFieldVisible && lst_ConditionalFieldInfo != null)
								{
									for (var FldIndex:Number = 0; FldIndex < lst_ConditionalFieldInfo.length; FldIndex++)
									{
										if (lst_ConditionalFieldInfo[FldIndex].FieldName == ConditionalFieldName)
										{
											DBFieldName= lst_ConditionalFieldInfo[FldIndex].DBFieldName;
											if (lst_ConditionalFieldInfo[FldIndex].FieldMode == "HIDDEN")
												if (lst_ConditionalFieldInfo[FldIndex].HiddenDueTo == "FIELDVISIBLE")
													ConditionalFieldVisible = true;
												else
													ConditionalFieldVisible = false;
												else
													ConditionalFieldVisible = true;
											break;
										}
									}
								}
	
								if (ConditionalFieldVisible)
								{
									
									if(InputXML == null)
									{
										//Evaulate conditon with Default value
										var result:Array 	 = EvaulateCondition(currField,lst_ConditionalFieldInfo,ConditionalFieldUIType);
										IsConditionSatisfied = Boolean(result["IsConditionSatisfied"]);
										BreakFlag 			 = Boolean(result["BreakFlag"]);
										ValueFound 			 = Boolean(result["ValueFound"]);		
										
										if (!BreakFlag)
											IsConditionSatisfied = false;
										
									}
									else if(InputXML != null)
									{
										// xpNav_InputField = xpNav_InputFieldList.SelectSingleNode("Field [@Name='" + ConditionalFieldName + "']");
										var InputField:XML = InputXML.child(DBFieldName)[0];
										if(InputField != null)
										{
										   //var CondFieldValueList:XMLList = currCondition.FIELD.VALUELIST;
										  var CondFieldValueList:XMLList = currField.VALUELIST;											
										   if (CondFieldValueList != null)
										   {
											   var ValueConjunction:String = CondFieldValueList.@CONJUNCTION;
											   
											   if (ValueConjunction == null || ValueConjunction == "")
												   ValueConjunction = "OR";
											   
											   var CondFieldValueIter:XMLList = CondFieldValueList.VALUE;
											   for(var CondValurCnt:Number=0; CondValurCnt < CondFieldValueIter.length(); CondValurCnt++)
											   {
												   var currConditionValue:XML = XML(CondFieldValueIter[CondValurCnt]);
												   if (ValueConjunction == "OR")
												   {
													   BreakFlag = false;
													   var xpNav_Value:XML = InputField;
													   if (xpNav_Value != null)
													   {
														   inputFieldValue = xpNav_Value[0].valueOf().toString();
														   if (ConditionalFieldUIType == "DROPDOWNLIST")
														   {   
															   if (currConditionValue[0].valueOf().toString() == inputFieldValue)
															   {
																   IsConditionSatisfied = true;
																   BreakFlag = true;
																   break;
															   }   
														   }
														   else if (ConditionalFieldUIType == "RADIOBUTTON" || ConditionalFieldUIType == "CHECKBOX")
														   {
															   var inpValueList: Array = inputFieldValue.split("$AL$");
															   for(var cnt:Number = 0; cnt< inpValueList.length; cnt++)
															   {
																   if (currConditionValue[0].valueOf().toString() == inpValueList[cnt])
																   {
																	   IsConditionSatisfied = true;
																	   BreakFlag = true;
																	   break;
																   }
															   }
															   
															   if( BreakFlag == true)
																   break;
														   }														 
														   
													   }//if (xpNav_Value != null)
													   else
													   {
														   //TO DO: If value not found in Input Xml then search for Value in Default values selected in Formconfiguration XML
														   
													   }//if (xpNav_Value == null)														   
												   }// if (ValueConjunction == "OR")
												   else
												   {
													   BreakFlag = true;
													   ValueFound = false;
													   var xpValueIter:XMLList = InputField.ValueList.Value;
													   //for(var InpValuCnt:Number=0; InpValuCnt < xpValueIter.length(); InpValuCnt++)
													   //{
														   //var InputValue:XML = XML(xpValueIter[InpValuCnt]);													   	 
													   	   inputFieldValue = InputField.valueOf().toString();
														   if (ConditionalFieldUIType == "DROPDOWNLIST")
														   {
															   if (currConditionValue[0].valueOf().toString() == inputFieldValue)
															   {
																   ValueFound = true;
																   //break;
															   }
														   }
														   else if (ConditionalFieldUIType == "RADIOBUTTON" || ConditionalFieldUIType == "CHECKBOX")
														   {
															   var inpValList: Array = inputFieldValue.split("$AL$");
															   for(var valcnt:Number = 0; valcnt< inpValList.length; valcnt++)
															   {
																   if (currConditionValue[0].valueOf().toString() == inpValList[valcnt])
																   {
																	   ValueFound = true;
																	   IsConditionSatisfied = true;
																	   BreakFlag = true;
																	   break;
																   }
															   }
														   }	
													   //}
													   if (!ValueFound)
													   {
														   IsConditionSatisfied = false;
														   BreakFlag = false;
														   break;
													   }
													   else
														   IsConditionSatisfied = true;
														   
												   }// else if (ValueConjunction == "AND")
											   }//For each Value					   
											   
											   if (!BreakFlag)
												   IsConditionSatisfied = false;
											   
										   }//if (CondFieldValueList != null)
										   else
											   IsConditionSatisfied = false;
										}//if(InputField != null)
										else
											IsConditionSatisfied = false;
									}//if(InputXML != null)
									else
										IsConditionSatisfied = false;
									
								}// if (ConditionalFieldVisible)
								else
									IsConditionSatisfied = false;										
							}
						}//if ConditionalFieldName != null
						else						
							IsConditionSatisfied = false;
						
						if (IsConditionSatisfied == false)
							break;
					}//For each condition field
					
					if (IsConditionSatisfied)
					{
						str_Mode = currCondition.@DISPLAYMODE;
						break;
					}
				}//for all conditions
				
			}//if(CondDisplayNode != null)
			returnArray[0] = str_Mode;
			returnArray[1] = IsConditionSatisfied;
			return returnArray;
		}
		
		public function ValidateCondition(str_ParentMode:String, CurrNode:XML, InputXMLList:XMLList, lst_ConditionalFieldInfo:Array):Array
		{
			var returnArray:Array = new Array(); //This array will contain following out parameters
			//  1. Condition_SectionMode 2. IsConditionSatisfied
			var IsConditionSatisfied:Boolean = false;
			var str_Mode:String = null;
			var ConditionalFieldName:String = null;
			var DBFieldName:String = null;
			var ConditionalFieldVisible:Boolean = false;
			var BreakFlag:Boolean = false;
			var ValueFound: Boolean = false;
			var InputXML:XML = null;
			var tmp_ConditionalSecInfo: ConditionalSectionInfo = null;
			var inputFieldValue:String = null;
			var ConditionalFieldUIType:String = null;
			var InputField:XML = null;
			
			str_Mode = str_ParentMode;
			IsConditionSatisfied = false;
			
			if(InputXMLList != null && InputXMLList.length() > 0)
				InputXML = InputXMLList[0];
			
			var CondDisplayNodeList:XMLList = CurrNode.CONDITIONALDISPLAY;
			if(CondDisplayNodeList != null)
			{
				var CondDisplayNode:XML = XML(CondDisplayNodeList[0]);
				str_Mode = CondDisplayNode.@DEFAULTDISPLAYMODE;
				if (str_Mode == null || str_Mode == "")
					str_Mode = str_ParentMode;
				
				var ConditionList:XMLList = CondDisplayNode.CONDITION;
				var arr_ConditionList:Array = Helper.sortXMLList(ConditionList, "ORDER");
				for(var condCnt:Number=0; condCnt < arr_ConditionList.length; condCnt++)
				{
					var currCondition:XML = XML(arr_ConditionList[condCnt]);
					var FieldListItr:XMLList = currCondition.FIELD;
					
					for(var fieldCnt:Number=0; fieldCnt < FieldListItr.length(); fieldCnt++)
					{
						var currField:XML = XML(FieldListItr[fieldCnt]);
						ConditionalFieldName = currField.@FIELDNAME;			
						inputFieldValue = "";
						ConditionalFieldUIType = GetFieldInfo(lst_ConditionalFieldInfo, ConditionalFieldName, "UIType");
						
						if(ConditionalFieldName != null && ConditionalFieldName != "")
						{
							ConditionalFieldVisible = true;
							if(lst_ConditionalSectionInfo != null)
							{
								for (var SectionIndex:Number = 0; SectionIndex < lst_ConditionalSectionInfo.length; SectionIndex++)
								{
									tmp_ConditionalSecInfo = ConditionalSectionInfo(lst_ConditionalSectionInfo[SectionIndex]);
									for (var FieldIndex:Number = 0; FieldIndex < tmp_ConditionalSecInfo.m_ConditionalFieldInfo.length; FieldIndex++)
									{
										if (tmp_ConditionalSecInfo.m_ConditionalFieldInfo[FieldIndex].FieldName == ConditionalFieldName)
										{
											if (tmp_ConditionalSecInfo.m_ConditionalFieldInfo[FieldIndex].FieldMode == "HIDDEN")
												if (tmp_ConditionalSecInfo.m_ConditionalFieldInfo[FieldIndex].HiddenDueTo == "FIELDVISIBLE")
													ConditionalFieldVisible = true;
												else
													ConditionalFieldVisible = false;
												else
													ConditionalFieldVisible = true;
											
											//if(lst_ConditionalFieldInfo == null)
											{
												lst_ConditionalFieldInfo = tmp_ConditionalSecInfo.m_ConditionalFieldInfo;
												ConditionalFieldUIType = GetFieldInfo(lst_ConditionalFieldInfo, ConditionalFieldName, "UIType");												
											}	
											break;
										}
									}//for all fields							
								}//For all sections
								
								if (ConditionalFieldVisible && lst_ConditionalFieldInfo != null)
								{
									for (var FldIndex:Number = 0; FldIndex < lst_ConditionalFieldInfo.length; FldIndex++)
									{
										if (lst_ConditionalFieldInfo[FldIndex].FieldName == ConditionalFieldName)
										{
											DBFieldName= lst_ConditionalFieldInfo[FldIndex].DBFieldName;
											if (lst_ConditionalFieldInfo[FldIndex].FieldMode == "HIDDEN")
												if (lst_ConditionalFieldInfo[FldIndex].HiddenDueTo == "FIELDVISIBLE")
													ConditionalFieldVisible = true;
												else
													ConditionalFieldVisible = false;
												else
													ConditionalFieldVisible = true;
											break;
										}
									}
								}
								
								if (ConditionalFieldVisible)
								{	
									//if(InputXML != null)
									//{
										// xpNav_InputField = xpNav_InputFieldList.SelectSingleNode("Field [@Name='" + ConditionalFieldName + "']");
										if(InputXML != null)
											InputField= InputXML.child(DBFieldName)[0];
										
										//if(InputField != null)
										//{											
											var CondFieldValueList:XMLList = currField.VALUELIST;											
											if (CondFieldValueList != null)
											{
												var ValueConjunction:String = CondFieldValueList.@CONJUNCTION;
												
												if (ValueConjunction == null || ValueConjunction == "")
													ValueConjunction = "OR";
												
												var CondFieldValueIter:XMLList = CondFieldValueList.VALUE;
												for(var CondValurCnt:Number=0; CondValurCnt < CondFieldValueIter.length(); CondValurCnt++)
												{
													var currConditionValue:XML = XML(CondFieldValueIter[CondValurCnt]);
													if (ValueConjunction == "OR")
													{
														BreakFlag = false;
														var xpNav_Value:XML = InputField;
														if (xpNav_Value != null)
														{
															inputFieldValue = xpNav_Value[0].valueOf().toString();
														}//if (xpNav_Value != null)
														else
														{
															//TO DO: If value not found in Input Xml then search for Value in Default values selected in Formconfiguration XML
															var fieldDefaultValue:String = null;
															for(var fCnt:Number=0; fCnt < lst_ConditionalFieldInfo.length; fCnt++)
															{
																if(ConditionalFieldInfo(lst_ConditionalFieldInfo[fCnt]).FieldName == ConditionalFieldName)
																{
																	fieldDefaultValue = ConditionalFieldInfo(lst_ConditionalFieldInfo[fCnt]).FieldDefaultValue;
																	break;
																}
															}
															inputFieldValue = fieldDefaultValue;															
														}//if (xpNav_Value == null)														
															
														if (ConditionalFieldUIType == "DROPDOWNLIST")
														{   
															if (currConditionValue[0].valueOf().toString() == inputFieldValue)
															{
																IsConditionSatisfied = true;
																BreakFlag = true;
																break;
															}   
														}
														else if (ConditionalFieldUIType == "RADIOBUTTON" || ConditionalFieldUIType == "CHECKBOX")
														{
															var inpValueList: Array = inputFieldValue.split("$AL$");
															for(var cnt:Number = 0; cnt< inpValueList.length; cnt++)
															{
																if (currConditionValue[0].valueOf().toString() == inpValueList[cnt])
																{
																	IsConditionSatisfied = true;
																	BreakFlag = true;
																	break;
																}
															}
															
															if( BreakFlag == true)
																break;
														}													 
															
																												   
													}// if (ValueConjunction == "OR")
													else
													{
														BreakFlag = true;
														ValueFound = false;
														
														var xpValueIter:XMLList = null;
														
														if(InputField != null)
															xpValueIter = InputField.ValueList.Value;
														//for(var InpValuCnt:Number=0; InpValuCnt < xpValueIter.length(); InpValuCnt++)
														//{
														//var InputValue:XML = XML(xpValueIter[InpValuCnt]);
														if(InputField != null)
															inputFieldValue = InputField.valueOf().toString();
														
														if (ConditionalFieldUIType == "DROPDOWNLIST")
														{
															if (currConditionValue[0].valueOf().toString() == inputFieldValue)
															{
																ValueFound = true;
																//break;
															}
														}
														else if (ConditionalFieldUIType == "RADIOBUTTON" || ConditionalFieldUIType == "CHECKBOX")
														{
															var inpValList: Array = inputFieldValue.split("$AL$");
															for(var valcnt:Number = 0; valcnt< inpValList.length; valcnt++)
															{
																if (currConditionValue[0].valueOf().toString() == inpValList[valcnt])
																{
																	ValueFound = true;
																	IsConditionSatisfied = true;
																	BreakFlag = true;
																	break;
																}
															}
														}	
														//}
														if (!ValueFound)
														{
															IsConditionSatisfied = false;
															BreakFlag = false;
															break;
														}
														else
															IsConditionSatisfied = true;
														
													}// else if (ValueConjunction == "AND")
												}//For each Value					   
												
												if (!BreakFlag)
													IsConditionSatisfied = false;
												
											}//if (CondFieldValueList != null)
											else
												IsConditionSatisfied = false;
										//}//if(InputField != null)
										//else
										//	IsConditionSatisfied = false;
									//}//if(InputXML != null)
									//else
									//	IsConditionSatisfied = false;
									
								}// if (ConditionalFieldVisible)
								else
									IsConditionSatisfied = false;										
							}
						}//if ConditionalFieldName != null
						else						
							IsConditionSatisfied = false;
						
						if (IsConditionSatisfied == false)
							break;
					}//For each condition field
					
					if (IsConditionSatisfied)
					{
						str_Mode = currCondition.@DISPLAYMODE;
						break;
					}
				}//for all conditions
				
			}//if(CondDisplayNode != null)
			returnArray[0] = str_Mode;
			returnArray[1] = IsConditionSatisfied;
			return returnArray;
		}
		
		private function EvaulateCondition(currField:XML, lst_ConditionalFieldInfo:Array, ConditionalFieldUIType:String):Array
		{
			var outputArray:Array = new Array();
			var IsConditionSatisfied:Boolean = false;
			var BreakFlag:Boolean = false;
			var inputFieldValue:String = null;
			var ValueFound:Boolean=false;				
			var xpNav_Value:XML = null;
			var xpNav_ValueLst:XMLList = null;
			var FieldName:String = null;
			var fieldDefaultValue:String = null;
			
			FieldName = currField.@FIELDNAME;
			for(var fCnt:Number=0; fCnt < lst_ConditionalFieldInfo.length; fCnt++)
			{
				if(ConditionalFieldInfo(lst_ConditionalFieldInfo[fCnt]).FieldName == FieldName)
				{
					fieldDefaultValue = ConditionalFieldInfo(lst_ConditionalFieldInfo[fCnt]).FieldDefaultValue;
					break;
				}
			}
			//var CondFieldValueList:XMLList = currCondition.FIELD.VALUELIST;
			var CondFieldValueList:XMLList = currField.VALUELIST;											
			if (CondFieldValueList != null)
			{
				var ValueConjunction:String = CondFieldValueList.@CONJUNCTION;
				
				if (ValueConjunction == null || ValueConjunction == "")
					ValueConjunction = "OR";
				
				var CondFieldValueIter:XMLList = CondFieldValueList.VALUE;
				for(var CondValurCnt:Number=0; CondValurCnt < CondFieldValueIter.length(); CondValurCnt++)
				{
					var currConditionValue:XML = XML(CondFieldValueIter[CondValurCnt]);
					if (ValueConjunction == "OR")
					{
						BreakFlag = false;
						
						if (currField != null)
						{
							inputFieldValue = null;
							if (ConditionalFieldUIType == "DROPDOWNLIST")
							{								   
								if (currConditionValue[0].valueOf().toString() == fieldDefaultValue)
								{
									IsConditionSatisfied = true;
									BreakFlag = true;
									break;
								}   
							}
							else if (ConditionalFieldUIType == "RADIOBUTTON" || ConditionalFieldUIType == "CHECKBOX")
							{
								var inpValList: Array = fieldDefaultValue.split("$AL$");								
								for(var cnt:Number = 0; cnt< inpValList.length; cnt++)
								{	
									if (currConditionValue[0].valueOf().toString() ==  inpValList[cnt])
									{
										IsConditionSatisfied = true;
										BreakFlag = true;
										break;
									}
								}
								
								if( BreakFlag == true)
									break;
							}
						}//if (xpNav_Value != null)																	   
					}// if (ValueConjunction == "OR")
					else
					{
						BreakFlag = true;
						ValueFound = false;						
						
						if (ConditionalFieldUIType == "DROPDOWNLIST")
						{	
							if (currConditionValue[0].valueOf().toString() == fieldDefaultValue)
							{
								ValueFound = true;
								//break;
							}
						}
						else if (ConditionalFieldUIType == "RADIOBUTTON" || ConditionalFieldUIType == "CHECKBOX")
						{							
							var inpValList1: Array = fieldDefaultValue.split("$AL$");								
							for(var cnt1:Number = 0; cnt1< inpValList1.length; cnt1++)
							{	
								if (currConditionValue[0].valueOf().toString() ==  inpValList1[cnt1])
								{
									IsConditionSatisfied = true;
									BreakFlag = true;
									break;
								}
							}
						}	
						//}
						if (!ValueFound)
						{
							IsConditionSatisfied = false;
							BreakFlag = false;
							break;
						}
						else
							IsConditionSatisfied = true;
						
					}// else if (ValueConjunction == "AND")
				}//For each Value					   
				
				if (!BreakFlag)
					IsConditionSatisfied = false;
				
			}//if (CondFieldValueList != null)
			else
				IsConditionSatisfied = false;
			
			outputArray["IsConditionSatisfied"] = IsConditionSatisfied;
			outputArray["BreakFlag"] = BreakFlag;
			outputArray["ValueFound"] = ValueFound;
			return outputArray; 
		}
				
		private function GetFieldInfo(lst_ConditionalFieldInfo:Array, FieldName: String, AttributeName:String):String
		{
			var returnValue: String = null;
			var ObjCfInfo:ConditionalFieldInfo = null;
			
			if(lst_ConditionalFieldInfo == null)
				return "";
			
			for(var FCnt:Number=0; FCnt < lst_ConditionalFieldInfo.length; FCnt++)
			{
				ObjCfInfo = ConditionalFieldInfo(lst_ConditionalFieldInfo[FCnt]);
				if(ObjCfInfo.FieldName == FieldName)
				{
					switch(AttributeName.toUpperCase())
					{
						case "UITYPE":
									   returnValue = ObjCfInfo.FieldUIType;
									   break;
						case "DATABASEFILEDNAME": 
							           returnValue = ObjCfInfo.DBFieldName;
									   break;
						case "DATATYPE":
									   returnValue = ObjCfInfo.FieldDataType;
									   break;
					}
					break;
				}
			}
			
			return returnValue;
		}
		
		private function IsConditionAwareField(FieldName:String, CurrentFacet:String):Boolean
		{
			var isConditionAwareField:Boolean = false;
			var IsFieldFound:Boolean = false;
			var ObjCondFieldInfo:ConditionalFieldInfo = null;			
			
			if(lst_ConditionalSectionInfo != null)
			{
				for(var CSCnt:Number=0; CSCnt < lst_ConditionalSectionInfo.length; CSCnt++)
				{
					var arrCondFields:Array = ConditionalSectionInfo(lst_ConditionalSectionInfo[CSCnt]).m_ConditionalFieldInfo;
					for(var CFCnt:Number=0; CFCnt < arrCondFields.length; CFCnt++)
					{
						ObjCondFieldInfo = arrCondFields[CFCnt];
						if(ObjCondFieldInfo.DBFieldName == FieldName)
						{
							IsFieldFound = true;
							if(ObjCondFieldInfo.IsConditionAwareField)
								isConditionAwareField = true;
							else	
								isConditionAwareField = false;
							break;
						}
					}					 
				}
			}
			
			if(!IsFieldFound)
			{
				lst_ConditionalSectionInfo = GetConditionalInfoFromCache(CurrentFacet);
				if(lst_ConditionalSectionInfo != null)
					return IsConditionAwareField(FieldName, CurrentFacet);
			}
			return isConditionAwareField;
		}
		
		private function GetConditionalInfoFromCache(CurrentFacet:String):Array 
		{
			var record:Object = null;
			for(var i:Number=0; i < globalConditionalInfo.length; i++)
			{
				record = globalConditionalInfo[i];
				if(record.facetName == CurrentFacet)
					return record.conditionalInfo;
			}
			return null;			
		}
		
		private function RenderROField(FieldBox:FormItem, currField:XML, txtOld:XML, isDataCommon:Boolean,facetFormConfig:XML, isPopup:Boolean=false):void
		{
			var nhObj:Object = Helper.GetNHDetails(currField, nhCollection);
			var nhTreeNode:XML = XML(nhObj.nhTreeNode);
			var customTreeNodes:Boolean = Boolean(nhObj.customTreeNodes);
			var currDate:Date;
			var tempValue:String = null;
			
			var FieldValue:Label = new Label();
			FieldValue.id = currField.@OBJECTTYPENAME + "$ALSEP$" + currField.@FIELDNAME;
			FieldValue.addEventListener(FocusEvent.FOCUS_OUT, ControlFocusOutHandler);						
			FieldValue.name = currField.toXMLString();
			
			
			if (String(currField.@UIType).toUpperCase() == "EDITBOX" || String(currField.@UIType).toUpperCase() == "TEXTAREA" 
				|| String(currField.@UIType).toUpperCase() == "DROPDOWNLIST")
			{
				if (txtOld == null)
					FieldValue.text = currField.@DefaultValue;
				
				if (txtOld != null && isDataCommon)
					FieldValue.text = txtOld;
				
				if (currField.@DataType == "INTEGER" || currField.@DataType == "FLOAT")
					FieldValue.text = Helper.convertStdValuetoDisplayFormat(FieldValue.text, currField.@DataType);
				
			}			
			else if (String(currField.@UIType).toUpperCase() == "MULTISELECT")
			{
				if(txtOld != null && txtOld != "")
				{
					var treeSelData:String = txtOld;
					fieldDataList[currField.@OBJECTTYPENAME + "$ALSEP$" + currField.@FIELDNAME] = treeSelData;
					var treeDisplayVal:String = treeSelData.substr(mulSelSep.length, treeSelData.length - (2*mulSelSep.length));
					while (treeDisplayVal.indexOf(mulSelSep) >= 0)
						treeDisplayVal = treeDisplayVal.replace(mulSelSep,',');
					FieldValue.text = treeDisplayVal;
				}
			}
			else if (String(currField.@UIType).toUpperCase() == "RADIOBUTTON")
			{	
				if (txtOld != null && isDataCommon)
				{
					var rbdata:String = txtOld.text();
					if (rbdata!=null)
					{				
						FieldValue.text = rbdata.replace(mulSelSep, " , ");
						fieldDataList[currField.@OBJECTTYPENAME + "$ALSEP$" + currField.@FIELDNAME] = rbdata + mulSelSep;
					}
				}
			}
			else if (String(currField.@UIType).toUpperCase() == "CHECKBOX")
			{					
				if (txtOld != null && isDataCommon)
				{					
					var cbdata:String = txtOld.text();
					if (cbdata!=null)
					{							
						FieldValue.text = cbdata.replace(mulSelSep, " , ");
						fieldDataList[currField.@OBJECTTYPENAME + "$ALSEP$" + currField.@FIELDNAME] = cbdata + mulSelSep;	
					}
				}
			}
			else if (String(currField.@UIType).toUpperCase() == "LISTCONTROL")
			{	
				facetSeries.ShowFacetSeries(FieldBox, currField, txtOld, isDataCommon, facetFormConfig, true);
			}
			else if (currField.@DataType == "CURRENCY")
			{		
				if (txtOld != null && txtOld.CURRENCY != null)
				{
					tempValue = txtOld.CURRENCY[0].valueOf().toString();					
					if(txtOld.AMOUNT != null)
						tempValue = tempValue + " " + Helper.convertStdValuetoDisplayFormat(txtOld.AMOUNT[0].valueOf().toString(),currField.@DataType);
					
					FieldValue.text = tempValue;
				}
			}
			else if (currField.@DataType == "DATETIME")
			{
				currDate = null;
				if (txtOld != null && String(txtOld.YEAR).length > 0 && isDataCommon)
					currDate = new Date(txtOld.YEAR, Number(txtOld.MONTH)-1, Number(txtOld.DAY));
				
				if(currDate != null)
					FieldValue.text = Helper.dateLabelFunction(currDate);
			}
			FieldBox.addChild(FieldValue);
		}
		
		private function UpdateFieldDataViewState(currField:XML,PreviousValue:String):void
		{			
			var isVSPopulated:Boolean = false;
			var fieldDataArray:Array = new Array();
			var fieldName:String= null;			
			var FieldValueObj:Object = new Object();
			var found:Boolean = false;
			var dataIndex:Number =0 ;
			var tempObj:Object = new Object();
			if(PreviousValue == null || PreviousValue == "")
				return;
			
			fieldName = currField.@FIELDNAME;
			FieldValueObj.FieldName = fieldName;
			FieldValueObj.PreviousValue = PreviousValue;			
			
			for(var index:Number=0; index < FieldDataViewStateDetails.length; index++)
			{
				tempObj = FieldDataViewStateDetails[index];
				if(tempObj.currSelectedFacet == currSelectedFacet)
				{
					isVSPopulated = true;					
					fieldDataArray = tempObj.fieldDataArray;
					dataIndex = index;
					break;
				}
			}
			
			tempObj = new Object();
			//If ViewState is not created then create the fieldDataArray for current field
			if(!isVSPopulated)	
				fieldDataArray.push(FieldValueObj);
			else
			{
				//If ViewState is created then check if current field exists or not in the fieldDataArray. If not add the data for
				//current field
				if(fieldDataArray.length > 0)
				{
					for(var cnt:Number = 0; cnt < fieldDataArray.length; cnt++)
					{
						tempObj = fieldDataArray[cnt];
						if(tempObj.FieldName == fieldName)
						{
							fieldDataArray[cnt] = FieldValueObj;
							found = true;
							break;
						}
					}
					
					if(!found)
						fieldDataArray.push(FieldValueObj);
				}
				else
					fieldDataArray.push(FieldValueObj);
				
			}
			var resultObj:Object = new Object();
			resultObj.currSelectedFacet = currSelectedFacet;
			resultObj.fieldDataArray = fieldDataArray;			
			
			if(!isVSPopulated)
				FieldDataViewStateDetails.addItem(resultObj);
			else
				FieldDataViewStateDetails.addItemAt(resultObj,dataIndex);		
			
		}
		
		private function getFieldDataFromViewState(currTypeName:String, currField:XML):String
		{
			var viewstateObj:Object = null;
			var FacetFound:Boolean  = false;
			var data:String 		= null;
			var fieldDataArray:Array = new Array;
			
			data = "";
			if(FieldDataViewStateDetails.length > 0)
			{
				for(var index:Number=0; index < FieldDataViewStateDetails.length; index++)
				{
					viewstateObj = FieldDataViewStateDetails[index];
					if(viewstateObj.currSelectedFacet == currTypeName)
					{
						FacetFound = true;
						fieldDataArray = viewstateObj.fieldDataArray;
						break;
					}
				}//For all Facets in Viewstate
				
				if(FacetFound)
				{
					var fieldName:String = currField.@FIELDNAME;
					for(var fIndex:Number=0; fIndex < fieldDataArray.length; fIndex++)
					{
						var FieldValueObj:Object = fieldDataArray[fIndex];
						if(FieldValueObj.FieldName == fieldName)
						{
							data = FieldValueObj.PreviousValue;
							break;
						}
					}
				}
			}
			return data;
		}
		
		public function ClearFieldDataViewState():void
		{
			if(FieldDataViewStateDetails != null && FieldDataViewStateDetails.length > 0)
			{
				FieldDataViewStateDetails.removeAll();	
			}
		}
		
		public function GetFieldValue(currFacetBox:VBox, facetFormConfig:XML):Object
		{	
			isDataValid = true;
			facetSeries.isDataValid = true;

			var businessInfoStr:String = "";
			var relatedFacet:XML = facetFormConfig.RELATEDFACETS.FACET[0];
			var currTypeName:String = relatedFacet.@TYPENAME;
			var currRelationshipName:String = relatedFacet.@RELATIONSHIPNAME;
			var isFirstLevelSeries:Boolean = false;
			
						
			//businessInfoStr += '<' + currRelationshipName + ' TYPE="RELATION">';
			//businessInfoStr += '<' + currTypeName + '>';    
			
			var sections:XMLList = facetFormConfig.Section;
			var FacetDataBox:VBox = currFacetBox.getChildAt(1) as VBox;
			var currSection:XML;
			
			for (var i:int = 0; i < sections.length(); i++)
			{
				currSection = sections.(@Order == (i+1).toString())[0];
				var SectionBox:VBox = FacetDataBox.getChildAt(i) as VBox;
				var SectionDataBox:HBox = SectionBox.getChildAt(1) as HBox;
				var columns:XMLList = currSection.Column; 
				var currColumn:XML;
				for (var j:int = 0; j < columns.length(); j++)
				{							
					currColumn = columns.(@Order == (j+1).toString())[0];
					var FacetColumnBox:Form = SectionDataBox.getChildAt(j) as Form;
					var fields:XMLList = currColumn.Field;
					var currField:XML;	  				
					for (var k:int = 0; k < fields.length(); k++)
					{    	  					
						currField = fields.(@Order == (k+1).toString())[0];
						if (currField.@RELATIONSHIPTYPE != null && String(currField.@RELATIONSHIPTYPE).length > 0)
						{	
							var FacetFieldBox:FormItem = FacetColumnBox.getChildAt(k) as FormItem;
							var FacetFieldTextInput:TextInput = null;
							var strValidator:StringValidator;
							var resultEvent:ValidationResultEvent;
							var tempStr:String = "";
							
							if (currField.@DataType == "INTEGER" || currField.@DataType == "FLOAT" || currField.@DataType == "STRING" || currField.@DataType == "TEXT" || currField.@DataType == "BOOLEAN")
							{
								if (String(currField.@UIType).toUpperCase() == "EDITBOX")
								{
									FacetFieldTextInput = FacetFieldBox.getChildAt(0) as TextInput;
									businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(FacetFieldTextInput.text));									  	  						
								}
								else if (String(currField.@UIType).toUpperCase() == "TEXTAREA")
								{
									var FacetFieldTxtArea:TextArea = FacetFieldBox.getChildAt(0) as TextArea;
									businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(FacetFieldTxtArea.text));								
								}
								else if (String(currField.@UIType).toUpperCase() == "DROPDOWNLIST")
								{
									var FacetFieldComboBox:ComboBox = FacetFieldBox.getChildAt(0) as ComboBox;
									businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(FacetFieldComboBox.selectedLabel));									
								}
								else if (String(currField.@UIType).toUpperCase() == "MULTISELECT")
								{
									if ((fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME] != null) && (fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME] != "$AL$"))
										tempStr = fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME];
									businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(tempStr));
									
								}
								else if (String(currField.@UIType).toUpperCase() == "RADIOBUTTON")
								{
									if (String(currField.@DataType).toUpperCase() == "BOOLEAN")
									{
										var FacetFieldRBGrp:HBox = FacetFieldBox.getChildAt(0) as HBox;
										var FacetFieldRBGrpChilds:Array = FacetFieldRBGrp.getChildren();
										if (FacetFieldRBGrpChilds != null && FacetFieldRBGrpChilds.length > 0)
										{
											var FacetFieldRB1:RadioButton = FacetFieldRBGrp.getChildAt(0) as RadioButton;
											var FacetFieldRB2:RadioButton = FacetFieldRBGrp.getChildAt(1) as RadioButton;
											if (FacetFieldRB1.selected)
												businessInfoStr += StringUtil.trim(FacetFieldRB1.value.toString());
											else
												businessInfoStr += StringUtil.trim(FacetFieldRB2.value.toString());	
										}										
									}
									else if (String(currField.@DataType).toUpperCase() == "STRING")
									{
										if (fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME] != null)
											tempStr = fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME];
										if (tempStr.length > 0)
											tempStr = tempStr.substr(0,tempStr.length - mulSelSep.length);		
										businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(tempStr));									
										
										tempStr = "";
									}
								}
								else if (String(currField.@UIType).toUpperCase() == "CHECKBOX")
								{	
									if (String(currField.@DataType).toUpperCase() == "BOOLEAN")
									{
										var FacetFieldCBGrp:HBox = FacetFieldBox.getChildAt(0) as HBox;
										var FacetFieldCB:CheckBox = FacetFieldCBGrp.getChildAt(0) as CheckBox;
										if (FacetFieldCB.selected)
											businessInfoStr += StringUtil.trim(FacetFieldCB.data.toString());
										else
											businessInfoStr += "0";								
									}
									else if (String(currField.@DataType).toUpperCase() == "STRING")
									{
										if (fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME] != null)
											tempStr = fieldDataList[currTypeName + "$ALSEP$" + currField.@FIELDNAME];
										
											
										businessInfoStr += Helper.EncodeSpecialChars(StringUtil.trim(tempStr));
										
										/*if (String(currField.@IsMandatory).toUpperCase() == "YES")
										{
											var cbGrp:HBox = FacetFieldBox.getChildAt(0) as HBox;
											isDataValid = validators.ValidateHBox(cbGrp, tempStr);
											if (isDataValidtemp == false)
												isDataValid = isDataValidtemp;			  									
										}*/
										tempStr = "";
									}
								}
								else if (String(currField.@UIType).toUpperCase() == "LISTCONTROL")
								{	
									var childfacetseriesList:XMLList = facetFormConfig.RELATEDFACETS.FACET.RELATEDFACETS.FACET.((@RELATIONSHIPNAME == currField.@RELATIONSHIPNAME) && (@IsSeries == "YES"));
									var innerfacetseriesList:XMLList = facetFormConfig.RELATEDFACETS.FACET.((@RELATIONSHIPNAME == currField.@RELATIONSHIPNAME));
									var seriesRelatedFacet:XML = null;
									if (childfacetseriesList != null && childfacetseriesList.length() > 0)
										seriesRelatedFacet = childfacetseriesList[0];
									else if (innerfacetseriesList != null && innerfacetseriesList.length() > 0)
									{
										innerfacetseriesList = innerfacetseriesList.(@IsSeries == "YES")
										if (innerfacetseriesList != null && innerfacetseriesList.length() > 0)
											seriesRelatedFacet = innerfacetseriesList[0];
										isFirstLevelSeries = true;	
									}
									
									var seriesDataXML:XML = XML(facetSeries.facetSeriesData[currTypeName + "$ALSEP$" + seriesRelatedFacet.@TYPENAME]);
									//The following is done as when there is no data in facet series, sending empty relationship node is not allowed
									// so when there is no data no node should be made. 
									if (seriesDataXML.children().length() > 0)
										businessInfoStr += facetSeries.facetSeriesData[currTypeName + "$ALSEP$" + seriesRelatedFacet.@TYPENAME];
									var FacetFieldDG:DataGrid = FacetFieldBox.getChildAt(0) as DataGrid;
									FacetFieldDG.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.ITEM_VALIDATE));
									if (String(currField.@IsMandatory).toUpperCase() == "YES")
									{
										if (FacetFieldDG.dataProvider == null || FacetFieldDG.dataProvider == "")
										{	
											FacetFieldDG.errorString = STRINGS.FACETSERIES_DATA_MANDATORY;
											isDataValid = false;
										}
										else
											FacetFieldDG.errorString = null;
									}
								}
							}
							else if (String(currField.@DataType).toUpperCase() == "CURRENCY")    	  					
							{
								var currecyBox:HBox = FacetFieldBox.getChildAt(0) as HBox;
								var currencyDD:ComboBox = currecyBox.getChildAt(0) as ComboBox;
								businessInfoStr += '<CURRENCY>'+ StringUtil.trim(currencyDD.selectedLabel) +'</CURRENCY>';
								FacetFieldTextInput = currecyBox.getChildAt(1) as TextInput;
								businessInfoStr += '<AMOUNT>' + StringUtil.trim(FacetFieldTextInput.text) +'</AMOUNT>';
								FacetFieldTextInput.dispatchEvent(new FocusEvent(FocusEvent.FOCUS_OUT));
							}
							else if (String(currField.@DataType).toUpperCase() == "DATETIME")
							{
								var calendarField:DateField = FacetFieldBox.getChildAt(0) as DateField;
								calendarField.dispatchEvent(new FocusEvent(FocusEvent.FOCUS_OUT));
								if (calendarField.selectedDate != null)
								{	
									businessInfoStr += '<DAY>' + calendarField.selectedDate.getDate().toString() + '</DAY>';
									businessInfoStr += '<MONTH>' + (calendarField.selectedDate.getMonth()+1).toString() + '</MONTH>';
									businessInfoStr += '<YEAR>' + calendarField.selectedDate.getFullYear().toString() + '</YEAR>';
									businessInfoStr += '<HOUR>0</HOUR>';
									businessInfoStr += '<MINUTE>0</MINUTE>';
									businessInfoStr += '<SECOND>0</SECOND>';
								}
							}
						}
					}  	  				    	  				
				} 
			}     			
			
			
			var result:Object = new Object();
			//Alert.show("end:::"+facetSeries.isDataValid);
			if (isDataValid == true && facetSeries.isDataValid == true)
			{	
				result.inputXML = businessInfoStr;
				result.isDataValid = true;
				//isDataSaved = true;  
			}
			else
			{
				result.isDataValid = false;
			}
			//-if (parentContainer != null)
			//-	parentContainer.stage.focus = null;
			return result;
		}
		
		
		private function getDisplayValueOfSelectedTreeNode(currentValue:String, TreeNodeList:XMLList):Object
		{
			var treeNode:XML = null;
			var displayTextID:String = null;
			var displayValue:String = "";
			var resultObj:Object;
			
			for(var nodeCnt:Number=0; nodeCnt < TreeNodeList.length(); nodeCnt++)
			{
				treeNode = XML(TreeNodeList[nodeCnt]);
				if(treeNode.@Text == currentValue)
				{
					displayTextID = treeNode.@DisplayTextID;
					if(displayTextID != null && displayTextID != "")
					{
						displayValue = utils.Helper.GetLocalizedString(displayTextID);
						if(displayValue == displayTextID)
							displayValue = currentValue;
					}
					else
						displayValue = currentValue;
					
					resultObj = new Object();
					resultObj.isValueFound = true;
					resultObj.displayValue = displayValue;
					
					return resultObj;
				}		
				if(treeNode.TreeNode != null && treeNode.TreeNode.length() > 0)
				{
					resultObj = getDisplayValueOfSelectedTreeNode(currentValue, treeNode.TreeNode);
					if(resultObj.isValueFound)
						return resultObj;
				}
			}
			
			if(displayValue == "")
			{
				displayValue = currentValue;			
				resultObj = new Object();
				resultObj.isValueFound = false;				
			}			
			
			return resultObj;
		}
		
		private function getDisplayValueOfSelectedPathTreeNode(currentValue:String, TreeNodeList:XMLList):String
		{
			var pathSeperator:String = "\\";
			var pathValues:Array = currentValue.split(pathSeperator);
			var currentNHNodeValue:String = null;
			var tempTreeNodeList:Array = new Array();
			var isLeafNode:Boolean = false;
			var tmpDispValue:String = null;
			var displayValue:String = "";
			var tmppathSeperator:String = "";
			
			for(var i:Number=0;i<TreeNodeList.length();i++)
				tempTreeNodeList[i] = XML(TreeNodeList[i]);
			
			for(var cnt:Number = 0; cnt < pathValues.length; cnt++)
			{
				tmpDispValue = "";
				if(cnt == pathValues.length - 1)
					isLeafNode = true;
				
				currentNHNodeValue = pathValues[cnt];
				tempTreeNodeList   = getCurrentNHValueNodeList(tempTreeNodeList, currentNHNodeValue,isLeafNode);
				
				if(tempTreeNodeList != null && tempTreeNodeList.length > 0)
				{
					tmpDispValue = tempTreeNodeList.pop() as String;
					if(tmpDispValue != "" )
					{
						displayValue = displayValue + tmppathSeperator + tmpDispValue;
						tmppathSeperator = "\\";
					}	
				}	
			}
			return displayValue;
		}
		
		private function getCurrentNHValueNodeList(TreeNodeArray:Array, currentNHNodeValue:String, isLeafNode:Boolean):Array
		{
			var TreeNode:XML = null;
			var updatedTreeNodeArray:Array = new Array();
			var cnt:Number = 0 ;
			var displayTextID:String = null;
			var displayValue:String = "";
			
			for(var i:Number=0;i<TreeNodeArray.length;i++)
			{
				TreeNode = XML(TreeNodeArray[i]);
				if(TreeNode.@Text == currentNHNodeValue)
				{	
					if(isLeafNode)
					{
						TreeNode.@Checked = "1";
					}
					else
					{
						var tmpList:XMLList = TreeNode.TreeNode;
						if(tmpList.length() > 0 )
						{
							for(var j:Number=0;j<tmpList.length();j++)
							{	
								updatedTreeNodeArray[cnt] =  XML(tmpList[j]);
								cnt++;								
							}
						}
					}
					
					displayTextID = TreeNode.@DisplayTextID;
					if(displayTextID != null && displayTextID != "")
					{						
						displayValue = utils.Helper.GetLocalizedString(displayTextID);
						if(displayTextID == displayValue)
							displayValue = currentNHNodeValue;
					}
					else
						displayValue = currentNHNodeValue;
					updatedTreeNodeArray.push(displayValue);
				}
			}
			return updatedTreeNodeArray;
		}
	}
}