package  assets.checkbox
{
	import events.FacetSeriesChangeEvent;
	
	import flash.events.MouseEvent;
	
	import mx.controls.CheckBox;
	import mx.controls.DataGrid;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.core.IDataRenderer;
	import mx.core.UIComponent;

	public class CheckBoxHeaderRenderer extends UIComponent implements IDataRenderer, IListItemRenderer
	{
		private var _data:CheckBoxHeaderColumn;
	
		private var cb:CheckBox = null;
		
		public function CheckBoxHeaderRenderer()
		{
			super();
			cb = new CheckBox();
			cb.styleName = "gridCheckBox"
		}
		
		public function get data():Object
		{
			return _data;
		}
		
		public function set data(value:Object):void
		{
			_data = value as CheckBoxHeaderColumn;
			 cb.selected = _data.selected;
		}
		
		protected override function createChildren():void
		{		
			this.addChild(cb);
			this.width = 5;
			cb.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
		    cb.x = (unscaledWidth - cb.width)/2-7;
			cb.y = (unscaledHeight - cb.height)/2;
		}
		
		private function clickHandler(evt:MouseEvent):void
		{
			//this is done so that datagrid should not raise the same event
			evt.stopImmediatePropagation();
			
			data.selected = cb.selected;
			data.dispatchEvent(evt);
			
			var dg:DataGrid = this.owner as DataGrid;         	
			if (dg.name.indexOf("$ALSEP$")>=0)
			{
				var ownernameArr:Array = dg.name.split("$ALSEP$");
				var target1:String = ownernameArr[0] + "$ALSEP$" + ownernameArr[1];
				dg.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.HEADERCHECKBOX_SELECTION, cb, target1, dg)); 
			}
		}
		
	}
}