package assets.combobox
{
	import assets.DataGridColumnEx;
	
	import events.FacetSeriesChangeEvent;
	
	import flash.events.Event;
	import flash.events.FocusEvent;
	
	import mx.controls.ComboBox;
	import mx.controls.DataGrid;
	import mx.controls.dataGridClasses.DataGridListData;
	import mx.controls.listClasses.BaseListData;
	import mx.controls.listClasses.IDropInListItemRenderer;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.core.IDataRenderer;
	import mx.core.UIComponent;
	import mx.utils.StringUtil;
	
	import utils.Helper;
	
	public class ComboBoxItemRenderer extends UIComponent implements IListItemRenderer, IDataRenderer, IDropInListItemRenderer
	{
		[Bindable]
		private var dataVal:Object;
		
		private var col:DataGridListData;
		private var ownernameArr:Array;
		private var dg:DataGrid;
		private var dgCol:DataGridColumnEx;
		private var cb:ComboBox;
		private var currfield:XML
		private var _listData:BaseListData;
		
		public function ComboBoxItemRenderer()
		{
			super();
			cb = new ComboBox();
			cb.addEventListener(Event.CHANGE, changeHandler);
			cb.addEventListener(FocusEvent.FOCUS_OUT, focusoutHandler);
		}
		
		public function get data():Object
        {
    		return dataVal;
        }
        
		public function set data(value:Object):void
		{	
			dataVal = value;
			if(_listData)
			{
                col = DataGridListData(_listData);
                dg = col.owner as DataGrid;
                dgCol = dg.columns[col.columnIndex];
                dg.removeEventListener(FacetSeriesChangeEvent.ITEM_VALIDATE,temp);
                dg.addEventListener(FacetSeriesChangeEvent.ITEM_VALIDATE,temp);
                ownernameArr = col.owner.name.split("$ALSEP$");
				var xml:XML = XML(dataVal);
				var currfieldlist:XMLList = xml.child(col.dataField.toString());
				currfield = currfieldlist[0];								
				//var NHID:String = ownernameArr[col.columnIndex + 2];
				col.owner.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.POPULATE_COMBOBOX, cb, dgCol.params, currfield.toString()));
			}
		}
		
		protected override function createChildren():void
		{	
			this.addChild(cb);
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			super.updateDisplayList(unscaledWidth,unscaledHeight);
			
			cb.width = unscaledWidth - 10;
			cb.height = 21;
			cb.x = 5; 
			validate();
		}
		
		public function get listData():BaseListData
        {
            return _listData;
        }
		        
        public function set listData(value:BaseListData):void
        { 
        	_listData = value;
        	
        }
        
        private function temp(evt:FacetSeriesChangeEvent):void
		{
			invalidateDisplayList();
		}
        
        private function validate(evt:FacetSeriesChangeEvent=null):void
		{	
			if (col != null)
				col.owner.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.ITEM_FOCUSIN, dgCol, cb));
		}
		
		private function focusoutHandler(evt:FocusEvent):void
		{
			//validate();	
		}
		
		private function changeHandler(evt:Event):void
		{	
			//var sendData:String = Helper.EncodeSpecialChars(StringUtil.trim(cb.selectedLabel.toString()));
			
			var treeNode:XML = cb.selectedItem as XML;
			var sendData:String = null;
			if(treeNode != null)
				sendData = Helper.EncodeSpecialChars(StringUtil.trim(treeNode.@Text));			
			
			currfield.setChildren(sendData);
						
			if (col != null)
			{
				var target1:String = ownernameArr[0] + "$ALSEP$" + ownernameArr[1];
				var target2:String = col.rowIndex + "$ALSEP$" + col.dataField.toString();
				this.owner.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.SERIES_CHANGE, sendData, target1, target2));
			}
		}
	}
}