package assets.datefield
{
	import assets.DataGridColumnEx;
	
	import constants.STRINGS;
	
	import events.FacetSeriesChangeEvent;
	
	import flash.events.FocusEvent;
	
	import mx.controls.DataGrid;
	import mx.controls.DateField;
	import mx.controls.dataGridClasses.DataGridListData;
	import mx.controls.listClasses.BaseListData;
	import mx.controls.listClasses.IDropInListItemRenderer;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.core.IDataRenderer;
	import mx.core.UIComponent;
	import mx.events.CalendarLayoutChangeEvent;
	
	import utils.Helper;
	
	public class DateFieldItemRenderer extends UIComponent implements IDataRenderer, IListItemRenderer, IDropInListItemRenderer
	{	
		[Bindable]
		private var dataVal:Object;
		
		private var col:DataGridListData;
		private var ownernameArr:Array;
		private var dg:DataGrid;
		private var df:DateField;
		private var date:XML;
		
		private var _listData:BaseListData;
		public function DateFieldItemRenderer()
		{
			super();
			df = new DateField();
			df.labelFunction = Helper.dateLabelFunction;			
			df.parseFunction = null;
			df.monthNames = STRINGS.MonthLabels;
			df.dayNames = STRINGS.WeekDayShortLabels;
			df.addEventListener(CalendarLayoutChangeEvent.CHANGE, datechangeHandler);
			df.addEventListener(FocusEvent.FOCUS_OUT, focusoutHandler);
		}
		
		
		public function get data():Object
        {	
    		return dataVal;
        }
        
		public function set data(value:Object):void
		{	
			dataVal = value;
			if(_listData)
			{
                col = DataGridListData(_listData); 
                dg = col.owner as DataGrid;
                dg.removeEventListener(FacetSeriesChangeEvent.ITEM_VALIDATE,temp);
                dg.addEventListener(FacetSeriesChangeEvent.ITEM_VALIDATE,temp);
                ownernameArr = col.owner.name.split("$ALSEP$");
				var xml:XML = XML(dataVal);
				var datelist:XMLList = xml.child(col.dataField.toString());
				date = datelist[0];
				df.selectedDate = null;
				df.monthNames = STRINGS.MonthLabels;
				df.dayNames = STRINGS.WeekDayShortLabels;
				if (date.DAY != null && String(date.DAY).length > 0)
				{	
					var currDay:int = Number(date.DAY);
					var currMonth:int = Number(date.MONTH);
					var currYear:int = Number(date.YEAR);
					df.selectedDate = new Date(currYear,currMonth,currDay);
				}
			}	  
		}
		
		
		private function temp(evt:FacetSeriesChangeEvent):void
		{
			invalidateDisplayList();
		}
		
		protected override function createChildren():void
		{
			this.addChild(df);
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			super.updateDisplayList(unscaledWidth,unscaledHeight);
			
			df.width = unscaledWidth - 10;
			df.height = 21;
			df.x = 5; 
			validate();
		}
		
		public function get listData():BaseListData
        {
            return _listData;
        }
		        
        public function set listData(value:BaseListData):void
        { 
        	_listData = value;
        	
        }
		
		private function validate(evt:FacetSeriesChangeEvent=null):void
		{	
			var dgCol:DataGridColumnEx;
			if (col != null)
			{	
				dgCol = dg.columns[col.columnIndex];
				col.owner.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.ITEM_FOCUSIN, dgCol, df));
			}
		}
		
		private function focusoutHandler(evt:FocusEvent):void
		{
			//validate();
		}
		
		private function datechangeHandler(evt:CalendarLayoutChangeEvent):void
		{	
			var sendData:String = "<DAY>"+df.selectedDate.getDate().toString()+"</DAY>";
			sendData += "<MONTH>"+(df.selectedDate.getMonth()+1).toString()+"</MONTH>";
			sendData += "<YEAR>"+df.selectedDate.getFullYear().toString()+"</YEAR>";
			sendData += "<HOUR>0</HOUR>";
			sendData += "<MINUTE>0</MINUTE>";
			sendData += "<SECOND>0</SECOND>";
			
			
			var tempxml:String = "<PARENT>" + sendData + "</PARENT>";
			date.setChildren(XML(tempxml).children());
			
			if (col != null)
			{
				var target1:String = ownernameArr[0] + "$ALSEP$" + ownernameArr[1];			
				var target2:String = col.rowIndex + "$ALSEP$" + col.dataField.toString();
				col.owner.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.SERIES_CHANGE, sendData, target1, target2));		
			}
		}
	}
}