package assets.multiselect
{
	import assets.ButtonEx;
	import assets.DataGridColumnEx;
	
	import constants.STRINGS;
	
	import events.FacetSeriesChangeEvent;
	
	import flash.events.FocusEvent;
	import flash.events.MouseEvent;
	
	import mx.controls.DataGrid;
	import mx.controls.TextInput;
	import mx.controls.dataGridClasses.DataGridListData;
	import mx.controls.listClasses.BaseListData;
	import mx.controls.listClasses.IDropInListItemRenderer;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.core.IDataRenderer;
	import mx.core.UIComponent;
	
	import utils.Helper;
	
	public class TreeViewItemRenderer extends UIComponent implements IListItemRenderer, IDataRenderer,IDropInListItemRenderer
	{
		[Bindable]
		private var dataVal:Object;
		
		private var col:DataGridListData;
		private var ownernameArr:Array;
		private var currfield:XML;
		private var mulSelSep:String = STRINGS.MULTISELECT_SEPERATOR;
		
		private var dg:DataGrid;
		private var dgCol:DataGridColumnEx;
		private var select:ButtonEx;
		//private var labeltxt:Label;
		private var labeltxt:TextInput;
		private var _listData:BaseListData;
		public function TreeViewItemRenderer()
		{
			super();
			select = new ButtonEx();
			//labeltxt = new Label();
			labeltxt = new TextInput();
			labeltxt.editable = false;
			labeltxt.addEventListener(FocusEvent.FOCUS_OUT, focusoutHandler);
		}
		
		protected override function createChildren():void
		{
			this.addChild(labeltxt);
			this.addChild(select);
			
			this.addEventListener(FacetSeriesChangeEvent.TREESELECTION_CHANGE, getTreeSelectedValues);
			
			select.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			super.updateDisplayList(unscaledWidth,unscaledHeight);
			
			select.setActualSize(80,20);	
			
			labeltxt.setActualSize(unscaledWidth-95,20);
			labeltxt.x = 5;
			
			select.label = STRINGS.BUTTON_TREEVIEW_SELECT;		
			select.x= unscaledWidth - select.width - 5;
			validate();
		}
		
		private function temp(evt:FacetSeriesChangeEvent):void
		{
			invalidateDisplayList();
		}
		
		 public function get listData():BaseListData
        {
            return _listData;
        }

        /**
         * @private
         */
        public function set listData(value:BaseListData):void
        { 
        	_listData = value;
        	
        }
		
		public function get data():Object
        {
    		return dataVal;
        }
        
		public function set data(value:Object):void
		{	
			
			dataVal = value;
			 
			if(_listData)
			{
            	col = DataGridListData(_listData);
            	dg = col.owner as DataGrid;
                dgCol = dg.columns[col.columnIndex];
                dg.removeEventListener(FacetSeriesChangeEvent.ITEM_VALIDATE,temp);
                dg.addEventListener(FacetSeriesChangeEvent.ITEM_VALIDATE,temp);
           		ownernameArr = col.owner.name.split("$ALSEP$");
            
                var xml:XML = XML(dataVal);
				var currfieldlist:XMLList = xml.child(col.dataField.toString());
				currfield = currfieldlist[0];
				labeltxt.text = "";
				if (String(currfield).length > 0)
				{
					var text:String = String(currfield);
					text = text.substr(mulSelSep.length, text.length - (2*mulSelSep.length)); 
					while (text.indexOf(mulSelSep) >= 0)
						text = text.replace(mulSelSep,',')
					labeltxt.text = text;
				}
			}
		}
		
		private function validate(evt:FacetSeriesChangeEvent=null):void
		{	
			if (col != null)
				col.owner.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.ITEM_FOCUSIN, dgCol, labeltxt));
		}
		
		private function focusoutHandler(evt:FocusEvent):void
		{
			//validate(); 
		}
		
		public function clickHandler(evt:MouseEvent):void
		{						
			//var NHID:String = ownernameArr[col.columnIndex + 2];
			this.owner.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.SHOW_TREEVIEW, this, dgCol.params, currfield.toString()));
		}
		
		private function getTreeSelectedValues(evt:FacetSeriesChangeEvent):void
		{	
			//var fieldData:String = evt.Data as String;
			var eventData:String = evt.Data as String;
			var fieldData:String = eventData.split("$DATA$")[0];
			var fieldDisplayData:String = eventData.split("$DATA$")[1];
						
			var text:String = fieldData;
			currfield.setChildren(text);
			
			/*if (text.length > 0)
			{	
				text = text.substr(mulSelSep.length, text.length - (2*mulSelSep.length)); 
				while (text.indexOf(mulSelSep) >= 0)
					text = text.replace(mulSelSep,',')
			}
			labeltxt.text = text;*/
			
			var displayVal:String;
			if (fieldData == mulSelSep)
				displayVal = "";
			else
				displayVal = fieldDisplayData;
							
			labeltxt.text = displayVal;
						
			fieldData = Helper.EncodeSpecialChars(fieldData);
			if (col != null)
			{
				var target1:String = ownernameArr[0] + "$ALSEP$" + ownernameArr[1];			
				var target2:String = col.rowIndex.toString() + "$ALSEP$" + col.dataField.toString();
				col.owner.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.SERIES_CHANGE, fieldData, target1, target2));
			}
		} 
	}
}