package assets.text
{
	import constants.STRINGS;
	
	import mx.controls.Text;
	import mx.controls.dataGridClasses.DataGridListData;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.core.IDataRenderer;
	
	public class TextItemRenderer extends Text implements IDataRenderer, IListItemRenderer
	{
		[Bindable]
		private var dataVal:Object;
		private var col:DataGridListData;
		private var mulSelSep:String = STRINGS.MULTISELECT_SEPERATOR;
		
		public function TextItemRenderer()
		{
			super();
		}
		
		override public function get data():Object
        {	
    		return dataVal;
        }
        
		override public function set data(value:Object):void
		{	
			dataVal = value;			
			if(listData)
			{
                col = DataGridListData(listData);
                
				var xml:XML = XML(dataVal);
				var fieldlist:XMLList = xml.child(col.dataField.toString());
				var field:XML = fieldlist[0];
				
				if (field.DAY != null && String(field.DAY).length > 0)
					ResolveDate(field);
				else if (field.length() > 0 && String(field).indexOf(mulSelSep) >= 0)
					ResolveTreeSelVals(field)
				else
					this.text = field.toString();
				
			}	  
		}
		
		private function ResolveDate(field:XML):void
		{
			var currDay:String = field.DAY;
			var currMonth:String = field.MONTH;
			var currYear:String = field.YEAR;
			this.text = currMonth + "/" + currDay + "/" + currYear;
		}
		
		private function ResolveTreeSelVals(field:XML):void
		{
			var selvals:String = field.toString();
			if (selvals.indexOf(mulSelSep) == 0)
				selvals = selvals.replace(mulSelSep,'');
			selvals = selvals.substr(0, selvals.length - mulSelSep.length);
			while (selvals.indexOf(mulSelSep) >= 0)
			{
				selvals = selvals.replace(mulSelSep,',');	
			}
			this.text = selvals;	
		}

	}
}