package assets.textarea
{
	import assets.DataGridColumnEx;
	
	import events.FacetSeriesChangeEvent;
	
	import flash.events.FocusEvent;
	
	import mx.controls.DataGrid;
	import mx.controls.TextArea;
	import mx.controls.dataGridClasses.DataGridListData;
	import mx.controls.listClasses.BaseListData;
	import mx.controls.listClasses.IDropInListItemRenderer;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.core.IDataRenderer;
	import mx.core.UIComponent;
	import mx.utils.StringUtil;
	
	import utils.Helper;
	
	public class TextAreaItemRenderer extends UIComponent implements IDataRenderer, IListItemRenderer, IDropInListItemRenderer
	{
		[Bindable]
		private var dataVal:Object;
		
		private var col:DataGridListData;
		private var ownernameArr:Array;
		private var currfield:XML
		
		private var ta:TextArea;
		private var dg:DataGrid;
		private var oldTxt:String = "";
		
		private var _listData:BaseListData;
		
		public function TextAreaItemRenderer() 
		{
			super();
			ta = new TextArea();
			ta.addEventListener(FocusEvent.FOCUS_OUT, focusoutHandler);
			ta.addEventListener(FocusEvent.FOCUS_IN, focusinHandler);
			ta.addEventListener(Event.CHANGE, changeDataHandler);
		}

		public function get data():Object
        {	
    		return dataVal;
        }
        
		public function set data(value:Object):void
		{	
			dataVal = value;			
			if(_listData)
			{ 	
                col = DataGridListData(_listData);
                dg = col.owner as DataGrid;
                dg.removeEventListener(FacetSeriesChangeEvent.ITEM_VALIDATE,temp);
                dg.addEventListener(FacetSeriesChangeEvent.ITEM_VALIDATE,temp);
                ownernameArr = col.owner.name.split("$ALSEP$");
				var xml:XML = XML(dataVal);
				var currfieldlist:XMLList = xml.child(col.dataField.toString());
				currfield = currfieldlist[0];
				//if (String(currfield).length > 0)
					ta.text = currfield.toString();
				//else
					//ta.text = "";
			}	 
		}
		
		protected override function createChildren():void
		{	
			ta.verticalScrollPolicy = "ON";
			this.addChild(ta);
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			super.updateDisplayList(unscaledWidth,unscaledHeight);
			
			ta.width = unscaledWidth - 10;
			ta.height = unscaledHeight;
			ta.x = 5;
			validate();
		}
		
		public function get listData():BaseListData
        {
            return _listData;
        }
		        
        public function set listData(value:BaseListData):void
        { 
        	_listData = value;
        	
        }
        
        private function temp(evt:FacetSeriesChangeEvent):void
		{
			invalidateDisplayList();
		}
        
        private function validate(evt:FacetSeriesChangeEvent=null):void
		{	
			var dgCol:DataGridColumnEx;
			if (col != null)
			{	
				dgCol = dg.columns[col.columnIndex];
				col.owner.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.ITEM_FOCUSIN, dgCol, ta));
			}
		}
		
		private function changeDataHandler(evt:Event):void
		{
			dg.dispatchEvent(new Event(Event.CHANGE)); 
		}
		
		private function focusinHandler(evt:FocusEvent):void
		{		
			oldTxt = ta.text;  
		}
		
		private function focusoutHandler(evt:FocusEvent):void
		{	
			if (ta.text != oldTxt)
			{	  
				var sendData:String = Helper.EncodeSpecialChars(StringUtil.trim(ta.text));
				currfield.setChildren(ta.text);
				if (col != null)
				{
					var target1:String = ownernameArr[0] + "$ALSEP$" + ownernameArr[1];			
					var target2:String = col.rowIndex + "$ALSEP$" + col.dataField.toString();
					dg.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.SERIES_CHANGE, sendData, target1, target2));			
				}
			}
		}

	}
}