package assets.textinput
{
	import assets.DataGridColumnEx;
	
	import events.FacetSeriesChangeEvent;
	
	import flash.events.Event;
	import flash.events.FocusEvent;
	
	import mx.controls.DataGrid;
	import mx.controls.TextInput;
	import mx.controls.dataGridClasses.DataGridListData;
	import mx.controls.listClasses.BaseListData;
	import mx.controls.listClasses.IDropInListItemRenderer;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.core.IDataRenderer;
	import mx.core.UIComponent;
	import mx.utils.StringUtil;
	
	import utils.Helper;
	
	public class TextInputItemRenderer extends UIComponent implements IDataRenderer, IListItemRenderer, IDropInListItemRenderer
	{
		[Bindable]
		private var dataVal:Object;
		
		private var col:DataGridListData;
		private var ownernameArr:Array;
		private var currfield:XML
		
		private var dg:DataGrid;
		private var ti:TextInput;
		
		private var _listData:BaseListData;
		
		private var oldTxt:String = "";
		
		public function TextInputItemRenderer() 
		{
			super();
			ti = new TextInput();
			ti.addEventListener(FocusEvent.FOCUS_OUT, focusoutHandler);
			ti.addEventListener(FocusEvent.FOCUS_IN, focusInHandler);
			ti.addEventListener(Event.CHANGE, changeDataHandler);
		}
	
		public function get data():Object
        {	
    		return dataVal;
        }
        
		public function set data(value:Object):void
		{	
			dataVal = value;
			if(_listData)
			{   
                col = DataGridListData(_listData);
                dg = col.owner as DataGrid;
                dg.removeEventListener(FacetSeriesChangeEvent.ITEM_VALIDATE,temp);
                dg.addEventListener(FacetSeriesChangeEvent.ITEM_VALIDATE,temp);
                ownernameArr = col.owner.name.split("$ALSEP$");
				var xml:XML = XML(dataVal);
				var currfieldlist:XMLList = xml.child(col.dataField.toString());
				currfield = currfieldlist[0];
				ti.text = currfield.toString();
			}	 
		}
		
		private function temp(evt:FacetSeriesChangeEvent):void
		{
			invalidateDisplayList();
		}
		
		private function validate(evt:FacetSeriesChangeEvent=null):void
		{	
			var dgCol:DataGridColumnEx;
			if (col != null)
			{
				dgCol = dg.columns[col.columnIndex];
				col.owner.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.ITEM_FOCUSIN, dgCol, ti));
			}
		}
		
		protected override function createChildren():void
		{	
			this.addChild(ti);
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			super.updateDisplayList(unscaledWidth,unscaledHeight);
			
			ti.width = unscaledWidth - 10;
			ti.height = 21;
			ti.x = 5;
			validate();
		}
		
		public function get listData():BaseListData
        {
            return _listData;
        }
		        
        public function set listData(value:BaseListData):void
        { 
        	_listData = value;
        }
		
		private function changeDataHandler(evt:Event):void
		{
			col.owner.dispatchEvent(new Event(Event.CHANGE)); 
		}
		
		private function focusinHandler(evt:FocusEvent):void
		{	
			oldTxt = ti.text;  
		}
		
		private function focusoutHandler(evt:FocusEvent):void
		{	
			if (ti.text != oldTxt)
			{
				var sendData:String = Helper.EncodeSpecialChars(StringUtil.trim(ti.text));
				currfield.setChildren(ti.text);
				if (col != null)
				{	
					var target1:String = ownernameArr[0] + "$ALSEP$" + ownernameArr[1];			
					var target2:String = col.rowIndex + "$ALSEP$" + col.dataField.toString();
					col.owner.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.SERIES_CHANGE, sendData, target1, target2));			
				}
			}
		}
	}
}