package utils
{	
	import Assetlink.Solutions.Formatting.DateTimeFormatting;
	import Assetlink.Solutions.Formatting.NumberFormatting;
	
	import constants.STRINGS;
	
	import flash.xml.XMLNode;
	
	import infrastructure.statemanagement.StateMgr;
	
	import mx.formatters.DateFormatter;
	import mx.messaging.AbstractConsumer;
	import mx.utils.XMLUtil;
	
	public class Helper
	{   
		private static var helper:Helper = new Helper();
		
		public function Helper()
		{	
		}
		
		public static function GetNHDetails(currField:XML, nhCollection:XML):Object
        {
        	var nhObj:Object = new Object();
        	nhObj.customTreeNodes = false;
        	//useNamedHeirarchy attribute does not exist always in xml and in that case default value is YES        	
        	if ((String(currField.@ISNAMEDHIERARCHY).toUpperCase() != "FALSE" && String(currField.@UseNamedHierarchy).toUpperCase() != "NO") ||
				((currField.@NAMEDHIERARCHYID != null && currField.@NAMEDHIERARCHYID != "") && String(currField.@UseNamedHierarchy).toUpperCase() != "NO"))
        	{
	    		var NHID:String = currField.@NAMEDHIERARCHYID;
	    		nhObj.nhTreeNode = helper.GetNHTreeNode(NHID, nhCollection);
        	}
        	else if (XMLList(currField.Item).length() > 0)
        	{
        		nhObj.customTreeNodes = true;
        		nhObj.nhTreeNode =  currField;
        	}
        	return nhObj;	
        }
		
		private function GetNHTreeNode(NHID:String, nhCollection:XML):XML
        {
        	var nhTreeNodeArr:Array = new Array();
        	var nhTreeNodeList:XMLList;
        	var nhTreeNode:XML;
        	if (nhTreeNodeArr[NHID] == null)
        	{
        		nhTreeNodeList = nhCollection.TreeNodes.TreeNode.(@NodeData==NHID);
        		nhTreeNode = nhTreeNodeList[0];
        		nhTreeNodeArr[NHID] = nhTreeNode;
        	}
        	else
        		nhTreeNode = nhTreeNodeArr[NHID];
    		return nhTreeNode;
        }
        
        public static function EncodeSpecialChars(text:String):String
		{	
			while (text.indexOf('&') >= 0)
				text = text.replace('&','$ALAND$');
			while (text.indexOf('$ALAND$') >= 0)
				text = text.replace('$ALAND$','&amp;');
			while (text.indexOf('<') >= 0)
				text = text.replace('<','&lt;');
			while (text.indexOf('>') >= 0)
				text = text.replace('>','&gt;');
        	while (text.indexOf('"') >= 0)
            	text = text.replace('"','&quot;');
			while (text.indexOf("'") >= 0)
            	text = text.replace("'",'&#39;');
			return text;
		}
		
		public static function DecodeSpecialChars(text:String):String
		{
			while (text.indexOf('&lt;') >= 0)
				text = text.replace('&lt;','<');
			while (text.indexOf('&gt;') >= 0)
				text = text.replace('&gt;','>');
			while (text.indexOf('&amp;') >= 0)
				text = text.replace('&amp;','&');
        	while (text.indexOf('&quot;')>=0)
            	text = text.replace('&quot;','"');
			while (text.indexOf("&#39;")>=0)
            	text = text.replace("&#39;","'");      
			return text;
		}
		
		public static function dateLabelFunction(date:Date):String
		{
			/*if(date == null)
				return "";
			return date.date + " " + STRINGS.MonthLabels[date.month] + " " + date.fullYear;*/
			
			if(date == null)
				return "";
			
			var currentLanguage:String = StateMgr.GetInstance().Language;
			var currentCulture:String = StateMgr.GetInstance().CurrentCulture;
			var FormatXml:XML = XML(StateMgr.GetInstance().FormatXml);
			var CurrentDateFormatting:XML = null;
			
			CurrentDateFormatting 				= XML(FormatXml.language.(@name == currentLanguage).FormattingTypes.DateFormatting);			
			var ObjDTFormat:DateTimeFormatting  = new DateTimeFormatting(CurrentDateFormatting);
			var formattedDate:String 			= ObjDTFormat.ConvertStdDateToDisplayFormat(date);	
									
			return formattedDate;
		}
		
		public static function LocalizeLabels(labelLocalization:XML):void
		{	
			var stringNode:XML = labelLocalization.string.(@id=='MD_BUTTON_SAVE_SHARED')[0];
			STRINGS.BUTTON_TREEVIEW_SAVE = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='MD_BUTTON_CANCEL_SHARED')[0];
			STRINGS.BUTTON_TREEVIEW_CANCEL = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='MD_FR_BUTTON_SELECT')[0];
			STRINGS.BUTTON_TREEVIEW_SELECT = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='MD_FR_ERROR_FACETSERIES_DATA_MANDATORY')[0];
			STRINGS.FACETSERIES_DATA_MANDATORY = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='January_Shared')[0];
			STRINGS.MonthLabels[0] = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='Febuary_Shared')[0];
			STRINGS.MonthLabels[1] = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='March_Shared')[0];			
			STRINGS.MonthLabels[2] = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='April_Shared')[0];			
			STRINGS.MonthLabels[3] = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='May_Shared')[0];			
			STRINGS.MonthLabels[4] = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='June_Shared')[0];			
			STRINGS.MonthLabels[5] = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='July_Shared')[0];			
			STRINGS.MonthLabels[6] = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='August_Shared')[0];			
			STRINGS.MonthLabels[7] = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='September_Shared')[0];			
			STRINGS.MonthLabels[8] = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='October_Shared')[0];			
			STRINGS.MonthLabels[9] = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='November_Shared')[0];			
			STRINGS.MonthLabels[10] = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='December_Shared')[0];			
			STRINGS.MonthLabels[11] = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='S_Shared')[0];			
			STRINGS.WeekDayShortLabels[0] = STRINGS.WeekDayShortLabels[6] = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='M_Shared')[0];			
			STRINGS.WeekDayShortLabels[1] = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='T_Shared')[0];			
			STRINGS.WeekDayShortLabels[2] = STRINGS.WeekDayShortLabels[4] = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='W_Shared')[0];			
			STRINGS.WeekDayShortLabels[3] = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='F_Shared')[0];			
			STRINGS.WeekDayShortLabels[5] = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='MD_MESSAGE_FIELD_REQUIRED')[0];			
			STRINGS.MANADATORY_FIELD_MESSAGE = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='MD_MESSAGE_FIELD_PRECISION_ERROR')[0];			
			STRINGS.FIELD_PRECISION_MESSAGE = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='MD_MESSAGE_MAXVALUE_EXCEED_ERROR')[0];			
			STRINGS.FIELD_MAXEXCEED_MESSAGE = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='MD_MESSAGE_INTEGER_ERROR')[0];			
			STRINGS.FIELD_INTEGERERROR_MESSAGE = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='MD_MESSAGE_INVALIDCHAR_ERROR')[0];			
			STRINGS.FIELD_INVALIDCHARERROR_MESSAGE = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='MD_MESSAGE_INVALIDFORMATCHARS_ERROR')[0];			
			STRINGS.FIELD_INVALIDFORMATCHARSERROR_MESSAGE = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='MD_MESSAGE_LOWERTHANMINVALUE_ERROR')[0];			
			STRINGS.FIELD_LOWERTHANMINERROR_MESSAGE = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='MD_MESSAGE_NEGATIVE_ERROR')[0];			
			STRINGS.FIELD_NEGATIVEERROR_MESSAGE = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='MD_MESSAGE_SEPERATION_ERROR')[0];			
			STRINGS.FIELD_SEPARATIONERROR_MESSAGE = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='MD_MESSAGE_TOOLONG_ERROR')[0];			
			STRINGS.FIELD_TOOLONGERROR_MESSAGE = stringNode.@value;
			
			stringNode = labelLocalization.string.(@id=='MD_MESSAGE_TOOSHORT_ERROR')[0];			
			STRINGS.FIELD_TOOSHORTERROR_MESSAGE = stringNode.@value;
		}
		
		private static var LocalizedStrings:XML = null;
		public static function InitLocalizedStrings(localStrings:XML):void
		{	
			LocalizedStrings = localStrings;				
		}
		
		public static function GetLocalizedString(key:String):String
		{			
			var returnVal:String = key;
			if (LocalizedStrings.string != null && XMLList(LocalizedStrings.string).length() > 0)
			{
				var reqdNode:XMLList = LocalizedStrings.string.(@id == key);
				if (reqdNode != null && reqdNode.length() > 0)
					returnVal = reqdNode[0].@value;
			}
			return returnVal;
		}
		
		
		//This method is used to sort the Sections/Columns/Fields by Order attribute.
		public static function sortXMLList(list:XMLList, SortOn:String):Array
		{
			var entry_items:Array=new Array();
			var sorted_items:Array = new Array();
			
			for(var i:Number=0;i<list.length();i++)
			{
				var entry_node:XML   =	list[i];				
				var temp_item:Object = new Object();
				switch(SortOn)
				{
					case "Order":
						temp_item.datumNum   = Number(entry_node.@Order);
					break;
					
					case "ORDER":
						temp_item.datumNum   = Number(entry_node.@ORDER);
					break;
						
				}
				temp_item.entry	     = entry_node;
				entry_items.push(temp_item);
			}
			
			if(entry_items.length>1)
			{
				entry_items.sortOn("datumNum", Array.NUMERIC | Array.DESCENDING);
			}
			
			for(var Cnt:Number=0; Cnt < entry_items.length; Cnt++)
			{
				var array_item:Object = entry_items[Cnt];
				sorted_items.push(array_item.entry);
			}
			return  sorted_items.reverse();
		}
		
		public static function GetMonthNumber(Month:String):String
		{
			var MonthIndex: String = null;
			
			for(var i:Number = 0; i < STRINGS.MonthLabels.length; i++)
			{
				if(STRINGS.MonthLabels[i] == Month)
				{
					MonthIndex = (i + 1).toString();
					break;
				}
			}
			return MonthIndex;
		}
		
		public static function getNamedHierarchyDisplayValue(TreeNode:Object):String
		{
			var NHDisplayValue: String = null;
			var TreeXML:XML = XML(TreeNode);
			var displayTextID:String = TreeNode.@DisplayTextID;
			if(displayTextID != null && displayTextID != "")
			{
				NHDisplayValue = utils.Helper.GetLocalizedString(displayTextID);
				if(NHDisplayValue == displayTextID)
					NHDisplayValue = TreeNode.@Text;
			}	
			else
				NHDisplayValue = TreeNode.@Text;
			return NHDisplayValue;			
		}
		
		public static function getItemListDisplayValue(ItemNode:Object):String
		{
			var DisplayValue: String = null;			
			var displayTextID:String = ItemNode.@DisplayTextID;
			if(displayTextID != null && displayTextID != "")
			{
				DisplayValue = utils.Helper.GetLocalizedString(displayTextID);
				if(DisplayValue == displayTextID)
					DisplayValue = ItemNode.Value;
			}	
			else
				DisplayValue = ItemNode.Value;
			return DisplayValue;			
		}
		
		public static function convertStdValuetoDisplayFormat(stdValue:String, dataType:String):String
		{
			var ResultValue:String;
			var CurrentNumberFormatting:XML = null;
			
			if(stdValue == null || stdValue == "")
				return "";
			
			var currentLanguage:String = StateMgr.GetInstance().Language;
			var currentCulture:String = StateMgr.GetInstance().CurrentCulture;
			var FormatXml:XML = XML(StateMgr.GetInstance().FormatXml);
			
			if(dataType.toUpperCase() == "FLOAT")
				CurrentNumberFormatting = XML(FormatXml.language.(@name == currentLanguage).FormattingTypes.FloatFormatting);
			else if(dataType.toUpperCase() == "CURRENCY")
				CurrentNumberFormatting = XML(FormatXml.language.(@name == currentLanguage).FormattingTypes.CurrencyFormatting);
			else
				CurrentNumberFormatting = XML(FormatXml.language.(@name == currentLanguage).FormattingTypes.NumberFormatting);
			
			var ObjNumberFormat:NumberFormatting  = new NumberFormatting(CurrentNumberFormatting);
			ResultValue 						  = ObjNumberFormat.ConvertStdValueToDisplayFormat(stdValue);	
			
			return ResultValue;			
		}
		
		public static function convertDisplayValuetoStdFormat(displayValue:String, dataType:String):String
		{
			var ResultValue:String;
			var CurrentNumberFormatting:XML = null;
			
			if(displayValue == null  || displayValue == "")
				return "";
			
			var currentLanguage:String 	= StateMgr.GetInstance().Language;
			var currentCulture:String 	= StateMgr.GetInstance().CurrentCulture;
			var FormatXml:XML 			= XML(StateMgr.GetInstance().FormatXml);
			
			if(dataType.toUpperCase() == "FLOAT")
				CurrentNumberFormatting = XML(FormatXml.language.(@name == currentLanguage).FormattingTypes.FloatFormatting);
			else if(dataType.toUpperCase() == "CURRENCY")
				CurrentNumberFormatting = XML(FormatXml.language.(@name == currentLanguage).FormattingTypes.CurrencyFormatting);
			else
				CurrentNumberFormatting	= XML(FormatXml.language.(@name == currentLanguage).FormattingTypes.NumberFormatting);
			
			var ObjNumberFormat:NumberFormatting  	= new NumberFormatting(CurrentNumberFormatting);
			ResultValue								= ObjNumberFormat.ConvertDisplayValueToStdFormat(displayValue);	
			
			return ResultValue;	
		}
		
		public static function convertStdValueToEditableFormat(stdValue:String, dataType:String):String 
		{
			var ResultValue:String;
			var CurrentNumberFormatting:XML = null;
			
			if(stdValue == null || stdValue == "")
				return "";
			
			var currentLanguage:String 	= StateMgr.GetInstance().Language;
			var currentCulture:String 	= StateMgr.GetInstance().CurrentCulture;
			var FormatXml:XML 			= XML(StateMgr.GetInstance().FormatXml);			
			
			if(dataType.toUpperCase() == "FLOAT")
				CurrentNumberFormatting = XML(FormatXml.language.(@name == currentLanguage).FormattingTypes.FloatFormatting);
			else if(dataType.toUpperCase() == "CURRENCY")
				CurrentNumberFormatting = XML(FormatXml.language.(@name == currentLanguage).FormattingTypes.CurrencyFormatting);
			else
				CurrentNumberFormatting = XML(FormatXml.language.(@name == currentLanguage).FormattingTypes.NumberFormatting);			
			var ObjNumberFormat:NumberFormatting  = new NumberFormatting(CurrentNumberFormatting);
			ResultValue 						  = ObjNumberFormat.ConvertStdValueToEditableFormat(stdValue);	
			
			return ResultValue;	
		}
	}
}